//
//  MyAppDelegate.m
//  MyRecorder
//
//  Created by steve on 11/3/10.
//  Copyright 2010 TriPrism, Inc. All rights reserved.
//

#import "MyAppDelegate.h"
#import "DvdStationWindowController.h"
#import "MyRecorderController.h"
#import "SalesStationWindowController.h"

#import "TPLogFileManager.h" // 2010-11-05steve
#import "TepsUrlHandler.h"   // 2013-06-17steve



NSString* sPrefStartupMode = @"prefStartupMode";

typedef enum  {
	eAppRunModeCamera = 1,
	eAppRunModeSales,
	eAppRunModeDvd
} eAppRunMode;

short gAppRunMode = 0;



#pragma mark -

@implementation MyAppDelegate

+ (void)setupFactoryDefaults
{
	NSLog ( @"setupFactoryDefaults" );
    NSString *userDefaultsValuesPath;
    NSDictionary *userDefaultsValuesDict;
	
	
    // load the default values for the user defaults
    userDefaultsValuesPath=[[NSBundle mainBundle] pathForResource:@"FactoryDefault"
														   ofType:@"plist"];
	
	NSLog ( @"userDefaultsValuesPath = [%@]", userDefaultsValuesPath );
	
    userDefaultsValuesDict=[NSDictionary dictionaryWithContentsOfFile:userDefaultsValuesPath];
	
	if( userDefaultsValuesDict==nil)
		NSLog ( @"userDefaultsValuesDict == NIL!!!!" );
	else
		NSLog ( @"About to register factory default dictionary:\n%@\n\n", userDefaultsValuesDict );
	
    // set them in the standard user defaults
	
    [[NSUserDefaults standardUserDefaults] registerDefaults:userDefaultsValuesDict];
	
	
    // if your application supports resetting a subset of the defaults to
    // factory values, you should set those values
    // in the shared user defaults controller
	//	resettableUserDefaultsKeys = GetPrefKeyNameArray();	// 05-08-08steve	
	//    initialValuesDict=[userDefaultsValuesDict dictionaryWithValuesForKeys:resettableUserDefaultsKeys];
	
	bool resetSomeParamsToDefault = false;
	if ( resetSomeParamsToDefault )
	{
//		[self initPrefKeyNameArray]; // 2009-08-10steve
//		initialValuesDict=[userDefaultsValuesDict dictionaryWithValuesForKeys:_myPrefKeyNameArray];	// 2009-08-10steve
//		
//		// Set the initial values in the shared user defaults controller
//		
//		[[NSUserDefaultsController sharedUserDefaultsController] setInitialValues:initialValuesDict];
//		
//		[[NSUserDefaultsController sharedUserDefaultsController] setAppliesImmediately :YES];	// 05-08-08steve
	}
	
	
}

// 2010-11-05steve - initialize
+(void) initialize
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

	
   //2013-06-17steve [TPLogFileManager setupLogFile];
	
	
	[self setupFactoryDefaults];	
	bool doDeleteOldLogs = true;
	if ( doDeleteOldLogs )
	{		
		{
			NSLog ( @"Checking for Old Log Files to Delete..." );
			// try to delete the old log files
			double daysOld = 7;	// [Preferences getDaysToSaveLogs]; // 12.0/24;
			NSTimeInterval oneDayOldInSeconds = -1 * 60.0 * 60.0 * 24.0;
			NSDate* lastDateToDeleteFrom = [NSDate dateWithTimeIntervalSinceNow:(oneDayOldInSeconds * daysOld)];
			NSDictionary* options = [NSMutableDictionary dictionaryWithObjectsAndKeys:
									 [NSNumber numberWithBool:YES],@"deleteSubDirectory",
									 [NSNumber numberWithBool:NO],@"deleteImmediately",
									 lastDateToDeleteFrom, @"beforeDate",
									 nil];
			[TPLogFileManager deleteOldLogsWithOptions:options];
			NSLog ( @"Checking for Old Log Files to Delete...Done." );
		}
		
	}
	
	
}

#pragma mark -


-(IBAction)relaunchApp:(id)param // 2013-06-17steve - add quit&relaunch
{
	NSLog (@ "Inside %@ => %@...param = [%@]", [self class], NSStringFromSelector(_cmd), param );
	
	// set these vars so that applicationWillTerminate will not halt quitting
	[NSApp relaunch:param];
}

- (IBAction)selectStartupModeButtonHit:(id)sender
{
	int mode = [sender selectedTag];
	[[NSUserDefaults standardUserDefaults] setInteger:mode forKey: sPrefStartupMode];	// 5-8-03 use predefine
	NSLog (@ "Inside %@ => %@...mode = [%i]", self, NSStringFromSelector(_cmd), mode );
	[[NSUserDefaults standardUserDefaults] synchronize];
	
}

-(IBAction) closeSheet:(id)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	[NSApp endSheet:[sender window] returnCode:NSRunContinuesResponse  ];

}	
- (void)didEndSheet:(NSWindow *)sheet returnCode:(NSInteger)returnCode contextInfo:(void *)contextInfo
{
	NSLog (@ "Inside %@ => %@... with returnCode=[%i] and ContextInfo=[%@]", self, NSStringFromSelector(_cmd), returnCode, contextInfo );
	
	[sheet orderOut:self];
	
}


-(IBAction) showStartupModeOptions:(id) sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

	
	if ( _mainWindowController )
	{
		NSLog (@ "Inside %@ => %@...Need to release _mainWindowController", self, NSStringFromSelector(_cmd) );
		NSLog (@ "Inside %@ => %@...[_mainWindowController class] = [%@]", self, NSStringFromSelector(_cmd), [_mainWindowController class] );

//		[_mainWindowController release];
//		_mainWindowController = nil;
	}
	
	NSLog (@ "Inside %@ => %@...Need to release show window", self, NSStringFromSelector(_cmd) );
	short curTag = [[NSUserDefaults standardUserDefaults] integerForKey:sPrefStartupMode];
	switch (curTag) {
		case eAppRunModeCamera:
		case eAppRunModeSales:
		case eAppRunModeDvd:
			break;
		default:
			curTag = eAppRunModeCamera;
			break;
	}
	
	// set to default tag
	[_selectionMatrix selectCellWithTag:curTag];
	// sync to pref
	[[NSUserDefaults standardUserDefaults] setInteger:curTag forKey: sPrefStartupMode];	// 5-8-03 use predefine
	[[NSUserDefaults standardUserDefaults] synchronize];
	
	
	if ( ![_selectStartupWindow isVisible] )
	{
		[NSApp beginSheet:_selectStartupWindow
		   modalForWindow:nil
			modalDelegate:self 
		   didEndSelector:@selector(didEndSheet:returnCode:contextInfo:) 
			  contextInfo:nil];
	}
	
	
}

-(void) doInitializeWindow
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

//	NSModalSession* myModalSession = [NSApp beginModalSessionForWindow:_selectStartupWindow];

	
	short startupMode = [[NSUserDefaults standardUserDefaults] integerForKey:sPrefStartupMode];
	NSLog ( @"2010-11-08steve  startupMode is [%i]", startupMode );
	switch ( startupMode )
	{
		case eAppRunModeCamera:
		case eAppRunModeSales:
		case eAppRunModeDvd:
			gAppRunMode = startupMode;
			break;
		default:
			NSLog ( @"2010-11-08steve BAD startupMode is [%i]", startupMode );
			
			gAppRunMode = 0;
			// this is where we probably want to present user with options as to what mode to startup in
			[self showStartupModeOptions:nil];
			
			break;
	}
	
	
	if ( _mainWindowController )
	{
		[_mainWindowController release];
		_mainWindowController = nil;
	}
	switch ( gAppRunMode )
	{
		case eAppRunModeCamera:
			_mainWindowController = [[MyRecorderController alloc] initWithWindowNibName:@"CameraStationWindow"];
			break;
			
		case eAppRunModeSales:
			_mainWindowController = [[SalesStationWindowController alloc] initWithWindowNibName:@"SalesStationWindow"];
			break;
			
		case eAppRunModeDvd:
			_mainWindowController = [[DvdStationWindowController alloc] initWithWindowNibName:@"DvdStationWindow"];
			break;
			
		default:
			_mainWindowController = nil;
			NSLog ( @"2010-11-06steve - UNKNOWN Initializer?????" );
			break;
	}
	
	[_mainWindowController window]; // force nib to load
	
}




#pragma mark -

-(void) dealloc
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

	[super dealloc];
}


- (void)awakeFromNib
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

	_mainWindowController = nil;

}


- (BOOL)application:(NSApplication *)theApplication openFile:(NSString *)filename
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	return YES;

}


- (NSApplicationTerminateReply)applicationShouldTerminate:(NSApplication *)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	//	// 2010-10-25steve
	//	NSNotificationCenter* nc = [NSNotificationCenter defaultCenter];
	//	[nc removeObserver:self
	//				  name:NSThreadWillExitNotification
	//				object:nil];
	//	
	
	if ( ![_mainWindowController isKindOfClass:[MyRecorderController class]] )
	{
		[_mainWindowController release];
		_mainWindowController = nil;		
	}
	
	return NSTerminateNow;
}

- (void)applicationWillFinishLaunching:(NSNotification *)aNotification
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	
	// 2010-11-10steve
	// we only want to be notified if the quicktime player has launched 
//	[[[NSWorkspace sharedWorkspace] notificationCenter] addObserver:self
//														   selector:@selector(childProcessDidTerminate:) 
//															   name:NSWorkspaceDidTerminateApplicationNotification
//															 object:nil];
	
    
    
    
    
    BOOL doTestSecurityKey = NO; // 2013-06-17steve - test Security Key from ka.triprism.com site
    if ( doTestSecurityKey) {
        
        TepsUrlHandler * urlHandler = [[TepsUrlHandler alloc] init];
        [urlHandler doTestStuff];

    }
    
    BOOL doForceExpiration = YES; // 2013-07-09steve - force time limit
    if (doForceExpiration) {
        NSDate * curDate = [NSDate date];
        NSLog(@"2013-07-09steve check for date...%@",curDate);
        NSString* zoneString = @"000";
        NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
        [dateFormatter setDateFormat:@"Z"];
        NSString *tz = [dateFormatter stringFromDate:[NSDate date]];
        if ( tz)
            zoneString = [NSString stringWithFormat:@"%@",tz];
        [dateFormatter release];
        
        NSDate* expirationDate = [NSDate dateWithString:[NSString stringWithFormat: @"2013-08-01 00:00:00 %@",zoneString]];
        
        NSLog(@"2013-07-08steve expirationDate = %@",zoneString);
        NSLog(@"2013-07-08steve expirationDate = %@",expirationDate);
        
        BOOL doTerminate = NO;
        if ( [curDate compare:expirationDate] == NSOrderedAscending) {
            NSLog(@"2013-07-08 curDate is BEFORE expiration date = %@",expirationDate);
        } else {
            NSLog(@"2013-07-08 curDate is AFTER expiration date = %@",expirationDate);
            doTerminate = YES;
        }
        
        NSLog(@"2013-07-08steve expirationDate = %@",[expirationDate descriptionWithLocale:[NSLocale currentLocale]]);

        if ( doTerminate) {
            
            NSAlert* alert = [[NSAlert alloc] init];
            [alert setMessageText:[NSString stringWithFormat:@"Sorry KEY EXPIRED..." ]];
            [alert setInformativeText:[NSString stringWithFormat:@"This App Expired on %@..", [expirationDate descriptionWithLocale:[NSLocale currentLocale]]]];
            [alert addButtonWithTitle:@"OK"];
            [[NSApplication sharedApplication] activateIgnoringOtherApps: YES];
            [alert runModal];
            [alert release];
            NSLog(@"2013-07-08steve expirationDate = %@",expirationDate);

        }
        
        
        
    }
	
}


- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

	
	[self doInitializeWindow]; // 2010-11-08steve

	switch ( gAppRunMode )
	{
		case eAppRunModeCamera:
			break;
		case eAppRunModeSales:
			break;
		case eAppRunModeDvd:
			// [_mainWindowController setupWatcher]; // force nib to load
			break;
	}

}

- (void)applicationWillTerminate:(NSNotification *)aNotification
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

}


// 2010-11-10steve
-(void)childProcessDidTerminate:(NSNotification *)notification
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	NSLog (@ "Inside %@ => %@...notification = %@", self, NSStringFromSelector(_cmd), notification );
	
	// this way we know that they are done with the full screen quicktime player
	bool isOurWatcherApp = false;
	id watcherApp = [notification userInfo];
	if ( [watcherApp caseInsensitiveCompare:@"Quicktime Player"]==NSOrderedSame )
	{
		isOurWatcherApp = true;
	
		[[[NSWorkspace sharedWorkspace] notificationCenter] removeObserver:self];
	}
	
}






@end
