//
//  BarcodeEntryController.m
//  Teps-Previewer
//
//  Created by steve on 4/15/11.
//  Copyright 2011 TriPrism, Inc. All rights reserved.
//

#import "BarcodeEntryController.h"




extern id getDailyFolderName (void);  // 2014-10-13steve
extern id getDailyFolderName2 (NSString* mydateformat);  // 2014-10-13steve


static BOOL gVerbose = YES; // 2011-06-03steve
static NSString* sDefaultDateFormatString = @"MM-dd-yyyy"; // 2014-10-14@"yyyyMMdd"; // 2014-10-13steve MM-dd-yyyy for BATES

BOOL gVideoIsRecording = NO; // 2014-08-22steve

NSString* sAddStringToBufferNotification = @"AddStringToBuffer";
NSString* sNewCustomerIdNotification = @"NewCustomerId";
static NSString* sTepsPreviewerNotification = @"TepsPreviewerNotification"; // 2011-10-10steve
static NSString * sTepsXNotification = @"tepsXNotification"; // 2011-10-24steve
NSString* cTepsOpenPanelString = @"TepsOpenPanel";
NSString*	sPrefClearWindowForNewCustomerID = @"prefClearWindowForNewCustomerID"; // 2011-10-08steve
NSString* sDoButtonNotification = @"DoButtonNotification";



@implementation BarcodeEntryController

@synthesize fAllowFirstResponder;
@synthesize fTimer;
@synthesize fTimerInterval;
@synthesize fTempBuffer;
@synthesize fNewBarcode;
@synthesize fCurrentBarcode; // 2011-10-08steve
@synthesize fSlideShowBarcode; // 2014-10-13steve
@synthesize voidPtrToBitmap; // 2014-10-13steve





#pragma mark -

- (id) init
{
	if ( self=[super init] )
	{
		if (gVerbose) NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

		self.fTempBuffer = [NSMutableString stringWithString:@""];
		self.fTimer = nil;
		self.fTimerInterval = 0.5;
		self.fAllowFirstResponder = NO;
		self.fCurrentBarcode = nil; // 2011-10-08steve
		self.fNewBarcode = nil; // 2011-10-08steve
		[[NSNotificationCenter defaultCenter] addObserver:self
												 selector:@selector(handleAddStringToBufferNotification:)
													 name:sAddStringToBufferNotification
												   object:nil];
		[[NSNotificationCenter defaultCenter] addObserver:self
												 selector:@selector(handleNewCustomerIdNotification:)
													 name:sNewCustomerIdNotification
												   object:nil];
		
        
        
//		[[NSDistributedNotificationCenter defaultCenter] addObserver:self
//															selector:@selector(handleTepsPreviewerNotification:)	// 2011-10-10steve
//																name:sTepsPreviewerNotification // 2011-10-25steve
//															  object:nil
//												  suspensionBehavior:NSNotificationSuspensionBehaviorDeliverImmediately ]; // 2011-10-25steve
//
//		[[NSDistributedNotificationCenter defaultCenter] addObserver:self
//															selector:@selector(handleTepsVideoNotification:) // 2014-08-22steve
//																name:sTepsXNotification
//															  object:nil
//												  suspensionBehavior:NSNotificationSuspensionBehaviorDeliverImmediately ]; // 2011-10-25steve
		


        
        
	}
	
	return self;
}

-(void) dealloc
{
	if (gVerbose) NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

	[[NSNotificationCenter defaultCenter] removeObserver:self];

	self.fTimer = nil;
	self.fTempBuffer = nil; // 2011-10-08steve [NSMutableString stringWithString:@""];
	self.fNewBarcode = nil; // 2011-10-08steve
	self.fCurrentBarcode = nil; // 2011-10-08steve

	[super dealloc];
}


- (BOOL)acceptsFirstResponder
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );	// 2008-08-14steve
	
	return self.fAllowFirstResponder;
}

- (BOOL)resignFirstResponder
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );	// 2008-08-14steve
	return NO; // 2014-10-13steve
}

#pragma mark -

- (void)cancelOperation:(id)sender
{
	NSLog (@ "Inside %@ => %@... withSEnder=[%@]", self, NSStringFromSelector(_cmd), sender );	// 2008-08-14steve
	NSLog (@ "Inside %@ => %@... withTimer=[%@]", self, NSStringFromSelector(_cmd), self.fTimer );	// 2008-08-14steve

	if ( self.fTimer && [self.fTimer isValid] )
		[self.fTimer invalidate];
	
	self.fTimer = nil;

	[self.fTempBuffer setString:@""];

}

/*
- (void)keyDown:(NSEvent *)theEvent
{
	if (gVerbose) NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );	// 2008-08-14steve
	
	
	BOOL handled = NO;
	
	if (gVerbose) NSLog ( @"2011-04-17steve [theEvent type] = [0x%x]", [theEvent type] );
	if (gVerbose) NSLog ( @"2011-04-17steve [theEvent modifierFlags] = [0x%x]", [theEvent modifierFlags] );
	if (gVerbose) NSLog ( @"2011-08-17steve NSNumericPadKeyMask = [0x%x]", NSNumericPadKeyMask );
	
	if ([theEvent modifierFlags] & NSNumericPadKeyMask) // 2011-08-17steve
	{
		// arrow keys have this mask
        NSString *theArrow = [theEvent charactersIgnoringModifiers];
		unichar keyChar = 0;
        if ( [theArrow length] )
		{
            keyChar = [theArrow characterAtIndex:0];
			if ( keyChar == NSLeftArrowFunctionKey ) {
				handled = YES;
				NSLog ( @"2011-08-17steve keyChar = NSLeftArrowFunctionKey" );
				// 2011-10-08steve [[NSNotificationCenter defaultCenter] postNotificationName:cTepsOpenPanelString object:[theEvent window]];
			}
			if ( keyChar == NSRightArrowFunctionKey ) {
				handled = YES;
				NSLog ( @"2011-08-17steve keyChar = NSRightArrowFunctionKey" );
			}
			if ( keyChar == NSUpArrowFunctionKey ) {
				handled = YES;
				NSLog ( @"2011-08-17steve keyChar = NSUpArrowFunctionKey" );
			}
			if ( keyChar == NSDownArrowFunctionKey ) {
				handled = YES;
				NSLog ( @"2011-08-17steve keyChar = NSDownArrowFunctionKey" );
			}
		}
		else {
			NSLog ( @"2011-08-17steve keyChar = empty" );

		}

		if (handled)
		{
			[super keyDown:theEvent];
			return;
		}
	}
	
	NSString *characters = [[theEvent characters] stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceCharacterSet]];
	unichar mychar = [characters characterAtIndex:0];
	if (gVerbose) NSLog (@"Found Letter [0x%02x] = [%c]", mychar, mychar );

	if ( [theEvent modifierFlags]&(NSCommandKeyMask|NSControlKeyMask|NSAlternateKeyMask) )
	{
		// cmd key was pressed
		if (gVerbose) NSLog (@ "********************************Inside %@ => %@...NSCommandKeyMask|NSControlKeyMask|NSAlternateKeyMask", self, NSStringFromSelector(_cmd) );	// 2008-08-14steve
		if (gVerbose) NSLog (@ "********************************Inside %@ => %@...NSCommandKeyMask|NSControlKeyMask|NSAlternateKeyMask", self, NSStringFromSelector(_cmd) );	// 2008-08-14steve
		
		if ( [theEvent modifierFlags]&(NSCommandKeyMask) ) // 2011-06-03steve
		{
			if ( tolower(mychar)=='1' ) // 2011-06-03steve
			{
				// cmd-1
				[[NSNotificationCenter defaultCenter] postNotificationName:cTepsOpenPanelString object:[theEvent window]];
			}
			else if ( tolower(mychar)=='t' )
			{
				// cmd-t
				// menubar may handle it before it gets here
				NSLog (@ "2011-06-03steve ======================= Found CMD-T" );
			}
			
		}
		
	}
	else {
		
		if ( characters )
		{
			handled = YES;
			NSDictionary* param = [NSDictionary dictionaryWithObjectsAndKeys:characters,@"newString", [NSDate date],@"date", theEvent, @"NSEvent", nil];
			[[NSNotificationCenter defaultCenter] postNotificationName:sAddStringToBufferNotification object:param];
		}

	}

	
	
	
	
	if ( !handled )
		[super keyDown:theEvent];
	
}	
*/


#pragma mark -

- (void) timerFired:(NSTimer*) sender
{
	if (gVerbose) NSLog (@ "Inside %@ => %@... for NSTimer = [%@]", self, NSStringFromSelector(_cmd), sender );

	self.fTimer = nil;

	// we want to clear the buffer
	[self.fTempBuffer setString:@""];
	
}

-(void) resetTimer
{
	if (gVerbose) NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );


	self.fTimer = nil; // want to reset it asap
	self.fTimer = [NSTimer scheduledTimerWithTimeInterval:self.fTimerInterval	// 0.10
												   target:self
												 selector:@selector(timerFired:)
												 userInfo:nil
												  repeats:NO];
	
}



#pragma mark -


-(void) handleTepsVideoNotification:(NSNotification*)note // 2014-08-22steve
{
    NSLog (@ "%@->%@...........................................................................", self, NSStringFromSelector(_cmd) );
    NSLog (@ "%@->%@...with Notif = %@", self, NSStringFromSelector(_cmd), note );
    NSLog (@ "%@->%@...........................................................................", self, NSStringFromSelector(_cmd) );
    
    
//    id param = [note userInfo];
//    
//	id action = [param objectForKey:@"action"];
//    id senderapp = [param objectForKey:@"senderApp"];
//	
//	if (action && senderapp && [senderapp caseInsensitiveCompare:@"Teps-Video.app"]==NSOrderedSame ) // 2014-08-22steve
//	{
//		if ( [action caseInsensitiveCompare:@"statusIsRecording"]==NSOrderedSame ) {
//            gVideoIsRecording = YES;
//            
//        }
//        else if ( [action caseInsensitiveCompare:@"statusNotRecording"]==NSOrderedSame ) {
//            
//            gVideoIsRecording = NO;
//        }
//    }
    
}



// from teps - fills in dictionary in userInfo
-(void) handleTepsPreviewerNotification:(NSNotification*) note	// 2011-10-10steve
{
	// if (gVerbose) 
		NSLog (@ "%@->%@...with Notif = %@", self, NSStringFromSelector(_cmd), note );

	id param = [note userInfo];

	id action = [param objectForKey:@"action"];
	
	if (action)
	{
		if ( [action caseInsensitiveCompare:@"newCustomerSittingStarted"]==NSOrderedSame )
		{
			id newId = [param objectForKey:@"value"];
			
			newId = [newId stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
			
			if (newId )
			{
				NSMutableDictionary* param = [NSMutableDictionary dictionaryWithObjectsAndKeys:newId,@"newBarcode",nil];
                [param setObject:[NSNumber numberWithBool:YES] forKey:@"fromTeps"]; // 2014-07-22steve
				[[NSNotificationCenter defaultCenter] postNotificationName:sNewCustomerIdNotification object:param];
                
                NSLog(@"Just sent sNewCustomerIdNotification with param = %@", param);
			} else {
                NSLog (@ "%@->%@...Not a NEW ID = %@", self, NSStringFromSelector(_cmd), note );

            }
			
		}
	}
	
}


-(void) handleNewCustomerIdNotification:(NSNotification*) note	// 2011-06-03steve
{
    gVerbose = YES; // 2014-07-22steve
    
	if (gVerbose) NSLog (@ "%@->%@...", self, NSStringFromSelector(_cmd) );
	
	id param = [note object];
	NSString* newBarcode = [param objectForKey:@"newBarcode"];
	
	newBarcode = [newBarcode stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]]; // 2011-10-10steve

	if ( [newBarcode length]==0 ) // 2011-10-10steve if empty - dont bother talking to teps
	{
		newBarcode = nil;
	}
	
	// 2011-10-08steve
	BOOL doClearWindowForNewID = YES; // [[NSUserDefaults standardUserDefaults] boolForKey:sPrefClearWindowForNewCustomerID]; // 2011-10-08steve
	if ( doClearWindowForNewID && newBarcode && [newBarcode length] ) // 2011-10-24steve // 2011-10-10steve check for nil newBarcode
	{
		if ( fCurrentBarcode && [fCurrentBarcode caseInsensitiveCompare:newBarcode]==NSOrderedSame )
		{
			// scanned the same barcode - so dont do anything
			if (gVerbose) NSLog ( @"OLD ID is same as NEW ID..." );
			
		}
		else {
            
            
            // 2014-08-22steve - now we cannot start a new session unless the video app is NOT recording
            if (gVideoIsRecording) {
                NSInteger  returnvalue =  [[NSAlert alertWithMessageText:@"WARNING - VIDEO is STILL RECORDING !!!"
                                                           defaultButton:@"Close"
                                                         alternateButton:nil
                                                             otherButton:nil
                                               informativeTextWithFormat:@"PLease Make Sure to STOP the Video Recording First!!!\n\n"] runModal];

                
                if ( returnvalue==NSAlertAlternateReturn) {
                    
                    // tell video to stop
                    
                    // and continue
                    
                } else {
                    return;

                }
                
                
            }
            
            
            
            
			self.fCurrentBarcode = [NSString stringWithString:newBarcode]; // 2011-10-08steve
            
            NSLog(@"GOT NEW BARCODE ID = [%@]",self.fCurrentBarcode); // 2014-10-13steve
            NSLog(@"GOT NEW BARCODE ID = [%@]",self.fCurrentBarcode); // 2014-10-13steve
			
            
		}
		
	}
	
	
}


- (void) handleAddStringToBufferNotification:(NSNotification*) note
{
	if (gVerbose) NSLog (@ "%@->%@...", self, NSStringFromSelector(_cmd) );
	
	id param = [note object];
	
	
	// reset the timer

	if ( self.fTimer && [self.fTimer isValid] )
	{
		[self.fTimer invalidate];
	}
	
	self.fTimer = nil;
	

	
	// add the char to buffer
	BOOL gotEndChar = NO;
	BOOL gotEscChar = NO;
	
	NSString* newString = [[param objectForKey:@"newString"] stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceCharacterSet]];
	if (newString && [newString length])
	{
		if (gVerbose) NSLog ( @"2011-04-17teve trying to evaluate newString = [%@]...", newString );

		unichar lastChar = [newString characterAtIndex:([newString length]-1)];
		if ( lastChar==0x0d ) {
			gotEndChar = YES;
			// if (gVerbose) NSLog ( @"========  Just Found 0x0d   ======" );
		}
		else if (lastChar==0x01b)
		{
			// esc key pressed
			gotEscChar = YES;
		}
		else {
			//NSLog ( @"2011-04-17teve Found newString=[%@]", newString );
			[self.fTempBuffer appendString:[NSString stringWithString:newString]];
		}

	}

	
	// startup a new one
	if ( gotEndChar )
	{
		// if (gVerbose) NSLog ( @"========  gotEndChar is True   ======" );
		if ( self.fTempBuffer )
		{
			self.fNewBarcode = [[self.fTempBuffer copy] autorelease];
			[self.fTempBuffer setString:@""];
			
			// 2011-10-08steve should go thru one method [self	sendAppleEventToTeps:self.fNewBarcode];
			
            
            
            
			// 2011-10-08steve - go thru one method
			NSMutableDictionary* param = [NSMutableDictionary dictionaryWithObjectsAndKeys:self.fNewBarcode,@"newBarcode",nil];
			[[NSNotificationCenter defaultCenter] postNotificationName:sNewCustomerIdNotification object:param];

		}
		else
		{
			if (gVerbose) NSLog ( @"========  self.fTempBuffer is NIL????   ======" );
		}

		if (gVerbose) NSLog ( @"========  fTempBuffer: [%@]   ======", self.fTempBuffer );
		
		NSLog ( @"%@  ========  fNewBarcode: [%@]   ======", self, self.fNewBarcode );
		NSLog ( @"%@  ========  fNewBarcode: [%@]   ======", self, self.fNewBarcode );
		// 2014-10-20steve NSBeep();
		// 2014-10-20steve NSBeep();
        
        
        // 2014-11-04steve FOUND A SCANNED BARCODE
//        [self FindTepsFilesWithID:[NSString stringWithFormat:@"%@",fNewBarcode]]; // 2014-10-13steve

		

	}
	else {
		if ( gotEscChar )
		{
			if ( self.fTempBuffer )
			{
				[self.fTempBuffer setString:@""];
				NSLog ( @"Reset the fTempBuffer..." );
			}
		}
		
		[self resetTimer];
	}

}
			 

@end
