//
//  DvdStationWindowController.m
//  MyRecorder
//
//  Created by steve on 11/3/10.
//  Copyright 2010 TriPrism, Inc. All rights reserved.
//

#import "DvdStationWindowController.h"
#import "NSTextField+TepsAdditions.h"
#import "TepsExtras.h"
#import "MyAliasKit.h"
#import "watcher.h"
#import "Preferences.h"


/*
 
 /LocalCameraFolder/2010-11-09/nextMovie_002.mov
	|	|	|
	V	V	V
 /Server/MasterOriginalMovies/2010-11-09/nextMovie_002.mov
 /Server/MasterOriginalMovies/2010-11-09/_Purchased/nextMovie_002.mov
 /Server/MasterOriginalMovies/2010-11-09/_NotPurchased/nextMovie_002.mov
	|	|	|
	V	V	V
 /DvdsToBeBurnedFolder/2010-11-09/nextMovie_002.mov
	V	V	V
 /DvdsToBeBurnedFolder/2010-11-09/_Processed/nextMovie_002.mov
 /LocalDvdStationFolder/WorkingFolder/nextMovie_002.mov
 
*/


#define ShowBOOL(x) x?@"YES":@"NO"

// 2011-11-04steve never utilized other than creating empty folder static NSString* sLocalWorkingFolderName = @"WorkingFolderForProcess";
NSString* sPrefProcessedSubFolderName = @"_FinishedDvds";
NSString* localWorkingFolderPath = @"/TepsDvdTempFolder";

NSString* beginningChapterMovieName = @"??Chapter1.mov"; // 2011-11-04steve add??	// 2010-11-16steve
NSString* endingChapterMovieName = @"??Chapter3.mov";	// 2011-11-04steve add??

NSString* masterDvdFolderPath = @"/MasterDvdContentFolder";
NSString* cDefaultDvdTitleFormat = @"%@+Santa at The Grove";


NSString* sPrefDvdTitleStringFormat = @"prefDvdTitleStringFormat"; // 2010-11-13

NSString* sPrefMasterDvdFolderKey = @"prefMasterDvdFolderFolder"; // 2011-11-04steve sPrefMasterDvdFolderFolder // 2010-11-13
NSString* sPrefLocalWorkingFolderKey = @"prefLocalWorkingFolder"; // 2011-11-04steve // 2010-11-13
NSString* sPrefBeginningChapterNameKey = @"prefBeginningChapterName"; // 2011-11-04steve
NSString* sPrefEndingChapterNameKey = @"prefEndingChapterName"; // 2011-11-04steve



extern NSString* runThisShellScript ( NSString*scriptName, NSArray*paramArray );
extern NSInteger mySortByDate(id path1, id path2, void *info);



#pragma mark -
@implementation DvdStationWindowController

@synthesize _mInstalledWatcherPath;
@synthesize _mCurrentMovieTitle;
@synthesize _mCurrentMoviePath;
@synthesize _mCurrentMoviesToBurnList;
@synthesize mCurWorkingPath;


#pragma mark -

-(BOOL)launchChildProcess:(NSDictionary *)d
{
    BOOL didLaunch = NO;
    
    NSString * launchPath = [d objectForKey:@"NSApplicationPath"];
    FSRef appToLaunch;
    OSStatus err = FSPathMakeRef((const UInt8 *)[launchPath fileSystemRepresentation], &appToLaunch, NULL);
    if (noErr == err)
    {
        id environmentDict = [d objectForKey:@"NSApplicationEnvironment"];
        id argvArray = [d objectForKey:@"NSApplicationArgv"];
        AppleEventPtr initialEvent = (AppleEventPtr)[[d objectForKey:@"NSApplicationInitialAppleEvent"] aeDesc];
        LSLaunchFlags flags = [[d objectForKey:@"NSApplicationLaunchFlags"] unsignedLongValue];
        LSApplicationParameters appParams = {0, flags, &appToLaunch, self, (CFDictionaryRef)environmentDict, (CFArrayRef)argvArray, initialEvent};
        ProcessSerialNumber outPSN = {0,0};
        err = LSOpenApplication(&appParams, &outPSN);
        //kEventAppLaunchNotification;
        
        if(noErr == err && (outPSN.lowLongOfPSN | outPSN.highLongOfPSN))
        {
            didLaunch = YES;
            NSMutableDictionary * m = [[d mutableCopy] autorelease];
            [m setObject:[NSNumber numberWithUnsignedLong:outPSN.lowLongOfPSN] forKey:@"NSApplicationProcessSerialNumberLow"];
            [m setObject:[NSNumber numberWithUnsignedLong:outPSN.highLongOfPSN] forKey:@"NSApplicationProcessSerialNumberHigh"];
            d = [[m copy] autorelease];
            [_childProcesses addObject:d];
        }
    }
    //nsvErr
    return didLaunch;
}


#pragma mark -

-(IBAction) deleteItemsInLocalWorkingFolder:(id)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

	NSString* thePath = [NSString stringWithString:localWorkingFolderPath];
	
	NSError* error = nil;
	BOOL isDirectory = NO;
	BOOL exists = [[NSFileManager defaultManager] fileExistsAtPath:thePath isDirectory:&isDirectory];
	if ( exists && isDirectory )
	{

		bool didDelete = [[NSFileManager defaultManager] removeItemAtPath:thePath error:&error];
		if (error)
		{
			NSLog (@ "Inside %@ => %@...removeItemAtPath has error = %@", self, NSStringFromSelector(_cmd), error );
		}
	
	
	}
	
}


// 2010-11-10steve
-(BOOL) updateWorkingDirectory
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	return true; // 2011-11-04steve - never used
	
	
	// 2011-11-04steve NSString* curWorkingPath = getWorkingDirectoryPath(sLocalWorkingFolderName);
	NSString* curWorkingPath = getWorkingDirectoryPath(localWorkingFolderPath); // 2011-11-04steve
	
	
	NSLog ( @"2010-11-11steve curWorkingPath is [%@]", curWorkingPath );
	BOOL didCreate = createDirectoryIfMissing (curWorkingPath);
	if ( didCreate )
	{
		self.mCurWorkingPath = curWorkingPath;
	}
	else 
	{
		NSLog ( @"2010-11-11steve ERROR - unable to create current working directory???" );
	}
	
	return didCreate;
	
}


- (void)awakeFromNib
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

	
	[self setWindowFrameAutosaveName:@"DvdStationWindow"]; 
	
	
	// 2011-11-04steve - use factory default
	endingChapterMovieName = [[NSUserDefaults standardUserDefaults] stringForKey:sPrefEndingChapterNameKey]; // 2011-11-04steve
	beginningChapterMovieName = [[NSUserDefaults standardUserDefaults] stringForKey:sPrefBeginningChapterNameKey]; // 2011-11-04steve
	masterDvdFolderPath = [[NSUserDefaults standardUserDefaults] stringForKey:sPrefMasterDvdFolderKey]; // 2011-11-04steve
	localWorkingFolderPath = [[NSUserDefaults standardUserDefaults] stringForKey:sPrefLocalWorkingFolderKey]; // 2011-11-04steve

	
	
	// delete items local working directory - if exists
	[self deleteItemsInLocalWorkingFolder:nil];
	
	// 2010-11-13steve createDirectoryIfMissing(masterDvdFolderPath);
	// 2011-11-04steve use factory default above NSString* userMasterDvdFolderPath = [[NSUserDefaults standardUserDefaults] stringForKey:sPrefMasterDvdFolderFolder];
	
	createDirectoryIfMissing(masterDvdFolderPath); // 2011-11-04steve

	{
		// 2010-11-16steve
		// check for missing REQUIRED movies
		NSArray* contents = [[NSFileManager defaultManager] directoryContentsAtPath:masterDvdFolderPath]; // 2011-11-04steve
		NSLog (@"2010-11-16steve directoryContentsAtPath:[%@] = %@", masterDvdFolderPath, contents );
		NSLog (@"2010-11-16steve count = %i", [contents count] );
		NSLog (@"2010-11-16steve count = %i", [contents count] );
		if ( contents==nil || [contents count]==0 )
		{
			bool doAlert = true;
			if (doAlert)
			{
				NSAlert* alert = [[NSAlert alloc] init];
				[alert setMessageText:[NSString stringWithFormat:@"Folder [%@] Empty or Missing...", masterDvdFolderPath ]];
				[alert setInformativeText:[NSString stringWithFormat:@"Make sure this folder is created and does contain the movies: %@ and %@...", beginningChapterMovieName, endingChapterMovieName]];
				[alert addButtonWithTitle:@"OK"];
				
				[[NSApplication sharedApplication] activateIgnoringOtherApps: YES];
				[alert runModal];
				
				[alert release];
				alert = nil;
			}
		}
		else
		{

			BOOL exists1 = [[NSFileManager defaultManager] fileExistsAtPath:[[NSString stringWithString:masterDvdFolderPath] stringByAppendingPathComponent:beginningChapterMovieName]];
			BOOL exists2 = [[NSFileManager defaultManager] fileExistsAtPath:[[NSString stringWithString:masterDvdFolderPath] stringByAppendingPathComponent:endingChapterMovieName]];

			NSString* mesg = @"";
			if ( !exists1 && !exists2 )
			{
				mesg = [NSString stringWithFormat:@"Missing Required Movies: %@ and %@",beginningChapterMovieName, endingChapterMovieName];
			}
			else if ( !exists1 )
			{
				mesg = [NSString stringWithFormat:@"Missing Movie: %@",beginningChapterMovieName];
			}
			if ( !exists2 )
			{
				mesg = [NSString stringWithFormat:@"Missing Movie: %@", endingChapterMovieName];
			}
			
			if ( !(exists1 && exists2) )
			{
				bool doAlert = true;
				if (doAlert)
				{
					NSAlert* alert = [[NSAlert alloc] init];
					[alert setMessageText:[NSString stringWithFormat:@"Missing Required Items in Folder:\r[%@]...", masterDvdFolderPath ]];
					[alert setInformativeText:mesg];
					[alert addButtonWithTitle:@"OK"];
					
					[[NSApplication sharedApplication] activateIgnoringOtherApps: YES];
					[alert runModal];
					
					[alert release];
					alert = nil;
				}
			}
			
		}
		
	}
	
	
	BOOL allValid = [self validateAllFolders];
	
	if ( allValid )
	{
		[_myNSTabView selectTabViewItemAtIndex:0];
	}
	else
	{
		[_myNSTabView selectTabViewItemAtIndex:2];
	}
	
	
	
	
	_mStartedProcess = NO;
	_mFoundNewMovie = NO;
	_mInstalledWatcher = NO;
	self._mInstalledWatcherPath = nil;
	self._mCurrentMoviePath = nil;
	self._mCurrentMoviesToBurnList = nil;
	
	
	NSNotificationCenter* nc = [NSNotificationCenter defaultCenter];
	[nc addObserver:self
		   selector:@selector(handleNotification_WatcherStarted:)
			   name:cNotification_WatcherStarted
			 object:nil];
	
	
	[self setupWatcher]; // 2010-11-11steve

	
	[NSThread detachNewThreadSelector:@selector(handleWatcherItemChangedFunctionInThread:) toTarget:self withObject:nil];	

	
	[[self window] makeKeyAndOrderFront:nil];
	
	bool doTest = false;
	if (doTest)
	{
		NSArray* testObj = [NSArray arrayWithObjects:@"param1",@"param2",nil];
		NSLog (@"2010-11-06steve testObj returned: %@", testObj  );
		NSLog (@"2010-11-06steve testObj class is: %@", [testObj class]  );
		NSLog (@"2010-11-06steve [testObj isKindOfClass:[NSMutableArray class] is: %@", ShowBOOL([testObj isMemberOfClass:[NSMutableArray class]])  );
		NSLog (@"2010-11-06steve [testObj isKindOfClass:[NSArray class] is: %@", ShowBOOL([testObj isMemberOfClass:[NSArray class]])  );
		
		id returnObject = [self prepareFolderForBurn];
		NSLog (@"2010-11-06steve returnObject returned: %@", returnObject  );
		NSLog (@"2010-11-06steve returnObject class is: %@", [returnObject class]  );
		NSLog (@"2010-11-06steve [returnObject isKindOfClass:[NSMutableArray class] is: %@", ShowBOOL([returnObject isMemberOfClass:[NSMutableArray class]])  );
		NSLog (@"2010-11-06steve [returnObject isKindOfClass:[NSArray class] is: %@", ShowBOOL([returnObject isMemberOfClass:[NSArray class]])  );
		[NSApp terminate:self];
	}
	
    
    BOOL dolaunchusbburner = NO; // 2013-11-06steve YES;    // 2013-08-15steve - if USING FLASH DRIVES

    if (dolaunchusbburner) {
        NSString* sPrefLaunchChildApp = @"prefLaunchChildApp3"; // 2011-09-27steve
        NSString* myBundlePath = [[NSBundle mainBundle] bundlePath ];
        NSString* myAppNameToLaunch = [[NSUserDefaults standardUserDefaults] stringForKey:sPrefLaunchChildApp];
        
        if ( myAppNameToLaunch) {
            _childProcesses = [[NSMutableSet alloc] initWithCapacity:0];
            NSString* pathToApp = nil;
            NSArray* pathsToSearch = [NSArray arrayWithObjects:myBundlePath, @"/Applications",@"/Applications/TEPS OS X Share Folder",nil];
            for ( id subpath in pathsToSearch) {
                pathToApp = [subpath stringByAppendingPathComponent:myAppNameToLaunch];
                BOOL exists = [[NSFileManager defaultManager] fileExistsAtPath:pathToApp];
                if (!exists)
                    pathToApp = nil;
                else {
                    break;
                }
                
            }
            if(pathToApp) {
                LSLaunchFlags flags = kLSLaunchDontAddToRecents | kLSLaunchDontSwitch | kLSLaunchAndHide;
                [self launchChildProcess:[NSDictionary dictionaryWithObjectsAndKeys:pathToApp, @"NSApplicationPath",
                                          [NSNumber numberWithUnsignedLong:flags], @"NSApplicationLaunchFlags",
                                          nil]];
            }
        }
    }
    
    
    

}


-(void) dealloc
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

	NSNotificationCenter* nc = [NSNotificationCenter defaultCenter];
	[nc removeObserver:self
				  name:cNotification_WatcherItemChanged
				object:nil];
	
	[super dealloc];
	
}

- (void) doSetupWatchFolderInThread:(id) info
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];

	NSString* pathToWatch = [NSString stringWithString:info];
	BOOL isDirectory = NO;
	BOOL exists = [[NSFileManager defaultManager] fileExistsAtPath:pathToWatch isDirectory:&isDirectory];
	if ( exists && isDirectory )
	{
		NSNotificationCenter* nc = [NSNotificationCenter defaultCenter];
		[nc addObserver:self
			   selector:@selector(handleNotification_WatcherItemChanged:)
				   name:cNotification_WatcherItemChanged
				 object:nil];
		
		
		char fullpath[500];
		memset ( fullpath,0,sizeof(fullpath) );
		sprintf ( fullpath,"%s", [pathToWatch cStringUsingEncoding:NSMacOSRomanStringEncoding] );
		
		doInstallTheWatcher(fullpath);
		
		
	}
	else
	{
		NSLog (@ "Inside %@ => %@... FAILED to install the watcher - folder does NOT exists?", self, NSStringFromSelector(_cmd) );
	}
	
	
	
	if ( pool )	[pool release];

}


-(void) setupWatcher
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

	NSString* pathToWatch = getDailyFolderPathForToBeBurnedFolder(); // 2010-11-11 [[NSUserDefaults standardUserDefaults] objectForKey:sPrefToBeBurnedFolder];
	if ( pathToWatch==nil )
	{
		NSBeep();
		NSLog (@ "Inside %@ => %@...NEED to set preference for sPrefToBeBurnedFolder...", self, NSStringFromSelector(_cmd) );
		return;
	}
	
	[NSThread detachNewThreadSelector:@selector(doSetupWatchFolderInThread:) toTarget:self withObject:pathToWatch];

	
}


- (void) handleNotification_WatcherStarted:(NSNotification*) note
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	NSLog (@ "Inside %@ => %@...", [self class], NSStringFromSelector(_cmd) );
	
	_mInstalledWatcher = YES;
	NSString* pathToWatch = getDailyFolderPathForToBeBurnedFolder();	// 2010-11-11 [[NSUserDefaults standardUserDefaults] objectForKey:sPrefToBeBurnedFolder];

	if ( self._mInstalledWatcherPath == nil )
	{
		// great
		
		self._mInstalledWatcherPath = [NSString stringWithString:pathToWatch];
	}
	else
	{
		// we NEED to STOP the previous watched folder

	
	
	}

	
	
	if (pool) [pool release];
}

- (void) handleNotification_WatcherItemChanged:(NSNotification*) note
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	NSLog (@ "Inside %@ => %@...", [self class], NSStringFromSelector(_cmd) );
	
	NSDictionary* parameters = [NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithBool:YES],@"doSpeak",nil];
	[NSThread detachNewThreadSelector:@selector(handleWatcherItemChangedFunctionInThread:) toTarget:self withObject:parameters];	
		
	if (pool) [pool release];
}




#pragma mark -

-(BOOL) showTabForError:(BOOL) isValid
{
	if ( isValid )
	{
		
	}
	else
	{
		[_myNSTabView selectTabViewItemAtIndex:2];
	}
	return YES;
}


-(BOOL) validateAllFolders
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

	
	// 2010-11-11steve create the local working directory
	[self updateWorkingDirectory];
	
	createDirectoryIfMissing(localWorkingFolderPath);
	createDirectoryIfMissing(masterDvdFolderPath);
	
	
	
	NSDictionary* parameters = nil;
	
	parameters = [NSDictionary dictionaryWithObjectsAndKeys:
				  sPrefToBeBurnedFolder, sPrefFolderNameKey,
				  sPrefToBeBurnedFolderAliasData, sPrefFolderAliasDataKey,
				  sPrefToBeBurnedFolderIsValid, sPrefFolderNameIsValidKey,
				  nil];
	BOOL validate1 = validateFolderPrefWithParam (parameters ); // 2010-11-12steve [self validateFolderPrefWithParam:parameters];
	
	parameters = [NSDictionary dictionaryWithObjectsAndKeys:
				  sPrefFinishedDvdFolder, sPrefFolderNameKey,
				  sPrefFinishedDvdFolderAliasData, sPrefFolderAliasDataKey,
				  sPrefFinishedDvdFolderIsValid, sPrefFolderNameIsValidKey,
				  nil];
	BOOL validate2 = validateFolderPrefWithParam (parameters ); // 2010-11-12steve [self validateFolderPrefWithParam:parameters];
	
	NSLog ( @"2010-11-03steve validate1 = %@", validate1?@"YES":@"NO" );
	NSLog ( @"2010-11-03steve validate2 = %@", validate2?@"YES":@"NO" );

	BOOL allValid = (validate1 && validate2);
	if ( allValid )
	{
		// great - all found
		createDirectoryIfMissing ( getDailyFolderPathForToBeBurnedFolder() ); // 2010-11-11steve
		createDirectoryIfMissing ( getDailyFolderPathForFinishedDvds() ); // 2010-11-11steve
		

	}
	else
	{
		// need to open in Pref Tab
		NSInteger returnValue = NSRunAlertPanel (	@"Alert",
												 @"Please Point To Valid Folders...",
												 @"OK",	// default
												 nil,	// alternate
												 nil,		// NSAlertOtherReturn
												 @"param1",
												 @"param2"
												 );
		
	}
	
	return allValid;
}

#pragma mark -



-(void) createAVMovieViewController
{
    if ( self.mAVMovieViewController ==nil )
    {
        self.mAVMovieViewController = nil;
        
        self.mAVMovieViewController = [[[AVMovieViewController alloc]initWithNibName:@"AVMovieView" bundle:nil] autorelease];
        if (self.mAVMovieViewController) {
            [self.mAVMovieViewController loadView];
            
            // the the mqtmovie
            NSRect frame = _myQTMovieView.frame;
            NSWindow* window = _myQTMovieView.window;
            NSView* superview = _myQTMovieView.superview;
            
            
            NSLog(@"_mQTMovieView.frame = %@", NSStringFromRect(_myQTMovieView.frame) );
            
            NSView* contentview = superview; // window.contentView;
            if (contentview) {
                [contentview addSubview:self.mAVMovieViewController.view];
                self.mAVMovieViewController.view.frame = frame;
                NSLog(@"self.mAVMovieViewController.view.frame = %@", NSStringFromRect(self.mAVMovieViewController.view.frame) );
                
                BOOL doLoadTest = NO;
                if (doLoadTest) {
                    NSString* pathToMovie = @"/Users/Shared/serge720.mov";
                    // pathToMovie = @"/Users/Shared/ntsc.mov";
                    
                    BOOL exists = [[NSFileManager defaultManager] fileExistsAtPath:pathToMovie];
                    if ( exists==NO ) {
                        NSLog(@"movie file path does NOT exist = %@", pathToMovie);
                    }
                    
                    self.mAVMovieViewController.fileURL = [NSURL fileURLWithPath:pathToMovie];
                    
                    NSLog(@"fileURL = %@", self.mAVMovieViewController.fileURL);
                    
                    if (self.mAVMovieViewController.fileURL) {
                        AVURLAsset* asset = [AVURLAsset URLAssetWithURL:self.mAVMovieViewController.fileURL options:nil];
                        CGFloat aspectratio = asset.naturalSize.width / asset.naturalSize.height;
                        NSSize size = NSMakeSize(asset.naturalSize.width, asset.naturalSize.height);
                        NSLog(@"movie naturalSize = %@", NSStringFromSize(size));
                        NSLog(@"movie aspectRatio = %5.2f", aspectratio );
                        
                        NSArray* videotracks = [asset tracksWithMediaType:AVMediaTypeVideo];
                        NSLog(@"videotracks = %@", videotracks);
                    	if ([videotracks count] != 0) {
                            AVAssetTrack* firsttrack = [videotracks objectAtIndex:0];
                            NSLog(@"first track = %@", firsttrack);
                            
                            CGFloat aspectratio = firsttrack.naturalSize.width / firsttrack.naturalSize.height;
                            NSSize size = NSMakeSize(firsttrack.naturalSize.width, firsttrack.naturalSize.height);
                            NSLog(@"firsttrack naturalSize = %@", NSStringFromSize(size));
                            NSLog(@"firsttrack aspectRatio = %5.2f", aspectratio );
                            
                        }
                        
                    }
                    
                    [self.mAVMovieViewController setup];
                }
            }
            
        }
        
    } else {
        // [self.mAVMovieViewController close];
        
    }
    
}

-(void) setAVMovie:(NSString*) moviePath
{
    // 2013-11-03steve - fix crashing when in findNextMovie mode and AVFoundation
    if ( moviePath==nil)
        return;
    moviePath = [moviePath stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
    if ([moviePath length]==0) {
        return;
    }
    
    
    [_myQTMovieView setMovie:nil]; // 2013-10-22steve
    [_myQTMovieView setHidden:YES]; // 2013-10-22steve
    
    [self.mAVMovieViewController close];
	//[self.mAVMovieViewController.player pause];
    
    
    [self createAVMovieViewController];
    
    if (self.mAVMovieViewController ) {
        BOOL exists = [[NSFileManager defaultManager] fileExistsAtPath:moviePath];
        if ( exists==NO ) {
            NSLog(@"movie file path does NOT exist = %@", moviePath);
            self.mAVMovieViewController.fileURL = nil;
            
        } else {
            self.mAVMovieViewController.fileURL = [NSURL fileURLWithPath:moviePath];
            [self.mAVMovieViewController setup];
            
        }
    }
    
}


-(void) setupMovie:(NSString*)moviePath
{
    // 2013-11-06steve
    BOOL doUseAVFoundation = [[NSUserDefaults standardUserDefaults]boolForKey:@"prefUseAVFoundation"];
    if ( doUseAVFoundation) {
        [self setAVMovie:moviePath]; // 2013-10-22steve
        return; // 2013-10-22steve
    }
    
    // 2013-11-06steve
    self.mAVMovieViewController.view.hidden = YES;
    [self.mAVMovieViewController.view removeFromSuperview];
    [self.mAVMovieViewController close];
    self.mAVMovieViewController = nil;
    [_myQTMovieView setHidden:NO];

    
    
	if ( moviePath )
	{
		NSError* errorPtr=nil;
		QTMovie* myMovie = [QTMovie movieWithFile:moviePath error:&errorPtr];
		if ( errorPtr )
		{
			NSLog (@ "Inside %@ => %@... movieWithFile returned error: %@", self, NSStringFromSelector(_cmd), errorPtr );
			[_myQTMovieView setHidden:YES];				
		}
		else
		{
			[_myQTMovieView setMovie:myMovie];
		}
		
		
		
	}
}


-(void) handleWatcherItemChangedFunctionInThread:(id)sender
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];

	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	NSLog (@ "Inside %@ => %@... sender = [%@]", self, NSStringFromSelector(_cmd), sender );

	NSString* mesg = nil;
	short totalNewMovies = [self getTotalInNewMoviesFolder];
	if ( totalNewMovies>=0 )
	{
		NSBeep();
		mesg = [NSString stringWithFormat:@"%i", totalNewMovies];
	}
	else
	{
		mesg = [NSString stringWithString:@"< ??? >"];
	}
	
	[_myNSTextFieldStatus ibUpdateNSTextFieldWithString:mesg doWait:NO isError:NO];
	
	
	bool doSpeak = [sender objectForKey:@"doSpeak"];
	if ( doSpeak )
	{
		NSSpeechSynthesizer* speech = [[NSSpeechSynthesizer alloc] initWithVoice:[NSSpeechSynthesizer defaultVoice]];
		[speech startSpeakingString:@"Movie Folder Changed"];
		[speech autorelease];
	}
	
	
	[pool release];
}

-(short) getTotalInNewMoviesFolder
{
	short totalNewMovies = 0;
	
	// NSUserDefaults* prefMgr = [NSUserDefaults standardUserDefaults];
	NSString* myFolderPath = getDailyFolderPathForToBeBurnedFolder();	// 2010-11-11 [prefMgr objectForKey:sPrefToBeBurnedFolder];  // @"/DailyMoviesToBurn";
	
	NSFileManager* mgr = [NSFileManager defaultManager];
	NSError* error = nil;
	
	BOOL isDirectory = NO;
	BOOL exists = [mgr fileExistsAtPath:myFolderPath isDirectory:&isDirectory];
	if ( !(exists && isDirectory) )
	{
		return -1;
	}
	
	
	
	NSArray * filesArray = [mgr contentsOfDirectoryAtPath:myFolderPath error:&error];
	if ( error !=nil )
	{
		NSLog(@"Error in getting contentsOfDirectoryAtPath %@: %@", myFolderPath, [error localizedDescription]);
	}
	
	if ( filesArray==nil || ([filesArray count] <=0) )
	{
		NSBeep();
		NSLog (@ "There's NO More New Movies..." );
		bool doAlert = false;
		if ( doAlert )
		{
			NSInteger returnValue = NSRunAlertPanel (	@"Alert",
													 @"NO New Movie To Process, Yet...\rTry Again Later...",
													 @"OK",	// default
													 nil,	// alternate
													 nil,		// NSAlertOtherReturn
													 @"param1",
													 @"param2"
													 );
		}
		
		return totalNewMovies;
	}
	
	
	// sort by creation date
	BOOL isHidden = NO;
	// BOOL isDirectory = NO;
	BOOL isTempItem = NO;
    NSMutableArray* filesAndProperties = [NSMutableArray arrayWithCapacity:[filesArray count]];
    for(NSString* file in filesArray)
	{
		isHidden = NO;
		isDirectory = NO;
		isTempItem = NO;
		
		NSString* baseName = [file lastPathComponent];
		NSRange foundRange = [baseName rangeOfString:@"."];
		// NSLog ( @"Checking if HIDDEN File => [%i][%i]\n", foundRange.location, foundRange.length );
		if ( foundRange.location==0 && foundRange.length )
		{
			// NSLog ( @"THIS IS A HIDDEN FILE" );
			isHidden = YES;
		}
		
		foundRange = [baseName rangeOfString:@"temp"]; // 2010-11-05steve
		if ( foundRange.location==0 && foundRange.length )
		{		
			isTempItem = YES;
		}
		
		NSString* fullFilePath = [myFolderPath stringByAppendingPathComponent:file];
		bool exists = [mgr fileExistsAtPath:fullFilePath isDirectory:&isDirectory];
		if ( !exists )
		{
			NSLog ( @"2010-11-03steve - WHAT?? file [%@] does NOT exist???", fullFilePath );
		}
		
		if ( isHidden || isDirectory || isTempItem || !exists ) // 2010-11-05steve
		{
			// we need to skip
		}
		else
		{
			NSDictionary* properties = [[NSFileManager defaultManager]
										attributesOfItemAtPath:fullFilePath
										error:&error];
			NSDate* modDate = [properties objectForKey:NSFileModificationDate];
			
			if(error == nil)
			{
				[filesAndProperties addObject:[NSDictionary dictionaryWithObjectsAndKeys:
											   fullFilePath, @"path",
											   modDate, @"lastModDate",
											   nil]];                 
			}
		}
		
		
    }
	
	totalNewMovies = [filesAndProperties count];
	
	return totalNewMovies;

}



#pragma mark -

-(id) prepareFolderForBurn
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

	NSMutableArray* theNewContentList = nil;
	
	BOOL success = NO;
	// make sure the MASTER DVD Folder exists
	{
		NSString* thePath = [NSString stringWithString:masterDvdFolderPath];
		NSFileManager* mgr = [NSFileManager defaultManager];
		BOOL isDirectory = NO;
		BOOL exists = [mgr fileExistsAtPath:thePath isDirectory:&isDirectory];
		if ( exists && isDirectory )
		{
			success = YES;
		}
		else
		{
			NSLog ( @"2010-11-06steve Missing the path: %@", thePath );
		}
	}
	
// 2010-11-12steve remove unused folder
//	// make sure the sourceImageDvdFolder exists
//	{
//		NSString* thePath = [NSString stringWithString:sourceDvdFolderPath];
//		NSFileManager* mgr = [NSFileManager defaultManager];
//		BOOL isDirectory = NO;
//		BOOL exists = [mgr fileExistsAtPath:thePath isDirectory:&isDirectory];
//		if ( exists && isDirectory )
//		{
//			success = YES;
//		}
//		else
//		{
//			NSLog ( @"2010-11-06steve Missing the path: %@", thePath );
//		}
//	}
//	
	
	// format the titleOfTheDVD
	
	{
		NSString* childsName = [NSString stringWithString: self._mCurrentMoviePath];
		childsName = [childsName lastPathComponent];
		
		NSString *baseID = [NSString stringWithString:[childsName stringByDeletingPathExtension]];
		NSRange foundRange = [childsName rangeOfString:@"_"];
		if ( foundRange.location == NSNotFound )
		{
			NSLog ( @"NOT Found..." );
			baseID = @"ME";
		}
		else
		{
			NSLog ( @"FoundRange={%i,%i}", foundRange.location, foundRange.length );
			NSRange newRange;
			newRange.location = 0;
			newRange.length = foundRange.location;
			baseID = [NSString stringWithString:[childsName substringWithRange:newRange]];
			NSLog ( @"Found BaseID = [%@]", baseID );
			
		}
		
		NSString* dvdTitleFormat = [[NSUserDefaults standardUserDefaults] stringForKey:sPrefDvdTitleStringFormat]; // 2010-11-13steve
		if ( dvdTitleFormat==nil )
			dvdTitleFormat = [NSString stringWithString:cDefaultDvdTitleFormat];
		
		self._mCurrentMovieTitle = [NSString stringWithFormat:dvdTitleFormat,[baseID uppercaseString]]; // 2010-11-13steve
		NSLog ( @"2010-11-06steve self._mCurrentMovieTitle = %@", self._mCurrentMovieTitle );
	}
	
	
	if ( success )
	{
		NSLog (@ "Inside %@ => %@... success -trying to create list", self, NSStringFromSelector(_cmd) );
		// we want to pass the three chapters to the burn script
		// OR 
		// we combine all three chapters here
		//
		{
			
			theNewContentList = [[NSMutableArray alloc] initWithCapacity:1];
			// 1st object
			[theNewContentList addObject:[[NSString stringWithString:masterDvdFolderPath] stringByAppendingPathComponent:beginningChapterMovieName]]; // 2010-11-16steve
			
			// 2nd object
			if ( self._mCurrentMoviePath )
				[theNewContentList addObject:[NSString stringWithString:self._mCurrentMoviePath]];
			
			// 3rd object
			[theNewContentList addObject:[[NSString stringWithString:masterDvdFolderPath] stringByAppendingPathComponent:endingChapterMovieName]]; // 2010-11-16steve
			
			NSLog (@"2010-11-06steve [theNewContentList class] is: %@", [theNewContentList class]  );
			NSLog (@"2010-11-06steve [theNewContentList isKindOfClass:[NSMutableArray class] is: %@", ShowBOOL([theNewContentList isKindOfClass:[NSMutableArray class]])  );
			NSLog (@"2010-11-06steve [theNewContentList isKindOfClass:[NSArray class] is: %@", ShowBOOL([theNewContentList isKindOfClass:[NSArray class]])  );

			NSLog ( @"2010-10-11steve - theNewContentList is: %@", theNewContentList );
		}
	}
	
	
	return [theNewContentList autorelease];
}
-(BOOL) processResponseFromScript:(NSString*) response
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	NSString *response2 = [response stringByTrimmingCharactersInSet:[NSCharacterSet newlineCharacterSet]];

	if ( [response2 caseInsensitiveCompare:@"success"]==NSOrderedSame )
	{
		return YES;
	}
	if ( [response2 caseInsensitiveCompare:@"task failed."]==NSOrderedSame )
	{
		NSBeep();
		
		bool doAlert = false;
		if (doAlert)
		{
			NSAlert* alert = [[NSAlert alloc] init];
			[alert setMessageText:@"Problem while running the script..."];
			[alert setInformativeText:response];
			[alert addButtonWithTitle:@"OK"];
			
			[[NSApplication sharedApplication] activateIgnoringOtherApps: YES];
			NSInteger answer = [alert runModal];
			
			[alert release];
			alert = nil;
		}
		
		//			NSInteger returnValue = NSRunAlertPanel (	@"Alert",
		//													 @"Toast Titanium is BUSY and Requires Your Attention...",
		//													 @"OK",	// default
		//													 nil,	// alternate
		//													 nil,		// NSAlertOtherReturn
		//													 @"param1",
		//													 @"param2"
		//													 );
	}
	else
	{
		
		//			NSInteger returnValue = NSRunAlertPanel (	@"Alert",
		//													 @"Toast Titanium is Still Busy...",
		//													 @"OK",	// default
		//													 nil,	// alternate
		//													 nil,		// NSAlertOtherReturn
		//													 @"param1",
		//													 @"param2"
		//													 );
		
	}
	
	return NO;
}



-(BOOL) tellToastToQuit
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

	BOOL didQuit = NO;
	
	NSString* scriptName = @"quitToast.scpt";
	NSBundle *bundle = [NSBundle mainBundle];
	NSString *scriptPath = [bundle pathForAuxiliaryExecutable:scriptName];
	if ( scriptPath==nil )
	{
		NSLog ( @"2010-11-04steve Could NOT find Script named: %@", scriptName);
		return NO;
	}
	else
	{
		NSLog ( @"2010-11-04steve Found Script named: %@", scriptPath);
	}
	
	
	bool doOsaScript = true;
	if ( doOsaScript )
	{
		NSString *scriptName = @"/usr/bin/osascript";
		NSArray *paramArray = [NSArray arrayWithObjects:scriptPath,nil];
		NSString* response2 = runThisShellScript ( scriptName, paramArray );
		NSLog ( @"2010-11-03steve response2 = [%@]", response2 );
		
		didQuit = [self processResponseFromScript:response2];
		
	}
	
	NSLog ( @"2010-11-04steve didQuit = %@", ShowBOOL(didQuit) );
	
	return didQuit;
}

-(BOOL) getNextMovieToBurn
{
	BOOL foundNextMovie = NO;
	
	
	// NSUserDefaults* prefMgr = [NSUserDefaults standardUserDefaults];
	NSString* myFolderPath = getDailyFolderPathForToBeBurnedFolder(); // 2010-11-11 [prefMgr objectForKey:sPrefToBeBurnedFolder];  // @"/DailyMoviesToBurn";
	NSString* myProcessPath = getDailyFolderPathForFinishedDvds();	// 2010-11-11 [prefMgr objectForKey:sPrefFinishedDvdFolder]; // @"/DailyMoviesProcessed";
	NSString* myWorkingPath = [NSString stringWithString:localWorkingFolderPath];	// @"/WorkingPath";
	
	NSFileManager* mgr = [NSFileManager defaultManager];
	NSError* error = nil;
	
	
	BOOL isDirectory = NO;
	BOOL exists = [mgr fileExistsAtPath:myFolderPath isDirectory:&isDirectory];
	if ( !(exists && isDirectory) )
	{
		return NO;
	}
	
	// WE NEED to Clear OUT the Old Items in the appropriate folder
	// test deleting a file
	// BOOL didDelete = [mgr removeItemAtPath:@"/Caruso theGrove/ChapterNNN.mov" error:&error];
	if (error) NSLog (@"2010-11-03steve rerror with removeItemAtPath: %@",error );
	

	
	error = nil;
	NSArray * filesArray = [mgr contentsOfDirectoryAtPath:myFolderPath error:&error];
	if ( error !=nil )
	{
		NSLog(@"Error in getting contentsOfDirectoryAtPath %@: %@", myFolderPath, [error localizedDescription]);
	}
	
	if ( filesArray==nil || ([filesArray count] <=0) )
	{
		NSBeep();
		NSLog (@ "There's NO More New Movies..." );
		NSInteger returnValue = NSRunAlertPanel (	@"Alert",
												 @"NO New Movie To Process, Yet...\rPlease Try Again Later...",
												 @"OK",	// default
												 nil,	// alternate
												 nil,		// NSAlertOtherReturn
												 @"param1",
												 @"param2"
												 );
		
		return foundNextMovie;
	}

	
	// sort by creation date
	BOOL isHidden = NO;
	// BOOL isDirectory = NO;
	BOOL isTempItem = NO;
    NSMutableArray* filesAndProperties = [NSMutableArray arrayWithCapacity:[filesArray count]];
    for(NSString* file in filesArray)
	{
		isHidden = NO;
		isDirectory = NO;
		isTempItem = NO;
		
		NSString* baseName = [file lastPathComponent];
		NSRange foundRange = [baseName rangeOfString:@"."];
		// NSLog ( @"Checking if HIDDEN File => [%i][%i]\n", foundRange.location, foundRange.length );
		if ( foundRange.location==0 && foundRange.length )
		{
			// NSLog ( @"THIS IS A HIDDEN FILE" );
			isHidden = YES;
		}
		
		foundRange = [baseName rangeOfString:@"temp"]; // 2010-11-05steve
		if ( foundRange.location==0 && foundRange.length )
		{		
			isTempItem = YES;
		}
		
		NSString* fullFilePath = [myFolderPath stringByAppendingPathComponent:file];
		bool exists = [mgr fileExistsAtPath:fullFilePath isDirectory:&isDirectory];
		if ( !exists )
		{
			NSLog ( @"2010-11-03steve - WHAT?? file [%@] does NOT exist???", fullFilePath );
		}
		
		if ( isHidden || isDirectory || isTempItem || !exists ) // 2010-11-05steve
		{
			// we need to skip
		}
		else
		{
			NSDictionary* properties = [[NSFileManager defaultManager]
										attributesOfItemAtPath:fullFilePath
										error:&error];
			NSDate* modDate = [properties objectForKey:NSFileModificationDate];
			
			if(error == nil)
			{
				[filesAndProperties addObject:[NSDictionary dictionaryWithObjectsAndKeys:
											   fullFilePath, @"path",
											   modDate, @"lastModDate",
											   nil]];                 
			}
		}
		
		
    }
	
	if ( [filesAndProperties count] <=0 )
	{
		NSBeep();
		NSLog (@ "There's NO More New Movies..." );
		NSInteger returnValue = NSRunAlertPanel (	@"Alert",
												 @"There's NO More New Movies...",
												 @"OK",	// default
												 nil,	// alternate
												 nil,		// NSAlertOtherReturn
												 @"param1",
												 @"param2"
												 );
		
		return foundNextMovie;
	}
	
	
	// NSLog ( @"2010-11-03steve filesAndProperties = %@", filesAndProperties );
	
	// sort using a block
	// order inverted as we want latest date first
    NSArray* sortedFiles = [filesAndProperties sortedArrayUsingFunction:mySortByDate context:nil];
	// NSLog ( @"2010-11-03steve sortedFiles = %@", sortedFiles );
	
	
	
	id nextItem = [sortedFiles objectAtIndex:0];
	NSLog ( @"2010-11-03steve Next Item File To Burn is: %@", nextItem );
	id nextItemPath = [nextItem objectForKey:@"path"];
	
	error = nil;
	id destPath = [myWorkingPath stringByAppendingPathComponent:[nextItemPath lastPathComponent]];
	NSLog ( @"2010-11-03steve destPath = %@", destPath );
	
	// make a copy to the current working path
	NSString* tempItemPath = [myWorkingPath stringByAppendingPathComponent:[nextItemPath lastPathComponent]];
	NSString* safeWorkingItemPath = createSafeFilePathFromBase(tempItemPath);	// 2010-11-12steve [self createSafeFilePathFromBase:tempItemPath];
	BOOL didCopy = [mgr copyItemAtPath:nextItemPath toPath:safeWorkingItemPath error:&error];
	if (error) NSLog (@"2010-11-03steve rerror with copyItemAtPath: %@",error );
	
	// move item to the processed(finished) path
	tempItemPath = [myProcessPath stringByAppendingPathComponent:[nextItemPath lastPathComponent]];
	NSString* safeProcessItemPath = createSafeFilePathFromBase(tempItemPath);	// 2010-11-12steve [self createSafeFilePathFromBase:tempItemPath];
	BOOL didMove = [mgr moveItemAtPath:nextItemPath toPath:safeProcessItemPath error:&error];
	if (error) NSLog (@"2010-11-03steve rerror with moveItemAtPath: %@",error );
	
	
	// 2010-11-04steve - NOW SAVE Settings
	
	[self setupMovie:safeWorkingItemPath];
	[_myNSTextField ibUpdateNSTextFieldWithString:safeWorkingItemPath doWait:NO isError:NO];

	if ( safeWorkingItemPath )
	{
		self._mCurrentMoviePath = [NSString stringWithString:safeWorkingItemPath];
		foundNextMovie = YES;
	}
	
	NSLog ( @"2010-11-04steve foundNextMovie = %@", ShowBOOL(foundNextMovie) );

	
	return foundNextMovie;
}

-(BOOL) tellToastToBurn
{
	BOOL didSendMovieToToast = NO;
	
	NSString* scriptName = @"burnToast.scpt";
	NSBundle *bundle = [NSBundle mainBundle];
	NSString *scriptPath = [bundle pathForAuxiliaryExecutable:scriptName];
	if ( scriptPath==nil )
	{
		NSLog ( @"2010-11-04steve Could NOT find Script named: %@", scriptName);
		return NO;
	}
	else
	{
		NSLog ( @"2010-11-04steve Found Script named: %@", scriptPath);
	}
	
	
	bool doOsaScript = true;
	if ( doOsaScript )
	{
		NSString *scriptName = @"/usr/bin/osascript";
		// NSMutableArray *paramArray = [NSMutableArray arrayWithObjects:scriptPath,@"ME+SANTA at the Grove",nil];
		NSMutableArray *paramArray = [NSMutableArray arrayWithObjects:scriptPath,self._mCurrentMovieTitle,nil];
		
		NSLog (@"2010-11-06steve self._mCurrentMoviesToBurnList is: %@", self._mCurrentMoviesToBurnList );
		short movieCount = [self._mCurrentMoviesToBurnList count];
		short i=0;
		for ( i=0; i<movieCount; i++ )
		{
			[paramArray addObject:[self._mCurrentMoviesToBurnList objectAtIndex:i]];
		}
		NSLog (@"2010-11-06steve paramArray is: %@", paramArray );
		
		
		NSString* response2 = runThisShellScript ( scriptName, paramArray );
		NSLog ( @"2010-11-03steve response2 = %@", response2 );
		
		didSendMovieToToast = [self processResponseFromScript:response2];

	}
	
	NSLog ( @"2010-11-04steve didSendMovieToToast = %@", ShowBOOL(didSendMovieToToast) );

	return didSendMovieToToast;
}


#pragma mark -

NSString * sTepsFlashWriterNotification = @"TepsFlashDriveNotification";
void mySendFlashWriterAppNotificationWithFilePath(NSArray *array) // 2011-11-21
{
    
    NSMutableDictionary *notificationDictionary = [NSMutableDictionary dictionaryWithCapacity:3];
    
    if (notificationDictionary)
    {
        NSString *myAppName = @"Teps-Video.app";
        
        [notificationDictionary setObject:myAppName forKey:@"senderApp"];
        [notificationDictionary setObject:@"/" forKey:@"destSubFolder"];
        [notificationDictionary setObject:array forKey:@"sourceItem"];
        
        NSLog(@"Dictionary=%@", notificationDictionary);
        
        NSNotification* note = [NSNotification notificationWithName:sTepsFlashWriterNotification object:@"test"
                                                           userInfo:notificationDictionary];
        [[NSDistributedNotificationCenter defaultCenter] performSelectorOnMainThread:@selector(postNotification:)
                                                                          withObject:note waitUntilDone:YES];
        
        
    }
}
// 2013-08-15steve
-(IBAction)launchFlashWriter:(id)sender
{
    {
        NSString* sPrefLaunchChildApp = @"Teps-FlashWriter.app";
        NSString* myBundlePath = [[NSBundle mainBundle] bundlePath ];
        NSString* myAppNameToLaunch = [[NSUserDefaults standardUserDefaults] stringForKey:sPrefLaunchChildApp];
        
        if ( myAppNameToLaunch) {
            _childProcesses = [[NSMutableSet alloc] initWithCapacity:0];
            NSString* pathToApp = nil;
            NSArray* pathsToSearch = [NSArray arrayWithObjects:myBundlePath, @"/Applications",@"/Applications/TEPS OS X Share Folder",nil];
            for ( id subpath in pathsToSearch) {
                pathToApp = [subpath stringByAppendingPathComponent:myAppNameToLaunch];
                BOOL exists = [[NSFileManager defaultManager] fileExistsAtPath:pathToApp];
                if (!exists)
                    pathToApp = nil;
                else {
                    break;
                }
                
            }
            if(pathToApp) {
                LSLaunchFlags flags = kLSLaunchDontAddToRecents | kLSLaunchDontSwitch | kLSLaunchAndHide;
                [self launchChildProcess:[NSDictionary dictionaryWithObjectsAndKeys:pathToApp, @"NSApplicationPath",
                                          [NSNumber numberWithUnsignedLong:flags], @"NSApplicationLaunchFlags",
                                          nil]];
            }
        }
    }

}

#pragma mark - Process Tab

-(IBAction) doRevealItem1:(id)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	NSString* pathToReveal = getDailyFolderPathForToBeBurnedFolder();	// 2010-11-11 [[NSUserDefaults standardUserDefaults] objectForKey:sPrefToBeBurnedFolder];
	revealItemInFinder (pathToReveal);
	
}

-(IBAction) doRevealItem2:(id)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	NSString* pathToReveal = getDailyFolderPathForFinishedDvds();	// 2010-11-11 [[NSUserDefaults standardUserDefaults] objectForKey:sPrefFinishedDvdFolder];
	revealItemInFinder (pathToReveal);
	
}


-(IBAction) doFindNextMovieAndBurnUSBFlashDrive:(id)sender
{
    NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

    if ( [self getNextMovieToBurn]  ) {
        NSString* filePath = [NSString stringWithString: self._mCurrentMoviePath];
        
        if (filePath) {
            NSLog(@"Tell Teps-FlashWriter to burn [%@]", filePath );
            NSArray* array = [NSArray arrayWithObjects:filePath, nil];
            mySendFlashWriterAppNotificationWithFilePath( array);
            
        } else{
            NSLog (@ "Inside %@ => %@...nothing to burn...", self, NSStringFromSelector(_cmd) );
        }
        
//        BOOL didlaunch = [[NSWorkspace sharedWorkspace] openFile:filePath withApplication:@"Teps-FlashWriter"];
//        if (didlaunch==NO)
//        {
//            NSAlert* alert = [[NSAlert alloc] init];
//            [alert setMessageText:[NSString stringWithFormat:@"UNABLE to launch Teps-FlashWriter.app..." ]];
//            [alert setInformativeText:[NSString stringWithFormat:@"Please put app in /Applications Folder..."]];
//            [alert addButtonWithTitle:@"OK"];
//            
//            [[NSApplication sharedApplication] activateIgnoringOtherApps: YES];
//            [alert runModal];
//            
//            [alert release];
//            alert = nil;
//        }

    }

}





-(IBAction) doFindNextMovieAndBurn:(id)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

// 2013-12-06steve
//    [self doFindNextMovieAndBurnUSBFlashDrive:sender]; // 2013-08-09steve
//    return; // 2013-08-09steve
    

	// 0. make sure all the paths are valid
	BOOL allValid = [self validateAllFolders];
	if ( allValid == false )
	{
		[self showTabForError:allValid];
		
		return;
	}
	
	
	
	
	// 1. check to see if we already started a process or not
	if ( !_mStartedProcess )
	{
		// try to quit toast - 
		// if toast is busy,
		// then it may still be burning a DVD
		// so dont get a new movie yet
		
		BOOL didQuitToast = [self tellToastToQuit];
		if ( !didQuitToast )
			return;
	}
		
	if (!_mStartedProcess  )
	{
		// Get the Next Customer
		_mStartedProcess = [self getNextMovieToBurn];
		if ( !_mStartedProcess )
		{
			// Alert User NO more movies
		}
		
	}
	
	
	if ( _mStartedProcess )
	{

	}
	
	
	if ( _mStartedProcess )
	{
		self._mCurrentMoviesToBurnList = [self prepareFolderForBurn];
		if ( self._mCurrentMoviesToBurnList )
		{
			BOOL didSendMovieToToast = [self tellToastToBurn];
			if ( didSendMovieToToast )
			{
				_mStartedProcess = NO;
			}
		}
		
	}
	
}


#pragma mark - Admin Tab

- (IBAction)doClickOnQuitToast:(id)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	NSString* scriptName = @"quitToast.scpt";
	NSBundle *bundle = [NSBundle mainBundle];
	NSString *scriptPath = [bundle pathForAuxiliaryExecutable:scriptName];
	if ( scriptPath==nil )
	{
		NSLog ( @"2010-11-04steve Could NOT find Script named: %@", scriptName);
		return;
	}
	else
	{
		NSLog ( @"2010-11-04steve Found Script named: %@", scriptPath);
	}
		
	
	bool doOsaScript = true;
	if ( doOsaScript )
	{
		NSString *scriptName = @"/usr/bin/osascript";
		NSArray *paramArray = [NSArray arrayWithObjects:scriptPath,nil];
		NSString* response2 = runThisShellScript ( scriptName, paramArray );
		NSLog ( @"2010-11-05steve response2 = %@", response2 );
		
		[self processResponseFromScript:response2];
		
	}
	
	
	
}

- (IBAction)doClickOnBurnToast:(id)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

	
	
	BOOL didSendMovieToToast = [self tellToastToBurn];
	if ( didSendMovieToToast )
	{
		
	}
	else
	{

	}
	return;
	
	
	
//	NSString* scriptPath = @"/Caruso theGrove steve/testToast4.scpt";
	
	NSString* scriptName = @"burnToast.scpt";
	NSBundle *bundle = [NSBundle mainBundle];
	NSString *scriptPath = [bundle pathForAuxiliaryExecutable:scriptName];
	if ( scriptPath==nil )
	{
		NSLog ( @"2010-11-04steve Could NOT find Script named: %@", scriptName);
		return;
	}
	else
	{
		NSLog ( @"2010-11-04steve Found Script named: %@", scriptPath);
	}
	
	// get the name of the last item to burn
	NSString* itemToBurnAgain = self._mCurrentMoviePath;
	NSLog ( @"2010-11-05steve self.mCurrentMoviePath = [%@]", self._mCurrentMoviePath );
	BOOL isDirectory = NO;
	BOOL exists = [[NSFileManager defaultManager] fileExistsAtPath:itemToBurnAgain isDirectory:&isDirectory];
	if ( !exists )
	{
		NSRunAlertPanel (	@"Alert",
						 @"No Movie was selected or is missing...",
						 @"OK",	// default
						 nil,	// alternate
						 nil,		// NSAlertOtherReturn
						 @"param1",
						 @"param2"
						 );
		return;
	}
	
	
	bool doOsaScript = true;
	if ( doOsaScript )
	{
		NSString *scriptName = @"/usr/bin/osascript";
		NSArray *paramArray = [NSArray arrayWithObjects:scriptPath,@"ME & SANTA at The Grove" ,itemToBurnAgain,nil];
		NSString* response2 = runThisShellScript ( scriptName, paramArray );
		NSLog ( @"2010-11-03steve response2 = %@", response2 );
		
		[self processResponseFromScript:response2];

	}
	
	
	
}


#pragma mark - Pref Tab


-(IBAction) ibClickedOnChangeToBeBurnFolder:(id)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	NSDictionary* parameters = [NSDictionary dictionaryWithObjectsAndKeys:self,sPanelDelegateKey, 
								@"Please Select the New Movies To Process Folder", sPanelMessageKey, 
								@"Select", sPanelPromptKey,
								sender, sPanelSenderKey,
								sPrefToBeBurnedFolder, sPrefFolderNameKey,
								sPrefToBeBurnedFolderAliasData, sPrefFolderAliasDataKey,
								sPrefToBeBurnedFolderIsValid, sPrefFolderNameIsValidKey,
								nil];
	
	[self doNSOpenPanelWithParameters:parameters];
	
}

- (IBAction) ibClickedOnChangeFinishedDvdFolder:(id)sender
{
	
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	NSDictionary* parameters = [NSDictionary dictionaryWithObjectsAndKeys:self,sPanelDelegateKey, 
								@"Please Select the FINISHED DVD Folder", sPanelMessageKey, 
								@"Select", sPanelPromptKey,
								sender, sPanelSenderKey,
								sPrefFinishedDvdFolder, sPrefFolderNameKey,
								sPrefFinishedDvdFolderAliasData, sPrefFolderAliasDataKey,
								sPrefFinishedDvdFolderIsValid, sPrefFolderNameIsValidKey,
								nil];
	
	[self doNSOpenPanelWithParameters:parameters];
	
}



#pragma mark -

- (void)openPanelDidEnd:(NSOpenPanel *)sheet returnCode:(int)returnCode contextInfo: (void*)contextInfo
{
	NSLog (@ "Inside %@ => %@... with returnCode=[%i] and ContextInfo=[%@]", self, NSStringFromSelector(_cmd), returnCode, contextInfo );

	
	if (returnCode == NSOKButton)
	{
		NSLog (@"openPanelDidEnd:returnCode:contextInfo returned NSOKButton" );

		NSString* itemName = [[sheet filenames] lastObject];

		if ( contextInfo )
		{
			
			id parameters = (id) contextInfo;
			if ( [parameters isKindOfClass:[NSDictionary class]] )
			{
				// great 
				
				NSString* folderPathKey = [parameters objectForKey:sPrefFolderNameKey];
				NSString* folderPathIsValidKey = [parameters objectForKey:sPrefFolderNameIsValidKey];
				NSString* folderAliasDataKey = [parameters objectForKey:sPrefFolderAliasDataKey];
				
				
				if ( itemName )
				{
					[[NSUserDefaults standardUserDefaults] setObject:itemName forKey:folderPathKey];
					[[NSUserDefaults standardUserDefaults] setBool:YES forKey:folderPathIsValidKey ];
					[MyAliasKit savePath:itemName forKey:folderAliasDataKey];
				}
			}
			
			else
			{
				NSLog ( @"2010-11-04steve - we dont know what to do????" );
				
			}
			
			
			
			
				
		}
		
		else
		{
			NSLog ( @"openPanelDidEnd passed NIL for contextInfo??????" );
		}
	}
	else if (returnCode == NSCancelButton)
	{
		NSLog (@"openPanelDidEnd:returnCode:contextInfo returned NSCancelButton" );
	}
	else
	{
		NSLog (@"openPanelDidEnd:returnCode:contextInfo returned ?????" );
	}
	
	
	
}

- (IBAction) doNSOpenPanelWithParameters:(NSDictionary*)parameters
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	NSLog (@ "Inside %@ => %@... parameters = %@", self, NSStringFromSelector(_cmd), parameters );
	
	NSString* prefFolderNameKey =[parameters objectForKey:sPrefFolderNameKey];
	NSString* panelDelegate = [parameters objectForKey:sPanelDelegateKey];
	NSString* panelMessage = [parameters objectForKey:sPanelMessageKey];
	NSString* panelPrompt = [parameters objectForKey:sPanelPromptKey];
	id panelSender = [parameters objectForKey:sPanelSenderKey];
	
		
	NSWindow* parentWindow = [panelSender window];
	NSOpenPanel* op = [NSOpenPanel openPanel];
	
	[op setCanChooseDirectories:YES];
	[op setCanChooseFiles:NO];
	[op setAllowsMultipleSelection:NO];
	[op setCanCreateDirectories:YES];
	
	[op setMessage:[NSString stringWithString:panelMessage]];
	[op setPrompt:[NSString stringWithString:panelPrompt]];
	

	NSString* initialDirectory = [[NSUserDefaults standardUserDefaults] stringForKey:prefFolderNameKey];
	
	bool doAsSheet = true;	// 08-20-07 put back
	if ( doAsSheet )
	{
		[op setDelegate:panelDelegate];

		[op beginSheetForDirectory:initialDirectory
							  file:nil
							 types:nil
					modalForWindow:parentWindow
					 modalDelegate:panelDelegate
					didEndSelector:@selector(openPanelDidEnd:returnCode:contextInfo:)
					   contextInfo:[parameters retain]];
		
	}
	
	
}



@end
