//
//  EditAVMovieWindowController.h
//  Teps-Video
//
//  Created by tyler on 10/25/13.
//
//

#import <Cocoa/Cocoa.h>
#import <AVFoundation/AVFoundation.h>
#import "MyAVAssetRW.h"

//@class AVPlayer, AVPlayerLayer;


@protocol TepsEditAVMovieDelegate <NSObject>
-(void)didCancelEditedMovie:(id)param;
-(void)didSaveEditedMovie:(id)param;
@end

@interface EditAVMovieWindowController : NSWindowController <NSWindowDelegate>

{
    dispatch_semaphore_t waitSemaphore;
}

@property (nonatomic,retain) IBOutlet NSSlider * mSlideIn;
@property (nonatomic,retain) IBOutlet NSSlider * mSlideOut;
@property (nonatomic,retain) IBOutlet NSSlider * mSlideHead;
@property (nonatomic,retain) IBOutlet NSButton * revertButton;
@property (nonatomic,retain) IBOutlet NSTextField * tSlideInValue;
@property (nonatomic,retain) IBOutlet NSTextField * tSlideOutValue;
@property (nonatomic,retain) IBOutlet NSTextField * tSelectionLength;
@property (nonatomic,retain) IBOutlet NSView * playerView;
@property (nonatomic,retain) IBOutlet NSProgressIndicator *loadingSpinner;
@property (nonatomic,retain) IBOutlet NSButton *playPauseButton;
@property (nonatomic,retain) AVAsset * mAVMovieAsset;
@property (nonatomic,retain) AVMutableComposition *composition;
//@property (nonatomic,retain) AVMutableVideoComposition *videoComposition;
//@property (nonatomic,retain) AVMutableAudioMix *audioMix;
@property (nonatomic,retain) AVPlayer *player;
@property (nonatomic,retain) AVPlayerLayer *playerLayer;
@property (nonatomic,retain) id timeObserverToken;
@property (nonatomic,retain) id boundaryObserverToken;
@property (nonatomic,retain) id movieRef;
@property (nonatomic,retain) NSTimer * playTimer;
@property (nonatomic,assign) double setIn;
@property (nonatomic,assign) double setOut;
@property (nonatomic,assign) id <TepsEditAVMovieDelegate> mydelegate; // 2013-10-08steve
@property (nonatomic,assign) NSTimeInterval originalAssetDuration; // 2013-11-03steve
@property (nonatomic,assign) BOOL handleAsSheet; // 2013-11-20steve


@property double currentTime;
@property (readonly) double duration;

-(IBAction)setInSelection:(id)sender;
-(IBAction)setPlayHead:(id)sender;
-(IBAction)setOutSelection:(id)sender;
-(IBAction)playSelection:(id)sender;
-(IBAction)trim:(id)sender;
-(IBAction)revertToOriginal:(id)sender;
-(IBAction)cropAndSave:(id)sender;

-(NSString*) getTrimmedMoviePath; // 2013-11-03steve


@end
