//
//  EditMovieWindowController.m
//  Teps-Video
//
//  Created by tyler on 9/26/13.
//
//

#import "EditMovieWindowController.h"

@interface EditMovieWindowController ()

@end

@implementation EditMovieWindowController

- (id)initWithWindow:(NSWindow *)window
{
    self = [super initWithWindow:window];
    if (self) {
        // Initialization code here.
    }
    
//    [self addObserver:self forKeyPath:@"mQTMovie" options:NSKeyValueObservingOptionNew context:NULL];
    [self addObserver:self forKeyPath:@"movieRef" options:NSKeyValueObservingOptionNew context:NULL];
//    [NSNotificationCenter.defaultCenter addObserver:self selector:@selector(gotNote:) name:nil object:nil];
    [NSNotificationCenter.defaultCenter addObserver:self selector:@selector(movieTimeDidChange:) name:QTMovieTimeDidChangeNotification object:nil];
    [NSNotificationCenter.defaultCenter addObserver:self selector:@selector(movieRateDidChange:) name:QTMovieRateDidChangeNotification object:nil];
    return self;
}
-(void)playbackTimer:(NSTimer *)aTimer
{
    //check the movie
    if ([aTimer.userInfo isKindOfClass:QTMovie.class])
    {
        QTMovie * movie = aTimer.userInfo;
        NSTimeInterval currentTime;
        QTGetTimeInterval(movie.currentTime,&currentTime);
        //NSLog(@"current time:%.2f for movie:%@",currentTime,movie);
        self.mSlideHead.doubleValue = currentTime;
        if(currentTime >= self.setOut || self.setOut - currentTime < 0.01)
        {
            NSLog(@"stopping movie due to outTime:%.2f",self.setOut);
            [movie stop];
        }
    }
}
-(void)movieTimeDidChange:(NSNotification *)note
{
    // reset the playhead
    if([note.object isKindOfClass:QTMovie.class])
    {
        QTMovie * movie = note.object;
        NSTimeInterval currentTime;
        QTGetTimeInterval(movie.currentTime,&currentTime);
        self.mSlideHead.doubleValue = currentTime;
    }
    
}
-(void)movieRateDidChange:(NSNotification *)note
{
    //NSLog(@"%@",note);
    if([note.name isEqualToString:QTMovieRateDidChangeNotification] && [note.object isKindOfClass:QTMovie.class])
    {
        // 2013-10-09steve NSNumber *newRate = note.userInfo[QTMovieRateDidChangeNotificationParameter];
        NSNumber *newRate = [note.userInfo objectForKey:QTMovieRateDidChangeNotificationParameter];
        if ([newRate isEqualToNumber:@0])
        {
            //kill the playback timer
            NSLog(@"Killing playbacktimer for movie %@",note.object);
            [self.playTimer invalidate];
            self.playTimer = nil;
        }
        else
        {
            [self.playTimer invalidate];
            self.playTimer = [NSTimer scheduledTimerWithTimeInterval:0.01 target:self selector:@selector(playbackTimer:) userInfo:note.object repeats:YES];
        }

    }
}
-(void)gotNote:(NSNotification *)note
{
    NSString * name = note.name;
    if([name isEqualToString:@"BufferBackingWillDeallocate"]);
    else if([name isEqualToString:@"NSWindowDidUpdateNotification"]);
    else if([name isEqualToString:@"NSApplicationDidUpdateNotification"]);
    else if([name hasPrefix:@"FigImageQueueNotification"]);
    else
    {
        NSLog(@"%@",note);
    }
}
- (void)dealloc
{
    [NSNotificationCenter.defaultCenter removeObserver:self];
//    [self removeObserver:self forKeyPath:@"mQTMovie"];
    [self removeObserver:self forKeyPath:@"movieRef"];

    self.mQTMovie = nil;
    self.mQTMovieView = nil;
    self.movieRef = nil;
    self.mSlideIn = nil;
    self.mSlideOut = nil;
    self.mSlideHead = nil;
    self.revertButton = nil;
    self.tSlideInValue = nil;
    self.tSlideOutValue = nil;
    self.tSelectionLength = nil;
    
    [super dealloc];
}
- (void)windowDidLoad
{
    [super windowDidLoad];
    
    // Implement this method to handle any initialization after your window controller's window has been loaded from its nib file.
    if (nil == self.mQTMovieView.movie && self.mQTMovie)
    {
        [self loadMovie];
    }
}
-(void)setSliders
{
    NSTimeInterval duration;
    if(QTGetTimeInterval(self.mQTMovie.duration, &duration))
    {
        // got the duration
        //now set the selection sliders
        self.mSlideIn.minValue = 0;
        self.mSlideOut.minValue = 0;
        self.mSlideHead.minValue = 0;

        self.mSlideIn.maxValue = duration;
        self.mSlideOut.maxValue = duration;
        self.mSlideHead.maxValue = duration;

        self.setIn = 0;
        self.mSlideIn.doubleValue = 0;
        self.tSlideInValue.stringValue = [self timeStringForTimeInterval:self.setIn];

        self.setOut = duration;
        self.mSlideOut.doubleValue = duration;
        self.tSlideOutValue.stringValue = [self timeStringForTimeInterval:self.setOut];

        [self setMovieSelection];
    }
}
-(void)loadMovie
{
    QTMovie * movie = nil;
    NSError * error;
    if([self.movieRef isKindOfClass:NSString.class])
    {
        //try to load the movie
        movie = [QTMovie movieWithFile:self.movieRef error:&error];
    }
    else if([self.movieRef isKindOfClass:NSURL.class])
    {
        //try to load the movie
        movie = [QTMovie movieWithURL:self.movieRef error:&error];
    }
    if(movie)
    {
        [movie setAttribute:@YES forKey:QTMovieEditableAttribute];
        NSLog(@"Movie attribs: %@",movie.movieAttributes);
        self.mQTMovie = movie;
    }

    // load the movie into the view
    if([self.mQTMovie isKindOfClass:QTMovie.class])
    {
        self.mQTMovieView.movie = self.mQTMovie;
        [self setSliders];
        self.revertButton.enabled = NO;
    }
}
-(void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary *)change context:(void *)context
{
    if([keyPath isEqualToString:@"mQTMovie"]||[keyPath isEqualToString:@"movieRef"])
    {
        NSLog(@"someone set a new movie");
        [self loadMovie];
    }
}
-(IBAction)cropAndSave:(id)sender
{
    //do a crop and save operation
    if([self.mQTMovie canUpdateMovieFile] && [self.mQTMovie updateMovieFile])
    {
        NSLog(@"movie file updated!");
        self.revertButton.enabled = NO;
        
        // 2013-10-08steve
        NSLog(@"self.mydelegate = %@", self.mydelegate);
        if (self.mydelegate && [self.mydelegate respondsToSelector:@selector(didSaveEditedMovie:)])
        {
            [self.mydelegate didSaveEditedMovie:self];
        }
        
    }
}
-(IBAction)cancel:(id)sender
{
    // 2013-10-08steve
    NSLog(@"self.mydelegate = %@", self.mydelegate);
    if (self.mydelegate && [self.mydelegate respondsToSelector:@selector(didCancelEditedMovie:)])
    {
        [self.mydelegate didCancelEditedMovie:self];
    }
    
}

-(void)setMovieSelection
{
    //get the movie duration and set the in selection to this percent of duration
    NSTimeInterval timeIn = self.mSlideIn.doubleValue;
    QTTime startTime = QTMakeTimeWithTimeInterval(timeIn);
    NSTimeInterval selectionDuration = MAX(self.mSlideOut.doubleValue - timeIn, 0);
    QTTime duration = QTMakeTimeWithTimeInterval( selectionDuration);
    QTTimeRange selection = QTMakeTimeRange(startTime, duration);
    [self.mQTMovie setSelection:selection];
    self.tSelectionLength.stringValue = [self timeStringForTimeInterval:selectionDuration];
}
-(NSString *)timeStringForTimeInterval:(NSTimeInterval)aTime
{
    NSString * s = @"0.00";
    NSTimeInterval secs;
    unsigned hundreths = modf(aTime, &secs)*100;
    unsigned minutes = secs/60;
    unsigned seconds = secs - minutes*60;
    if(minutes)
    {
        s = [NSString stringWithFormat:@"%u:%.2u.%.2u",minutes,seconds,hundreths];
    }
    else if (seconds)
    {
        s = [NSString stringWithFormat:@"%u.%.2u",seconds,hundreths];
    }
    else
    {
        s = [NSString stringWithFormat:@"0.%.2u",hundreths];
    }
    return s;
}
-(IBAction)setInSelection:(id)sender
{
    self.setIn = self.mSlideIn.doubleValue;
//    self.tSlideInValue.doubleValue = self.setIn;
    self.tSlideInValue.stringValue = [self timeStringForTimeInterval:self.setIn];
    [self setMovieSelection];
    [self.mQTMovie setCurrentTime:QTMakeTimeWithTimeInterval(self.mSlideIn.doubleValue)];
}
-(IBAction)setOutSelection:(id)sender
{
    self.setOut = self.mSlideOut.doubleValue;
//    self.tSlideOutValue.doubleValue = self.setOut;
    self.tSlideOutValue.stringValue = [self timeStringForTimeInterval:self.setOut];

    [self setMovieSelection];
//    [self.mQTMovie gotoEnd];
//    [self.mQTMovie gotoPreviousSelectionPoint];
    [self.mQTMovie setCurrentTime:QTMakeTimeWithTimeInterval(self.mSlideOut.doubleValue)];
}
-(IBAction)setPlayHead:(id)sender
{
    [self.mQTMovie setCurrentTime:QTMakeTimeWithTimeInterval(self.mSlideHead.doubleValue)];
}
-(IBAction)playSelection:(id)sender
{
    if(self.mQTMovie.rate == 0.0f)
    {
        //play current selection
        // check if the slideOut was set and play from SlideIn
        NSTimeInterval currentTime;
        QTGetTimeInterval(self.mQTMovie.currentTime, &currentTime);
        double tDiff = currentTime - self.setOut;
        NSLog(@"tDiff = %f",tDiff);
        if(0 < tDiff || -0.05 < tDiff)
        {
            // move play head to slideIn
            [self.mQTMovie setCurrentTime:QTMakeTimeWithTimeInterval(self.setIn)];
        }
        [self.mQTMovie play];
    }
    else
    {
        [self.mQTMovie stop];
    }
}
-(IBAction)revertToOriginal:(id)sender
{
    // reload the file
    //get confirmation before discarding changes
    NSAlert * alert = [NSAlert alertWithMessageText:@"Revert to Original?" defaultButton:@"Revert" alternateButton:@"Cancel" otherButton:nil informativeTextWithFormat:@"All changes to this point will be lost."];
    NSImage * icon = [NSImage imageNamed:NSImageNameCaution];
    if(icon)
    {
        [alert setIcon:icon];
    }
    [alert beginSheetModalForWindow:[self window] modalDelegate:self didEndSelector:@selector(alertDidEnd:returnCode:contextInfo:) contextInfo:NULL];
}
- (void)alertDidEnd:(NSAlert *)alert returnCode:(NSInteger)returnCode contextInfo:(void *)contextInfo
{
    if(NSAlertDefaultReturn == returnCode)
    {
        //revert to original movie
        NSLog(@"Reverting to original");
        [self loadMovie];
    }
}

-(IBAction)trim:(id)sender
{
    [self.mQTMovieView trim:self];
    [self setSliders];
    self.revertButton.enabled = YES;
}
@end
