//
//  MyAliasKit.m
//  testFypController
//
//  Created by steve on 7/2/10.
//  Copyright 2010 TriPrism, Inc. All rights reserved.
//

#import "MyAliasKit.h"


@implementation MyAliasKit



+(NSData *)aliasDataForAliasHandle:(AliasHandle)inAlias
{
    NSData * aliasData = nil;
    if(NULL != inAlias)
    {
        Size s = GetHandleSize((Handle)inAlias);
        aliasData = [NSData dataWithBytes:*inAlias length:s];
    }
    return aliasData;
}

+(NSData *)aliasDataForPath:(NSString *)path
{
    NSData * aliasData = nil;
    BOOL isDirectory;
    if(path && [[NSFileManager defaultManager] fileExistsAtPath:path isDirectory:&isDirectory])
    {
        Boolean isDir = isDirectory;
        AliasHandle inAlias;
        OSStatus err = FSNewAliasFromPath(NULL, [path fileSystemRepresentation], 0, &inAlias, &isDir);
        if(noErr == err)
        {
            aliasData = [self aliasDataForAliasHandle:inAlias];
        }
        DisposeHandle((Handle)inAlias);
    }
    return aliasData;
}

+(BOOL)resolveAliasFromData:(NSData *) aliasData resolvedPath:(NSString **)resolvedPath changedData:(NSData **)newData
{
    BOOL didResolveAlias = NO;
    if(aliasData)
    {
        AliasHandle inAlias;
        OSErr err = PtrToHand([aliasData bytes], (Handle *)&inAlias, (long)[aliasData length]);
        if(noErr == err)
        {
            FSRef target;
            Boolean wasChanged;
            unsigned long mountFlags = 0;
            err = FSResolveAliasWithMountFlags(NULL, inAlias, &target, &wasChanged, mountFlags);
            if( noErr == err )
            {
                didResolveAlias = YES;
                if(wasChanged && newData)
                {
                    *newData = [self aliasDataForAliasHandle:inAlias];
                }
                if(resolvedPath)
                {
                    FSCopyAliasInfo(inAlias, NULL, NULL, (CFStringRef *)resolvedPath, NULL, NULL);
                    *resolvedPath = [*resolvedPath autorelease];
                }
            }
            DisposeHandle((Handle)inAlias);
        }
    }
    return didResolveAlias;
}

+(BOOL)resolveAliasFromData:(NSData *) aliasData resolvedPath:(NSString **)resolvedPath
{
    return [self resolveAliasFromData:aliasData resolvedPath:resolvedPath changedData:NULL];
}


+(void)savePath:(NSString *)path forKey:(NSString*)aliasKeyName
{
	NSLog (@ "Inside %@ => %@...withPath=[%@] forKey=[%@]", self, NSStringFromSelector(_cmd), path, aliasKeyName );
	
    NSData * d = [self aliasDataForPath:path];
    if(d)
    {
        [[NSUserDefaults standardUserDefaults] setObject:d forKey:aliasKeyName];
    }
	else
	{
		NSLog (@ "Inside %@ => %@... aliasDataForPath returned NIL?????? ", self, NSStringFromSelector(_cmd) );
		
	}
}





@end
