 //
//  MyAppDelegate.m
//  MyRecorder
//
//  Created by steve on 11/3/10.
//  Copyright 2010 TriPrism, Inc. All rights reserved.
//

#import "MyAppDelegate.h"
#import "DvdStationWindowController.h"
#import "MyRecorderController.h"
#import "SalesStationWindowController.h"
#import "SalesStationKioskWindowController.h" // 2014-10-26steve

#import "TPLogFileManager.h" // 2010-11-05steve
#import "TepsUrlHandler.h"   // 2013-06-17steve

#import "webKeyInfoObject.h" // 2014-01-30steve

#import <dlfcn.h>   // 2014-09-25steve


extern NSString * sTepsVideoAppNotification; // 2014-07-14steve



NSString* sPrefStartupMode = @"prefStartupMode";

typedef enum  {
	eAppRunModeCamera = 1,
	eAppRunModeSales,
	eAppRunModeDvd
} eAppRunMode;

short gAppRunMode = 0;






#pragma mark -

CFArrayRef CopyLaunchedApplicationsInFrontToBackOrder(void)
{
    CFArrayRef (*_LSCopyApplicationArrayInFrontToBackOrder)(uint32_t sessionID) = NULL;
    void       (*_LSASNExtractHighAndLowParts)(void const* asn, UInt32* psnHigh, UInt32* psnLow) = NULL;
    CFTypeID   (*_LSASNGetTypeID)(void) = NULL;
    
    void *lsHandle = dlopen("/System/Library/Frameworks/CoreServices.framework/Frameworks/LaunchServices.framework/LaunchServices", RTLD_LAZY);
    if (!lsHandle) { return NULL; }
    
    _LSCopyApplicationArrayInFrontToBackOrder = (CFArrayRef(*)(uint32_t))dlsym(lsHandle, "_LSCopyApplicationArrayInFrontToBackOrder");
    _LSASNExtractHighAndLowParts = (void(*)(void const*, UInt32*, UInt32*))dlsym(lsHandle, "_LSASNExtractHighAndLowParts");
    _LSASNGetTypeID = (CFTypeID(*)(void))dlsym(lsHandle, "_LSASNGetTypeID");
    
    if (_LSCopyApplicationArrayInFrontToBackOrder == NULL || _LSASNExtractHighAndLowParts == NULL || _LSASNGetTypeID == NULL) { return NULL; }
    
    CFMutableArrayRef orderedApplications = CFArrayCreateMutable(kCFAllocatorDefault, 64, &kCFTypeArrayCallBacks);
    if (!orderedApplications) { return NULL; }
    
    CFArrayRef apps = _LSCopyApplicationArrayInFrontToBackOrder(-1);
    if (!apps) { CFRelease(orderedApplications); return NULL; }
    
    CFIndex count = CFArrayGetCount(apps);
    for (CFIndex i = 0; i < count; i++)
    {
        ProcessSerialNumber psn = {0, kNoProcess};
        CFTypeRef asn = CFArrayGetValueAtIndex(apps, i);
        if (CFGetTypeID(asn) == _LSASNGetTypeID())
        {
            _LSASNExtractHighAndLowParts(asn, &psn.highLongOfPSN, &psn.lowLongOfPSN);
            
            CFDictionaryRef processInfo = ProcessInformationCopyDictionary(&psn, kProcessDictionaryIncludeAllInformationMask);
            if (processInfo)
            {
                CFArrayAppendValue(orderedApplications, processInfo);
                CFRelease(processInfo);
            }
        }
    }
    CFRelease(apps);
    
    CFArrayRef result = CFArrayGetCount(orderedApplications) == 0 ? NULL : CFArrayCreateCopy(kCFAllocatorDefault, orderedApplications);
    CFRelease(orderedApplications);
    return result;
}


#pragma mark -

@implementation MyAppDelegate

@synthesize _oldApp; // 2014-11-04steve
@synthesize fBarcodeController; // 2014-11-04steve

#pragma mark -

+ (void)setupFactoryDefaults
{
	NSLog ( @"setupFactoryDefaults" );
    NSString *userDefaultsValuesPath;
    NSDictionary *userDefaultsValuesDict;
	
	
    // load the default values for the user defaults
    userDefaultsValuesPath=[[NSBundle mainBundle] pathForResource:@"FactoryDefault"
														   ofType:@"plist"];
	
	NSLog ( @"userDefaultsValuesPath = [%@]", userDefaultsValuesPath );
	
    userDefaultsValuesDict=[NSDictionary dictionaryWithContentsOfFile:userDefaultsValuesPath];
	
	if( userDefaultsValuesDict==nil)
		NSLog ( @"userDefaultsValuesDict == NIL!!!!" );
	else
		NSLog ( @"About to register factory default dictionary:\n%@\n\n", userDefaultsValuesDict );
	
    // set them in the standard user defaults
	
    [[NSUserDefaults standardUserDefaults] registerDefaults:userDefaultsValuesDict];
	
	
    // if your application supports resetting a subset of the defaults to
    // factory values, you should set those values
    // in the shared user defaults controller
	//	resettableUserDefaultsKeys = GetPrefKeyNameArray();	// 05-08-08steve	
	//    initialValuesDict=[userDefaultsValuesDict dictionaryWithValuesForKeys:resettableUserDefaultsKeys];
	
	bool resetSomeParamsToDefault = false;
	if ( resetSomeParamsToDefault )
	{
//		[self initPrefKeyNameArray]; // 2009-08-10steve
//		initialValuesDict=[userDefaultsValuesDict dictionaryWithValuesForKeys:_myPrefKeyNameArray];	// 2009-08-10steve
//		
//		// Set the initial values in the shared user defaults controller
//		
//		[[NSUserDefaultsController sharedUserDefaultsController] setInitialValues:initialValuesDict];
//		
//		[[NSUserDefaultsController sharedUserDefaultsController] setAppliesImmediately :YES];	// 05-08-08steve
	}
	
	
}

// 2010-11-05steve - initialize
+(void) initialize
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

	
   //2013-06-17steve
#ifndef DebugVersion // 2013-10-04steve - only output to file if we are not debugging in xcode
    [TPLogFileManager setupLogFile]; // 2013-08-27steve
#endif
	
	[self setupFactoryDefaults];	
	bool doDeleteOldLogs = true;
	if ( doDeleteOldLogs )
	{		
		{
			NSLog ( @"Checking for Old Log Files to Delete..." );
			// try to delete the old log files
			double daysOld = 7;	// [Preferences getDaysToSaveLogs]; // 12.0/24;
			NSTimeInterval oneDayOldInSeconds = -1 * 60.0 * 60.0 * 24.0;
			NSDate* lastDateToDeleteFrom = [NSDate dateWithTimeIntervalSinceNow:(oneDayOldInSeconds * daysOld)];
			NSDictionary* options = [NSMutableDictionary dictionaryWithObjectsAndKeys:
									 [NSNumber numberWithBool:YES],@"deleteSubDirectory",
									 [NSNumber numberWithBool:NO],@"deleteImmediately",
									 lastDateToDeleteFrom, @"beforeDate",
									 nil];
			[TPLogFileManager deleteOldLogsWithOptions:options];
			NSLog ( @"Checking for Old Log Files to Delete...Done." );
		}
		
	}
    
    
    // 2014-10-27steve - prevent app nap???????
    if([NSProcessInfo instancesRespondToSelector:@selector(disableAutomaticTermination:)])
    {
        [[NSProcessInfo processInfo] disableAutomaticTermination:@"to prevent appNap"];
    }


	
	
}

#pragma mark -

// 2014-10-26steve
- (IBAction) showMenu:(id)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
    
	[NSMenu setMenuBarVisible:!([NSMenu menuBarVisible])];
	
}


#pragma mark -

-(IBAction)relaunchApp:(id)param // 2013-06-17steve - add quit&relaunch
{
	NSLog (@ "Inside %@ => %@...param = [%@]", [self class], NSStringFromSelector(_cmd), param );
	
	// set these vars so that applicationWillTerminate will not halt quitting
	[NSApp relaunch:param];
}

- (IBAction)selectStartupModeButtonHit:(id)sender
{
	int mode = [sender selectedTag];
	[[NSUserDefaults standardUserDefaults] setInteger:mode forKey: sPrefStartupMode];	// 5-8-03 use predefine
	NSLog (@ "Inside %@ => %@...mode = [%i]", self, NSStringFromSelector(_cmd), mode );
	[[NSUserDefaults standardUserDefaults] synchronize];
	
}

-(IBAction) closeSheet:(id)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	[NSApp endSheet:[sender window] returnCode:NSRunContinuesResponse  ];

}	
- (void)didEndSheet:(NSWindow *)sheet returnCode:(NSInteger)returnCode contextInfo:(void *)contextInfo
{
	NSLog (@ "Inside %@ => %@... with returnCode=[%i] and ContextInfo=[%@]", self, NSStringFromSelector(_cmd), returnCode, contextInfo );
	
	[sheet orderOut:self];
	
}


-(IBAction) showStartupModeOptions:(id) sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

	
	if ( _mainWindowController )
	{
		NSLog (@ "Inside %@ => %@...Need to release _mainWindowController", self, NSStringFromSelector(_cmd) );
		NSLog (@ "Inside %@ => %@...[_mainWindowController class] = [%@]", self, NSStringFromSelector(_cmd), [_mainWindowController class] );

//		[_mainWindowController release];
//		_mainWindowController = nil;
	}
	
	NSLog (@ "Inside %@ => %@...Need to release show window", self, NSStringFromSelector(_cmd) );
	short curTag = [[NSUserDefaults standardUserDefaults] integerForKey:sPrefStartupMode];
	switch (curTag) {
		case eAppRunModeCamera:
		case eAppRunModeSales:
		case eAppRunModeDvd:
			break;
		default:
			curTag = eAppRunModeCamera;
			break;
	}
	
	// set to default tag
	[_selectionMatrix selectCellWithTag:curTag];
	// sync to pref
	[[NSUserDefaults standardUserDefaults] setInteger:curTag forKey: sPrefStartupMode];	// 5-8-03 use predefine
	[[NSUserDefaults standardUserDefaults] synchronize];
	
	
	if ( ![_selectStartupWindow isVisible] )
	{
		[NSApp beginSheet:_selectStartupWindow
		   modalForWindow:nil
			modalDelegate:self 
		   didEndSelector:@selector(didEndSheet:returnCode:contextInfo:) 
			  contextInfo:nil];
	}
	
	
}


-(IBAction)showSalesPref:(id)sender // 2014-10-27steve
{
    short curTag = [[NSUserDefaults standardUserDefaults] integerForKey:sPrefStartupMode];

    switch (curTag) {
		case eAppRunModeSales:
            [[NSNotificationCenter defaultCenter] postNotificationName:@"OpenSalesPreferenceNotification" object:self userInfo:nil]; // 2014-10-27steve

			break;
        default:
            NSBeep();
            break;
	}

}


-(NSString*)getSalesStationWindowString // 2014-10-26steve
{
    NSString* suffix = @"";
    BOOL doKioskMode = [[NSUserDefaults standardUserDefaults] boolForKey:@"prefRunSalesWindowInKioskMode"]; // 2014-11-06steve
    
    if (doKioskMode) {
        suffix = [NSString stringWithFormat:@"%@",@"Kiosk"];
    }
    
    NSString* name = [NSString stringWithFormat:@"SalesStationWindow%@",suffix];
    
    return name;
}

-(void) doInitializeWindow
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

//	NSModalSession* myModalSession = [NSApp beginModalSessionForWindow:_selectStartupWindow];

	
	short startupMode = [[NSUserDefaults standardUserDefaults] integerForKey:sPrefStartupMode];
	NSLog ( @"2010-11-08steve  startupMode is [%i]", startupMode );
	switch ( startupMode )
	{
		case eAppRunModeCamera:
		case eAppRunModeSales:
		case eAppRunModeDvd:
			gAppRunMode = startupMode;
			break;
		default:
			NSLog ( @"2010-11-08steve BAD startupMode is [%i]", startupMode );
			
			gAppRunMode = 0;
			// this is where we probably want to present user with options as to what mode to startup in
			[self showStartupModeOptions:nil];
			
			break;
	}
	
	
	if ( _mainWindowController )
	{
		[_mainWindowController release];
		_mainWindowController = nil;
	}
	switch ( gAppRunMode )
	{
		case eAppRunModeCamera:
			_mainWindowController = [[MyRecorderController alloc] initWithWindowNibName:@"CameraStationWindow"];
			break;
			
		case eAppRunModeSales:
        {
            // 2014-10-27steve - TYLER - change here to see difference
            BOOL doKioskMode = [[NSUserDefaults standardUserDefaults] boolForKey:@"prefRunSalesWindowInKioskMode"];
            if (doKioskMode) {
                // 2014-10-26steve
                _mainWindowController = [[SalesStationKioskWindowController alloc] initWithWindowNibName:@"SalesStationWindowKiosk"]; // 2014-10-26steve
            } else {
                _mainWindowController = [[SalesStationWindowController alloc] initWithWindowNibName:@"SalesStationWindow"];
            }
        }
			break;
			
		case eAppRunModeDvd:
			_mainWindowController = [[DvdStationWindowController alloc] initWithWindowNibName:@"DvdStationWindow"];
			break;
			
		default:
			_mainWindowController = nil;
			NSLog ( @"2010-11-06steve - UNKNOWN Initializer?????" );
			break;
	}
	
	[_mainWindowController window]; // force nib to load
	
}

#pragma mark -

- (void)beginEditingMovie:(id)movieRef
{
    //NSString * srcPath = self.mRecordedMoviePath;
    //open a QTMovieView with this movie open for editing
    if(nil == _editMovieWindowController)
    {
        _editMovieWindowController = [[EditAVMovieWindowController alloc] initWithWindowNibName:@"EditStationWindow"];
        NSWindow * w =[_editMovieWindowController window]; // force nib to load
        [w makeKeyAndOrderFront:self];
    }
    _editMovieWindowController.movieRef = movieRef;
//    QTMovie * movie = nil;
//    NSError * error;
//    if([movieRef isKindOfClass:NSString.class])
//    {
//        //try to load the movie
//        movie = [QTMovie movieWithFile:movieRef error:&error];
//    }
//    else if([movieRef isKindOfClass:NSURL.class])
//    {
//        //try to load the movie
//        movie = [QTMovie movieWithURL:movieRef error:&error];
//    }
//    if(movie)
//    {
//        [movie setAttribute:@YES forKey:QTMovieEditableAttribute];
//        NSLog(@"Movie attribs: %@",movie.movieAttributes);
//        _editMovieWindowController.mQTMovie = movie;
//    }
}


#pragma mark -

- (int)daysBetween:(NSDate *)dt1 and:(NSDate *)dt2
{
    NSUInteger unitFlags = NSDayCalendarUnit;
    NSCalendar *calendar = [[[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar] autorelease];
    NSDateComponents *components = [calendar components:unitFlags fromDate:dt1 toDate:dt2 options:0];
    return [components day]+1;
}


#pragma mark -

-(void)quitApplication:(NSDictionary *)d
{
    ProcessSerialNumber processToQuit = { [[d objectForKey:@"NSApplicationProcessSerialNumberHigh"] unsignedLongValue], [[d objectForKey:@"NSApplicationProcessSerialNumberLow"] unsignedLongValue]};
    AEDesc targetProcess = {typeNull, NULL};
    AppleEvent theEvent = {typeNull, NULL};
    AppleEvent eventReply = {typeNull, NULL};
    
    //OSStatus status;
    if(noErr == AECreateDesc(typeProcessSerialNumber, &processToQuit, sizeof(processToQuit), &targetProcess))
    {
        if(noErr == AECreateAppleEvent(kCoreEventClass, kAEQuitApplication, &targetProcess, kAutoGenerateReturnID, kAnyTransactionID, &theEvent))
        {
            if(noErr == AESendMessage(&theEvent, &eventReply, kAENoReply | kAENeverInteract, kAEDefaultTimeout))
            {
                AEDisposeDesc(&eventReply);
            }
            AEDisposeDesc(&theEvent);
        }
        AEDisposeDesc(&targetProcess);
    }
}

-(void)childProcessDidTerminate:(NSNotification *)notification
{
    // check if it is our app
    NSDictionary * d = [notification userInfo];
    
    NSLog(@"App terminated: %@",d);
    
    if([_childProcesses count])
    {
        NSNumber * low = [d objectForKey:@"NSApplicationProcessSerialNumberLow"];
        NSNumber * high = [d objectForKey:@"NSApplicationProcessSerialNumberHigh"];
        id object;
        // enumerate a snapshot of the mutable set
        NSEnumerator * e = [[_childProcesses allObjects] objectEnumerator];
        while (object = [e nextObject])
        {
            if([object respondsToSelector:@selector(objectForKey:)] && [[object objectForKey:@"NSApplicationProcessSerialNumberLow"] isEqualToNumber:low] && [[object objectForKey:@"NSApplicationProcessSerialNumberHigh"] isEqualToNumber:high])
            {
                [object retain];
                [_childProcesses removeObject:object];
                
                NSLog(@"Child process \"%@\" (PID %@) has terminated unexpectedly. Attempting to relaunch...", [d objectForKey:@"NSApplicationName"], [d objectForKey:@"NSApplicationProcessIdentifier"]);
                
                [self performSelector:@selector(launchChildProcess: ) withObject:object afterDelay:3];
                [object release];
                break;
            }
        }
    }
}

-(BOOL)launchChildProcess:(NSDictionary *)d
{
    BOOL didLaunch = NO;
    
    NSString * launchPath = [d objectForKey:@"NSApplicationPath"];
    FSRef appToLaunch;
    OSStatus err = FSPathMakeRef((const UInt8 *)[launchPath fileSystemRepresentation], &appToLaunch, NULL);
    if (noErr == err)
    {
        id environmentDict = [d objectForKey:@"NSApplicationEnvironment"];
        id argvArray = [d objectForKey:@"NSApplicationArgv"];
        AppleEventPtr initialEvent = (AppleEventPtr)[[d objectForKey:@"NSApplicationInitialAppleEvent"] aeDesc];
        LSLaunchFlags flags = [[d objectForKey:@"NSApplicationLaunchFlags"] unsignedLongValue];
        LSApplicationParameters appParams = {0, flags, &appToLaunch, self, (CFDictionaryRef)environmentDict, (CFArrayRef)argvArray, initialEvent};
        ProcessSerialNumber outPSN = {0,0};
        err = LSOpenApplication(&appParams, &outPSN);
        //kEventAppLaunchNotification;
        
        if(noErr == err && (outPSN.lowLongOfPSN | outPSN.highLongOfPSN))
        {
            didLaunch = YES;
            NSMutableDictionary * m = [[d mutableCopy] autorelease];
            [m setObject:[NSNumber numberWithUnsignedLong:outPSN.lowLongOfPSN] forKey:@"NSApplicationProcessSerialNumberLow"];
            [m setObject:[NSNumber numberWithUnsignedLong:outPSN.highLongOfPSN] forKey:@"NSApplicationProcessSerialNumberHigh"];
            d = [[m copy] autorelease];
            [_childProcesses addObject:d];
        }
    }
    //nsvErr
    return didLaunch;
}



// 2013-10-08steve
-(IBAction)launchFlashWriter:(id)sender
{
    {
        NSString* myAppNameToLaunch = @"Teps-FlashWriter.app";
        NSString* myBundlePath = [[NSBundle mainBundle] bundlePath ];
        //NSString* myAppNameToLaunch = [[NSUserDefaults standardUserDefaults] stringForKey:sPrefLaunchChildApp];
        
        if ( myAppNameToLaunch) {
            if (_childProcesses==nil)
                _childProcesses = [[NSMutableSet alloc] initWithCapacity:0];
            NSString* pathToApp = nil;
            NSArray* pathsToSearch = [NSArray arrayWithObjects:myBundlePath, @"/Applications",@"/Applications/TEPS OS X Share Folder",nil];
            for ( id subpath in pathsToSearch) {
                pathToApp = [subpath stringByAppendingPathComponent:myAppNameToLaunch];
                BOOL exists = [[NSFileManager defaultManager] fileExistsAtPath:pathToApp];
                if (!exists)
                    pathToApp = nil;
                else {
                    break;
                }
                
            }
            if(pathToApp) {
                LSLaunchFlags flags = kLSLaunchDontAddToRecents | kLSLaunchDontSwitch | kLSLaunchAndHide;
                [self launchChildProcess:[NSDictionary dictionaryWithObjectsAndKeys:pathToApp, @"NSApplicationPath",
                                          [NSNumber numberWithUnsignedLong:flags], @"NSApplicationLaunchFlags",
                                          nil]];
            }
        }
    }
    
}



#pragma mark -

-(IBAction) sendToBack:(id)sender // 2014-09-25steve
{
    

    NSArray * appsArray =   (id)CopyLaunchedApplicationsInFrontToBackOrder();
    NSLog(@"current running apps (in GUI order):%@",appsArray);
    
    // get the first app in the list using "method 1"
    NSString * nextApp = appsArray.count ? [appsArray[1] objectForKey:@"BundlePath"] : nil;
    
    NSLog(@"nextApp (in GUI order):%@",nextApp);

    // launch the first app after a delay (use NSWorkspace method)
    __block BOOL didLaunch = NO;
    double delayInSeconds = 0.1;
    dispatch_time_t popTime = dispatch_time(DISPATCH_TIME_NOW, (int64_t)(delayInSeconds * NSEC_PER_SEC));
    dispatch_after(popTime, dispatch_get_main_queue(), ^(void){
        didLaunch = [[NSWorkspace sharedWorkspace] launchApplication:nextApp];
        NSLog(@"DID%s acitvate %@", didLaunch ? "": " NOT",nextApp);
    });

    
    
    
}


#pragma mark -

-(void) dealloc
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

    self.fBarcodeController = nil; // 2014-11-04steve

	[super dealloc];
}


- (void)awakeFromNib
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

	_mainWindowController = nil;
    
    
    short curTag = [[NSUserDefaults standardUserDefaults] integerForKey:sPrefStartupMode];
    if (curTag==eAppRunModeSales || curTag==eAppRunModeCamera ) // 2014-11-05steve check for recorder mode too // 2014-11-04steve
    { // 2014-11-04steve
        NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init];
        self.fBarcodeController = [[[BarcodeEntryController alloc] init] autorelease];
        NSLog (@ "%@->%@... BarcodeEntryController = %@", self, NSStringFromSelector(_cmd), self.fBarcodeController );
        [pool release];
        
    }


}


// 2014-11-07steve - this one seems to not get called even if just one item being passed
- (void)application:(NSApplication *)theApplication openFile:(NSString*)filename
{
    NSLog ( @"%@ - %@...filename=[%@]", self, NSStringFromSelector(_cmd),filename );
    
    if (filename) {
        NSArray* filenames = [NSArray arrayWithObjects:filename, nil];
        [self application:theApplication openFiles:filenames];
    }
    
}

// 2014-11-07steve - just play a movie in sales mode only
// this is for external drag/drop to this app
// we want single and multi items be in an array
- (void)application:(NSApplication *)theApplication openFiles:(NSArray *)filenames
{
    NSLog ( @"%@ - %@...filenames=[%@]", self, NSStringFromSelector(_cmd),filenames );	// 2011-08-12steve
    
    if ( filenames && [filenames count]) {
        NSString* validItem = [filenames firstObject];
        NSNotification* note =[NSNotification notificationWithName:sTepsVideoAppNotification
                                                            object:nil
                                                          userInfo:[NSDictionary dictionaryWithObjectsAndKeys:validItem,@"moviepath",@"playvideofile",@"action", nil]];
        [[NSDistributedNotificationCenter defaultCenter] performSelectorOnMainThread:@selector(postNotification:)
                                                                          withObject:note
                                                                       waitUntilDone:NO];

    }


}





- (NSApplicationTerminateReply)applicationShouldTerminate:(NSApplication *)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	//	// 2010-10-25steve
	//	NSNotificationCenter* nc = [NSNotificationCenter defaultCenter];
	//	[nc removeObserver:self
	//				  name:NSThreadWillExitNotification
	//				object:nil];
	//	
	
	if ( ![_mainWindowController isKindOfClass:[MyRecorderController class]] )
	{
		[_mainWindowController release];
		_mainWindowController = nil;		
	}
	
	return NSTerminateNow;
}

- (void)applicationWillFinishLaunching:(NSNotification *)aNotification
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	
	// 2013-10-08steve
	// we only want to be notified if the quicktime player has launched 
	[[[NSWorkspace sharedWorkspace] notificationCenter] addObserver:self
														   selector:@selector(childProcessDidTerminate:)
															   name:NSWorkspaceDidTerminateApplicationNotification
															 object:nil];
	
    
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(handleAppDelegateNotification:)
                                                 name:@"AppDelegateNotification" // 2014-07-31steve
                                               object:nil];
    
    
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(handleSendSelfToBack:) // 2014-09-25steve
                                                 name:@"TepsNotificationSendToBack"
                                               object:nil];
    
    
    
    
    BOOL doTestSecurityKey = YES; // 2014-10-01steve // 2013-06-17steve - test Security Key from ka.triprism.com site
    if ( doTestSecurityKey) {
        
        TepsUrlHandler * urlHandler = [[TepsUrlHandler alloc] init];
        BOOL needToTerminate = [urlHandler doTestStuff];
        if ( needToTerminate) {
            
            NSAlert * alert = [NSAlert alertWithMessageText:@"PLEASE REGISTER This APP"
                                              defaultButton:@"OK"
                                            alternateButton:@"Purchase Original Movie"
                                                otherButton:@"Trim and Purchase"
                                  informativeTextWithFormat:@"Do Want to Purchase Original Movie or Trimmed Movie"];
            
            [alert runModal];
            
            
            
        }


    }
    
    BOOL doForceExpiration = YES; // 2014-01-30steve // 2013-07-09steve - force time limit
    if (doForceExpiration) {

        NSDate * curDate = [NSDate date];
        NSLog(@"2013-07-09steve check for date...%@",curDate);
        NSString* zoneString = @"000";
        NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
        [dateFormatter setDateFormat:@"Z"];
        NSString *tz = [dateFormatter stringFromDate:[NSDate date]];
        if ( tz)
            zoneString = [NSString stringWithFormat:@"%@",tz];
        [dateFormatter release];
        
        // ================================================================================================================
        //   SET EXPIRATION DATE to EXPIRE
        int minWarningDays = 10; // 2013-10-23steve
        NSDate* expirationDate = [NSDate dateWithString:[NSString stringWithFormat: @"2015-01-06 00:00:00 %@",zoneString]]; // 2014-09-04 // 2014-06-01 // 2014-01-30steve
        // ================================================================================================================
        
        NSLog(@"2013-07-08steve expirationDate = %@",zoneString);
        NSLog(@"2013-07-08steve expirationDate = %@",expirationDate);
        
        BOOL doTerminate = NO;
        if ( [curDate compare:expirationDate] == NSOrderedAscending) {
            NSLog(@"2013-07-08 curDate is BEFORE expiration date = %@",expirationDate);
        } else {
            NSLog(@"2013-07-08 curDate is AFTER expiration date = %@",expirationDate);
            doTerminate = YES;
        }
        
        NSLog(@"2013-07-08steve expirationDate = %@",[expirationDate descriptionWithLocale:[NSLocale currentLocale]]);

        if ( doTerminate) {
            
            NSAlert* alert = [[NSAlert alloc] init];
            [alert setMessageText:[NSString stringWithFormat:@"Sorry KEY EXPIRED..." ]];
            [alert setInformativeText:[NSString stringWithFormat:@"This App Expired on %@..", [expirationDate descriptionWithLocale:[NSLocale currentLocale]]]];
            [alert addButtonWithTitle:@"OK"];
            [[NSApplication sharedApplication] activateIgnoringOtherApps: YES];
            [alert runModal];
            [alert release];
            NSLog(@"2013-07-08steve expirationDate = %@",expirationDate);
            [NSApp terminate:self]; // tyler added actual terminate call 2013-10-01
        } else {
            
            int daysLeft = [self daysBetween:curDate and:expirationDate]; // 2013-10-08steve
            NSLog(@"2013-10-08steve Days Left is = %i",daysLeft);
            if ( daysLeft>=0 && daysLeft < minWarningDays ) {
                NSAlert* alert = [[NSAlert alloc] init];
                [alert setMessageText:[NSString stringWithFormat:@"WARNING - Key is Expiring Soon..." ]];
                [alert setInformativeText:[NSString stringWithFormat:@"\nThis App Will Expire in less than %i Day%@.\n\nExpiration Date is:\n%@.\n\n",daysLeft, daysLeft>1?@"s":@"" , [expirationDate descriptionWithLocale:[NSLocale currentLocale]] ]];
                [alert addButtonWithTitle:@"OK"];
                [[NSApplication sharedApplication] activateIgnoringOtherApps: YES];
                [alert runModal];
                [alert release];
            }

        }
        
        
        
    }
	else {
        
        /* 2014-09-04steve - we are doing it above - so really NO NEED for this...
         
        // 2014-01-30steve - check for PTI or TPI security key file
        
        webKeyInfoObject *myKeyInfo = [[webKeyInfoObject alloc] initForTPI];
        if ( myKeyInfo && [myKeyInfo isValidLicense] ) {
            doForceExpiration = NO;
            [myKeyInfo release];
        } else {
            doForceExpiration = YES;
        }
        
        if ( doForceExpiration ) {
            NSLog(@"UNABLE to Validate Security Info...");		// either does not exist or expired
            NSRunAlertPanel( @"INVALID License", @"Your Teps License is Missing or has Expired...", @"Quit", nil, nil );
            [NSApp terminate:self];
        }

         */
        
    }
    

    
    
    
    // 2013-10-16steve - get the version
    NSString* infoString = @"Unknown Version";
    NSBundle *myBundle = [NSBundle mainBundle];
    if ( myBundle )
    {
        infoString = [myBundle objectForInfoDictionaryKey:@"CFBundleShortVersionString" ];
    }
    
    if ( infoString==nil ) // 2009-08-10steve
    {
        infoString = [NSString stringWithString:@"Unknown CFBundleShortVersionString" ];
    }
 
    if (infoString==nil) {
        infoString = @"Unknown Version";
    }

// 2014-09-23steve - new info.plist method dynamically fills in release or debug
//#ifdef DebugVersion
//    if (infoString) infoString = [NSString stringWithFormat:@"%@ (DEBUG)", infoString];
//#endif
    
    NSString* copyright = [myBundle objectForInfoDictionaryKey:@"NSHumanReadableCopyright"];
    if (copyright) {
        if (infoString)
            infoString = [infoString stringByAppendingFormat:@"  %@",copyright]; // 2013-11-03
    }

    NSLog(@"This AppVersion is: %@", infoString);
    if (infoString) {
        [[NSUserDefaults standardUserDefaults] setObject:infoString forKey:@"prefAppVersion"]; // 2013-10-14steve
    }
    
}


- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

	
	[self doInitializeWindow]; // 2010-11-08steve

	switch ( gAppRunMode )
	{
		case eAppRunModeCamera:
			break;
		case eAppRunModeSales:
			break;
		case eAppRunModeDvd:
			// [_mainWindowController setupWatcher]; // force nib to load
			break;
	}
    

}

- (void)applicationWillTerminate:(NSNotification *)aNotification
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

    [[[NSWorkspace sharedWorkspace] notificationCenter] removeObserver:self];
    if([_childProcesses count])
    {
        id object;
        // enumerate a snapshot of the mutable set
        NSEnumerator * e = [[_childProcesses allObjects] objectEnumerator];
        while (object = [e nextObject])
        {
            [object retain];
            [_childProcesses removeObject:object];
            [self quitApplication:object];
            [object release];
        }
    }

}


- (void)applicationWillBecomeActive:(NSNotification *)notification // 2014-09-25steve
{
    NSLog(@"%@-> frontmost app is %@", self,[[NSWorkspace sharedWorkspace] frontmostApplication].bundleIdentifier);
    
    
    NSRunningApplication* curapp = [NSRunningApplication currentApplication];
    NSLog(@"%@-> curapp is %@", self,curapp.bundleIdentifier);
    if ( self._oldApp) {
        if ( [self._oldApp.bundleIdentifier caseInsensitiveCompare:curapp.bundleIdentifier]!=NSOrderedSame) {
            self._oldApp = [[NSWorkspace sharedWorkspace] frontmostApplication];
        } else {
            NSLog(@"%@-> still the same old app is %@", self, self._oldApp);
        }
    } else {
        self._oldApp = [[NSWorkspace sharedWorkspace] frontmostApplication];

    }
    
    
    NSLog(@"%@-> _oldApp is %@", self, self._oldApp);
    
}



//// 2010-11-10steve
//-(void)childProcessDidTerminate:(NSNotification *)notification
//{
//	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
//	NSLog (@ "Inside %@ => %@...notification = %@", self, NSStringFromSelector(_cmd), notification );
//	
//	// this way we know that they are done with the full screen quicktime player
//	bool isOurWatcherApp = false;
//	id watcherApp = [notification userInfo];
//	if ( [watcherApp caseInsensitiveCompare:@"Quicktime Player"]==NSOrderedSame )
//	{
//		isOurWatcherApp = true;
//	
//		[[[NSWorkspace sharedWorkspace] notificationCenter] removeObserver:self];
//	}
//	
//}




#pragma mark -

-(void) handleAppDelegateNotification:(NSNotification*)notif // 2014-07-31steve
{
    NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

    NSDictionary* userInfo = [notif userInfo];
    NSString* action = [userInfo objectForKey:@"action"];
    if ( action) {
        if ([action caseInsensitiveCompare:@"relaunchApp"]==NSOrderedSame) {
            [self relaunchApp:nil];
        }
    }
    
    
}


-(void) handleSendSelfToBack:(NSNotification*)note // 2014-09-25steve
{
    NSLog (@ "%@->%@...........................................................................", self, NSStringFromSelector(_cmd) );
    NSLog (@ "%@->%@...with Notif = %@", self, NSStringFromSelector(_cmd), note );
    NSLog (@ "%@->%@...........................................................................", self, NSStringFromSelector(_cmd) );
    
    [self sendToBack:nil];
    
}


@end
