//
//  MyRecorderController.h
//  MyRecorder

 /*

Disclaimer: IMPORTANT:  This Apple software is supplied to you by 
Apple Inc. ("Apple") in consideration of your agreement to the
following terms, and your use, installation, modification or
redistribution of this Apple software constitutes acceptance of these
terms.  If you do not agree with these terms, please do not use,
install, modify or redistribute this Apple software.

In consideration of your agreement to abide by the following terms, and
subject to these terms, Apple grants you a personal, non-exclusive
license, under Apple's copyrights in this original Apple software (the
"Apple Software"), to use, reproduce, modify and redistribute the Apple
Software, with or without modifications, in source and/or binary forms;
provided that if you redistribute the Apple Software in its entirety and
without modifications, you must retain this notice and the following
text and disclaimers in all such redistributions of the Apple Software. 
Neither the name, trademarks, service marks or logos of Apple Inc. 
may be used to endorse or promote products derived from the Apple
Software without specific prior written permission from Apple.  Except
as expressly stated in this notice, no other rights or licenses, express
or implied, are granted by Apple herein, including but not limited to
any patent rights that may be infringed by your derivative works or by
other works in which the Apple Software may be incorporated.

The Apple Software is provided by Apple on an "AS IS" basis.  APPLE
MAKES NO WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION
THE IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE, REGARDING THE APPLE SOFTWARE OR ITS USE AND
OPERATION ALONE OR IN COMBINATION WITH YOUR PRODUCTS.

IN NO EVENT SHALL APPLE BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE, REPRODUCTION,
MODIFICATION AND/OR DISTRIBUTION OF THE APPLE SOFTWARE, HOWEVER CAUSED
AND WHETHER UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE),
STRICT LIABILITY OR OTHERWISE, EVEN IF APPLE HAS BEEN ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

Copyright (C) 2007-2008 Apple Inc. All Rights Reserved.

*/

#import <Cocoa/Cocoa.h>
#import <QTKit/QTkit.h>
#import "StatusWindowController.h" // 2014-07-13steve


@interface MyRecorderController : NSWindowController <NSWindowDelegate, NSTabViewDelegate> {
    
    IBOutlet QTCaptureView *mCaptureView;
	IBOutlet NSProgressIndicator* mProgressIndicator;
	
    QTCaptureSession            *mCaptureSession;
    QTCaptureMovieFileOutput    *mCaptureMovieFileOutput;
    QTCaptureDeviceInput        *mCaptureVideoDeviceInput;
    QTCaptureDeviceInput        *mCaptureAudioDeviceInput;
	
	NSString					*mRecordedMoviePath;
	NSString					*mMergedMovieItem;
	
	BOOL						mDoMergeVideo; // 2010-10-29
	BOOL						_mIsRecording;
	
	NSString					*mMovieToPlayPath;
	
	IBOutlet	NSWindow		*mMainWindow;
	
	
	IBOutlet NSTabView		*_myNSTabView;

	// SaveAs Panel
	NSString					*mTempRenameString;
	IBOutlet	NSPanel			*mSaveAsPanel;
	
	// update timer
	NSTimer						*mRecordingTimer; // 2010-11-02steve
	
	IBOutlet	NSTextField		*ibTextField1;
	
	
    IBOutlet NSArrayController  *mOptionsArrayController; // 2013-10-10steve
    IBOutlet NSArrayController  *mCameraArrayController; // 2014-06-10steve
    IBOutlet NSArrayController  *mMicrophoneArrayController; // 2014-06-26steve
    
    NSNumber* fSelectedIndex; // 2013-10-10steve
    NSString* fSelectedOptionValue; // 2013-10-10steve
    IBOutlet NSPopUpButton* ibPopupButton; // 2013-10-14steve
    
	NSDateFormatter*	_mDateFormatter;
	
	NSString*	mCurWorkingPath;
    
    StatusWindowController * mVideoStatusWindowController; // 2014-07-13steve
    // StatusWindowController * mVideoAlertWindowController2; // 2014-08-09steve
    
    IBOutlet NSPanel        *ibAlertPanel; // 2014-08-9steve
    IBOutlet NSTextField	*ibAlertTextField2; // 2014-08-09steve

    // IBOutlet NSWindow* ibStatusWindow; // 2014-07-02
    
    NSString* fCurrentTepsCustomerID; // 2014-07-14steve
    NSString* fCurrentTepsDailyFolderPath; // 2014-07-14steve
    NSTimer* fWarningTimer1; // 2014-07-22steve
    
    NSRunningApplication* _oldApp; // 2015-09-25steve
    
    IBOutlet	NSPanel			*ibPromptForChildNamePanel; // 2014-10-17steve

}

@property (retain) NSString *mRecordedMoviePath;
@property (retain) NSString *mMergedMovieItem;
@property (retain) NSString *mMovieToPlayPath;
@property (retain) NSString *mTempRenameString;
@property (retain) NSString *mCurWorkingPath;
@property (retain) NSTimer *mRecordingTimer;
@property (nonatomic,retain) NSNumber* fSelectedIndex; // 2013-10-10steve
@property (nonatomic,retain) NSString* fSelectedOptionValue; // 2013-10-10steve
@property (nonatomic,retain) StatusWindowController * mVideoStatusWindowController; // 2014-07-13steve
//@property (nonatomic,retain) StatusWindowController * mVideoAlertWindowController2; // 2014-08-09steve
@property (nonatomic,retain) NSString* fCurrentTepsCustomerID; // 2014-07-15steve
@property (nonatomic,retain) NSString* fCurrentTepsDailyFolderPath; // 2014-07-15steve
@property (nonatomic,retain) NSTimer* fWarningTimer1; // 2014-07-22steve
@property (nonatomic,retain) NSRunningApplication* _oldApp; // 2014-09-25steve

- (IBAction)toggleRecording:(id)sender;

- (IBAction)startRecording:(id)sender;
- (IBAction)stopRecording:(id)sender;
- (IBAction) doAction1:(id)sender; // 2010-10-22steve


//- (IBAction) doRename:(id)sender;
- (IBAction) doClear:(id)sender;
- (IBAction) closeSheet:(id)sender;

-(IBAction) ibClickedOnChangeOriginalVideosFolder:(id)sender;



@end
