//
//  NSTextField+TepsAdditions.m
//  MyRecorder
//
//  Created by steve on 11/3/10.
//  Copyright 2010 TriPrism, Inc. All rights reserved.
//

#import "NSTextField+TepsAdditions.h"


@implementation NSTextField (TepsAdditions)

- (void) ibUpdateNSTextFieldWithString:(NSString*)theText doWait:(BOOL) doWait withColor:(NSColor*)textColor
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	{
		{
			NSColor* useColor = [NSColor blackColor];
			if (textColor)
			{
				useColor = textColor;
			}
			
			[self performSelectorOnMainThread:@selector(setTextColor:)
								   withObject:useColor 
								waitUntilDone:doWait];
			
			[self performSelectorOnMainThread:@selector(setStringValue:)
								   withObject:theText 
								waitUntilDone:doWait];
			
			[self performSelectorOnMainThread:@selector(display)
								   withObject:nil 
								waitUntilDone:doWait];
		}
		
	}
	
	if ( pool) [pool release];
}

- (void) ibUpdateNSTextFieldWithString:(NSString*)theText doWait:(BOOL) doWait isError:(BOOL)isError
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	{
		{
			NSColor* useColor = [NSColor blackColor];
			if (isError)
			{
				useColor = [NSColor redColor];
			}
			
			[self performSelectorOnMainThread:@selector(setTextColor:)
								   withObject:useColor 
								waitUntilDone:doWait];
			
			[self performSelectorOnMainThread:@selector(setStringValue:)
								   withObject:theText 
								waitUntilDone:doWait];
			
			[self performSelectorOnMainThread:@selector(display)
								   withObject:nil 
								waitUntilDone:doWait];
		}
		
	}
	
	if ( pool) [pool release];
}

- (void) ibUpdateNSTextFieldOld:(id)theField withString:(NSString*)theText doWait:(BOOL) doWait isError:(BOOL)isError
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	if ( theField )
	{
		{
			NSColor* useColor = [NSColor blackColor];
			if (isError)
			{
				useColor = [NSColor redColor];
			}
			
			[theField performSelectorOnMainThread:@selector(setTextColor:)
									   withObject:useColor 
									waitUntilDone:doWait];
			
			[theField performSelectorOnMainThread:@selector(setStringValue:)
									   withObject:theText 
									waitUntilDone:doWait];
			
			[theField performSelectorOnMainThread:@selector(display)
									   withObject:nil 
									waitUntilDone:doWait];
		}
		
	}
	else
	{
		NSLog (@ "Inside %@ => %@... NIL NSTextField....", self, NSStringFromSelector(_cmd) );
	}
	if ( pool) [pool release];
}

@end
