//
//  NSApplication+Relaunch.m
//  Relaunch Demo
//

#import "NSApplication+Relaunch.h"


@implementation NSApplication (Relaunch)

- (void)relaunch:(id)info
{
	
	NSLog (@ "Inside %@ => %@...info = [%@]", [self class], NSStringFromSelector(_cmd), info );
	
	id mySender = nil;
	LSLaunchFlags flags = kLSLaunchDefaults;	// NSApplicationRelaunchInBackground;
	if ( info )
	{
		if ( [info isKindOfClass:[NSDictionary class]] )
		{
			mySender = [info objectForKey:@"sender"];
			flags = [[info objectForKey:@"LSLaunchFlags"] longValue];
		}
		
		if ( [info isKindOfClass:[NSButton class]] )
		{
			mySender = info;
		}
	}
	
	
	NSString *daemonPath = [[NSBundle mainBundle] pathForResource:NSApplicationRelaunchDaemon ofType:nil];

	// [NSTask launchedTaskWithLaunchPath:daemonPath arguments:[NSArray arrayWithObjects:[[NSBundle mainBundle] bundlePath], [NSString stringWithFormat:@"%d", [[NSProcessInfo processInfo] processIdentifier]], nil]];
	[NSTask launchedTaskWithLaunchPath:daemonPath arguments:[NSArray arrayWithObjects:[[NSBundle mainBundle] bundlePath], 
															 [NSString stringWithFormat:@"%d", [[NSProcessInfo processInfo] processIdentifier]],
															 [NSString stringWithFormat:@"%d", flags],
															 nil]];
	
	[self terminate:mySender];
}




@end
