//
//  relaunch.m
//  Relaunch Demo
//
//  Created by Matt Patenaude on 4/16/09.
//  Copyright 2009 Matt Patenaude. All rights reserved.
//

#import <Cocoa/Cocoa.h>



BOOL launchChildProcess(NSDictionary *d )
{
    BOOL didLaunch = NO;
	NSMutableSet *_childProcesses = [[[NSMutableSet alloc] init] autorelease];
	
	
    NSString * launchPath = [d objectForKey:@"NSApplicationPath"];
    FSRef appToLaunch;
    OSStatus err = FSPathMakeRef((const UInt8 *)[launchPath fileSystemRepresentation], &appToLaunch, NULL);
    if (noErr == err)
    {
        id environmentDict = [d objectForKey:@"NSApplicationEnvironment"];
        id argvArray = [d objectForKey:@"NSApplicationArgv"];
        AppleEventPtr initialEvent = (AppleEventPtr)[[d objectForKey:@"NSApplicationInitialAppleEvent"] aeDesc];
        LSLaunchFlags flags = [[d objectForKey:@"NSApplicationLaunchFlags"] unsignedLongValue];
        LSApplicationParameters appParams = {0, flags, &appToLaunch, nil, (CFDictionaryRef)environmentDict, (CFArrayRef)argvArray, initialEvent};
        ProcessSerialNumber outPSN = {0,0};
        err = LSOpenApplication(&appParams, &outPSN);
        //kEventAppLaunchNotification;
		
        if(noErr == err && (outPSN.lowLongOfPSN | outPSN.highLongOfPSN))
        {
            didLaunch = YES;
            NSMutableDictionary * m = [[d mutableCopy] autorelease];
            [m setObject:[NSNumber numberWithUnsignedLong:outPSN.lowLongOfPSN] forKey:@"NSApplicationProcessSerialNumberLow"];
            [m setObject:[NSNumber numberWithUnsignedLong:outPSN.highLongOfPSN] forKey:@"NSApplicationProcessSerialNumberHigh"];
            d = [[m copy] autorelease];
            [_childProcesses addObject:d];
        }
    }
    //nsvErr
    return didLaunch;
}





#pragma mark Main method
int main(int argc, char *argv[])
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	NSLog (@"2010-11-26steve...........argc = %i", argc);
	
	// if argv[3] is not specified, then launch in the BG and do to bring window to front
	LSLaunchFlags flags = kLSLaunchDefaults;	// kLSLaunchDontAddToRecents | kLSLaunchDontSwitch | kLSLaunchAndHide;
	if (argc>3 )
	{
		NSLog (@"2010-11-26steve...........argv[3] = %s", argv[3]);
		flags = atol(argv[3]);
	}
	// flags = kLSLaunchDefaults;
	NSLog (@"2010-11-26steve...........flags = %i = 0x%02x", flags, flags);
	
	
	pid_t parentPID = atoi(argv[2]);
	ProcessSerialNumber psn;
	while (GetProcessForPID(parentPID, &psn) != procNotFound)
		sleep(1);
	
	// NSString *appPath = [NSString stringWithCString:argv[1] encoding:NSUTF8StringEncoding];
	// BOOL success = [[NSWorkspace sharedWorkspace] openFile:[appPath stringByExpandingTildeInPath]];
	// BOOL success = [[NSWorkspace sharedWorkspace] launchApplication:[appPath stringByExpandingTildeInPath]];
	
	
	// 2010-11-26steve - now argv[1] = nsdictionary
	
	
	// 2010-11-26steve - this works but launches the first app that matches the bundleIdentifier	
	//	BOOL success = [[NSWorkspace sharedWorkspace] launchAppWithBundleIdentifier:@"com.yourcompany.Relaunch_Demo"
	//																		options:NSWorkspaceLaunchWithoutActivation
	//												 additionalEventParamDescriptor:nil
	//															   launchIdentifier:nil];
	
	
	// 2010-11-26steve - want to launch specific appPath!!!	
	
	NSString *appPath = [NSString stringWithCString:argv[1] encoding:NSUTF8StringEncoding];
	BOOL success = launchChildProcess([NSDictionary dictionaryWithObjectsAndKeys:appPath, @"NSApplicationPath", 
									   [NSNumber numberWithUnsignedLong:flags], @"NSApplicationLaunchFlags", nil] );
	
	
	
	NSLog (@"2010-11-26steve...........launchAppWithBundleIdentifier");
	
	if (!success)
		NSLog(@"Error: could not relaunch application at %@", appPath);
	
	[pool drain];
	return (success) ? 0 : 1;
}






//
//  relaunch.m
//  Relaunch Demo
//
//  Created by Matt Patenaude on 4/16/09.
//  Copyright 2009 Matt Patenaude. All rights reserved.
//
//
//#import <Cocoa/Cocoa.h>
//
//
//#pragma mark Main method
//int main(int argc, char *argv[])
//{
//	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
//	
//	pid_t parentPID = atoi(argv[2]);
//	ProcessSerialNumber psn;
//	while (GetProcessForPID(parentPID, &psn) != procNotFound)
//		sleep(1);
//	
//	NSString *appPath = [NSString stringWithCString:argv[1] encoding:NSUTF8StringEncoding];
//	// BOOL success = [[NSWorkspace sharedWorkspace] openFile:[appPath stringByExpandingTildeInPath]];
//	BOOL success = [[NSWorkspace sharedWorkspace] launchApplication:[appPath stringByExpandingTildeInPath]];
//	
//	if (!success)
//		NSLog(@"Error: could not relaunch application at %@", appPath);
//	
//	[pool drain];
//	return (success) ? 0 : 1;
//}
