//
//  SalesWindowController.m
//  MyRecorder
//
//  Created by steve on 11/7/10.
//  Copyright 2010 TriPrism, Inc. All rights reserved.
//

#import "SalesStationKioskWindowController.h"




static NSString* sNewCustomerIdNotification = @"NewCustomerId"; // 2014-11-04steve
static NSString* cPrefRenameString = @"prefRenameStringKey"; // 2014-11-04steve
static NSString* sPrefSalesQTMovie = @"prefSalesQTMovie"; // 2014-11-07steve

extern NSString * sTepsVideoAppNotification; // 2014-11-07steve

@implementation SalesStationKioskWindowController

@synthesize ibPlayPauseButton;   // 2014-11-04steve
@synthesize mCurScreen; // 2014-11-07steve



#pragma mark -


-(NSScreen*)useThisScreen  // 2014-11-07steve
{
    BOOL useExternalScreen = YES; // 2014-11-07steve - need a pref

    NSScreen* theScreen = [NSScreen mainScreen];
    NSArray* screens = [NSScreen screens];
    if (useExternalScreen) {
        theScreen = [screens lastObject];
    }
    self.mCurScreen = theScreen; // 2014-11-10steve

    return theScreen;
}

-(void) dealloc
{
    [[NSNotificationCenter defaultCenter] removeObserver:self];
    [super dealloc];
}



-(void) awakeFromNib
{
    
    [super awakeFromNib];
    
    [NSMenu setMenuBarVisible:[[NSUserDefaults standardUserDefaults] boolForKey:@"prefDoShowMenuBar"]]; // 2014-11-10steve move up

    
    NSScreen* mainscreen = [self useThisScreen]; // 2014-11-07steve //[NSScreen mainScreen];
    [self.window setFrame:mainscreen.visibleFrame display:NO];
    

    
    
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(handleNotification_MovieExtFullScreenMode:) // 2014-10-27 tyler
                                                 name:@"MovieExitFullScreenMode"
                                               object:nil];

    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(handleNotification_OpenSalesPref:) // 2014-10-27steve
                                                 name:@"OpenSalesPreferenceNotification"
                                               object:nil];

    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(handleScannedBarcode:) // 2014-11-04steve
                                                 name:sNewCustomerIdNotification
                                               object:nil];

    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(handleAVMovieViewNotification:) // 2014-11-04steve
                                                 name:@"AVMovieViewNotificaiton"
                                               object:nil];


    // 2014-11-07steve - added to receive a new movie
    [[NSDistributedNotificationCenter defaultCenter] addObserver:self
                                                        selector:@selector(handleTepsNotification:)
                                                            name:@"TepsNotificationForVideo" // 2014-11-07steve
                                                          object:nil
                                              suspensionBehavior:NSNotificationSuspensionBehaviorDeliverImmediately ];
    

    
}



-(IBAction)doPlayMovieButton:(id)sender
{
    NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

    NSNotificationCenter *nc2 = [NSNotificationCenter defaultCenter];
    [nc2 postNotificationName:@"PlayMovieNotification" object:self userInfo:nil];

}




#pragma mark -

- (void)didEndSheet:(NSWindow *)sheet returnCode:(NSInteger)returnCode contextInfo:(void *)contextInfo
{
	NSLog (@ "Inside %@ => %@... with returnCode=[%li] and ContextInfo=[%@]", self, NSStringFromSelector(_cmd), (long)returnCode, contextInfo );
    
	[sheet orderOut:self];
    
	if ( returnCode==NSRunContinuesResponse )
	{
		
		
	}
    
}

-(IBAction) closeSheet:(id)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	[NSApp endSheet:[sender window] returnCode:NSRunContinuesResponse  ];
    
}	



#pragma mark -

- (void) handleNotification_MovieExtFullScreenMode:(NSNotification*) note // 2014-10-27steve
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	NSLog (@ "Inside %@ => %@...", [self class], NSStringFromSelector(_cmd) );
    
    BOOL doShowMenuBar = [[NSUserDefaults standardUserDefaults] boolForKey:@"prefDoShowMenuBar"];
    [NSMenu setMenuBarVisible:doShowMenuBar];
    NSScreen* mainscreen = [self useThisScreen]; // 2014-11-07steve [NSScreen mainScreen];
    [self.window setFrame:mainscreen.visibleFrame display:NO];

	
	if ( pool )	[pool release];
}


- (void) handleNotification_OpenSalesPref:(NSNotification*) note // 2014-10-27steve
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	NSLog (@ "Inside %@ => %@...", [self class], NSStringFromSelector(_cmd) );
    
    if (ibSalesPrefWindow) {
        
        [NSApp beginSheet:ibSalesPrefWindow
           modalForWindow:self.window
            modalDelegate:self
           didEndSelector:@selector(didEndSheet:returnCode:contextInfo:)
              contextInfo:nil];

    }
	
	if ( pool )	[pool release];
}




- (void) handleScannedBarcode:(NSNotification*) note // 2014-11-04steve
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	NSLog (@ "Inside %@ => %@...note = %@", [self class], NSStringFromSelector(_cmd), note );
    
    
    NSString* newbarcode = [[note object] objectForKey:@"newBarcode"];
    
    if ( newbarcode) {
        [[NSUserDefaults standardUserDefaults] setObject:[NSString stringWithFormat:@"%@",newbarcode] forKey:cPrefRenameString ];
        [self performSelectorOnMainThread:@selector(closeSearchSheet:) withObject:nil waitUntilDone:NO];
    }

    
	
	if ( pool )	[pool release];
}


-(void) handleAVMovieViewNotification:(NSNotification*) note // 2014-11-04steve
{
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];

    NSLog (@ "Inside %@ => %@...note = %@", [self class], NSStringFromSelector(_cmd), note );

    if (self.ibPlayPauseButton==nil) {
        NSLog(@"self.ibPlayPauseButton is not connected...");
    }
    
    NSDictionary* userinfo = [note userInfo];
    NSString* command = [userinfo objectForKey:@"command"];
    if ( command) {
        if ( [command caseInsensitiveCompare:@"setasplaybutton"]==NSOrderedSame ) {
            self.ibPlayPauseButton.image = [NSImage imageNamed:@"Play_button"];
            self.ibPlayPauseButton.alternateImage = [NSImage imageNamed:@"Play_button_on"];
        } else if ( [command caseInsensitiveCompare:@"setaspausebutton"]==NSOrderedSame ) {
            self.ibPlayPauseButton.image = [NSImage imageNamed:@"Pause_button"];
            self.ibPlayPauseButton.alternateImage = [NSImage imageNamed:@"Pause_button_on"];
        }

    }
    
    
    if ( pool )	[pool release];
}


-(void) handleTepsNotification:(NSNotification*) note // 2014-11-04steve
{
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];

    NSLog (@ "%@->%@...........................................................................", self, NSStringFromSelector(_cmd) );
    NSLog (@ "%@->%@...with Notif = %@", self, NSStringFromSelector(_cmd), note );
    NSLog (@ "%@->%@...........................................................................", self, NSStringFromSelector(_cmd) );
    
    id param = [note userInfo];
    id action = [param objectForKey:@"action"];
    id senderApp = [param objectForKey:@"senderApp"]; // 2014-08-08steve
    
    
    if (senderApp && [senderApp caseInsensitiveCompare:@"Teps-Video.app"]==NSOrderedSame) { // 2014-08-08steve
        
        NSLog(@"SenderApp is Ourself... So Do Nothing...");
        return;
        
    }
    if (action)
    {
        
        if ( [action caseInsensitiveCompare:@"playvideofile"]==NSOrderedSame )
        {
            NSString* moviePath = [param objectForKey:@"moviepath"];
            if (moviePath) {
                self._myCurrentMovieToSell = [NSString stringWithFormat:@"%@",moviePath];
                [self setQTMovie:self._myCurrentMovieToSell];
                [[NSUserDefaults standardUserDefaults] setObject:self._myCurrentMovieToSell forKey:sPrefSalesQTMovie];
            } else {
                NSLog (@ "Inside %@ => %@...objectForKey=item is NIL", [self class], NSStringFromSelector(_cmd) );
            }
        }
        
    } else {
        NSLog(@"Unknown Action Sent from Notification???" );
    }

    
    
    /*
    NSDictionary* userinfo = [note userInfo];
    
    NSString* item = [userinfo objectForKey:@"item"];
    
    if (item) {
        self._myCurrentMovieToSell = [NSString stringWithFormat:@"%@",item];
        [self setQTMovie:self._myCurrentMovieToSell];
        [[NSUserDefaults standardUserDefaults] setObject:self._myCurrentMovieToSell forKey:sPrefSalesQTMovie];
    } else {
        NSLog (@ "Inside %@ => %@...objectForKey=item is NIL", [self class], NSStringFromSelector(_cmd) );
    }
    */
    
    if ( pool )	[pool release];
}

#pragma mark -

- (void) alertTimerFired:(NSTimer*) sender // 2014-11-04steve
{
    NSLog (@ "Inside %@ => %@... for NSTimer = [%@]", self, NSStringFromSelector(_cmd), sender );
    
    NSAlert* alert = [[sender userInfo]objectForKey:@"alert"];
    if (alert) {
        [NSApp endSheet:[alert window]];
    }
    
}

-(void) setupAlertWithAutoTimeOut:(NSDictionary*)userinfo // 2014-11-04steve
{
    NSTimer* atimer = [NSTimer scheduledTimerWithTimeInterval:3.0
                                                       target:self
                                                     selector:@selector(alertTimerFired:)
                                                     userInfo:userinfo
                                                      repeats:NO];
    [[NSRunLoop mainRunLoop] addTimer:atimer
                              forMode:NSDefaultRunLoopMode];

}


-(void) handleNoVideoFoundInKiosk:(NSString*)videoID
{
    NSLog (@ "Inside %@ => %@...videoID = %@", [self class], NSStringFromSelector(_cmd), videoID );

    NSBeep();
    
    NSAlert * alert = [NSAlert alertWithMessageText:@"UNABLE TO FIND YOUR VIDEO." // 2013-11-22steve
                                      defaultButton:@"OK"
                                    alternateButton:nil
                                        otherButton:nil
                          informativeTextWithFormat:@"\nSorry - Unable To Find Your VideoID[%@] at this time.\n\nPlease Try Again.\n\nPlease Get Assistance\n\n",videoID];
    
    
    [self setupAlertWithAutoTimeOut:[NSDictionary dictionaryWithObjectsAndKeys:alert,@"alert", nil]]; // 2014-11-04steve
    
    
    [alert beginSheetModalForWindow:self.window // 2013-11-22steve
                      modalDelegate:self
                     didEndSelector:nil
                        contextInfo:NULL];

    NSLog (@ "Inside %@ => %@...DONE...", [self class], NSStringFromSelector(_cmd) );

}


@end
