//
//  SalesWindowController.m
//  MyRecorder
//
//  Created by steve on 11/7/10.
//  Copyright 2010 TriPrism, Inc. All rights reserved.
//

#import "SalesStationWindowController.h"
#import "TepsExtras.h"
#import "MyAliasKit.h"
#import "Preferences.h"
#import "AVMovieViewController.h" // 2013-10-22steve


#define ShowBOOL(x) x?@"YES":@"NO"

typedef void (^taskCompletionBlock)(NSTask *);


extern NSString* sPrefStartupMode; // 2014-07-31steve
extern NSString * sTepsVideoAppNotification; // 2014-07-18steve

static NSString* sLocalWorkingFolderName = @"WorkingFolderForSales";
static NSString* prefRenameString = @"prefRenameStringKey";

NSString* sPrefSalesQTMovie = @"prefSalesQTMovie";
NSString* sPrefPurchasedSubFolderName = @"_Purchased";
NSString* sPrefSkippedSubFolderName = @"_NotPurchased";
NSString* sPrefSalesLoopMoveInPlayBack = @"prefSalesLoopMoveInPlayBack";

static NSString* cPrefErrorMessage = @"prefErrorMessage"; // 2013-10-04steve

NSString* sTepsFlashWriterNotificationName = @"TepsFlashDriveNotification"; // 2013-10-08steve




@implementation SalesStationWindowController

@synthesize _myCurrentMovieToSell;
@synthesize mTempRenameString;
@synthesize mCurWorkingPath;
@synthesize queryStarted; // 2013-10-04steve
@synthesize photoQuery; // 2013-10-04steve
@synthesize mAVMovieViewController; // 2013-10-22steve
@synthesize fTepsArrayOfPhotos; // 2014-07-27steve



#pragma mark -




#pragma mark-


// 2010-11-10steve
-(BOOL) updateWorkingDirectory
{
	NSString* curWorkingPath = getWorkingDirectoryPath(sLocalWorkingFolderName);
	
	NSLog ( @"2010-11-11steve curWorkingPath is [%@]", curWorkingPath );
	BOOL didCreate = createDirectoryIfMissing (curWorkingPath);
	if ( didCreate )
	{
		self.mCurWorkingPath = curWorkingPath;
	}
	else 
	{
		NSLog ( @"2010-11-11steve ERROR - unable to create current working directory???" );
	}
	
	return didCreate;
	
}


- (void)awakeFromNib
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	[self setWindowFrameAutosaveName:@"SalesStationWindow"]; 
	
	launchScriptWithParameters([NSDictionary dictionaryWithObjectsAndKeys:@"launchQTPlayer.scpt",@"scriptName",nil]);
	
	self._myCurrentMovieToSell = nil;
	
	
	NSNotificationCenter* nc = [NSNotificationCenter defaultCenter];
	[nc addObserver:self
		   selector:@selector(handleNotification_ChangeMovie:)
			   name:cNotification_ChangeMovie
			 object:nil];
	
	[nc addObserver:self
		   selector:@selector(handleNotification_UpdateProgress:)  // 2013-11-20steve
			   name:cNotification_UpdateProgressBar
			 object:nil];
	
    [[NSDistributedNotificationCenter defaultCenter] addObserver:self // 2014-07-27steve - make NSDistributedNotificationCenter
                                                        selector:@selector(handleNotificationBurnMovieFromTeps:)  // 2014-07-18steve
                                                            name:sTepsVideoAppNotification
                                                          object:nil
                                              suspensionBehavior:NSNotificationSuspensionBehaviorDeliverImmediately]; // 2014-07-28steve MUST deliver immediatley




	
	BOOL allValid = [self validateAllFolders];
	[_myNSTabView selectTabViewItemAtIndex:0];
	[self showTabForError:allValid];
	
	bool doLoadLastMovie = false;
	if ( doLoadLastMovie )
	{
		self._myCurrentMovieToSell = [[NSUserDefaults standardUserDefaults] stringForKey:sPrefSalesQTMovie];
		[self setQTMovie:self._myCurrentMovieToSell];
	}
	else
	{
		[[NSUserDefaults standardUserDefaults] setObject:@"" forKey:sPrefSalesQTMovie];
	}
	
    self.photoQuery = [[[TepsPhotoQueryController alloc] init] autorelease]; // 2013-10-04

    self.mEditMovieController = nil; // 2013-10-08steve
    
    if ( [[NSApp delegate] respondsToSelector:@selector(launchFlashWriter:) ] ) // 2013-10-08steve
    {
        [[NSApp delegate] launchFlashWriter:nil];
    }

    self.mAVMovieViewController = nil; // 2013-10-22steve
    
    self.fTepsArrayOfPhotos = nil; // 2014-07-27steve

    [_myNSTabView setDelegate:self]; // 2014-09-04steve

}

-(void) windowDidLoad
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	[self showWindow:nil];
	
}

-(void) dealloc
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

    self.photoQuery = nil; // 2013-10-04steve
    self.mEditMovieController = nil; // 2013-10-08steve
    self.mAVMovieViewController = nil; // 2013-10-22steve
    self.fTepsArrayOfPhotos = nil; // 2014-07-27steve
    
    if (waitSemaphore)
        dispatch_release(waitSemaphore); // 2013-11-19steve

    
	[super dealloc];
	
	launchScriptWithParameters([NSDictionary dictionaryWithObjectsAndKeys:@"quitQTPlayer.scpt",@"scriptName",nil]);
}

#pragma mark -

-(BOOL) processResponseFromScript:(NSString*) response
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	NSString *response2 = [response stringByTrimmingCharactersInSet:[NSCharacterSet newlineCharacterSet]];
	
	if ( [response2 caseInsensitiveCompare:@"success"]==NSOrderedSame )
	{
		return YES;
	}
	if ( [response2 caseInsensitiveCompare:@"task failed."]==NSOrderedSame )
	{
		NSBeep();
		
		bool doAlert = false;
		if (doAlert)
		{
			NSAlert* alert = [[NSAlert alloc] init];
			[alert setMessageText:@"Problem while running the QTPlayer script..."];
			[alert setInformativeText:response];
			[alert addButtonWithTitle:@"OK"];
			
			[[NSApplication sharedApplication] activateIgnoringOtherApps: YES];
			NSInteger answer = [alert runModal];
			
			[alert release];
			alert = nil;
		}
		
		//			NSInteger returnValue = NSRunAlertPanel (	@"Alert",
		//													 @"Toast Titanium is BUSY and Requires Your Attention...",
		//													 @"OK",	// default
		//													 nil,	// alternate
		//													 nil,		// NSAlertOtherReturn
		//													 @"param1",
		//													 @"param2"
		//													 );
	}
	else
	{
		
		//			NSInteger returnValue = NSRunAlertPanel (	@"Alert",
		//													 @"Toast Titanium is Still Busy...",
		//													 @"OK",	// default
		//													 nil,	// alternate
		//													 nil,		// NSAlertOtherReturn
		//													 @"param1",
		//													 @"param2"
		//													 );
		
	}
	
	return NO;
}

-(IBAction) loadQTPlayer:(id)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

}

#pragma mark - handle Movie Saved Window
-(IBAction) closeMovieSavedSheet:(id)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	short tagID = 0;
	if ( sender && [sender isKindOfClass:[NSButton class]] )
	{
		tagID = [sender tag];
		if ( tagID == 99 )
		{
			// User Hit Cancel
			NSLog ( @"2010-11-07steve User Close" );
			[NSApp endSheet:[sender window] returnCode:NSRunStoppedResponse  ];

			return;
		}
	}

	[NSApp endSheet:[sender window] returnCode:NSRunContinuesResponse  ];
	
}


#pragma mark - handle RENAME Window 

-(NSString*) getBaseIdFromFileName:(NSString*)filename // 2013-11-21steve
{
    // filename = aaaaaa_bbbbb_ccc.ext
    // should return aaaaaa
    
    if (filename==nil) return nil;
    
    NSString* newbaseID = filename;
    filename = [[filename lastPathComponent] stringByDeletingPathExtension];
    
    NSArray* array = [filename componentsSeparatedByString:@"_"];
    newbaseID = [array objectAtIndex:0];

    NSLog( @"getBaseIdFromFileName returning: [%@]",newbaseID );
    return newbaseID;
}

-(IBAction) doClear:(id)sender
{
	[[NSUserDefaults standardUserDefaults] setObject:@"" forKey:prefRenameString ];
	[[NSUserDefaults standardUserDefaults] setObject:@"" forKey:cPrefErrorMessage ]; // 2013-10-04steve
}


// tagID 99 = Cancel
// tagID 100 = Resume
-(IBAction) closeSheet:(id)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	short tagID = 0;
	if ( sender && [sender isKindOfClass:[NSButton class]] )
	{
		tagID = [sender tag];
		if ( tagID == 99 )
		{
			// User Hit Cancel
			NSLog ( @"2010-11-07steve User Cancelled" );
			[NSApp endSheet:[sender window] returnCode:NSRunContinuesResponse  ];
			return;
		}
	}
	if ( self._myCurrentMovieToSell==nil || ([self._myCurrentMovieToSell length]==0) )
	{
		[NSApp endSheet:[sender window] returnCode:NSRunContinuesResponse  ];
		return;
	}
	
	self.mTempRenameString = [[NSUserDefaults standardUserDefaults] objectForKey:prefRenameString ];
	
	
	// NSLog ( @"2010-11-07steve self.mTempRenameString = [%@]", self.mTempRenameString );
	// NSLog ( @"2010-11-07steve self._myCurrentMovieToSell = [%@]", self._myCurrentMovieToSell );
	
	if ( self.mTempRenameString && [self.mTempRenameString length] )
	{
		NSString *basePath = [self._myCurrentMovieToSell stringByDeletingLastPathComponent]; //  @"/";
		
		NSString *filename = [self._myCurrentMovieToSell lastPathComponent];
		NSString *ext = [filename pathExtension];
		filename = [filename stringByDeletingPathExtension];
		
		
		NSLog ( @"2010-11-07steve ext is: [%@]", ext );
		
		NSString* newbaseID = [NSString stringWithString:filename];
		NSRange foundRange = [filename rangeOfString:@"_"];
		if ( foundRange.location == NSNotFound )
		{
			NSLog ( @"foundRange => NOT Found..." );
		}
		else
		{
			NSLog ( @"FoundRange={%i,%i}", foundRange.location, foundRange.length );
			NSRange newRange;
			newRange.location = foundRange.location + 1;
			newRange.length = [filename length] - newRange.location;
			newbaseID = [NSString stringWithString:[filename substringWithRange:newRange]];
			
		}
		NSLog ( @"NEWLY Formed BaseID = [%@]", newbaseID );

		NSString* tempString = [NSString stringWithFormat:@"%@_%@", self.mTempRenameString, newbaseID ];
		if ( ext) tempString = [tempString stringByAppendingPathExtension:ext];
		tempString = [basePath stringByAppendingPathComponent:tempString];

		NSLog ( @"2010-11-07steve the NEW RENAMED File should be: %@", tempString );
		
		NSFileManager* mgr = [NSFileManager defaultManager];
		NSError* myErr = nil;
		[mgr moveItemAtPath:self._myCurrentMovieToSell toPath:tempString error:&myErr];
		if (myErr) 
		{
			NSLog (@ "2010-11-01steve myErr = %@", myErr );
			
		}
		else
		{
			self._myCurrentMovieToSell = [NSString stringWithString:tempString];
			
			// update the pref
			[[NSUserDefaults standardUserDefaults] setObject:self._myCurrentMovieToSell forKey:sPrefSalesQTMovie ];
		}
		
		

		
		NSLog ( @"2010-11-07steve the NEW RENAMED File should be: %@", tempString );
		
	}
	else
	{
		NSLog ( @"2010-11-07steve NOTHING to ReName..." );
	}
	
	[NSApp endSheet:[sender window] returnCode:NSRunContinuesResponse  ];
	
}

- (void)didEndSheet:(NSWindow *)sheet returnCode:(NSInteger)returnCode contextInfo:(void *)contextInfo
{
	NSLog (@ "Inside %@ => %@... with returnCode=[%li] and ContextInfo=[%@]", self, NSStringFromSelector(_cmd), (long)returnCode, contextInfo );
	
	[sheet orderOut:self];
		
}

- (void)didEndSheet2:(NSWindow *)sheet returnCode:(NSInteger)returnCode contextInfo:(void *)contextInfo
{
	NSLog (@ "Inside %@ => %@... with returnCode=[%li] and ContextInfo=[%@]", self, NSStringFromSelector(_cmd), (long)returnCode, contextInfo );
	
	[sheet orderOut:self];

	if ( returnCode==NSRunContinuesResponse )
	{
		[self performSelectorOnMainThread:@selector(doFindNextCustomer:) withObject:nil waitUntilDone:NO];
	}
	
}


#pragma mark - handle search window // 2013-10-04steve

-(void) doneSearchOperation:(id) param // 2013-10-04steve
{
	NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
	NSLog (@ "Inside %@ => %@ ...", [self class], NSStringFromSelector(_cmd) );
	
	self.queryStarted = NO;
	
    BOOL foundValidMovie = NO; // 2014-10-15steve
    NSString* validItem = nil; // 2014-10-15steve
    
	if ( [self.photoQuery.response count] )
	{
		NSMutableArray* resultArray = [NSMutableArray arrayWithArray:self.photoQuery.response]; // 2012-03-01steve JED
		
		NSLog ( @"2012-06-12steve resultArray = %@", resultArray );

        // this should be the next movie file
        // 2013-10-08steve dONT MOVE YEt [self moveCurrentMovie]; // 2013-10-04steve

        
        // 2014-10-15steve - we need to iterate thru the array
        // and only allow for .mp4 or .mov
        for ( NSString* anItem in resultArray) {
            if ([anItem isKindOfClass:[NSString class]]) {
                if ([[anItem pathExtension] caseInsensitiveCompare:@"mp4"]==NSOrderedSame) {
                    // good
                    foundValidMovie = YES;
                } else if ([[anItem pathExtension] caseInsensitiveCompare:@"mov"]==NSOrderedSame) {
                    // good
                    foundValidMovie = YES;
                }
            }
            if (foundValidMovie) {
                validItem = [NSString stringWithFormat:@"%@",anItem];
                break;
            }
        }
        
        
        
//        self._myCurrentMovieToSell = [NSString stringWithString:[resultArray objectAtIndex:0]];
//        [self setQTMovie:self._myCurrentMovieToSell];
//        [[NSUserDefaults standardUserDefaults] setObject:self._myCurrentMovieToSell forKey:sPrefSalesQTMovie];
//
//
//        [NSApp endSheet:mSearchIdPanel returnCode:NSRunContinuesResponse];

	}
    
    /* 2014-10-15steve
     else {
        // NO .mov file found for id
        
        NSLog (@ "Inside %@ => %@ ...param = %@", [self class], NSStringFromSelector(_cmd), param );

        NSLog(@"NO MOVIE FILE FOUND?????");
        
        id searchId = [[param objectForKey:keySearchKey] objectAtIndex:0];
        if (searchId==nil)
            searchId = @"????";
        
        [[NSUserDefaults standardUserDefaults] setObject:[NSString stringWithFormat:@"Unable To Find Movie with ID = [%@]",searchId] forKey:cPrefErrorMessage];


    } */
    
    
    if (validItem) {
        
        BOOL doTestNotif = YES; // 2014-11-07steve DEBUG TESTING
        if (doTestNotif) {
//            NSNotification* note =[NSNotification notificationWithName:@"TepsNotificationForVideo"
//                                                                 object:nil
//                                                               userInfo:[NSDictionary dictionaryWithObjectsAndKeys:validItem,@"item", nil]];
//            [[NSDistributedNotificationCenter defaultCenter] performSelectorOnMainThread:@selector(postNotification:)
//                                                                              withObject:note
//                                                                           waitUntilDone:NO];
            NSNotification* note =[NSNotification notificationWithName:sTepsVideoAppNotification
                                                                object:nil
                                                              userInfo:[NSDictionary dictionaryWithObjectsAndKeys:validItem,@"moviepath",@"playvideofile",@"action", nil]];
            [[NSDistributedNotificationCenter defaultCenter] performSelectorOnMainThread:@selector(postNotification:)
                                                                              withObject:note
                                                                           waitUntilDone:NO];
            
            
        } else {
            self._myCurrentMovieToSell = [NSString stringWithFormat:@"%@",validItem];
            [self setQTMovie:self._myCurrentMovieToSell];
            [[NSUserDefaults standardUserDefaults] setObject:self._myCurrentMovieToSell forKey:sPrefSalesQTMovie];
        }
        
        [NSApp endSheet:mSearchIdPanel returnCode:NSRunContinuesResponse];
    }
    else {
        
        NSLog (@ "Inside %@ => %@ ...param = %@", [self class], NSStringFromSelector(_cmd), param );
        
        NSLog(@"NO VALID MOVIE FILE FOUND?????");
        
        id searchId = [[param objectForKey:keySearchKey] objectAtIndex:0];
        if (searchId==nil)
            searchId = @"????";
        
        [[NSUserDefaults standardUserDefaults] setObject:[NSString stringWithFormat:@"Unable To Find Movie with ID = [%@]",searchId] forKey:cPrefErrorMessage];
        
        // 2014-11-04steve - if in kiosk mode - we need to somehow send message to kisok window to display error
        if ([self respondsToSelector:@selector(handleNoVideoFoundInKiosk:)]) {
            [self handleNoVideoFoundInKiosk:[NSString stringWithFormat:@"%@",searchId]]; // 2014-11-04steve
        }
        
    }
		
	[pool release];
}



-(void) setupAndStartQuery
{
    
    return [self setupAndStartQuery:nil]; // 2013-10-04steve
    
    
    
    
	NSLog (@ "%@->%@...", self, NSStringFromSelector(_cmd) );
    
	if ( self.queryStarted ) {
		// we dont want to start another one...
		// maybe put a request in queue and wait...
		NSLog (@ "%@->%@...Another in progress...", self, NSStringFromSelector(_cmd) );
		return;
	}
	
	self.queryStarted = YES;
    
    NSString* myFolderPath = getDailyFolderPathForMasterOriginalVideos(); // 2010-11-11steve [prefMgr objectForKey:sPrefOriginalVideosFolder];

	
	if ( myFolderPath && [[NSFileManager defaultManager] fileExistsAtPath:myFolderPath] )
	{
		// get all the images
		// the query process is Asynchronous
		// this means the current thread must live long enough for the process to finish
		//
		// since this thread will live forever - we can query it on this thread
		BOOL doAsQuery = YES; // 2012-02-29steve
		if ( doAsQuery )
		{
			NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init];
			
			NSDictionary* param = [NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithString:myFolderPath],keySearchPath,
								   [NSArray arrayWithObjects:@"*" ,nil],keySearchKey,
								   self,@"delegate",
								   nil ];
			
			// [param retain];
			
            
			[self.photoQuery startSearchActionWithParam:param];
            
			//[self.photoQuery performSelectorOnMainThread:@selector(startSearchActionWithParam:) withObject:param waitUntilDone:NO];
			// also should setup timeOut NSTimer - in case something goes wrong so dont hang???
			
			[pool drain];
			
		}
		
	}
	
	
}

-(void) setupAndStartQuery:(NSArray*)keys // 2013-10-04steve
{
	NSLog (@ "%@->%@...", self, NSStringFromSelector(_cmd) );
    
	if ( self.queryStarted ) {
		// we dont want to start another one...
		// maybe put a request in queue and wait...
		NSLog (@ "%@->%@...Another in progress...", self, NSStringFromSelector(_cmd) );
		return;
	}
	
	self.queryStarted = YES;
    
    NSString* myFolderPath = getDailyFolderPathForMasterOriginalVideos(); // 2010-11-11steve [prefMgr objectForKey:sPrefOriginalVideosFolder];
    
	
	if ( myFolderPath && [[NSFileManager defaultManager] fileExistsAtPath:myFolderPath] )
	{
		// get all the images
		// the query process is Asynchronous
		// this means the current thread must live long enough for the process to finish
		//
		// since this thread will live forever - we can query it on this thread
		BOOL doAsQuery = YES; // 2012-02-29steve
		if ( doAsQuery )
		{
			NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init];
			
            NSArray* tmpArray = nil;
            if ( keys ) {
                tmpArray = [NSArray arrayWithArray:keys];
            } else {
                tmpArray = [NSArray arrayWithObjects:@"*",nil];
            }
            
			NSDictionary* param = [NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithString:myFolderPath],keySearchPath,
								   [NSArray arrayWithArray:tmpArray],keySearchKey,
								   self,@"delegate",
								   nil ];

            
			[self.photoQuery startSearchActionWithParam:param];
            
			//[self.photoQuery performSelectorOnMainThread:@selector(startSearchActionWithParam:) withObject:param waitUntilDone:NO];
			// also should setup timeOut NSTimer - in case something goes wrong so dont hang???
			
			[pool drain];
			
		}
		
	}
	
	
}

- (void)didEndSheetSearch:(NSWindow *)sheet returnCode:(NSInteger)returnCode contextInfo:(void *)contextInfo
{
	NSLog (@ "Inside %@ => %@... with returnCode=[%li] and ContextInfo=[%@]", self, NSStringFromSelector(_cmd), (long)returnCode, contextInfo );
	
	[sheet orderOut:self];
    
}


-(void) doFindCustomerReally // 2014-11-04steve
{
    NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

	self.mTempRenameString = [[NSUserDefaults standardUserDefaults] objectForKey:prefRenameString ];
	self.mTempRenameString = [self.mTempRenameString stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
	if ([self.mTempRenameString length]==0)
        self.mTempRenameString = nil;
    if ( self.mTempRenameString) {
        
        // try to find it
        [self setupAndStartQuery:[NSArray arrayWithObjects:self.mTempRenameString, nil]];
        
    }
}

// tagID 99 = Cancel
// tagID 100 = Resume
-(IBAction) closeSearchSheet:(id)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	short tagID = 0;
	if ( sender && [sender isKindOfClass:[NSButton class]] )
	{
		tagID = [sender tag];
		if ( tagID == 99 )
		{
			// User Hit Cancel
			NSLog ( @"2010-11-07steve User Cancelled" );
			[NSApp endSheet:[sender window] returnCode:NSRunContinuesResponse  ];
			return;
		}
	}
	
	self.mTempRenameString = [[NSUserDefaults standardUserDefaults] objectForKey:prefRenameString ];
	self.mTempRenameString = [self.mTempRenameString stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
	if ([self.mTempRenameString length]==0)
        self.mTempRenameString = nil;
    if ( self.mTempRenameString) {
        
        // try to find it
        [self setupAndStartQuery:[NSArray arrayWithObjects:self.mTempRenameString, nil]];
        
    }


}


-(IBAction) doSearchId:(id)sender // 2013-10-04steve
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
    
	// [[NSUserDefaults standardUserDefaults] setObject:@"" forKey:prefRenameString ];
	[self doClear:nil]; // 2013-10-04steve
    
    
	[NSApp beginSheet:mSearchIdPanel
	   modalForWindow:[self window]
		modalDelegate:self
	   didEndSelector:@selector(didEndSheetSearch:returnCode:contextInfo:)
		  contextInfo:nil];
	
}





#pragma mark -

-(IBAction) hideAVMovieController
{
    if ( self.mAVMovieViewController ) {
        [self.mAVMovieViewController.view setHidden:YES ];

    }

}


-(void) createAVMovieViewController
{
    if ( self.mAVMovieViewController ==nil )
    {
        self.mAVMovieViewController = nil;
        
        self.mAVMovieViewController = [[[AVMovieViewController alloc]initWithNibName:@"AVMovieView" bundle:nil] autorelease];
        if (self.mAVMovieViewController) {
            [self.mAVMovieViewController loadView];
            
            // the the mqtmovie
            NSRect frame = _mQTMovieView.frame;
            NSWindow* window = _mQTMovieView.window;
            NSView* superview = _mQTMovieView.superview;
            
            
            NSLog(@"_mQTMovieView.frame = %@", NSStringFromRect(_mQTMovieView.frame) );
            
            NSView* contentview = superview; // window.contentView;
            if (contentview) {
                [contentview addSubview:self.mAVMovieViewController.view];
                self.mAVMovieViewController.view.frame = frame;
                NSLog(@"self.mAVMovieViewController.view.frame = %@", NSStringFromRect(self.mAVMovieViewController.view.frame) );

                BOOL doLoadTest = NO;
                if (doLoadTest) {
                    NSString* pathToMovie = @"/Users/Shared/serge720.mov";
                    // pathToMovie = @"/Users/Shared/ntsc.mov";
                    
                    BOOL exists = [[NSFileManager defaultManager] fileExistsAtPath:pathToMovie];
                    if ( exists==NO ) {
                        NSLog(@"movie file path does NOT exist = %@", pathToMovie);
                    }
                    
                    self.mAVMovieViewController.fileURL = [NSURL fileURLWithPath:pathToMovie];
                    
                    NSLog(@"fileURL = %@", self.mAVMovieViewController.fileURL);
                    
                    if (self.mAVMovieViewController.fileURL) {
                        AVURLAsset* asset = [AVURLAsset URLAssetWithURL:self.mAVMovieViewController.fileURL options:nil];
                        CGFloat aspectratio = asset.naturalSize.width / asset.naturalSize.height;
                        NSSize size = NSMakeSize(asset.naturalSize.width, asset.naturalSize.height);
                        NSLog(@"movie naturalSize = %@", NSStringFromSize(size));
                        NSLog(@"movie aspectRatio = %5.2f", aspectratio );
                    
                        NSArray* videotracks = [asset tracksWithMediaType:AVMediaTypeVideo];
                        NSLog(@"videotracks = %@", videotracks);
                    	if ([videotracks count] != 0) {
                            AVAssetTrack* firsttrack = [videotracks objectAtIndex:0];
                            NSLog(@"first track = %@", firsttrack);

                            CGFloat aspectratio = firsttrack.naturalSize.width / firsttrack.naturalSize.height;
                            NSSize size = NSMakeSize(firsttrack.naturalSize.width, firsttrack.naturalSize.height);
                            NSLog(@"firsttrack naturalSize = %@", NSStringFromSize(size));
                            NSLog(@"firsttrack aspectRatio = %5.2f", aspectratio );

                        }

                    }
                    
                    // 2014-11-04steve - this is getting called twice???? TYLER???  [self.mAVMovieViewController setup];
                }
            }
            
        }

    } else {
        // [self.mAVMovieViewController close];
        [self.mAVMovieViewController.view setHidden:NO ]; // 2014-11-04steve

    }
    
}

-(void) setAVMovie:(NSString*) moviePath
{
    // 2013-11-03steve - fix crashing when in findNextMovie mode and AVFoundation
    if ( moviePath==nil)
        return;
    moviePath = [moviePath stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
    if ([moviePath length]==0) {
        return;
    }
    
    
    [_mQTMovieView setMovie:nil]; // 2013-10-22steve
    [_mQTMovieView setHidden:YES]; // 2013-10-22steve

     [self.mAVMovieViewController close];
	//[self.mAVMovieViewController.player pause];

    
    [self createAVMovieViewController];
    
    if (self.mAVMovieViewController ) {
        BOOL exists = [[NSFileManager defaultManager] fileExistsAtPath:moviePath];
        if ( exists==NO ) {
            NSLog(@"movie file path does NOT exist = %@", moviePath);
            self.mAVMovieViewController.fileURL = nil;
            
        } else {
            self.mAVMovieViewController.fileURL = [NSURL fileURLWithPath:moviePath];
            [self.mAVMovieViewController setup];

        }
    }
    
}

-(void) setQTMovie:(NSString*) moviePath
{
    
    BOOL doUseAVFoundation = [[NSUserDefaults standardUserDefaults]boolForKey:@"prefUseAVFoundation"];
    if ( doUseAVFoundation) {
        [self setAVMovie:moviePath]; // 2013-10-22steve
        return; // 2013-10-22steve
    }
    
    self.mAVMovieViewController.view.hidden = YES;
    [self.mAVMovieViewController.view removeFromSuperview];
    [self.mAVMovieViewController close];
    self.mAVMovieViewController = nil; // 2013-10-22steve make sure it is destroyed
    [_mQTMovieView setHidden:NO]; // 2013-10-22steve
    
    
	if (moviePath==nil )
	{
		[_mQTMovieView setMovie:nil];
		return;
	}
	
	NSError* error = nil;
	QTMovie* myMovie = [QTMovie movieWithFile:moviePath error:&error];
	if ( error )
	{
		NSLog ( @"2010-11-09steve %@->%@ error = [%@]", self,NSStringFromSelector(_cmd), error );
	}
	else
	{
        [_mQTMovieView setEditable:YES]; // 2013-09-04

		[_mQTMovieView setMovie:myMovie];
	}

    
}

-(void) bringToBack:(id)sender
{
    [self.window miniaturize:nil];
}


-(void) bringToFront:(id)sender // 2014-07-28steve
{
    NSLog(@"%@-%@....",self,NSStringFromSelector(_cmd));
    
    [[NSApplication sharedApplication] activateIgnoringOtherApps: YES]; // 2014-07-27steve force TepsVideo.app to the front

//    [[NSRunningApplication currentApplication] activateWithOptions:(NSApplicationActivateAllWindows | NSApplicationActivateIgnoringOtherApps)];
//
    [self.window makeKeyAndOrderFront:nil];
}



-(BOOL) okToSkipThisAction:(id)action
{
    NSArray* listToSkip = [NSArray arrayWithObjects:@"GetStatus",
                           @"StopRecording",
                           @"StartRecording",
                           @"statusIsRecording",
                           @"statusNotRecording",
                           @"statusMovieThumbnailCreated",
                           nil];
    
    for (NSString* item in listToSkip) {
        if ( [action caseInsensitiveCompare:item]==NSOrderedSame )
        {
            return YES; // ok to skip
        }

    }

}

- (void) handleNotificationBurnMovieFromTeps:(NSNotification*) note // 2014-07-18steve
{
    NSLog (@ "Inside %@ => %@... note = %@", [self class], NSStringFromSelector(_cmd),note );
    
    id userinfo = [note userInfo];

    id senderapp = [userinfo objectForKey:@"senderApp"];
    id action = [userinfo objectForKey:@"action"];
    id sourceItem = [userinfo objectForKey:@"sourceItem"];
    id movieFile = [userinfo objectForKey:@"movieFile"];
    
    if (sourceItem ) {
        if ([sourceItem isKindOfClass:[NSArray class]]) {
            if ([sourceItem count]==0) {
                NSLog(@"2014-07-27 sourceItem of photos is an empty array");
                sourceItem = nil; // 2014-07-27steve
            }
        } else if ([sourceItem isKindOfClass:[NSString class]]) {
            sourceItem = [NSArray arrayWithObject:sourceItem];
        }
    }
    
    if ( movieFile && [movieFile isKindOfClass:[NSString class]]) {
        NSString* stringItem = (NSString*)movieFile;
        if ([stringItem length]<=0) {
            NSLog(@"2014-07-27 movieItem has 0 length...");
            movieFile = nil;
        }
    }
    
    
    BOOL showAlert = NO;

    
    NSString* message = [NSString stringWithFormat:@"Some CRAP userinfo -\n%@",userinfo];
    if (action && [action caseInsensitiveCompare:@"burnVideo"]==NSOrderedSame) {
        NSLog (@ "Inside %@ => %@... action = %@", [self class], NSStringFromSelector(_cmd),action );

        
        BOOL movieExists = [[NSFileManager defaultManager] fileExistsAtPath:movieFile]; // 2014-08-12steve

        message = [NSString stringWithFormat:@"Got action = %@\n",action];
        message = [message stringByAppendingFormat:@"MovieFilePath = %@\n", movieFile];
        if (!movieExists) {
            message = [message stringByAppendingFormat:@"< ERROR: Movie File Does NOT Exist !!! >\n"]; // 2014-08-12steve
        }
        // 2014-08-12steve message = [message stringByAppendingFormat:@"Got movieFile = %@\n", movieFile?movieFile:@"<No Movie Specified>"];
        message = [message stringByAppendingFormat:@"Got sourceItem = %@\n", sourceItem?sourceItem:@"<No SourceItem Specified OR Empty>"]; // 2014-07-26steve
        NSLog (@"2014-07-18steve - burnVideo notification returned:\n%@",message);
        
        // 2014-07-27steve
        // if moviepath exists from teps  then try to setup for sales
        // 2014-08-12steve BOOL exists = [[NSFileManager defaultManager] fileExistsAtPath:movieFile];
        // 2014-08-12steveif (exists) {
        if (movieExists) {
            self._myCurrentMovieToSell = [NSString stringWithFormat:@"%@",movieFile];
            [self setQTMovie:self._myCurrentMovieToSell];
            [[NSUserDefaults standardUserDefaults] setObject:self._myCurrentMovieToSell forKey:sPrefSalesQTMovie];

            
            // 2014-07-27steve
            BOOL interfaceWithTeps = [[NSUserDefaults standardUserDefaults] boolForKey:@"prefInterfaceWithTeps"]; // 2014-07-27steve
            if (interfaceWithTeps) {
                NSMutableArray* tempArray = nil;
                if ( sourceItem) {
                    tempArray = [NSMutableArray arrayWithArray:sourceItem]; // 2014-07-27steve
//                    if(movieFile) {
//                        [tempArray addObject:movieFile];
//                    }
                }
                if ([tempArray count]) {
                    self.fTepsArrayOfPhotos = [NSArray arrayWithArray:tempArray];
                }
            } else {
                self.fTepsArrayOfPhotos = nil;
            }
            
            [self performSelectorOnMainThread:@selector(bringToFront:) withObject:nil waitUntilDone:YES]; // 2014-07-28steve
            
            // [[NSApplication sharedApplication] activateIgnoringOtherApps: YES]; // 2014-07-27steve force TepsVideo.app to the front

            [self performSelectorOnMainThread:@selector(doPurchaseMovie:) withObject:nil waitUntilDone:NO];
            

            [self performSelectorOnMainThread:@selector(bringToFront:) withObject:nil waitUntilDone:YES]; // 2014-07-28steve

            // [self performSelector:@selector(doPurchaseMovie:) withObject:nil afterDelay:.5];
            
            showAlert = NO;
        } else {
            showAlert = YES;
        }

    }
    else if (action && [action caseInsensitiveCompare:@"SetCustomerID"]==NSOrderedSame) { // 2014-07-30steve
        NSLog(@"2014-07-30steve IGNORING Notification for action=[%@]...",action );
    }
    else if (action && [action caseInsensitiveCompare:@"playvideofile"]==NSOrderedSame) { // 2014-11-07steve
        BOOL inkioskMode = [[NSUserDefaults standardUserDefaults] boolForKey:@"prefRunSalesWindowInKioskMode"]; // 2014-11-07steve
        if (inkioskMode)
        {
            NSString* moviePath = [userinfo objectForKey:@"moviepath"];
            if (moviePath) {
                self._myCurrentMovieToSell = [NSString stringWithFormat:@"%@",moviePath];
                [self setQTMovie:self._myCurrentMovieToSell];
                [[NSUserDefaults standardUserDefaults] setObject:self._myCurrentMovieToSell forKey:sPrefSalesQTMovie];
            } else {
                NSLog (@ "Inside %@ => %@...objectForKey=item is NIL", [self class], NSStringFromSelector(_cmd) );
            }
        } else {
            NSLog(@"2014-07-30steve IGNORING Notification for action=[%@]...NOT IN KIOSK MODE...",action );
        }

    }
    else if ([self okToSkipThisAction:action]) { // 2014-08-11steve
        NSLog(@"2014-07-30steve IGNORING Notification for action=[%@]...",action );
    }
    else {
        showAlert = YES;
    }
    
    if (showAlert) {
        NSAlert* alert = [[NSAlert alloc] init];
        [alert setMessageText:[NSString stringWithFormat:@"Got Notification from [%@]...", senderapp ]];
        [alert setInformativeText:[NSString stringWithFormat:@"%@",message]]; // 2014-07-26steve
        [alert addButtonWithTitle:@"OK"];
        [[NSApplication sharedApplication] activateIgnoringOtherApps: YES];
        [alert runModal];
        [alert release];
        alert = nil;
    }

    
    
    
    
}


- (void) handleNotification_UpdateProgress:(NSNotification*) note // 2013-11-20steve
{
    // NSLog (@ "Inside %@ => %@... note = %@", [self class], NSStringFromSelector(_cmd),note );

    id userinfo = [note userInfo];
    id obj = [userinfo objectForKey:@"progress"];
    if (obj) {
        [mProgressIndicatorBar setMaxValue:1.0];
        [mProgressIndicatorBar setMinValue:0.0];
        [mProgressIndicatorBar setDoubleValue:[obj doubleValue]];
    }
    
}


- (void) handleNotification_ChangeMovie:(NSNotification*) note
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	NSLog (@ "Inside %@ => %@...", [self class], NSStringFromSelector(_cmd) );
	NSLog (@ "Inside %@ => %@...note = %@", [self class], NSStringFromSelector(_cmd), note );
	
	
	id sender = [note object];
	id userInfo = [note userInfo];
	
	NSLog (@ "Inside %@ => %@...sender = %@", [self class], NSStringFromSelector(_cmd), sender );
	NSLog (@ "Inside %@ => %@...userInfo = %@", [self class], NSStringFromSelector(_cmd), userInfo );
	NSLog (@ "Inside %@ => %@...sender class = %@", [self class], NSStringFromSelector(_cmd), [sender class] );
	NSLog (@ "Inside %@ => %@...userInfo class = %@", [self class], NSStringFromSelector(_cmd), [userInfo class] );

	// we only want to open the first movie
	id item1 = [userInfo objectAtIndex:0];
	
	// we may need to copy to our machine from the server
	// then use that as the new movie
	if ( item1 )
	{
		[[NSUserDefaults standardUserDefaults] setObject:[NSString stringWithString:item1] forKey:sPrefSalesQTMovie];
		[[NSUserDefaults standardUserDefaults] synchronize];
		
		self._myCurrentMovieToSell = item1;
		
		
		// set the _myQTMovieView
		[self setQTMovie:self._myCurrentMovieToSell];
		
		//[self doPresentMovie:nil];
		// [self performSelectorOnMainThread:@selector(doPresentMovie:) withObject:nil waitUntilDone:NO];
		// [self performSelectorOnMainThread:@selector(doPresentMovie:) withObject:nil waitUntilDone:NO];
        if ([self respondsToSelector:@selector(doPresentMovie:)]) // 2012-11-14steve prevents exception
            [self performSelector:@selector(doPresentMovie:) withObject:nil afterDelay:0.1];
		else NSLog(@"Will NOT autoPlay movie after drag-n-drop"); // 2012-11-14steve

	}
	else
	{
		NSBeep();
	}
	
	
	
	if (pool) [pool release];
}

#pragma mark -

- (void)openPanelDidEnd:(NSOpenPanel *)sheet returnCode:(int)returnCode contextInfo: (void*)contextInfo
{
	NSLog (@ "Inside %@ => %@... with returnCode=[%i] and ContextInfo=[%@]", self, NSStringFromSelector(_cmd), returnCode, contextInfo );
	
	
	if (returnCode == NSOKButton)
	{
		NSLog (@"openPanelDidEnd:returnCode:contextInfo returned NSOKButton" );
		
		NSString* itemName = [[sheet filenames] lastObject];
		
		if ( contextInfo )
		{
			
			id parameters = (id) contextInfo;
			if ( [parameters isKindOfClass:[NSDictionary class]] )
			{
				// great 
				
				NSString* folderPathKey = [parameters objectForKey:sPrefFolderNameKey];
				NSString* folderPathIsValidKey = [parameters objectForKey:sPrefFolderNameIsValidKey];
				NSString* folderAliasDataKey = [parameters objectForKey:sPrefFolderAliasDataKey];
				
				
				if ( itemName )
				{
					[[NSUserDefaults standardUserDefaults] setObject:itemName forKey:folderPathKey];
					[[NSUserDefaults standardUserDefaults] setBool:YES forKey:folderPathIsValidKey ];
					[MyAliasKit savePath:itemName forKey:folderAliasDataKey];
				}
				
				createDirectoryIfMissing(getDailyFolderPathForKey(folderPathKey)); // 2010-11-12steve
				
			}
			
			else
			{
				NSLog ( @"2010-11-04steve - we dont know what to do????" );
				
			}
			
			
			// 2010-11-12steve - we need it to build the corresponding daily folder
			
		}
		
		else
		{
			NSLog ( @"openPanelDidEnd passed NIL for contextInfo??????" );
		}
	}
	else if (returnCode == NSCancelButton)
	{
		NSLog (@"openPanelDidEnd:returnCode:contextInfo returned NSCancelButton" );
	}
	else
	{
		NSLog (@"openPanelDidEnd:returnCode:contextInfo returned ?????" );
	}
	
	
	
}

- (IBAction) doNSOpenPanelWithParameters:(NSDictionary*)parameters
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	NSLog (@ "Inside %@ => %@... parameters = %@", self, NSStringFromSelector(_cmd), parameters );
	
	NSString* prefFolderNameKey =[parameters objectForKey:sPrefFolderNameKey];
	NSString* panelDelegate = [parameters objectForKey:sPanelDelegateKey];
	NSString* panelMessage = [parameters objectForKey:sPanelMessageKey];
	NSString* panelPrompt = [parameters objectForKey:sPanelPromptKey];
	id panelSender = [parameters objectForKey:sPanelSenderKey];
	
	
	NSWindow* parentWindow = [panelSender window];
	NSOpenPanel* op = [NSOpenPanel openPanel];
	
	[op setCanChooseDirectories:YES];
	[op setCanChooseFiles:NO];
	[op setAllowsMultipleSelection:NO];
	[op setCanCreateDirectories:YES];
	
	[op setMessage:[NSString stringWithString:panelMessage]];
	[op setPrompt:[NSString stringWithString:panelPrompt]];
	
	
	NSString* initialDirectory = [[NSUserDefaults standardUserDefaults] stringForKey:prefFolderNameKey];
	
	bool doAsSheet = true;	// 08-20-07 put back
	if ( doAsSheet )
	{
		[op setDelegate:panelDelegate];
		
		[op beginSheetForDirectory:initialDirectory
							  file:nil
							 types:nil
					modalForWindow:parentWindow
					 modalDelegate:panelDelegate
					didEndSelector:@selector(openPanelDidEnd:returnCode:contextInfo:)
					   contextInfo:[parameters retain]];
		
	}
	
	
}

#pragma mark -

-(void) adjustViews
{
	
	// remove it from the UI
	self._myCurrentMovieToSell = [NSString stringWithString:@""];
	[[NSUserDefaults standardUserDefaults] setObject:self._myCurrentMovieToSell forKey:sPrefSalesQTMovie];
	[self setQTMovie:nil];
	
	
}

-(BOOL) showTabForError:(BOOL) isValid
{
	if ( isValid )
	{
		
	}
	else
	{
		[_myNSTabView selectTabViewItemAtIndex:1];
	}
	return YES;
}

-(BOOL) validateAllFolders
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	
	NSDictionary* parameters = nil;
	
	parameters = [NSDictionary dictionaryWithObjectsAndKeys:
				  sPrefOriginalVideosFolder, sPrefFolderNameKey,
				  sPrefOriginalVideosFolderAliasData, sPrefFolderAliasDataKey,
				  sPrefOriginalVideosFolderIsValid, sPrefFolderNameIsValidKey,
				  nil];
	BOOL validate2 = validateFolderPrefWithParam (parameters ); // 2010-11-12steve [self validateFolderPrefWithParam:parameters];

	parameters = [NSDictionary dictionaryWithObjectsAndKeys:
				  sPrefToBeBurnedFolder, sPrefFolderNameKey,
				  sPrefToBeBurnedFolderAliasData, sPrefFolderAliasDataKey,
				  sPrefToBeBurnedFolderIsValid, sPrefFolderNameIsValidKey,
				  nil];
	BOOL validate1 = validateFolderPrefWithParam (parameters ); // 2010-11-12steve [self validateFolderPrefWithParam:parameters];
	
	
	NSLog ( @"2010-11-03steve validate1 = %@", validate1?@"YES":@"NO" );
	NSLog ( @"2010-11-03steve validate2 = %@", validate2?@"YES":@"NO" );
	
	BOOL allValid = (validate1 && validate2);
	if ( allValid )
	{
		// great - all found
		
		// 2010-11-11steve
		NSString* dailyPath = getDailyFolderPathForMasterOriginalVideos();
		createDirectoryIfMissing ( dailyPath );
		
		createDirectoryIfMissing ( getDailyFolderPathForToBeBurnedFolder() ); // 2010-11-11steve

		
	}
	else
	{
		// need to open in Pref Tab
		NSInteger returnValue = NSRunAlertPanel (	@"Alert",
												 @"Please Point To Valid Folders...",
												 @"OK",	// default
												 nil,	// alternate
												 nil,		// NSAlertOtherReturn
												 @"param1",
												 @"param2"
												 );
		
	}
	
	return allValid;
}

/* 2010-11-12steve rewritten as c
-(BOOL) validateFolderPrefWithParam:(NSDictionary*)parameters
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	
	BOOL isValid = NO;
	
	NSString* folderPathKey = [parameters objectForKey:sPrefFolderNameKey];
	NSString* folderPathIsValidKey = [parameters objectForKey:sPrefFolderNameIsValidKey];
	NSString* folderAliasDataKey = [parameters objectForKey:sPrefFolderAliasDataKey];
	
	
	NSString* path1 = [[NSUserDefaults standardUserDefaults] objectForKey:folderPathKey];
	id aliasData1 = [[NSUserDefaults standardUserDefaults] objectForKey:folderAliasDataKey];
	
	if ( path1 )
	{
		BOOL isDirectory = NO;
		BOOL exists = [[NSFileManager defaultManager] fileExistsAtPath:path1 isDirectory:&isDirectory];
		if ( exists && isDirectory )
		{
			// great
			isValid = YES;
		}
		else
		{
			NSString* resolvedPath = nil;
			BOOL didResolve = [MyAliasKit resolveAliasFromData:aliasData1 resolvedPath:&resolvedPath];
			if ( didResolve==false )
			{
				[[NSUserDefaults standardUserDefaults] setBool:NO forKey:folderPathIsValidKey];
				// need to openPref Tab
			}
			else
			{
				[[NSUserDefaults standardUserDefaults] setBool:YES forKey:folderPathIsValidKey];
				[[NSUserDefaults standardUserDefaults] setObject:resolvedPath forKey:folderPathKey];
				isValid = NO;
			}
		}
		
	}
	
	return isValid;
	
}
*/


-(BOOL) getNextMovieToSell
{
	BOOL foundNextMovie = NO;
	
	
	NSUserDefaults* prefMgr = [NSUserDefaults standardUserDefaults];
	NSString* myFolderPath = getDailyFolderPathForMasterOriginalVideos(); // 2010-11-11steve [prefMgr objectForKey:sPrefOriginalVideosFolder];
	
	
	NSFileManager* mgr = [NSFileManager defaultManager];
	NSError* error = nil;
	
	
	BOOL isDirectory = NO;
	BOOL exists = [mgr fileExistsAtPath:myFolderPath isDirectory:&isDirectory];
	if ( !(exists && isDirectory) )
	{
		return NO;
	}
	
	error = nil;
	NSArray * filesArray = [mgr contentsOfDirectoryAtPath:myFolderPath error:&error];
	if ( error !=nil )
	{
		NSLog(@"Error in getting contentsOfDirectoryAtPath %@: %@", myFolderPath, [error localizedDescription]);
	}
	
	if ( filesArray==nil || ([filesArray count] <=0) )
	{
		NSBeep();
		NSLog (@ "There's NO More New Movies..." );
		NSInteger returnValue = NSRunAlertPanel (	@"Alert",
												 @"NO New Movies to Show, Yet...\rPlease Try Again Later...",
												 @"OK",	// default
												 nil,	// alternate
												 nil,		// NSAlertOtherReturn
												 @"param1",
												 @"param2"
												 );
		
		return foundNextMovie;
	}
	
	
	// sort by creation date
	BOOL isHidden = NO;
	// BOOL isDirectory = NO;
	BOOL isTempItem = NO;
    NSMutableArray* filesAndProperties = [NSMutableArray arrayWithCapacity:[filesArray count]];
    for(NSString* file in filesArray)
	{
		isHidden = NO;
		isDirectory = NO;
		isTempItem = NO;
		
		NSString* baseName = [file lastPathComponent];
		NSRange foundRange = [baseName rangeOfString:@"."];
		// NSLog ( @"Checking if HIDDEN File => [%i][%i]\n", foundRange.location, foundRange.length );
		if ( foundRange.location==0 && foundRange.length )
		{
			// NSLog ( @"THIS IS A HIDDEN FILE" );
			isHidden = YES;
		}
		
		foundRange = [baseName rangeOfString:@"temp"]; // 2010-11-05steve
		if ( foundRange.location==0 && foundRange.length )
		{		
			isTempItem = YES;
		}
		
		NSString* fullFilePath = [myFolderPath stringByAppendingPathComponent:file];
		bool exists = [mgr fileExistsAtPath:fullFilePath isDirectory:&isDirectory];
		if ( !exists )
		{
			NSLog ( @"2010-11-03steve - WHAT?? file [%@] does NOT exist???", fullFilePath );
		}
		
		if ( isHidden || isDirectory || isTempItem || !exists ) // 2010-11-05steve
		{
			// we need to skip
		}
		else
		{
			NSDictionary* properties = [[NSFileManager defaultManager]
										attributesOfItemAtPath:fullFilePath
										error:&error];
			NSDate* modDate = [properties objectForKey:NSFileModificationDate];
			
			if(error == nil)
			{
				[filesAndProperties addObject:[NSDictionary dictionaryWithObjectsAndKeys:
											   fullFilePath, @"path",
											   modDate, @"lastModDate",
											   nil]];                 
			}
		}
		
		
    }
	
	if ( [filesAndProperties count] <=0 )
	{
		NSBeep();
		NSLog (@ "There's NO More New Movies..." );
		NSInteger returnValue = NSRunAlertPanel (	@"Alert",
												 @"There's NO More New Movies to Show...",
												 @"OK",	// default
												 nil,	// alternate
												 nil,		// NSAlertOtherReturn
												 @"param1",
												 @"param2"
												 );
		
		return foundNextMovie;
	}
	
	
	// NSLog ( @"2010-11-03steve filesAndProperties = %@", filesAndProperties );
	
	// sort using a block
	// order inverted as we want latest date first
    NSArray* sortedFiles = [filesAndProperties sortedArrayUsingFunction:mySortByDate context:nil];
	// NSLog ( @"2010-11-09steve sortedFiles = %@", sortedFiles );
	
	
	id nextItem = [sortedFiles objectAtIndex:0];
	NSLog ( @"2010-11-03steve Next Item File To Play is: %@", nextItem );
	id nextItemPath = [nextItem objectForKey:@"path"];
	
	
	NSString* tempItemPath = [myFolderPath stringByAppendingPathComponent:[nextItemPath lastPathComponent]];

	
	self._myCurrentMovieToSell = [NSString stringWithString:tempItemPath];
	[self setQTMovie:self._myCurrentMovieToSell];

	[[NSUserDefaults standardUserDefaults] setObject:self._myCurrentMovieToSell forKey:sPrefSalesQTMovie];
	
	foundNextMovie = YES;
	
	NSLog ( @"2010-11-09steve foundNextMovie = %@", ShowBOOL(foundNextMovie) );
	
	
	return foundNextMovie;
}

#pragma mark -

// 2013-11-08steve - from tyler
static const NSString * TepsAV_AssetsArray = @"TepsAVAssetsArray";
static const NSString * TepsAV_AssetDoRecreate = @"TepsAV_AssetDoRecreate"; // 2013-11-20steve
static const NSString * TepsAV_AssetURL = @"TepsAV_AssetURL";
static const NSString * TepsAV_ffmpegLaunchPath = @"TepsAV_ffmpegLaunchPath";
static const NSString * TepsAV_OutputURL = @"TepsAVOutputURL";
static const NSString * TepsAV_TempPath = @"TepsAV_TempPath"; // 2013-11-21steve
static const NSString * TepsAVRedirectedPath = @"~/Desktop/ConvertedMovies"; // 2013-11-21steve
static const NSString * TepsAV_UseableTimeRange = @"TepsAV_UseableTimeRange";
static NSString* sPrefMasterDvdFolderKey = @"prefMasterDvdFolderFolder"; // 2013-11-11steve
static NSString* sPrefBeginningChapterNameKey = @"prefBeginningChapterName"; // 2013-11-11steve
static NSString* sPrefEndingChapterNameKey = @"prefEndingChapterName"; // 2013-11-11steve


-(CGSize)trackDimensionsForAsset:(AVAsset *)asset
{
    
    AVAssetTrack *videoTrack = nil;
    
    // Check if the asset contains video and audio tracks
    if ([[asset tracksWithMediaType:AVMediaTypeVideo] count] != 0)
    {
        videoTrack = [[asset tracksWithMediaType:AVMediaTypeVideo] objectAtIndex:0];
    }
    
    // Get the format description of the track, to fill in attributes of the video stream that we don't want to change
    CMFormatDescriptionRef formatDescription = NULL;
    NSArray *formatDescriptions = [videoTrack formatDescriptions];
    if ([formatDescriptions count] > 0)
        formatDescription = (CMFormatDescriptionRef)[formatDescriptions objectAtIndex:0];
    
    // Grab track dimensions from format description
    CGSize trackDimensions = {
        .width = 0.0,
        .height = 0.0,
    };
    if (formatDescription)
        trackDimensions = CMVideoFormatDescriptionGetPresentationDimensions(formatDescription, true, false);
    else
        trackDimensions = [videoTrack naturalSize];
    return trackDimensions;
    
    
    // Grab clean aperture, pixel aspect ratio from format description
    NSDictionary *compressionSettings = nil;
    if (formatDescription)
    {
        NSDictionary *cleanAperture = nil;
        NSDictionary *pixelAspectRatio = nil;
        CFDictionaryRef cleanApertureFromCMFormatDescription = CMFormatDescriptionGetExtension(formatDescription, kCMFormatDescriptionExtension_CleanAperture);
        if (cleanApertureFromCMFormatDescription)
        {
            cleanAperture = [NSDictionary dictionaryWithObjectsAndKeys:
                             CFDictionaryGetValue(cleanApertureFromCMFormatDescription, kCMFormatDescriptionKey_CleanApertureWidth), AVVideoCleanApertureWidthKey,
                             CFDictionaryGetValue(cleanApertureFromCMFormatDescription, kCMFormatDescriptionKey_CleanApertureHeight), AVVideoCleanApertureHeightKey,
                             CFDictionaryGetValue(cleanApertureFromCMFormatDescription, kCMFormatDescriptionKey_CleanApertureHorizontalOffset), AVVideoCleanApertureHorizontalOffsetKey,
                             CFDictionaryGetValue(cleanApertureFromCMFormatDescription, kCMFormatDescriptionKey_CleanApertureVerticalOffset), AVVideoCleanApertureVerticalOffsetKey,
                             nil];
        }
        CFDictionaryRef pixelAspectRatioFromCMFormatDescription = CMFormatDescriptionGetExtension(formatDescription, kCMFormatDescriptionExtension_PixelAspectRatio);
        if (pixelAspectRatioFromCMFormatDescription)
        {
            pixelAspectRatio = [NSDictionary dictionaryWithObjectsAndKeys:
                                CFDictionaryGetValue(pixelAspectRatioFromCMFormatDescription, kCMFormatDescriptionKey_PixelAspectRatioHorizontalSpacing), AVVideoPixelAspectRatioHorizontalSpacingKey,
                                CFDictionaryGetValue(pixelAspectRatioFromCMFormatDescription, kCMFormatDescriptionKey_PixelAspectRatioVerticalSpacing), AVVideoPixelAspectRatioVerticalSpacingKey,
                                nil];
        }
        
        if (cleanAperture || pixelAspectRatio)
        {
            NSMutableDictionary *mutableCompressionSettings = [NSMutableDictionary dictionary];
            if (cleanAperture)
                [mutableCompressionSettings setObject:cleanAperture forKey:AVVideoCleanApertureKey];
            if (pixelAspectRatio)
                [mutableCompressionSettings setObject:pixelAspectRatio forKey:AVVideoPixelAspectRatioKey];
            compressionSettings = mutableCompressionSettings;
        }
    }
    return trackDimensions;
    
}
-(void)writerDidFinishWithSuccess:(BOOL)success
{
    if(success)
    {
        //a conversion just completed
        dispatch_semaphore_signal(waitSemaphore);
    }
}

-(void)progressTimer2:(NSTimer*)aTimer
{
    NSLog(@"Inside [%@ %@]", [self class], NSStringFromSelector(_cmd)); // 2013-12-05steve
    
}

-(void)ffmpegAVOutputTicket:(NSDictionary *)ticket
{
    NSLog(@"entering %s... ticket = %@", __func__, ticket);

    // 2013-11-20steve - show a progress panel
    [NSApp beginSheet:mProgressPanel // 2013-11-20steve
       modalForWindow:self.window
        modalDelegate:self
       didEndSelector:nil
          contextInfo:nil];
    [mProgressIndicator performSelectorOnMainThread:@selector(startAnimation:) withObject:nil waitUntilDone:NO];

    // "ticket" is a dict that contains the following pairs:
    
    //NSDictionary * d = @{TepsAV_AssetsArray : @[@{TepsAV_AssetURL : [NSURL URLWithString:@"file:///anAssestURL1"],TepsAV_UseableTimeRange : [NSValue valueWithCMTimeRange:CMTimeRangeMake(kCMTimeZero, kCMTimeZero)]},@{TepsAV_AssetURL : [NSURL URLWithString:@"file:///anAssestURL2"],TepsAV_UseableTimeRange : [NSValue valueWithCMTimeRange:CMTimeRangeMake(kCMTimeZero, kCMTimeZero)]},@{TepsAV_AssetURL : [NSURL URLWithString:@"file:///anAssestURL3"],TepsAV_UseableTimeRange : [NSValue valueWithCMTimeRange:CMTimeRangeMake(kCMTimeZero, kCMTimeZero)]}], TepsAV_OutputURL:[NSURL URLWithString:@"file:///outputFile"]};
    //
    // 1) key=TepsAV_AssetsArray; value is an NSArray of dicts
    // 2) key=TepsAV_OutputURL; value is an NSURL pointing to the output file location (must be a file URL)
    
    NSArray * assets = ticket[TepsAV_AssetsArray];
    NSDictionary * dict;
    AVURLAsset * asset;
    NSURL * url;
    NSString * pathExtension = nil;
    NSUInteger assetCount = assets.count;

    if(3 == assetCount)
    {
        //process lead-in and lead-out to match the feature
        MyAVAssetRW * resizer = [[MyAVAssetRW alloc] init];
        
        resizer.targetBitrateInKbps = 1000; // 2014-09-24 always set in kbps
        
        resizer.delegate = self;
        dispatch_queue_t newQ =  NULL;
        
        dict = assets[1];
        url = dict[TepsAV_AssetURL];
        // get the output size that we need to match
        asset = [AVURLAsset URLAssetWithURL:url options:@{AVURLAssetPreferPreciseDurationAndTimingKey:@YES}];
        CGSize featureSize = [self trackDimensionsForAsset:asset];
        
        BOOL doForce = NO; // 2013-11-27steve
        if (doForce) {
            featureSize.height = 480; // 540; // 2013-11-26steve
            featureSize.width  = 854; // 960; // 2013-11-26teve
        }
        
        
        //NSLog(@"2013-11-26steve trackDimensionsForAsset size = %@", NSStringFromSize((NSSize)featureSize));
        int intWidth = (int)featureSize.width;
        //NSLog(@"2013-11-26steve trackDimensionsForAsset size = %i", intWidth);
        if (intWidth%2) {
            // it's odd
            featureSize.width = (CGFloat)(intWidth+1);
            NSLog(@"2013-11-26steve Need to make it even width = %@", NSStringFromSize((NSSize)featureSize));
        }
        
        
        
        resizer.outputSize = featureSize;
        pathExtension = [NSString stringWithFormat:@"%.0fx%.0f.%@",resizer.outputSize.width,resizer.outputSize.height,[url pathExtension]];
        
        
        // resize the lead-in(asset[0]) and lead-out(asset[2]) to match the feature (asset[1])
        dict = assets[0];
        CGSize size;
        newQ = dispatch_queue_create(NULL, NULL);
        for (dict in @[assets[0],assets[2]])
        {
            BOOL doRecreate = [dict[TepsAV_AssetDoRecreate] boolValue];
            if (doRecreate) {
                NSLog (@"2013-11-20steve - WE MUST FORCED a doRecreate!!!!");
            }
            url = dict[TepsAV_AssetURL];
            asset = [AVURLAsset URLAssetWithURL:url options:@{AVURLAssetPreferPreciseDurationAndTimingKey:@YES}];
            size = [self trackDimensionsForAsset:asset];
            // 2013-11-18steve if (!CGSizeEqualToSize(resizer.outputSize, size))
            {
                resizer.inputURL = url;
                NSLog(@"resizer.inputURL = [%@]",resizer.inputURL); // 2013-11-21steve
                
                url = [url URLByDeletingPathExtension];
                url = [url URLByAppendingPathExtension:pathExtension];
                if(![[NSFileManager defaultManager] isReadableFileAtPath:[url path]] || doRecreate)
                {
                    resizer.outputURL = url;
                    
                    // 2013-11-21steve
                    id redirectedPath = dict[TepsAV_TempPath];
                    if (redirectedPath) {
                        NSString* originalpath = [resizer.inputURL path];
                        NSURL* redirectedURL = [NSURL fileURLWithPath:[redirectedPath stringByExpandingTildeInPath]];
                        redirectedURL = [redirectedURL URLByAppendingPathComponent:[originalpath lastPathComponent]];
                        redirectedURL = [redirectedURL URLByDeletingPathExtension];
                        redirectedURL = [redirectedURL URLByAppendingPathExtension:pathExtension];
                        resizer.outputURL = redirectedURL;
                        NSLog(@"redirectURL = [%@]",redirectedURL); // 2013-11-21steve
                    }
                    
                    dispatch_async(newQ, ^{
                        [resizer start:nil];
                    });
                    
                    dispatch_semaphore_wait(waitSemaphore, DISPATCH_TIME_FOREVER);
                }
            }
        }
        dispatch_release(newQ);
        
        [resizer release]; // 2013-12-04steve fix LEAK
        
    }
    else
    {
        NSLog(@"conversion failed with bad asset count of %lu (should be 3)", (unsigned long)assetCount);
    }
    
    // the above part does any necessary resizing. Ideally, the resizing is done only once per asset size (e.g 1280x720)
    
    // the part below calls ffmpeg to perform the file merge
    
    // first we convert each asset to mpeg2 transcode then we concatenate them
    
    // ffmpeg -i "${chapter1}" -c copy -bsf:v h264_mp4toannexb -f mpegts "${chapter1/.mp4/.ts}"
    // ffmpeg -i "${feature}" -c:v copy -c:a copy -bsf:v h264_mp4toannexb -f mpegts "${feature/.mp4/.ts}"
    // ffmpeg -i "${chapter3}" -c copy -bsf:v h264_mp4toannexb -f mpegts "${chapter3/.mp4/.ts}"
    // ffmpeg -i "concat:${chapter1/.mp4/.ts}|${feature/.mp4/.ts}|${chapter3/.mp4/.ts}" -c:v copy -c:a copy -bsf:a aac_adtstoasc "${outputMovie}"

    // (required) TepsAV_UseableTimeRange: NSValue encoding CMTimeRange for the usable portion of the asset

    NSValue * value;
    CMTimeRange selectedRange = (value = (dict = assets[1])[TepsAV_UseableTimeRange]).CMTimeRangeValue;
    

    NSString * ffmpegPath = dict[TepsAV_ffmpegLaunchPath] ? : @"/usr/local/bin/ffmpeg";
    NSString * outputPath = (url = ticket[TepsAV_OutputURL]).path;
    NSString * inputPath;
    NSString * chapter1;
    NSString * chapter3;
    NSString * feature;
    
    NSLog(@"2014-10-07steve outputPath here1 = %@",outputPath);
    NSLog(@"2014-11-06steve ffmpegPath = %@",ffmpegPath);
    NSLog(@"2014-11-06steve outputPath = %@",outputPath);
    
    NSMutableArray * junkPaths = [NSMutableArray array];

    // start each task and wait for exit
    inputPath = (url = (dict = assets[0])[TepsAV_AssetURL]).path;
    inputPath = [inputPath.stringByDeletingPathExtension stringByAppendingPathExtension:pathExtension];
    chapter1 = [self transcodedFilePathFromInput:inputPath usingToolAtPath:ffmpegPath];
    [junkPaths addObject:chapter1?:@"/dev/null"];

    inputPath = (url = (dict = assets[2])[TepsAV_AssetURL]).path;
    inputPath = [inputPath.stringByDeletingPathExtension stringByAppendingPathExtension:pathExtension];
    chapter3 = [self transcodedFilePathFromInput:inputPath usingToolAtPath:ffmpegPath];
    [junkPaths addObject:chapter3?:@"/dev/null"];

    inputPath = (url = (dict = assets[1])[TepsAV_AssetURL]).path;
    inputPath = [self paddedFilePathFromInput:inputPath usingToolAtPath:ffmpegPath];
    [junkPaths addObject:inputPath?:@"/dev/null"];
    feature = [self transcodedFilePathFromInput:inputPath usingToolAtPath:ffmpegPath];
    [junkPaths addObject:feature?:@"/dev/null"];
    
    if(!(chapter1 && chapter3 && feature) || ![[NSFileManager defaultManager] fileExistsAtPath:chapter1] || ![[NSFileManager defaultManager] fileExistsAtPath:chapter3] || ![[NSFileManager defaultManager] fileExistsAtPath:feature])
    {
        NSLog(@"EPIC FAIL! big problem going from %@ to %@",inputPath,outputPath);
    }
    
    NSLog(@"014-10-07steve outputPath here2 = %@",outputPath);

    if([[NSFileManager defaultManager] fileExistsAtPath:outputPath])
    {
        NSLog(@"output file already exists at %@ ... deleting it",outputPath);
        NSError *e =nil;
        if(![[NSFileManager defaultManager] removeItemAtPath:outputPath error:&e])
        {
            NSLog(@"EPIC FAIL! Could not delete file at%@ (error:%@)",outputPath,e);
        }
    }

    inputPath = [NSString stringWithFormat:@"concat:%@|%@|%@",chapter1,feature,chapter3];
    

    [self launchToolAtPath:ffmpegPath withArguments:@[@"-i",inputPath,@"-c",@"copy",@"-bsf:a",@"aac_adtstoasc",outputPath] completionHandler:^(NSTask *task) {
        int status = task.terminationStatus;
        if(status)
        {
            //FAIL!
            NSLog(@"task %d failed with exit code %d",task.processIdentifier,status);
        }
        else
        {
            NSLog(@"%@ Export completed to :%@",[self class],outputPath);
            
            // 2014-07-27steve - if fromTepsNotification
            // get the list of Photos
            // and add it to the movie and
            // then pass to UsbFlash Writer
            BOOL doBurnUSB = YES; // [[NSUserDefaults standardUserDefaults] boolForKey:@""]; // 2014-07-28steve
            BOOL interfaceWithTeps = [[NSUserDefaults standardUserDefaults] boolForKey:@"prefInterfaceWithTeps"];
            NSMutableArray* itemsForUsbFlashWriter = [NSMutableArray arrayWithObjects:outputPath, nil];
            if (interfaceWithTeps) {
                if (self.fTepsArrayOfPhotos && [self.fTepsArrayOfPhotos count]) {
                    [itemsForUsbFlashWriter addObjectsFromArray:self.fTepsArrayOfPhotos];
                }
                [self sendNotificationToBurnUsbFlash:itemsForUsbFlashWriter]; // 2013-11-19steve
            } else {
                [self sendNotificationToBurnUsbFlash:[NSArray arrayWithObject:outputPath]]; // 2013-11-19steve
            }
            
            
            
            [NSApp endSheet:mProgressPanel returnCode:NSRunStoppedResponse]; // 2013-11-22steve
            [mProgressPanel orderOut:nil];
            
            if (doBurnUSB) {
                [self performSelectorOnMainThread:@selector(bringToBack:) withObject:nil waitUntilDone:NO];
            }
        }
        for (NSString * path in junkPaths)
        {
            NSError *e =nil;
            if(![[NSFileManager defaultManager] removeItemAtPath:path error:&e])
            {
                NSLog(@"Warning: failed to delete file at %@ (error:%@)",path,e);
            }
        }
    }];
}
-(NSString *)paddedFilePathFromInput:(NSString *)inputPath usingToolAtPath:(NSString *)launchPath
{
    
    // this method does the equivalent of this:
    // ffmpeg  -i "${feature}" -ss 00:00:00 -codec copy -t 200000 "${feature_a}"
    
    // steve discovered this "fix" will cure any "green flash" between chapter 1 and the feature
    NSString * outputPath = inputPath.stringByDeletingLastPathComponent;
    NSString * lastPathComponent = inputPath.lastPathComponent.stringByDeletingPathExtension;
    NSString * pathExtension = inputPath.pathExtension;
    lastPathComponent = [lastPathComponent stringByAppendingPathExtension:@"pad"];
    lastPathComponent = [lastPathComponent stringByAppendingPathExtension:pathExtension];
    lastPathComponent = [@"." stringByAppendingString:lastPathComponent];
    outputPath = [outputPath stringByAppendingPathComponent:lastPathComponent];
    if ([[NSFileManager defaultManager] fileExistsAtPath:outputPath])
    {
        return outputPath;
    }
    
    dispatch_group_t group = dispatch_group_create();
    // start each task and wait for exit
    dispatch_group_enter(group);
    [self launchToolAtPath:launchPath withArguments:@[@"-i",inputPath,@"-ss",@"00:00:00",@"-c",@"copy",@"-t",@"200000",outputPath] completionHandler:^(NSTask *task) {
        int status = task.terminationStatus;
        if(status)
        {
            NSLog(@"task %@ failed with exit code %d",task.launchPath,status);
        }
        dispatch_group_leave(group);
    }];
    dispatch_group_wait(group, DISPATCH_TIME_FOREVER);
    if (![[NSFileManager defaultManager] fileExistsAtPath:outputPath])
    {
        outputPath = nil;
    }
    return outputPath;
}
-(NSString *)transcodedFilePathFromInput:(NSString *)inputPath usingToolAtPath:(NSString *)launchPath
{
    NSString * outputPath = inputPath.stringByDeletingLastPathComponent;
    NSString * lastPathComponent = inputPath.lastPathComponent.stringByDeletingPathExtension;
    lastPathComponent = [lastPathComponent stringByAppendingPathExtension:@"ts"];
    lastPathComponent = [@"." stringByAppendingString:lastPathComponent];
    outputPath = [outputPath stringByAppendingPathComponent:lastPathComponent];
    if ([[NSFileManager defaultManager] fileExistsAtPath:outputPath])
    {
        return outputPath;
    }

    __block BOOL didComplete = NO;
    dispatch_group_t group = dispatch_group_create();
    // start each task and wait for exit
    dispatch_group_enter(group);
    [self launchToolAtPath:launchPath withArguments:@[@"-i",inputPath,@"-c",@"copy",@"-bsf:v",@"h264_mp4toannexb",@"-f",@"mpegts",outputPath] completionHandler:^(NSTask *task) {
        int status = task.terminationStatus;
        if(status)
        {
            NSLog(@"task %@ failed with exit code %d",task.launchPath,status);
        }
        else
        {
            didComplete = YES;
        }
        dispatch_group_leave(group);
    }];
    dispatch_group_wait(group, DISPATCH_TIME_FOREVER);
    if (![[NSFileManager defaultManager] fileExistsAtPath:outputPath])
    {
        outputPath = nil;
    }
    return outputPath;
}
-(NSTask *)launchToolAtPath:(NSString *)launchPath withArguments:(NSArray *)args completionHandler:(void (^)(NSTask * task))completionBlock
{
    NSLog(@"starting task %@ %@",launchPath,[args componentsJoinedByString:@" "]);

    NSTask * task = [[NSTask alloc] init];
    [task setLaunchPath:launchPath];
    [task setArguments:args];
    task.terminationHandler = completionBlock;
    [task launch];
    NSLog(@"started task %d ",task.processIdentifier);
    [task autorelease];
    return  task;
//    [convertTask setLaunchPath:@"/usr/bin/avconvert"];
//    NSString * trackWidth = [NSString stringWithFormat:@"%.0f",size.width];
//    NSString * trackHeight = [NSString stringWithFormat:@"%.0f",size.height];
//    NSAssert(inputURL.isFileURL, @"inputURL (%@) must be a FILE URL",inputURL);
//    NSAssert(outputURL.isFileURL, @"outputURL (%@) must be a FILE URL",outputURL);
//    dispatch_group_enter(group);
    /*
     Presets available for use with avconvert:
     PresetAppleM4VCellular
     PresetAppleM4ViPod
     PresetAppleM4VWiFi
     PresetAppleM4VAppleTV
     PresetAppleM4V480pSD
     PresetAppleM4V720pHD
     PresetAppleM4V1080pHD
     PresetAppleM4A
     Preset640x480
     Preset1280x720
     Preset1920x1080
     PresetAppleProRes422LPCM
     */
//    NSArray * args = @[@"-v",@"-prog",@"-p",@"PresetAppleM4V480pSD",@"--source",inputURL.path,@"--output", outputURL.path, @"-vt",@"-tw",trackWidth,@"-th",trackHeight];
//    NSLog(@"avconverting with args %@",[args componentsJoinedByString:@" "]);
    //,@"--videoTrack",@"--dataRate",@"777777",@"--trackHeight",@"480",@"--trackWidth",@"640",@"--videoCodec",@"avc1"]
}

// 2013-11-08steve - from tyler
-(void)processAVOutputTicket:(NSDictionary *)ticket
{
    NSLog(@"2013-11-20steve %@... ticket = %@", NSStringFromSelector(_cmd), ticket);

    // 2013-11-20steve - show a progress panel
    [NSApp beginSheet:mProgressPanel // 2013-11-20steve
       modalForWindow:self.window
        modalDelegate:self
       didEndSelector:nil
          contextInfo:nil];
    [mProgressIndicator performSelectorOnMainThread:@selector(startAnimation:) withObject:nil waitUntilDone:NO]; // 2013-11-20steve
    
    /* 2013-12-05steve - dont need
    // 2013-11-19steve
    NSTimer* aTimer = [NSTimer timerWithTimeInterval:1.0
                                              target:self
                                            selector:@selector(progressTimer2:)
                                            userInfo:nil
                                             repeats:YES]; // 2013-11-19steve
    
    [[NSRunLoop mainRunLoop] addTimer:aTimer
                              forMode:NSDefaultRunLoopMode]; // 2013-11-19steve
    */
    
    // 2013-11-19steve   [[NSTimer scheduledTimerWithTimeInterval:2.5 target:self selector:@selector(progressTimer:) userInfo:exportSession repeats:YES] retain];
    
    
    
    // 2013-11-12steve DEBUG[self exportCurrentMovie:ticket]; // 2013-11-12steve - TEST exporting of feature video in case it was trimmed
    
    
    
    // [self processAVOutputTicketSteve:ticket]; // 2013-11-12steve
    // return; // 2013-11-12steve
    
    // tyler (for steve)
    // "ticket" is a dict that contains the following pairs:
    
    //NSDictionary * d = @{TepsAV_AssetsArray : @[@{TepsAV_AssetURL : [NSURL URLWithString:@"file:///anAssestURL1"],TepsAV_UseableTimeRange : [NSValue valueWithCMTimeRange:CMTimeRangeMake(kCMTimeZero, kCMTimeZero)]},@{TepsAV_AssetURL : [NSURL URLWithString:@"file:///anAssestURL2"],TepsAV_UseableTimeRange : [NSValue valueWithCMTimeRange:CMTimeRangeMake(kCMTimeZero, kCMTimeZero)]},@{TepsAV_AssetURL : [NSURL URLWithString:@"file:///anAssestURL3"],TepsAV_UseableTimeRange : [NSValue valueWithCMTimeRange:CMTimeRangeMake(kCMTimeZero, kCMTimeZero)]}], TepsAV_OutputURL:[NSURL URLWithString:@"file:///outputFile"]};
    //
    // 1) key=TepsAV_AssetsArray; value is an NSArray of dicts
    // 2) key=TepsAV_OutputURL; value is an NSURL pointing to the output file location (must be a file URL)
    
    NSArray * assets = ticket[TepsAV_AssetsArray];
    NSDictionary * dict;
    AVURLAsset * asset;
    NSURL * url;
    NSString * pathExtension = nil;
    NSUInteger assetCount = assets.count;
    if(3 == assetCount)
    {
        //process lead-in and lead-out to match the feature
        MyAVAssetRW * resizer = [[MyAVAssetRW alloc] init];
        
        resizer.targetBitrateInKbps = 500; // 2014-09-24 always set in kbps
        
        resizer.delegate = self;
        dispatch_queue_t newQ =  NULL;
        
        dict = assets[1];
        url = dict[TepsAV_AssetURL];
        // get the output size that we need to match
        asset = [AVURLAsset URLAssetWithURL:url options:@{AVURLAssetPreferPreciseDurationAndTimingKey:@YES}];
        CGSize size = [self trackDimensionsForAsset:asset];

        BOOL doForce = NO; // 2013-11-27steve
        if (doForce) {
            size.height = 480; // 540; // 2013-11-26steve
            size.width  = 854; // 960; // 2013-11-26teve
        }

        
        //NSLog(@"2013-11-26steve trackDimensionsForAsset size = %@", NSStringFromSize((NSSize)size));
        int intWidth = (int)size.width;
        //NSLog(@"2013-11-26steve trackDimensionsForAsset size = %i", intWidth);
        if (intWidth%2) {
            // it's odd
            size.width = (CGFloat)(intWidth+1);
            NSLog(@"2013-11-26steve Need to make it even width = %@", NSStringFromSize((NSSize)size));
        }

        
        
        resizer.outputSize = size;
        pathExtension = [NSString stringWithFormat:@"%.0fx%.0f.%@",resizer.outputSize.width,resizer.outputSize.height,[url pathExtension]];
        
        
        // resize the lead-in(asset[0]) and lead-out(asset[2]) to match the feature (asset[1])
        dict = assets[0];
        newQ = dispatch_queue_create(NULL, NULL);
        for (dict in @[assets[0],assets[1],assets[2]])
        {
            BOOL doRecreate = [dict[TepsAV_AssetDoRecreate] boolValue];
            if (doRecreate) {
                NSLog (@"2013-11-20steve - WE MUST FORCED a doRecreate!!!!");
            }
            url = dict[TepsAV_AssetURL];
            asset = [AVURLAsset URLAssetWithURL:url options:@{AVURLAssetPreferPreciseDurationAndTimingKey:@YES}];
            size = [self trackDimensionsForAsset:asset];
            // 2013-11-18steve if (!CGSizeEqualToSize(resizer.outputSize, size))
            {
                resizer.inputURL = url;
                NSLog(@"resizer.inputURL = [%@]",resizer.inputURL); // 2013-11-21steve

                url = [url URLByDeletingPathExtension];
                url = [url URLByAppendingPathExtension:pathExtension];
                if(![[NSFileManager defaultManager] isReadableFileAtPath:[url path]] || doRecreate)
                {
                    resizer.outputURL = url;
                    
                    // 2013-11-21steve
                    id redirectedPath = dict[TepsAV_TempPath];
                    if (redirectedPath) {
                        NSString* originalpath = [resizer.inputURL path];
                        NSURL* redirectedURL = [NSURL fileURLWithPath:[redirectedPath stringByExpandingTildeInPath]];
                        redirectedURL = [redirectedURL URLByAppendingPathComponent:[originalpath lastPathComponent]];
                        redirectedURL = [redirectedURL URLByDeletingPathExtension];
                        redirectedURL = [redirectedURL URLByAppendingPathExtension:pathExtension];
                        resizer.outputURL = redirectedURL;
                        NSLog(@"redirectURL = [%@]",redirectedURL); // 2013-11-21steve
                    }
                    
                    dispatch_async(newQ, ^{
                        [resizer start:nil];
                    });
                    
                    dispatch_semaphore_wait(waitSemaphore, DISPATCH_TIME_FOREVER);
                }
            }
        }
        dispatch_release(newQ);
        
        [resizer release]; // 2013-12-04steve fix LEAK
        
    }
    
    NSUInteger i = 0;
    const NSString * key;
    CMTime insertionPoint = kCMTimeZero;
    CMTime duration = kCMTimeZero;
    CMTime transitionDuration = CMTimeMake(1, 1);
    CMTimeRange selectedRange;
    NSError * error = nil;
    NSValue * v;
    AVMutableComposition * mutableComposition = [AVMutableComposition composition];
    AVMutableVideoComposition * mutableVideoComposition = nil;
    for (NSDictionary * dict in assets)
    {
        // (required) TepsAV_AssetURL: an NSURL for each asset file
        key = TepsAV_AssetURL;
        if( (url = dict[key]) )
        {
            
            // 2013-11-21steve
            id redirectedPath = dict[TepsAV_TempPath];
            if (redirectedPath) {
                NSString* originalpath = [url path];
                NSURL* redirectedURL = [NSURL fileURLWithPath:[redirectedPath stringByExpandingTildeInPath]];
                redirectedURL = [redirectedURL URLByAppendingPathComponent:[originalpath lastPathComponent]];
                redirectedURL = [redirectedURL URLByDeletingPathExtension];
                redirectedURL = [redirectedURL URLByAppendingPathExtension:pathExtension];
                url = redirectedURL;
                NSLog(@"redirectURL = [%@]",redirectedURL); // 2013-11-22steve
            }
            
            
            NSURL *testURL = [[url URLByDeletingPathExtension] URLByAppendingPathExtension:pathExtension];
            
            if([[NSFileManager defaultManager] isReadableFileAtPath:[testURL path]])
            {
                url = testURL;
            }
            
            asset = [AVURLAsset URLAssetWithURL:url options:@{AVURLAssetPreferPreciseDurationAndTimingKey:@YES}];
            //asset = [AVAsset assetWithURL:url];
        }
        else
        {
            NSAssert(NO, @"Dictionary does not include required value for key %@ for asset %@",key,url);
            
        }
        AVAssetTrack *videoTrack = nil;
        AVAssetTrack *audioTrack = nil;
        // Check if the asset contains video and audio tracks
        if ([[asset tracksWithMediaType:AVMediaTypeVideo] count] != 0)
        {
            videoTrack = [[asset tracksWithMediaType:AVMediaTypeVideo] objectAtIndex:0];
        }
        if ([[asset tracksWithMediaType:AVMediaTypeAudio] count] != 0)
        {
            audioTrack = [[asset tracksWithMediaType:AVMediaTypeAudio] objectAtIndex:0];
        }
        
        // (required) TepsAV_UseableTimeRange: NSValue encoding CMTimeRange for the usable portion of the asset
        key = TepsAV_UseableTimeRange;
        if( (v = dict[key]) )
        {
            selectedRange = v.CMTimeRangeValue;
        }
        else
        {
            NSLog(@"Getting asset duration for asset %@",asset);
            selectedRange = CMTimeRangeMake(kCMTimeZero, asset.duration);
            CFStringRef strRef;
            NSLog(@"Got range %@ for asset %@",(strRef = CMTimeRangeCopyDescription(NULL, selectedRange)),asset);
            CFRelease(strRef);
            // fail here
            //NSAssert(NO, @"Dictionary does not include required value for key %@ for asset %@",key,url);
        }
        duration = CMTimeAdd(duration, selectedRange.duration);
        // Insert selection of video and audio tracks from AVAsset
        AVMutableCompositionTrack * vtrack = nil;
        AVMutableCompositionTrack * atrack;
        if(videoTrack)
        {
            vtrack = [mutableComposition mutableTrackCompatibleWithTrack:videoTrack] ?: [mutableComposition addMutableTrackWithMediaType:AVMediaTypeVideo preferredTrackID:kCMPersistentTrackID_Invalid];
            
            [vtrack insertTimeRange:selectedRange ofTrack:videoTrack atTime:insertionPoint error:&error];
        }
        if(audioTrack != nil)
        {
            atrack = [mutableComposition mutableTrackCompatibleWithTrack:audioTrack] ?:[mutableComposition addMutableTrackWithMediaType:AVMediaTypeAudio preferredTrackID:kCMPersistentTrackID_Invalid];
            [atrack insertTimeRange:selectedRange ofTrack:audioTrack atTime:insertionPoint error:&error];
        }
        
        AVMutableVideoCompositionInstruction * segmentInstruction = [AVMutableVideoCompositionInstruction videoCompositionInstruction];
        CGColorRef bgcolor = CGColorCreateGenericRGB(1.0, 0.5, 0.2, 1.0);
        segmentInstruction.backgroundColor = bgcolor;
        CGColorRelease(bgcolor);
        
        segmentInstruction.timeRange = CMTimeRangeMake(insertionPoint, selectedRange.duration);
        AVMutableVideoCompositionLayerInstruction * segmentLayer = [AVMutableVideoCompositionLayerInstruction videoCompositionLayerInstructionWithAssetTrack:videoTrack];
        CMTime rampStart = CMTimeAdd(insertionPoint, selectedRange.duration);
        CMTime rampDuration = kCMTimeZero;
        if (CMTIME_COMPARE_INLINE(selectedRange.duration, >=, transitionDuration))
        {
            rampStart = CMTimeSubtract(rampStart, transitionDuration);
            rampDuration = transitionDuration;
        }
        ////////////////
        //rampStart = insertionPoint;
        //rampDuration = selectedRange.duration;
        ////////////////
        [segmentLayer setOpacityRampFromStartOpacity:1.0f toEndOpacity:0.0f timeRange:CMTimeRangeMake(rampStart, rampDuration)];
        segmentInstruction.layerInstructions = @[segmentLayer];
        if(nil == mutableVideoComposition)
        {
            rampStart = CMTimeMakeWithSeconds(1.0f/videoTrack.nominalFrameRate, 30);
            // on maverix we could use videoCompositionWithPropertiesOfAsset:
            mutableVideoComposition = [AVMutableVideoComposition videoComposition];
            mutableVideoComposition.frameDuration = CMTimeMakeWithSeconds(1.0f/videoTrack.nominalFrameRate, 30); // 30 fps
            mutableVideoComposition.renderSize = mutableComposition.naturalSize;
            
            // CGSize forcedSize = CGSizeMake(1280, 720);
            // mutableVideoComposition.renderSize = forcedSize;

            NSLog(@"2013-11-27steve - mutableVideoComposition.renderSize = %@", NSStringFromSize((NSSize) mutableVideoComposition.renderSize) );
            
            mutableVideoComposition.instructions = [NSArray array];
        }
        mutableVideoComposition.instructions = [mutableVideoComposition.instructions arrayByAddingObject:segmentInstruction];
        
        
        insertionPoint = CMTimeAdd(insertionPoint, selectedRange.duration);
        i++;
    }
    
    // (required) TepsAV_UseableTimeRange: NSValue encoding CMTimeRange for the usable portion of the asset
    key = TepsAV_OutputURL;
    NSURL * outputURL = ticket[key];
    NSAssert(outputURL, @"ExportTicket does not include required value for key %@",key);
    
    
    // Create an export session with the composition
    //    AVAssetExportSession *exportSession = [[AVAssetExportSession alloc] initWithAsset:mutableComposition presetName:AVAssetExportPresetPassthrough]; //AVAssetExportPreset1280x720 AVAssetExportPresetPassthrough
    
    
    
    NSLog(@"exportPresetsCompatibleWithAsset = %@", [AVAssetExportSession exportPresetsCompatibleWithAsset:mutableComposition] );
    
    
#ifndef NSAppKitVersionNumber10_8
#define NSAppKitVersionNumber10_8 1187
#endif
    
    NSString * exportPreset;
    if (floor(NSAppKitVersionNumber) <= NSAppKitVersionNumber10_8)
    {
        /* On a 10.8 or earlier */
        exportPreset = AVAssetExportPreset1280x720;
        exportPreset = AVAssetExportPreset960x540;
    } else {
        /* 10.9 or later system */
        exportPreset = AVAssetExportPresetPassthrough; // this will NOT work correctly on 10.9 - cant playback
        exportPreset = AVAssetExportPreset1920x1080;
        exportPreset = AVAssetExportPreset1280x720;
        exportPreset = AVAssetExportPreset960x540;
    }
    exportPreset =  AVAssetExportPresetAppleM4V480pSD; // 2014-09-30  AVAssetExportPreset960x540; // 2014-09-26steve AVAssetExportPresetPassthrough; // AVAssetExportPreset1280x720; // tyler set this as a test on 2013-11-18
    //exportPreset = AVAssetExportPreset1280x720; // 2013-11-21steve AVAssetExportPresetPassthrough would NOT work
    
    
    // Create an export session with the composition
    AVAssetExportSession *exportSession = [[[AVAssetExportSession alloc] initWithAsset:mutableComposition presetName:exportPreset] autorelease]; // 2013-12-04steve LEAK
    
    //    exportSession.videoComposition = mutableVideoComposition;
    exportSession.outputURL = outputURL;
    exportSession.outputFileType=AVFileTypeAppleM4V; // 2014-09-30  AVFileTypeQuickTimeMovie;
    
    [exportSession exportAsynchronouslyWithCompletionHandler:^(void){
        switch (exportSession.status) {
            case AVAssetExportSessionStatusCompleted:
                NSLog(@"%@ Export FINALLY completed to :%@",[self class],exportSession.outputURL.path); // 2014-07-27steve
                
                // 2014-07-27steve - if fromTepsNotification
                // get the list of Photos
                // and add it to the movie and
                // then pass to UsbFlash Writer
                BOOL doBurnUSB = YES; // [[NSUserDefaults standardUserDefaults] boolForKey:@""]; // 2014-07-28steve
                BOOL interfaceWithTeps = [[NSUserDefaults standardUserDefaults] boolForKey:@"prefInterfaceWithTeps"];
                NSMutableArray* itemsForUsbFlashWriter = [NSMutableArray arrayWithObjects:exportSession.outputURL.path, nil];
                if (interfaceWithTeps) {
                    if (self.fTepsArrayOfPhotos && [self.fTepsArrayOfPhotos count]) {
                        [itemsForUsbFlashWriter addObjectsFromArray:self.fTepsArrayOfPhotos];
                    }
                    [self sendNotificationToBurnUsbFlash:itemsForUsbFlashWriter]; // 2013-11-19steve
                } else {
                    [self sendNotificationToBurnUsbFlash:[NSArray arrayWithObject:exportSession.outputURL.path]]; // 2013-11-19steve
                }
                
                
                
                [NSApp endSheet:mProgressPanel returnCode:NSRunStoppedResponse]; // 2013-11-22steve
                [mProgressPanel orderOut:nil];
                
                if (doBurnUSB) {
                    [self performSelectorOnMainThread:@selector(bringToBack:) withObject:nil waitUntilDone:NO];
                }
                
                
                break;
            case AVAssetExportSessionStatusFailed:
                //
                NSLog(@"Failed:%@",exportSession.error);
                break;
            case AVAssetExportSessionStatusCancelled:
                //
                NSLog(@"Canceled:%@",exportSession.error);
                break;
            default:
                NSLog(@"Other:(Status %ld),%@",exportSession.status,exportSession.error);
                break;
        }
    }];
    
    // we need a progress timer during the conversion of each movie file - not during
    // 2013-11-19steve   [[NSTimer scheduledTimerWithTimeInterval:2.5 target:self selector:@selector(progressTimer:) userInfo:exportSession repeats:YES] retain];
    
    // 2013-12-05steve [aTimer invalidate]; // 2013-11-19steve
    
    NSLog(@"%@-%@ -> DONE................", self, NSStringFromSelector(_cmd));

}


-(BOOL)mergeVideos:(id)featureItem
{
    BOOL didMergeVideo = NO;
    BOOL doMergeVideo = YES;
    NSLog(@"%@-%@ -> doMergeVideo is %@", [self class], NSStringFromSelector(_cmd), doMergeVideo?@"YES":@"NO");
    
    if (doMergeVideo==NO) {
        return didMergeVideo;
    }
    
    if (waitSemaphore==nil)
        waitSemaphore = dispatch_semaphore_create(0);

    
    NSString* currentFeatureVideoPath = featureItem;
    
	NSString* endingChapterMovieName = [[NSUserDefaults standardUserDefaults] stringForKey:sPrefEndingChapterNameKey];
	NSString* beginningChapterMovieName = [[NSUserDefaults standardUserDefaults] stringForKey:sPrefBeginningChapterNameKey];
	NSString* masterDvdFolderPath = [[NSUserDefaults standardUserDefaults] stringForKey:sPrefMasterDvdFolderKey];
    
    NSLog(@"   endingChapterMovieName = [%@]",endingChapterMovieName);
    NSLog(@"beginningChapterMovieName = [%@]",beginningChapterMovieName);
    NSLog(@"      masterDvdFolderPath = [%@]",masterDvdFolderPath);
    
    
    NSURL * chapter1URL = [NSURL URLWithString:@"file:///Users/Shared/MasterDvdContentFolder/chapter1.mov"];
    NSURL * chapter3URL = [NSURL URLWithString:@"file:///Users/Shared/MasterDvdContentFolder/chapter3.mov"];
    NSURL * featureURL = [NSURL URLWithString:@"file:///Users/Shared/customer.mov"];
    NSURL * outputURL = [NSURL URLWithString:@"file:///tmp/MergeMovie.mov"];
    
    if ( endingChapterMovieName && beginningChapterMovieName && masterDvdFolderPath && currentFeatureVideoPath) {
        NSString* tempPath = nil;
        
        tempPath = [masterDvdFolderPath stringByAppendingPathComponent:beginningChapterMovieName];
        chapter1URL = [NSURL fileURLWithPath:tempPath];
        
        tempPath = [masterDvdFolderPath stringByAppendingPathComponent:endingChapterMovieName];
        chapter3URL = [NSURL fileURLWithPath:tempPath];
        
        tempPath = currentFeatureVideoPath; // [masterDvdFolderPath stringByAppendingPathComponent:currentFeatureVideoPath];
        featureURL = [NSURL fileURLWithPath:tempPath];
        
        
//        // 2014-09-30steve - USE AVConvert
//        NSString* avconvertedItemPath = [[currentFeatureVideoPath stringByDeletingLastPathComponent] stringByAppendingPathComponent:@"AVCONVERTEDMOVIE.M4V"];
//        
//        //[[[currentFeatureVideoPath stringByDeletingPathExtension] stringByAppendingFormat:@"_avc"] stringByAppendingPathExtension:[currentFeatureVideoPath pathExtension]];
//        NSLog(@"avconvertedItem = %@",avconvertedItemPath);
//		NSString *scriptName = @"/usr/bin/avconvert";
//		NSArray *paramArray = [NSArray arrayWithObjects:@"--preset",@"PresetAppleM4V480pSD",@"--source",currentFeatureVideoPath,@"--output",avconvertedItemPath ,nil];
//		NSString* response2 = runThisShellScript ( scriptName, paramArray );
//		NSLog ( @"2010-11-03steve response2 = [%@]", response2 );
//        BOOL exists = [[NSFileManager defaultManager] fileExistsAtPath:avconvertedItemPath];
//        if (exists) {
//            featureURL = [NSURL fileURLWithPath:avconvertedItemPath];
//            NSLog(@"2014-09-30steve - SUCCESS - AVConverted item at [%@]",currentFeatureVideoPath);
//        } else {
//            NSLog(@"2014-09-30steve - UNABLE to AVConvert item at [%@]",currentFeatureVideoPath);
//        }
//        
        

        NSString* customerId = [self getBaseIdFromFileName:currentFeatureVideoPath]; // 2013-11-21steve

        BOOL doNewRenameMethod = YES; // 2014-10-07steve
        
        if (doNewRenameMethod) {
            NSString* defaultOutputFormatString = @"ME-And-Santa_[id].mov";
            
            // tempPath = @"/tmp/ME-And-Santa.mov";
            tempPath = @"/tmp";
            
            NSString* idholder = @"[id]";
            
            NSString* prefOutputPathFormatString = [[NSUserDefaults standardUserDefaults] stringForKey:@"prefFinalMovieFileNameFormatString"]; // 2014-10-07steve
            if (prefOutputPathFormatString) {
                if ([prefOutputPathFormatString rangeOfString:idholder].location != NSNotFound) {
                    // ah found the replacement holder
                    
                } else {
                    // missing [id] placeholder
                    prefOutputPathFormatString = [NSString stringWithFormat:@"%@",defaultOutputFormatString];
                    prefOutputPathFormatString = [prefOutputPathFormatString stringByDeletingPathExtension];
                    prefOutputPathFormatString = [prefOutputPathFormatString stringByAppendingFormat:@"_%@",idholder];
                    prefOutputPathFormatString = [prefOutputPathFormatString stringByAppendingPathExtension:[defaultOutputFormatString pathExtension]];
                    
                }
            } else {
                prefOutputPathFormatString = [NSString stringWithFormat:@"%@",defaultOutputFormatString];
            }
            
            /* 2014-10-07steve old way
             if (customerId) {
             NSString* ext = [tempPath pathExtension];
             tempPath = [tempPath stringByDeletingPathExtension]; // 2014-10-07steve
             tempPath = [tempPath stringByAppendingFormat:@"_%@",customerId]; // 2013-11-21steve
             tempPath = [tempPath stringByAppendingPathExtension:ext];
             }
             */
            if (customerId) {
                NSString* newOutputName = [NSString stringWithFormat:prefOutputPathFormatString,customerId]; // 2014-10-07steve
                newOutputName = [newOutputName stringByReplacingOccurrencesOfString:idholder withString:customerId];
                tempPath = [tempPath stringByAppendingPathComponent:newOutputName];
            } else {
                tempPath = [tempPath stringByAppendingPathComponent:@"Me-And-Santa.mov"]; // 2014-10-07steve
            }
            
            NSLog(@"2013-11-21steve - converted merged video = %@",tempPath);

        } else {
            tempPath = @"/tmp/TempMergedMovie.mov"; // 2014-10-07steve
            if (customerId) {
                NSString* ext = [tempPath pathExtension];
                tempPath = [tempPath stringByDeletingPathExtension]; // 2014-10-07steve
                tempPath = [tempPath stringByAppendingFormat:@"_%@",customerId]; // 2013-11-21steve
                tempPath = [tempPath stringByAppendingPathExtension:ext];
            }

        }
        
        outputURL = [NSURL fileURLWithPath:tempPath];
        
    }
    
    NSLog(@"chapter1URL = %@",chapter1URL);
    NSLog(@"chapter3URL = %@",chapter3URL);
    NSLog(@" featureURL = %@",featureURL);
    NSLog(@"  outputURL = %@",outputURL);
    
    
    // make sure all three realy exists
    if (chapter1URL) {
        BOOL exists = [[NSFileManager defaultManager] fileExistsAtPath:chapter1URL.path];
        if (exists==NO)
            chapter1URL = nil;
    }
    if (chapter3URL) {
        BOOL exists = [[NSFileManager defaultManager] fileExistsAtPath:chapter3URL.path];
        if (exists==NO)
            chapter3URL = nil;
    }
    
    
    if ( chapter1URL && chapter3URL && featureURL && outputURL ) {
        
        // 2013-11-21steve
        NSString* redirectedPath = TepsAVRedirectedPath;
        redirectedPath = [redirectedPath stringByExpandingTildeInPath];
        BOOL didCreate = createDirectoryIfMissing (redirectedPath); // 2013-11-21steve - create this temp directory on the desktop

        
        // delete the last temp
        [[NSFileManager defaultManager] removeItemAtURL:outputURL error:NULL];
        
        // setup params for merging
        NSDictionary * d = @{TepsAV_AssetsArray : @[@{TepsAV_AssetURL : chapter1URL},@{TepsAV_AssetURL:featureURL, TepsAV_AssetDoRecreate:@1, TepsAV_TempPath:TepsAVRedirectedPath},@{TepsAV_AssetURL : chapter3URL}], TepsAV_OutputURL:outputURL}; // 2013-11-21steve
        
        NSLog(@"2014-10-07steve passing dictionary to ffmpegAVOutputTicket: %@", d);
        
        dispatch_queue_t newQ = dispatch_queue_create(NULL, NULL);
        dispatch_async(newQ, ^{
//            [self processAVOutputTicket:d];
            [self ffmpegAVOutputTicket:d];
        });
        dispatch_release(newQ);
        
    } else { // 2013-11-20steve
        
        NSLog(@"%@-%@ -> NO Lead In/Out Video to Merge ....", self, NSStringFromSelector(_cmd)); // 2013-11-20steve

        BOOL interfaceWithTeps = [[NSUserDefaults standardUserDefaults] boolForKey:@"prefInterfaceWithTeps"];
        if (interfaceWithTeps) {
            NSMutableArray* itemsToBurn = [NSMutableArray arrayWithArray:self.fTepsArrayOfPhotos];
            if (featureItem) {
                [itemsToBurn addObject:featureItem];
            }
            [self sendNotificationToBurnUsbFlash:itemsToBurn]; // 2014-07-30steve
            
            
        } else {
            // 2013-11-20steve - we just want to burn the original item
            [self sendNotificationToBurnUsbFlash:[NSArray arrayWithObjects:featureItem, nil]]; // 2013-11-20steve
        }
        

    }
    
    NSLog(@"%@-%@ -> DONE................", self, NSStringFromSelector(_cmd));

    return didMergeVideo;
}



#pragma mark -


-(BOOL) sendNotificationToBurnUsbFlash:(NSArray*)listOfItems // 2013-10-20steve
{
    if (listOfItems==nil || [listOfItems count]==0) {
        
    	NSLog (@ "Inside %@ => %@...listOfItems is NIL - notification NOT Sent...", self, NSStringFromSelector(_cmd) );
        return NO;
    }
    
    NSMutableDictionary* p = [NSMutableDictionary dictionaryWithCapacity:0];
    [p setObject:listOfItems forKey:@"sourceItem"];
    [p setObject:@"/" forKey:@"destSubFolder"];
    [p setObject:[NSString stringWithString:[[NSBundle mainBundle] bundlePath]] forKey:@"senderApp"];
    
    NSNotification* note = [NSNotification notificationWithName:sTepsFlashWriterNotificationName
                                                         object:nil
                                                       userInfo:p];
    
    NSLog ( @"%@-%@...Created FlashWriter NSNotification = %@", self, NSStringFromSelector(_cmd), note ); // 2014-07-29steve
    
    [[NSDistributedNotificationCenter defaultCenter] performSelectorOnMainThread:@selector(postNotification:)
                                                                      withObject:note
                                                                   waitUntilDone:NO];
    
    return YES;
}

-(BOOL) preProcessToBurnUsbFlash:(NSArray*) listOfItems // 2013-11-19steve
{
    if (listOfItems==nil || [listOfItems count]==0) {
        
    	NSLog (@ "Inside %@ => %@...listOfItems is NIL - notification NOT Sent...", self, NSStringFromSelector(_cmd) );
        return NO;
    }
    
    BOOL doMergeVideo = YES;
    if ( doMergeVideo) {
        // 2013-11-19steve - mergeVideos before sending to TepsFlashWriter.app
        [self mergeVideos:[listOfItems objectAtIndex:0]];
    } else {
        [self sendNotificationToBurnUsbFlash:listOfItems];
    }
    
    return YES;
}




#pragma mark 


- (void)didEndEditSheet:(NSWindow *)sheet returnCode:(NSInteger)returnCode contextInfo:(void *)contextInfo // 2013-11-20steve
{
    NSLog (@ "Inside %@ => %@...contextInfo = [%@]", self, NSStringFromSelector(_cmd),contextInfo );

    [sheet orderOut:self];
    
    
    if (returnCode==NSRunAbortedResponse) {
        // user hit "cancel"
        self.mEditMovieController = nil;
    }
    if (returnCode==-2222) {
        
        // purchase withOUT trim
        
        BOOL doPromptForNextMovieByID = [[NSUserDefaults standardUserDefaults] boolForKey:@"prefFindNextCustomerById"]; // 2013-10-20steve
        BOOL doBurnFlashAtSalesStation = [[NSUserDefaults standardUserDefaults] boolForKey:@"prefDoBurnUSBFlash"]; // 2013-10-20steve
        if ( doPromptForNextMovieByID && doBurnFlashAtSalesStation) {
            if (self.mEditMovieController.movieRef) {
                NSArray* listOfItems = [NSArray arrayWithObjects:self.mEditMovieController.movieRef, nil];
                // 2013-11-19steve [self sendNotificationToBurnUsbFlash:listOfItems];
                [self preProcessToBurnUsbFlash:listOfItems]; // 2013-11-19steve
            }
            
        } else {
            [self saveMovieToBurnStationServer]; // 2013-10-20steve
        }
        
        self.mEditMovieController = nil;

    }
    if (returnCode==-3333) {
        
        // purchase TRIMMED video
        
        //  @"prefDoAllowMovieToBeEdited";
        // 2013-11-03steve - overwrite the existing file first
        // we NEED to know if AVFoundation Method or NOT????
        NSString* editedMoviePath = [self.mEditMovieController getTrimmedMoviePath];
        BOOL exists = [[NSFileManager defaultManager] fileExistsAtPath:editedMoviePath];
        if (exists) {
            // if trimmedMovie exists, we want to write over the original
            // get the original item
            // get the tempOriginal item - in case copy fails or something
            NSString* stringToDenoteTrimmed = @"_t";
            NSLog(@"current UNEditedMovie is: %@",self.mEditMovieController.movieRef);
            NSLog(@"self.mEditMovieController.movieRef class is: %@",[self.mEditMovieController.movieRef class]);
            NSString* originalMoviePath = self.mEditMovieController.movieRef;
            NSString* destPath = [self.mEditMovieController.movieRef stringByDeletingLastPathComponent];
            NSString* originalMovieName = [originalMoviePath lastPathComponent];
            NSString* tempRename = [NSString stringWithFormat:@"%@%@.%@",[originalMovieName stringByDeletingPathExtension],stringToDenoteTrimmed,[originalMoviePath pathExtension]];
            NSString* fullPathToTempRename = [destPath stringByAppendingPathComponent:tempRename];
            // fullPathToTempRename = /path/to/originalMovie/old_originalMovieName.ext
            exists = [[NSFileManager defaultManager] fileExistsAtPath:fullPathToTempRename];
            if (exists) {
                // we should delete the old_originalMovie.mov
                NSError* error = nil;
                BOOL didDelete = [[NSFileManager defaultManager] removeItemAtPath:fullPathToTempRename error:&error];
                exists = [[NSFileManager defaultManager] fileExistsAtPath:fullPathToTempRename];
            }
            if (exists==NO) {
                // bad - something from before??
                NSError* error = nil;
                BOOL didMove = [[NSFileManager defaultManager] moveItemAtPath:editedMoviePath toPath:fullPathToTempRename error:&error];
                if (error==nil) {
                    // after success to copying to temp name
                    // then delete the original
                    BOOL didDelete = [[NSFileManager defaultManager] removeItemAtPath:originalMoviePath error:&error];
                    
                    // and if they want to really overwrite -
                    // rename the trimmed file back to original file
                    BOOL didMove = [[NSFileManager defaultManager] moveItemAtPath:fullPathToTempRename toPath:originalMoviePath error:&error];
                }
            }
            // BOOL didCopy = [mgr copyItemAtPath:nextItemPath toPath:safeWorkingItemPath error:&error];
        } else {
            // not sure what to do if trimmed output does not exist?
            // maybe something went wrong and we didnt catch it?
            
        }
        
        
        
        BOOL doPromptForNextMovieByID = [[NSUserDefaults standardUserDefaults] boolForKey:@"prefFindNextCustomerById"]; // 2013-10-20steve
        BOOL doBurnFlashAtSalesStation = [[NSUserDefaults standardUserDefaults] boolForKey:@"prefDoBurnUSBFlash"]; // 2013-10-20steve
        if ( doPromptForNextMovieByID && doBurnFlashAtSalesStation) {
            
            // 2013-11-01steve - if doOverwriteMovie, then take the possible trimmed movie and overwrite the original
            // backup of all original movies should be in the WorkingDirectory
            
            NSArray* listOfItems = [NSArray arrayWithObjects:self.mEditMovieController.movieRef, nil];
            // 2013-11-19steve [self sendNotificationToBurnUsbFlash:listOfItems];
            [self preProcessToBurnUsbFlash:listOfItems]; // 2013-11-19steve
            
        } else {
            [self saveMovieToBurnStationServer]; // 2013-10-20steve
        }

        self.mEditMovieController = nil;
        
    }
    

}


- (void)beginEditingMovie:(id)movie // 2013-10-04steve
{
    NSString * srcPath = self._myCurrentMovieToSell;
    
    BOOL doTylersWay = NO;
    
    if ( doTylersWay) {
        //open a QTMovieView with this movie open for editing
        if ([[NSApp delegate] respondsToSelector:@selector(beginEditingMovie:)] )
        {
            [[NSApp delegate] beginEditingMovie:srcPath];
        }
    } else {
        if(nil == self.mEditMovieController)
        {
            self.mEditMovieController = [[[EditAVMovieWindowController alloc] initWithWindowNibName:@"EditStationAVWindow"] autorelease];
            self.mEditMovieController.mydelegate = self;
            
            self.mEditMovieController.handleAsSheet = YES; // 2013-11-20steve
            if (self.mEditMovieController.handleAsSheet) {
                // 2013-11-20steve
                [NSApp beginSheet:self.mEditMovieController.window
                   modalForWindow:self.window
                    modalDelegate:self
                   didEndSelector:@selector(didEndEditSheet:returnCode:contextInfo:)
                      contextInfo:self.mEditMovieController];
            } else {
                NSWindow * w =[self.mEditMovieController window]; // force nib to load
                [w makeKeyAndOrderFront:self];
            }
            
        }
        self.mEditMovieController.movieRef = srcPath;
    }
    
}

-(void)didSaveEditedMovie:(id)object // 2013-10-07
{
    NSLog (@ "Inside %@ => %@...self.mEditMovieController.movieRef = [%@]", self, NSStringFromSelector(_cmd),self.mEditMovieController.movieRef );
    
    
    if([object isKindOfClass:[NSWindowController class]] && [object window])
    {
        [[object window] close];
    }
    else
    {
        [self.mEditMovieController.window close];
    }
    // send notification to flashwriter.app to burn the item
    
    if ( self.mEditMovieController.movieRef==nil )
    {
        self.mEditMovieController = nil;
        return;
    }
    
   //  @"prefDoAllowMovieToBeEdited";
    // 2013-11-03steve - overwrite the existing file first
    // we NEED to know if AVFoundation Method or NOT????
    NSString* editedMoviePath = [self.mEditMovieController getTrimmedMoviePath];
    BOOL exists = [[NSFileManager defaultManager] fileExistsAtPath:editedMoviePath];
    if (exists) {
        // if trimmedMovie exists, we want to write over the original
        // get the original item
        // get the tempOriginal item - in case copy fails or something
        NSString* stringToDenoteTrimmed = @"_t";
        NSLog(@"current UNEditedMovie is: %@",self.mEditMovieController.movieRef);
        NSLog(@"self.mEditMovieController.movieRef class is: %@",[self.mEditMovieController.movieRef class]);
        NSString* originalMoviePath = self.mEditMovieController.movieRef;
        NSString* destPath = [self.mEditMovieController.movieRef stringByDeletingLastPathComponent];
        NSString* originalMovieName = [originalMoviePath lastPathComponent];
        NSString* tempRename = [NSString stringWithFormat:@"%@%@.%@",[originalMovieName stringByDeletingPathExtension],stringToDenoteTrimmed,[originalMoviePath pathExtension]];
        NSString* fullPathToTempRename = [destPath stringByAppendingPathComponent:tempRename];
        // fullPathToTempRename = /path/to/originalMovie/old_originalMovieName.ext
        exists = [[NSFileManager defaultManager] fileExistsAtPath:fullPathToTempRename];
        if (exists) {
            // we should delete the old_originalMovie.mov
            NSError* error = nil;
            BOOL didDelete = [[NSFileManager defaultManager] removeItemAtPath:fullPathToTempRename error:&error];
            exists = [[NSFileManager defaultManager] fileExistsAtPath:fullPathToTempRename];
        }
        if (exists==NO) {
            // bad - something from before??
            NSError* error = nil;
            BOOL didMove = [[NSFileManager defaultManager] moveItemAtPath:editedMoviePath toPath:fullPathToTempRename error:&error];
            if (error==nil) {
                // after success to copying to temp name
                // then delete the original
                BOOL didDelete = [[NSFileManager defaultManager] removeItemAtPath:originalMoviePath error:&error];
                
                // and if they want to really overwrite -
                // rename the trimmed file back to original file
                BOOL didMove = [[NSFileManager defaultManager] moveItemAtPath:fullPathToTempRename toPath:originalMoviePath error:&error];
            }
        }
        // BOOL didCopy = [mgr copyItemAtPath:nextItemPath toPath:safeWorkingItemPath error:&error];
    } else {
        // not sure what to do if trimmed output does not exist?
        // maybe something went wrong and we didnt catch it?
        
    }
    
    
    
    BOOL doPromptForNextMovieByID = [[NSUserDefaults standardUserDefaults] boolForKey:@"prefFindNextCustomerById"]; // 2013-10-20steve
    BOOL doBurnFlashAtSalesStation = [[NSUserDefaults standardUserDefaults] boolForKey:@"prefDoBurnUSBFlash"]; // 2013-10-20steve
    if ( doPromptForNextMovieByID && doBurnFlashAtSalesStation) {
        
        // 2013-11-01steve - if doOverwriteMovie, then take the possible trimmed movie and overwrite the original
        // backup of all original movies should be in the WorkingDirectory
        
        NSArray* listOfItems = [NSArray arrayWithObjects:self.mEditMovieController.movieRef, nil];
        // 2013-11-19steve [self sendNotificationToBurnUsbFlash:listOfItems];
        [self preProcessToBurnUsbFlash:listOfItems]; // 2013-11-19steve
        
    } else {
        [self saveMovieToBurnStationServer]; // 2013-10-20steve
    }


    /*
    
    NSArray* listOfItems = [NSArray arrayWithObjects:self.mEditMovieController.movieRef, nil];
    NSMutableDictionary* p = [NSMutableDictionary dictionaryWithCapacity:0];
    [p setObject:listOfItems forKey:@"sourceItem"];
    [p setObject:@"/" forKey:@"destSubFolder"];
    [p setObject:[NSString stringWithString:[[NSBundle mainBundle] bundlePath]] forKey:@"senderApp"];
    
    NSNotification* note = [NSNotification notificationWithName:sTepsFlashWriterNotificationName
                                                         object:nil
                                                       userInfo:p];
    
    NSLog ( @"Created FlashWriter NSNotification = %@", note );
    
    [[NSDistributedNotificationCenter defaultCenter] performSelectorOnMainThread:@selector(postNotification:)
                                                                      withObject:note
                                                                   waitUntilDone:NO];
    
    */

    
    self.mEditMovieController = nil;

}

-(void)didSaveWithoutEditing:(id)object
{
    NSLog (@ "Inside %@ => %@...[%@]", self, NSStringFromSelector(_cmd),self.mEditMovieController.movieRef );
    if([object isKindOfClass:[NSWindowController class]] && [object window])
    {
        [[object window] close];
    }
    else
    {
        [self.mEditMovieController.window close];
    }

    BOOL doPromptForNextMovieByID = [[NSUserDefaults standardUserDefaults] boolForKey:@"prefFindNextCustomerById"]; // 2013-10-20steve
    BOOL doBurnFlashAtSalesStation = [[NSUserDefaults standardUserDefaults] boolForKey:@"prefDoBurnUSBFlash"]; // 2013-10-20steve
    if ( doPromptForNextMovieByID && doBurnFlashAtSalesStation) {
        if (self.mEditMovieController.movieRef) {
            NSArray* listOfItems = [NSArray arrayWithObjects:self.mEditMovieController.movieRef, nil];
            // 2013-11-19steve [self sendNotificationToBurnUsbFlash:listOfItems];
            [self preProcessToBurnUsbFlash:listOfItems]; // 2013-11-19steve
        }
        
    } else {
        [self saveMovieToBurnStationServer]; // 2013-10-20steve
    }

    self.mEditMovieController = nil;

    
}

-(void)didCancelEditedMovie:(id)object
{
    NSLog (@ "Inside %@ => %@...[%@]", self, NSStringFromSelector(_cmd),self.mEditMovieController.movieRef );
    
    if([object isKindOfClass:[NSWindowController class]] && [object window])
    {
        [[object window] close];
    }
    else
    {
        [self.mEditMovieController.window close];
    }
    self.mEditMovieController = nil;

}




#pragma mark  - Sales Tab Buttons

- (void)tabView:(NSTabView *)tabView didSelectTabViewItem:(NSTabViewItem *)tabViewItem // 2014-09-04steve
{
    
    NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
    if([[tabViewItem identifier] caseInsensitiveCompare:@"2"]==NSOrderedSame ) {
        [self.window makeFirstResponder:nil]; // 2014-09-04steve
        
    }
    
}


-(IBAction) ibClickedOnResetDateToDefault:(id)sender // 2014-09-04steve
{
    setToFactoryDateFormatString (); // 2014-09-04
}


-(IBAction) doRevealOriginalVideosFolder:(id)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	NSString* pathToReveal = getDailyFolderPathForMasterOriginalVideos(); // 2010-11-11steve [[NSUserDefaults standardUserDefaults] objectForKey:sPrefOriginalVideosFolder];
	revealItemInFinder (pathToReveal);
}


- (IBAction)doShowMovieFullScreen:(id)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
    if ( self._myCurrentMovieToSell) {
        BOOL exists = [[NSFileManager defaultManager]fileExistsAtPath:self._myCurrentMovieToSell];
        if ( exists==NO) {
            NSBeep();
            NSLog ( @"2010-11-07steve NO Movie file selected???" );
            
            NSAlert * alert = [NSAlert alertWithMessageText:@"Selected Movie Item Moved or Deleted." // 2013-11-22steve
                                              defaultButton:@"OK"
                                            alternateButton:nil
                                                otherButton:nil
                                  informativeTextWithFormat:@"\nUnable to find movie at path:\n[%@]",self._myCurrentMovieToSell?self._myCurrentMovieToSell:@"No Movie Selected"];
            
            [alert beginSheetModalForWindow:self.window // 2013-11-22steve
                              modalDelegate:self
                             didEndSelector:nil
                                contextInfo:NULL];
            
            return;
        }
    }
    
	if ( self._myCurrentMovieToSell==nil )
	{
		NSBeep();
		NSLog ( @"2010-11-07steve NO Movie file selected???" );
        
        NSAlert * alert = [NSAlert alertWithMessageText:@"No Selected Movie To Play." // 2013-11-22steve
                                          defaultButton:@"OK"
                                        alternateButton:nil
                                            otherButton:nil
                              informativeTextWithFormat:@"Please Select A Movie to Play.\nOr\nSelected Movie Item May Been Moved/Deleted.\n\n[%@]",self._myCurrentMovieToSell?self._myCurrentMovieToSell:@"No Movie Selected"];
        
        [alert beginSheetModalForWindow:self.window // 2013-11-22steve
                          modalDelegate:self
                         didEndSelector:nil
                            contextInfo:NULL];

		return;
	}
	
	NSString* scriptName = @"playMovieInQTPlayer.scpt";
	
	NSArray* scriptParamArray = [NSArray arrayWithObjects:[NSString stringWithString:@"true"], self._myCurrentMovieToSell, nil ];
	// NSDictionary* parameters = [NSDictionary dictionaryWithObjectsAndKeys:scriptName,@"scriptName", self, @"delegate",self._myCurrentMovieToSell, @"scriptParams",nil];
	NSDictionary* parameters = [NSDictionary dictionaryWithObjectsAndKeys:scriptName,@"scriptName", self, @"delegate",scriptParamArray, @"scriptParams",nil];
	
	BOOL status = launchScriptWithParameters ( parameters );
	

//	// 2010-11-10steve
//	// we only want to be notified if the quicktime player has launched 
//	[[[NSWorkspace sharedWorkspace] notificationCenter] addObserver:self
//														   selector:@selector(childProcessDidTerminate:) 
//															   name:NSWorkspaceDidTerminateApplicationNotification
//															 object:nil];
	
}


-(IBAction) doRenameMovie:(id)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	NSLog (@ "Inside %@ => %@...self._myCurrentMovieToSell = [%@]...", self, NSStringFromSelector(_cmd),self._myCurrentMovieToSell ); // 2011-11-15steve fix crash

	if ( self._myCurrentMovieToSell==nil || [self._myCurrentMovieToSell length]==0 )
	{
		NSBeep();
		NSLog (@ "Inside %@ => %@...Nothing to rename yet...", self, NSStringFromSelector(_cmd) );
		return;
	}
	
	
	// 2010-11-01steve
	[[NSUserDefaults standardUserDefaults] setObject:[NSString stringWithString:@""] forKey:prefRenameString ];
	
	[NSApp beginSheet:mSaveAsPanel
	   modalForWindow:[self window]
		modalDelegate:self 
	   didEndSelector:@selector(didEndSheet:returnCode:contextInfo:) 
		  contextInfo:nil];
	
}


-(void) saveMovieToBurnStationServer // 2013-10-20steve
{
    // need to copy self._myCurrentMovieToSell to the "to be burned" folder
	{
		NSString* myProcessPath = getDailyFolderPathForToBeBurnedFolder();	// 2010-11-11steve [[NSUserDefaults standardUserDefaults] objectForKey:sPrefToBeBurnedFolder];
		NSString* tempItemPath = [myProcessPath stringByAppendingPathComponent:[self._myCurrentMovieToSell lastPathComponent]];
		NSString* safeProcessItemPath = createSafeFilePathFromBase(tempItemPath);	// 2010-11-12steve [self createSafeFilePathFromBase:tempItemPath];
		NSError* error = nil;
		BOOL didMove = [[NSFileManager defaultManager] copyItemAtPath:self._myCurrentMovieToSell toPath:safeProcessItemPath error:&error];
		if (error) NSLog (@"2010-11-03steve rerror with copyItemAtPath: %@",error );
	}
	
	
	// move item to the purchased path = sPrefPurchasedSubFolderName
	{
		NSString* myProcessPath = getDailyFolderPathForMasterOriginalVideos();	// 2010-11-11 [[NSUserDefaults standardUserDefaults] objectForKey:sPrefOriginalVideosFolder];
		myProcessPath = [myProcessPath stringByAppendingPathComponent:sPrefPurchasedSubFolderName];
		createDirectoryIfMissing (myProcessPath);
        
		
		NSString* tempItemPath = [myProcessPath stringByAppendingPathComponent:[self._myCurrentMovieToSell lastPathComponent]];
		NSString* safeProcessItemPath = createSafeFilePathFromBase(tempItemPath);	// 2010-11-12steve [self createSafeFilePathFromBase:tempItemPath];
		NSError* error = nil;
		BOOL didMove = [[NSFileManager defaultManager] moveItemAtPath:self._myCurrentMovieToSell toPath:safeProcessItemPath error:&error];
		if (error) NSLog (@"2010-11-03steve rerror with moveItemAtPath: %@",error );
	}
	
	
	// 2010-11-11steve
	[NSApp beginSheet:mMovieSavedPanel
	   modalForWindow:[self window]
		modalDelegate:self
	   didEndSelector:@selector(didEndSheet2:returnCode:contextInfo:)
		  contextInfo:nil];
	
	

}

-(IBAction) doNotPurchaseMovie:(id)sender // 2014-11-04steve
{
    NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
    [self hideAVMovieController];
    
    if ( self.mAVMovieViewController) {
        [self.mAVMovieViewController.player pause];
    }

    self._myCurrentMovieToSell = nil; // 2014-11-04steve
    NSLog (@"self._myCurrentMovieToSell after nil = %@", self._myCurrentMovieToSell );

    // tyler 2014-11-04 added three lines to better "clear" the station for next movie
    [[NSUserDefaults standardUserDefaults] setObject:@"" forKey:sPrefSalesQTMovie ];
    self.mAVMovieViewController.player = nil;
    self.mAVMovieViewController.playerLayer = nil;


// 2014-11-04steve
// somehow this causes an exception on the next time i scan for a new movie????
// need something to prevent the play button from working - even though view is hidden
// movie can still be heard
//
//    if (self.mAVMovieViewController) {
//        [self.mAVMovieViewController close];
//    }
    
}



-(IBAction) doPurchaseMovie:(id)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	NSLog (@ "Inside %@ => %@...self._myCurrentMovieToSell = %@", self, NSStringFromSelector(_cmd), self._myCurrentMovieToSell );

	
	BOOL itemExists = [[NSFileManager defaultManager] fileExistsAtPath:self._myCurrentMovieToSell];
	if ( !itemExists )
	{
		NSBeep();
		NSLog ( @"2010-11-10steve movie has been moved - so may already be processed" );
        
        NSAlert * alert = [NSAlert alertWithMessageText:@"No Selected Movie To Purchase." // 2013-11-22steve
                                          defaultButton:@"OK"
                                        alternateButton:nil
                                            otherButton:nil
                              informativeTextWithFormat:@"Please Select A Movie to Purchase.\nOr\nSelected Movie Item May Been Moved/Deleted.\n\n[%@]",self._myCurrentMovieToSell?self._myCurrentMovieToSell:@"No Movie Selected"];

        if ( [self respondsToSelector:@selector(setupAlertWithAutoTimeOut:)]) { // 2014-11-04teve
            [self setupAlertWithAutoTimeOut:[NSDictionary dictionaryWithObjectsAndKeys:alert,@"alert", nil]];
        }
        
        
        [alert beginSheetModalForWindow:self.window // 2013-11-22steve
                          modalDelegate:self
                         didEndSelector:nil
                            contextInfo:NULL];
        
		return;
	}
	
	
	if ( self._myCurrentMovieToSell==nil || [self._myCurrentMovieToSell length]==0 )
	{
		NSBeep();
		NSLog (@ "Inside %@ => %@...Nothing to purchase yet...", self, NSStringFromSelector(_cmd) );
		return;
	}

    // 2014-11-04steve - we need to make sure the movie is paused or stopped
    if ( self.mAVMovieViewController) {
        [self.mAVMovieViewController.player pause];
    }
    
    
    
    
    BOOL doPromptForNextMovieByID = [[NSUserDefaults standardUserDefaults] boolForKey:@"prefFindNextCustomerById"]; // 2013-10-04steve

    
    // 2013-10-04steve - need pref to burn at this station or push to a burn station
    // BOOL doAllowEditMovie = [[NSUserDefaults standardUserDefaults] boolForKey:@"prefFindNextCustomerById"]; // 2013-10-20steve
    //if (doAllowEditMovie )
    {
        
        // BOOL doEditMovie = YES; // 2013-10-18steve
        BOOL doEditMovie = [[NSUserDefaults standardUserDefaults] boolForKey:@"prefDoAllowMovieToBeEdited"]; // 2013-10-20steve
        if (doPromptForNextMovieByID && doEditMovie) {
            [self beginEditingMovie:nil];
            
            // somehow - need a didEndEditing delegate to then invoke the TepsFlashWriter.app
            // NSLog(@"2013-10-04 - need to call Teps-FlashWriter.app");
            
            return;
        }
        
    }
    
    // 2013-10-20steve
    BOOL doBurnFlashAtSalesStation = [[NSUserDefaults standardUserDefaults] boolForKey:@"prefDoBurnUSBFlash"]; // 2013-10-20steve
    if ( doPromptForNextMovieByID && doBurnFlashAtSalesStation) {
        
        if (self._myCurrentMovieToSell ) {
            NSArray* listOfItems = [NSArray arrayWithObjects:self._myCurrentMovieToSell, nil];
            // 2013-11-19steve [self sendNotificationToBurnUsbFlash:listOfItems];
            [self preProcessToBurnUsbFlash:listOfItems]; // 2013-11-19steve
        }
        
    } else {
        [self saveMovieToBurnStationServer]; // 2013-10-20steve        
    }
    

    [self doNotPurchaseMovie:nil];  // 2014-11-04steve - should go thru same code to clean up
    
}


-(IBAction) doFindNextCustomer:(id)sender;
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	
	// move item to the skipped video folder = sPrefSkippedSubFolderName
    
    // 2013-08-09steve - if empty string - not allowed
    self._myCurrentMovieToSell = [self._myCurrentMovieToSell stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
    
    BOOL doPromptForNextMovieByID = [[NSUserDefaults standardUserDefaults] boolForKey:@"prefFindNextCustomerById"]; // 2013-10-04steve
    if ( doPromptForNextMovieByID ) {
        [self doSearchId:sender];
        return;
    }
    
    
    /* 2013-10-04steve
	if ( self._myCurrentMovieToSell  )
	{
		NSString* myProcessPath = getDailyFolderPathForMasterOriginalVideos();	// 2010-11-11 [[NSUserDefaults standardUserDefaults] objectForKey:sPrefOriginalVideosFolder];
		myProcessPath = [myProcessPath stringByAppendingPathComponent:sPrefSkippedSubFolderName];
		createDirectoryIfMissing (myProcessPath);
		
		
		NSString* tempItemPath = [myProcessPath stringByAppendingPathComponent:[self._myCurrentMovieToSell lastPathComponent]];
		NSString* safeProcessItemPath = createSafeFilePathFromBase(tempItemPath);	// 2010-11-12steve [self createSafeFilePathFromBase:tempItemPath];
		NSError* error = nil;
        
        if (self._myCurrentMovieToSell && [self._myCurrentMovieToSell length] ) { // 2013-08-09steve - check nil
            NSLog(@"self._myCurrentMovieToSell = [%@]", self._myCurrentMovieToSell);
            NSLog(@"safeProcessItemPath = %@", safeProcessItemPath);
            BOOL didMove = [[NSFileManager defaultManager] moveItemAtPath:self._myCurrentMovieToSell toPath:safeProcessItemPath error:&error];
            if (error) NSLog (@"2010-11-09steve error with moveItemAtPath: %@",error );
        }
        

	
	
		// remove it from the UI
		self._myCurrentMovieToSell = [NSString stringWithString:@""];
		[[NSUserDefaults standardUserDefaults] setObject:self._myCurrentMovieToSell forKey:sPrefSalesQTMovie];
		[self setQTMovie:nil];
	
	
	}
	*/
    
    [self moveCurrentMovie]; // 2013-10-04steve
    
	
	// get the next new video
	[self getNextMovieToSell];
	
}


-(void) moveCurrentMovie // 2013-10-04steve
{
    NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

    
    if ( self._myCurrentMovieToSell  )
	{
		NSString* myProcessPath = getDailyFolderPathForMasterOriginalVideos();	// 2010-11-11 [[NSUserDefaults standardUserDefaults] objectForKey:sPrefOriginalVideosFolder];
		myProcessPath = [myProcessPath stringByAppendingPathComponent:sPrefSkippedSubFolderName];
		createDirectoryIfMissing (myProcessPath);
		
		
		NSString* tempItemPath = [myProcessPath stringByAppendingPathComponent:[self._myCurrentMovieToSell lastPathComponent]];
		NSString* safeProcessItemPath = createSafeFilePathFromBase(tempItemPath);	// 2010-11-12steve [self createSafeFilePathFromBase:tempItemPath];
		NSError* error = nil;
        
        if (self._myCurrentMovieToSell && [self._myCurrentMovieToSell length] ) { // 2013-08-09steve - check nil
            NSLog(@"self._myCurrentMovieToSell = [%@]", self._myCurrentMovieToSell);
            NSLog(@"safeProcessItemPath = %@", safeProcessItemPath);
            BOOL didMove = [[NSFileManager defaultManager] moveItemAtPath:self._myCurrentMovieToSell toPath:safeProcessItemPath error:&error];
            if (error) NSLog (@"2010-11-09steve error with moveItemAtPath: %@",error );
        }
        
        
		// remove it from the UI
		self._myCurrentMovieToSell = @"";
		[[NSUserDefaults standardUserDefaults] setObject:self._myCurrentMovieToSell forKey:sPrefSalesQTMovie];
		[self setQTMovie:nil];

	}

}



#pragma mark  - Pref Tab Buttons


-(IBAction) ibClickedOnRevealOriginalVideosFolder:(id)sender // 2014-08-06steve
{
    
}

-(IBAction) ibClickedOnChangeOriginalVideosFolder:(id)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	NSDictionary* parameters = [NSDictionary dictionaryWithObjectsAndKeys:self,sPanelDelegateKey, 
								@"Please Select the MASTER ORIGINAL Videos Folder", sPanelMessageKey, 
								@"Select", sPanelPromptKey,
								sender, sPanelSenderKey,
								sPrefOriginalVideosFolder, sPrefFolderNameKey,
								sPrefOriginalVideosFolderAliasData, sPrefFolderAliasDataKey,
								sPrefOriginalVideosFolderIsValid, sPrefFolderNameIsValidKey,
								nil];
	
	[self doNSOpenPanelWithParameters:parameters];
	
}


-(IBAction) ibClickedOnChangeToBeBurnFolder:(id)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	NSDictionary* parameters = [NSDictionary dictionaryWithObjectsAndKeys:self,sPanelDelegateKey, 
								@"Please Select the New Movies To Be Processed Folder", sPanelMessageKey, 
								@"Select", sPanelPromptKey,
								sender, sPanelSenderKey,
								sPrefToBeBurnedFolder, sPrefFolderNameKey,
								sPrefToBeBurnedFolderAliasData, sPrefFolderAliasDataKey,
								sPrefToBeBurnedFolderIsValid, sPrefFolderNameIsValidKey,
								nil];
	
	[self doNSOpenPanelWithParameters:parameters];
	
}


#pragma mark -

// 2010-11-10steve
-(void)childProcessDidTerminate:(NSNotification *)notification
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	NSLog (@ "Inside %@ => %@...notification = %@", self, NSStringFromSelector(_cmd), notification );
	
	// this way we know that they are done with the full screen quicktime player
	
	
	
	[[[NSWorkspace sharedWorkspace] notificationCenter] removeObserver:self];

	
}





@end
