//
//  TPLogFileManager.m
//  TepsPrintCenter
//
//  Created by steve on 10/15/10.
//  Copyright 2010 TriPrism, Inc. All rights reserved.
//

#import "TPLogFileManager.h"
// #import "Preferences.h" // 2010-10-16steve

NSString* _gDefaultLogBaseName = @"TepsLogFile";


NSString* _gLogPath = @"/Library/Logs/Teps";
NSString* _gLogExtension = @"log";
FILE* _gLogFileHandle = nil;
NSDateFormatter *   _gLogDateFormatter = nil;

NSString* _gCopyrightVersion = nil;
NSString* _gApplicationName = nil;

extern void moveFileToUserTrash (NSString *filePath);
extern NSString* computeCurrentDaysFolderString2 ( short hoursToShift, short minsToShift ); // 2014-09-23steve



/*
 CFBundleDevelopmentRegion = English;
 CFBundleDisplayName = "TEPS-PRINT CENTER Share";
 CFBundleExecutable = "TEPS-PRINT CENTER Share";
 CFBundleExecutablePath = "/[PROJECTS]/Teps-PrintCenter XCODE 2010/TepsPrintCenter35 2010-10-15 v4.8.9next/build/Universal - Release xcode/TEPS-PRINT CENTER Share.app/Contents/MacOS/TEPS-PRINT CENTER Share";
 CFBundleGetInfoString = "v4.8.8beta (ForTepsXShare)";
 CFBundleHelpBookFolder = TextEditHelp;
 CFBundleHelpBookName = TextEditHelp;
 CFBundleIconFile = printer;
 CFBundleIdentifier = "com.triprism.TepsPrintCenterShare";
 CFBundleInfoDictionaryVersion = "6.0";
 CFBundleInfoPlistURL = Contents/Info.plist -- file://localhost/%5BPROJECTS%5D/Teps-PrintCenter%20XCODE%202010/TepsPrintCenter35%202010-10-15%20v4.8.9next/build/Universal%20-%20Release%20xcode/TEPS-PRINT%20CENTER%20Share.app/;
 CFBundlePackageType = APPL;
 CFBundleShortVersionString = "4.8.8beta (ForTepsXShare)";
 CFBundleSignature = "????";
 NSBundleInitialPath = "/[PROJECTS]/Teps-PrintCenter XCODE 2010/TepsPrintCenter35 2010-10-15 v4.8.9next/build/Universal - Release xcode/TEPS-PRINT CENTER Share.app";
 NSBundleResolvedPath = "/[PROJECTS]/Teps-PrintCenter XCODE 2010/TepsPrintCenter35 2010-10-15 v4.8.9next/build/Universal - Release xcode/TEPS-PRINT CENTER Share.app";
 NSHumanReadableCopyright = "\U00a92010  TriPrism, Inc.";
 NSMainNibFile = MainMenu;
 NSPrincipalClass = NSApplication;
 
*/


/* 2014-08-27steve
// pass positive hoursToShift to shift back
NSString* computeCurrentDaysFolderString2 ( short hoursToShift, short minsToShift )
{
	long oneHourInSecs = 60*60;
	long oneMinInSecs = 60;
	long amHour = hoursToShift;		// 13;
	long amMinutes = minsToShift;	// 57;
	long amTimeInSeconds =  (amHour*oneHourInSecs) +  (amMinutes*oneMinInSecs);
	
	NSDate* hoursAgoDate = [NSDate dateWithTimeIntervalSinceNow:(-1*amTimeInSeconds)];
	//NSLog ( @"Shift Time By (HH::MM) = %02i:%02i => [%@]", amHour, amMinutes, hoursAgoDate );
	NSString *newString = nil;
	{
		NSDateFormatter *outputFormatter = [[NSDateFormatter alloc] init];
		[outputFormatter setFormatterBehavior:NSDateFormatterBehavior10_4];
		
		[outputFormatter setDateFormat:@"yyyy-MM-dd"]; // 2010-11-11steve changed to dash as separators
		
		// [outputFormatter setDateStyle:NSDateFormatterFullStyle]; // Use Constants from System Prefs
		// NSLog ( @"2010-10-14steve The Newly Shifted Date String is: %@", [outputFormatter stringFromDate:hoursAgoDate] );
		
		newString = [NSString stringWithString:[outputFormatter stringFromDate:hoursAgoDate]];
		
		// NSLog ( @"2010-10-14steve newString is %@", newString );
		// NSLog ( @"2010-10-14steve newString is %i", [newString length] );
		
		// success = [newString getCString:buffer maxLength:[newString length]+1 encoding:NSMacOSRomanStringEncoding];
		// NSLog ( @"2010-10-14steve didGet is %@", didGet?@"True":@"False" );		
		// NSLog ( @"2010-10-14steve as buffer => %s", buffer );
		
		[outputFormatter release];
	}
	
	return newString;
	// return success;
}
*/


// 2009-08-12steve
NSString* runShellScript2 ( NSString*scriptName, NSArray*paramArray )
{	
	bool doEcho = false;
	
	if ( scriptName==nil )
	{
		NSLog (@"\n\nrunShellScript2 FAILED => scriptName==nil!\n\n" );
		return nil;
	}
	if (doEcho) NSLog ( @"runShellScript2 => scriptName = [%@]", scriptName );
	if ( paramArray )
	{
		if (doEcho) NSLog ( @"runShellScript2 => param:\n%@", paramArray );
	}
	else
		NSLog ( @"runShellScript2 => NO param" );
	
	// NSLog ( @"\n\n\n" );
	
	
	NSString *latexPath = scriptName;	// [bundle pathForAuxiliaryExecutable:scriptName];
	if ( latexPath==nil )
	{
		NSLog (@"\n\nrunShellScript FAILED => UNABLE to find script named: [%@]!\n\n", scriptName );
		return nil;
	}
	
    NSTask *task;
    task = [[NSTask alloc] init];
    [task setLaunchPath: latexPath];
	
    NSArray *arguments = nil;
	
	if ( paramArray )
		arguments = [NSArray arrayWithArray: paramArray];
	
    [task setArguments: arguments];
	
    NSPipe *pipe;
    pipe = [NSPipe pipe];
    [task setStandardOutput: pipe];
	
    NSFileHandle *file;
    file = [pipe fileHandleForReading];
	
    [task launch];
	
	[task waitUntilExit];	// 05-15-08steve
	
	if (![task isRunning])
	{
		int status = [task terminationStatus];
		if (status == 0)
		{
			// NSLog(@"runShellScript2 Task succeeded.");			
		}
		else
			NSLog(@"runShellScript2 Task failed.");
	}
	
    NSData *data;
    data = [file readDataToEndOfFile];
	
    NSString *string = nil;
    string = [[NSString alloc] initWithData: data encoding: NSUTF8StringEncoding];
    if (doEcho) NSLog (@"runShellScript2 got back:\n%@\n", string);
	
	if ( task ) [task release];	// free memory
	// if ( string ) [string release]; // 05-15-08steve
	
	return [string autorelease];
	
}

// 2009-08-14steve - need to a general function to just get the creation date of the item
// BEFORE minNSDate
BOOL itemIsEarlierThan ( NSString *tempImagePath,NSDate* minNSDate, NSString* whichDate )
{
	BOOL doVerbose = NO;

	if (doVerbose) NSLog ( @"Inside itemIsEarlierThan..." ); // 2009-08-13steve
	BOOL isEarlier = NO;
	
	
	NSFileManager	*fileMgr = [NSFileManager defaultManager];
	NSDictionary	*fileAttributes = [fileMgr fileAttributesAtPath:tempImagePath traverseLink:YES];
	NSDate* zeroDate = [NSDate dateWithString : @"1904-01-01 00:00:00 +0000" ];
	NSDate* zeroDate2 = [NSDate dateWithString : @"1970-01-01 00:00:00 +0000" ];	// 07-02-07
	NSDate *fileCreationDate = nil;
	NSDate *fileModDate = nil;
	NSDate *comparisonDate = nil;
	
	
	NSString* useWhichDate = NSFileModificationDate;
	if ( whichDate )
		useWhichDate = whichDate;
	
	bool useFileCreationDate = ([useWhichDate caseInsensitiveCompare:NSFileCreationDate]==NSOrderedSame); // 2014-11-05steve
	
	if ( fileAttributes )
	{
		if (doVerbose) NSLog ( @"Inside itemIsEarlierThan => fileAttributes:\n%@", fileAttributes );
		
		fileCreationDate = [fileAttributes objectForKey:NSFileCreationDate];	// 05-06-07 CREATION DATE
		fileModDate	= [fileAttributes objectForKey:NSFileModificationDate];		// 05-06-07 MODIFICATION DATE
		
		
		
		
		if ( useFileCreationDate )
		{
			// we really want the creation date to be VALID
			if ( [fileCreationDate isEqualToDate: zeroDate] )
			{
				NSLog ( @"Inside itemIsEarlierThan => fileCreationDate isEqualToDate zeroDate: [%@]", zeroDate );
				
				// reassign it to mod date - have a better chance
				fileCreationDate = fileModDate;
			}
			
			// 07-02-07 check for 1970
			// we really want the creation date to be VALID
			//
			// 07-03-07 we want this to be an "else-if" check
			// was  an "if" check
			// fileCreationDate could have been changed to zeroDate2 by coincidence!!!!
			//
			else if ( [fileCreationDate isEqualToDate: zeroDate2] )
			{
				NSLog ( @"Inside itemIsEarlierThan => fileCreationDate isEqualToDate zeroDate2: [%@]", zeroDate2 );
				
				// reassign it to mod date - have a better chance
				fileCreationDate = fileModDate;
				
			}
			
			comparisonDate = fileCreationDate;
		}
		else
		{
			comparisonDate = fileModDate;
		}
		
		
		// 2009-08-14steve - check to see if it's before the mindate
		if (doVerbose) NSLog ( @"NEED To Compare comparisonDate: %@ [%@]", comparisonDate, useWhichDate );
		if (doVerbose) NSLog  (@"     NEED to Compare minNSDate: %@", minNSDate );
		if (NSOrderedAscending==[comparisonDate compare:minNSDate] )
		{
			isEarlier = YES;
			if (doVerbose) NSLog ( @"Inside itemIsEarlierThan => fileCreationDate is BEFORE minNSDate" );
		}
		else
		{
			isEarlier = NO;
			if (doVerbose) NSLog ( @"Inside itemIsEarlierThan => fileCreationDate is AFTER minNSDate" );
		}
		
	}
	else
	{
		NSLog ( @"itemIsEarlierThan -> file may NOT exist anymore?????" );
	}
	
	
	return isEarlier;
	
}


#pragma mark -

@implementation TPLogFileManager

+(TPLogFileManager*) defaultManager
{
	id mgr = [[TPLogFileManager alloc] init] ;

	if ( _gLogDateFormatter==nil )
	{
		
	}
	
	return [mgr autorelease];
}

+ (void) deleteItem:(NSString*)itemPath beforeDate:(NSDate*)beforeDate forBasename:(NSString*)basename deleteImmediately:(BOOL) deleteImmediately
{
	// NSLog ( @"Inside %@->[%@] ", [self class], NSStringFromSelector(_cmd) ); // 2009-08-14steve

	bool doVerbose = false;

	NSString* fullPath = [itemPath stringByExpandingTildeInPath];
	if (doVerbose) NSLog ( @"Inside %@->[%@]  fullPath = [%@]", [self class], NSStringFromSelector(_cmd), fullPath ); // 2009-10-16steve
	
	
	
	NSStringEncoding curEncoding = NSUTF8StringEncoding;	// able to show our ƒ characters

	BOOL isDirectory = false;
	NSFileManager* manager = [NSFileManager defaultManager];
	BOOL itemExists = [manager fileExistsAtPath:fullPath isDirectory:&isDirectory];
	if ( !itemExists )
	{
		NSString* tempString = [NSString stringWithFormat: @"testDirectory=> curItem does NOT exist: %@\n", fullPath];
		//fprintf (stderr, [tempString cStringUsingEncoding:NSASCIIStringEncoding] );	
		NSLog(@"%@",[tempString cStringUsingEncoding:curEncoding]);	
	}
	else
	{
		if ( !isDirectory )
		{
			if (doVerbose) NSLog(@"2010-10-16steve fullPath is: %@", fullPath);
			
			NSString* curItem = [fullPath lastPathComponent];
			
			NSRange foundRange = [curItem rangeOfString:basename options:NSCaseInsensitiveSearch|NSAnchoredSearch];
			if (doVerbose) NSLog ( @"2010-10-16steve foundRange.location = %i", foundRange.location );
			// if ( foundRange.location != NSNotFound ) // basename anywhere within string
			if ( foundRange.location == 0 ) // must BEGIN with basename
			{
				if (doVerbose) NSLog ( @"itemName is %@ File:      %s\n", @"Deletable",[curItem cStringUsingEncoding:curEncoding] );
                // 2014-11-05steve if ( itemIsEarlierThan(fullPath, beforeDate, NSFileModificationDate) ) // 2014-11-05steve - we want to check creation date not mod date
                if ( itemIsEarlierThan(fullPath, beforeDate, NSFileCreationDate) ) // 2014-11-05steve - we want to check creation date not mod date
				{
					
					bool doDelete = deleteImmediately;
					if ( doDelete )
					{
						NSLog ( @"Item DELETED: [%@]", curItem );
						[manager removeFileAtPath:fullPath handler:nil];
					}
					else
					{
						NSLog ( @"Item Moved To Trash: [%@]", curItem );
						moveFileToUserTrash ( fullPath );
					}
				}
				else
				{
					if(doVerbose) NSLog ( @"Item [%@] SHOULD NOT NOT NOT be Deleted - Still Within Range", curItem );
				}
				
				
			}
			else
			{
				if(doVerbose) NSLog ( @"itemName is NOT Deletable File: %s\n",[curItem cStringUsingEncoding:curEncoding] );
				
			}
			
		}
	}
	
	
}


//[NSNumber numberWithBool:YES],@"deleteSubDirectory",
//[NSNumber numberWithBool:NO],@"deleteImmediately",

//+ (void) deleteOldLogs:(NSString*)srcPath beforeDate:(NSDate*)beforeDate forBasename:(NSString*)basename options:(NSDictionary*)options
//{
//	NSLog ( @"Inside %@->[%@] ", [self class], NSStringFromSelector(_cmd) ); // 2009-08-14steve
//	NSLog ( @"Inside %@->[%@] ==> Passed SourcePath: [%@]", [self class], NSStringFromSelector(_cmd), srcPath ); // 2009-08-14steve
//
//	
//	if ( basename==nil )
//	{
//		NSLog ( @"2010-10-16steve param forBasename is NIL" );
//		return;
//	}
//
//	
//	bool doDeleteSubDirectory = [[options objectForKey:@"deleteSubDirectory"] boolValue];
//	bool deleteImmediately = [[options objectForKey:@"deleteImmediately"] boolValue];
//	
//	NSString* homePath = [srcPath stringByExpandingTildeInPath];
//
//	if ( doDeleteSubDirectory )
//	{
//		NSAutoreleasePool* pool2 = [[NSAutoreleasePool alloc] init];
//		// it is a directory - now iterate thru and test
//		NSDirectoryEnumerator* newDirEnum = [[NSFileManager defaultManager] enumeratorAtPath:homePath];
//		NSString* curItem	= nil;
//		if ( newDirEnum )
//		{
//			bool done = false;
//			while ( !done )
//			{
//				curItem = [newDirEnum nextObject];
//				if ( curItem==nil )
//				{
//					done = true;
//				}
//				else
//				{
//					NSString* fullPath = [srcPath stringByAppendingPathComponent:curItem];
//					[TPLogFileManager deleteItem:fullPath 
//									  beforeDate:beforeDate 
//									 forBasename:basename
//							   deleteImmediately:deleteImmediately  ];
//				}
//				
//				
//			}
//			
//			// [newDirEnum release];
//		} // if newDirEnum
//		[pool2 release];
//	}
//	else
//	{
//		NSFileManager* manager = [NSFileManager defaultManager];
//		NSArray* array = [manager directoryContentsAtPath:[homePath stringByExpandingTildeInPath]];
//		NSLog ( @"2010-10-16steve directoryArray is: %@", array );
//		if ( array && [array count] )
//		{
//			NSString* fullPath = nil;
//			for ( long i=0; i<[array count]; i++ )
//			{
//				NSLog ( @"2010-10-16steve [array objectAtIndex:%i] = %@", i, [array objectAtIndex:i] );
//				fullPath = [[homePath stringByAppendingPathComponent:[array objectAtIndex:i]] stringByExpandingTildeInPath];
//				[TPLogFileManager deleteItem:fullPath 
//								  beforeDate:beforeDate
//								 forBasename:basename
//						   deleteImmediately:deleteImmediately  ];
//			}
//		}
//		
//	}
//		
//	
//}


//NSMutableDictionary* 
//options = [NSMutableDictionary dictionaryWithObjectsAndKeys:
//		   [NSNumber numberWithBool:NO],@"deleteSubDirectory",
//		   [NSNumber numberWithBool:YES],@"deleteImmediately",
//		   @"~/Documents",@"sourcePath",
//		   @"myConsole",@"baseName",
//		   lastDateToDeleteFrom, @"beforeDate",
//		   nil];

+ (void) deleteOldLogsWithOptions:(NSDictionary*)options
{
    
    if ( _gApplicationName==nil) return; // 2013-06-17steve
    
	bool doVerbose = false;
	
	if (doVerbose) NSLog ( @"Inside %@->[%@] ", [self class], NSStringFromSelector(_cmd) ); // 2009-08-14steve
	
	bool doDeleteSubDirectory = [[options objectForKey:@"deleteSubDirectory"] boolValue];
	bool deleteImmediately = [[options objectForKey:@"deleteImmediately"] boolValue];
	NSString* srcPath = [options objectForKey:@"sourcePath"];
	if ( srcPath==nil )
		srcPath = [NSString stringWithString:_gLogPath]; // use the global for this app
	
	NSString* basename = [options objectForKey:@"baseName"];
	if (basename==nil)
		basename = [NSString stringWithString:_gApplicationName];
	
	NSDate* beforeDate = [options objectForKey:@"beforeDate"];
	if (beforeDate==nil)
	{
		double daysOld = 3;
		NSTimeInterval oneDayOldInSeconds = -1 * 60.0 * 60.0 * 24.0;
		beforeDate = [NSDate dateWithTimeIntervalSinceNow:(oneDayOldInSeconds * daysOld)];
		
	}
	
	if (doVerbose) NSLog ( @"Inside %@->[%@] ==> Passed SourcePath: [%@]", [self class], NSStringFromSelector(_cmd), srcPath ); // 2009-08-14steve
	
	
	if ( basename==nil )
	{
		NSLog ( @"2010-10-16steve param forBasename is NIL" );
		return;
	}
	
	NSString* homePath = [srcPath stringByExpandingTildeInPath];
	
	if ( doDeleteSubDirectory )
	{
		NSAutoreleasePool* pool2 = [[NSAutoreleasePool alloc] init];
		// it is a directory - now iterate thru and test
		NSDirectoryEnumerator* newDirEnum = [[NSFileManager defaultManager] enumeratorAtPath:homePath];
		NSString* curItem	= nil;
		if ( newDirEnum )
		{
			bool done = false;
			while ( !done )
			{
				curItem = [newDirEnum nextObject];
				if ( curItem==nil )
				{
					done = true;
				}
				else
				{
					NSString* fullPath = [srcPath stringByAppendingPathComponent:curItem];
					[TPLogFileManager deleteItem:fullPath 
									  beforeDate:beforeDate 
									 forBasename:basename
							   deleteImmediately:deleteImmediately  ];
				}
				
				
			}
			
			// [newDirEnum release];
		} // if newDirEnum
		[pool2 release];
	}
	else
	{
		NSFileManager* manager = [NSFileManager defaultManager];
		NSArray* array = [manager directoryContentsAtPath:[homePath stringByExpandingTildeInPath]];
		
		if (doVerbose) NSLog ( @"2010-10-16steve directoryArray is: %@", array );
		
		if ( array && [array count] )
		{
			NSString* fullPath = nil;
			long i =0;
			for ( i=0; i<[array count]; i++ )
			{
				if (doVerbose) NSLog ( @"2010-10-16steve [array objectAtIndex:%i] = %@", i, [array objectAtIndex:i] );
				fullPath = [[homePath stringByAppendingPathComponent:[array objectAtIndex:i]] stringByExpandingTildeInPath];
				[TPLogFileManager deleteItem:fullPath 
								  beforeDate:beforeDate
								 forBasename:basename
						   deleteImmediately:deleteImmediately  ];
			}
		}
		
	}
	
	
}



#pragma mark -

+(NSString*)getCopyrightInfo
{
	NSAutoreleasePool *poolx = [[NSAutoreleasePool alloc] init];
	
	NSString	*infoString = @"";
	NSBundle	*myBundle = [NSBundle mainBundle];
	if ( myBundle )
	{
		infoString = nil;	// [myBundle objectForInfoDictionaryKey:@"NSHumanReadableCopyright" ];
		if ( infoString==nil )
			infoString = [myBundle objectForInfoDictionaryKey:@"CFBundleShortVersionString"];
	}
	
	if ( infoString )
		_gCopyrightVersion = [[NSString alloc] initWithString:infoString];
	else
		_gCopyrightVersion = [[NSString alloc] initWithString:@"Unable to Get Copyright Info, TriPrism, Inc."];

	if (poolx) [poolx release];
	
	return _gCopyrightVersion;
}

+(NSString*)getApplicationName
{
	NSAutoreleasePool *poolx = [[NSAutoreleasePool alloc] init];
	
	
	
	
	NSString	*infoString = @"";
	NSBundle	*myBundle = [NSBundle mainBundle];
	if ( myBundle )
	{
		// CFBundleExecutable
		// CFBundleDisplayName
		infoString = [myBundle objectForInfoDictionaryKey:@"CFBundleExecutable" ];
		
		// NSLog ( @"Info Dictionary is: %@", [myBundle infoDictionary] );
		if ( infoString==nil )
			infoString = [myBundle objectForInfoDictionaryKey:@"CFBundleDisplayName"];
		
		if ( infoString==nil )
			infoString = [NSString stringWithString:_gDefaultLogBaseName];
		
		if ( infoString )
			infoString = [infoString stringByDeletingPathExtension];
	}
	
	if ( infoString )
		_gApplicationName = [[NSString alloc] initWithString:infoString];
	else
		_gApplicationName = [[NSString alloc] initWithString:_gDefaultLogBaseName];
	
	
	if (poolx) [poolx release];
	
	return _gApplicationName;
}

+(NSString *)hostModelAndArch
{
    NSString * string = nil;
    int mib[] = {CTL_HW,HW_MODEL};
    size_t len, mlen;
    char * p_string;
    sysctl(mib, 2, NULL, &len, NULL, 0);
    mlen = 16 < len ? len : 16;
    p_string = (char*)malloc(mlen);
    if(p_string)
    {
        sysctl(mib, 2, p_string, &len, NULL, 0);
        string = [NSString stringWithCString:p_string encoding:NSUTF8StringEncoding];
        mib[1] = HW_MACHINE;
        len = mlen;
        sysctl(mib, 2, p_string, &len, NULL, 0);
        string = [string stringByAppendingFormat:@" (%@)", [NSString stringWithCString:p_string encoding:NSUTF8StringEncoding]];
        free(p_string);
    }
	
    return string;
}

+(NSString *)logDateString
{
    return [_gLogDateFormatter stringFromDate:[NSDate date]];
}


#pragma mark -

+(BOOL) setupLogFile
{
	// 2010-10-13steve
	NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init];
	
	_gLogDateFormatter = [[NSDateFormatter alloc] init];
	[_gLogDateFormatter setFormatterBehavior:NSDateFormatterBehavior10_4];
	[_gLogDateFormatter setDateFormat:@"[YYYY/MM/dd HH:mm:ss.SSS Z]"];

	
	// call these others too
	[self getCopyrightInfo];
	[self getApplicationName];

	if ( _gApplicationName==nil ) { // 2013-06-17steve
        [pool release];
        return NO;
    }
	
	NSString *logPath = [NSString stringWithString:_gLogPath];
	
	NSFileManager *filemgr = [NSFileManager defaultManager];
	
	if ( [filemgr respondsToSelector:@selector(createDirectoryAtPath:withIntermediateDirectories:attributes:error:)] )
	{
		// NSLog ( @"2010-11-13steve 10.5 method... " );
		NSError* error = nil;
		[filemgr createDirectoryAtPath:logPath
		   withIntermediateDirectories:YES 
							attributes:nil
								 error:&error];
		if ( error )
		{
			NSLog ( @"createDirectoryAtPath returned error: %@", error );
		}
	}
	else
	{
		//NSLog ( @"2010-11-13steve 10.0 method... " );
		[filemgr createDirectoryAtPath:logPath attributes: nil];
	}
	
	// if path exists - then redirect it
	if ( [filemgr fileExistsAtPath:logPath] )
	{
		
		// NSString* logFilePath = [logPath stringByAppendingPathComponent:_gLogBaseName];
		
		NSString* logFilePath = [logPath stringByAppendingPathComponent:_gApplicationName];
		if ( logFilePath==nil )
		{
			logFilePath = [logPath stringByAppendingPathComponent:_gDefaultLogBaseName];
		}
		
		logFilePath = [NSString stringWithFormat:@"%@_%@",logFilePath,computeCurrentDaysFolderString2(3,0)];
		
		logFilePath = [logFilePath stringByAppendingPathExtension:_gLogExtension];
		
		bool doSimpleMethod = true;
		if (doSimpleMethod)
		{
			_gLogFileHandle = freopen([logFilePath cStringUsingEncoding:NSASCIIStringEncoding],"a+",stderr);
		}
		else
		{
			NSLog ( @"doSimpleMethod = false???" );
			if(_gLogFileHandle = fopen([logFilePath fileSystemRepresentation], "a+"))
			{
				FILE * test = _gLogFileHandle;
				chmod([logFilePath fileSystemRepresentation], S_IRUSR | S_IRGRP | S_IROTH | S_IWUSR | S_IWGRP );
				// unset buffering to skip all the fflush calls
				setbuf(_gLogFileHandle, NULL);
				
				// fprintf (_gLogFileHandle, "this is a newly redirected text??" );

				
				test = freopen([logFilePath fileSystemRepresentation], "a+", stderr);
			}
			else
				NSLog ( @"Something bad with fopen???" );
		}
		
		
		
		NSLog ( @"===========================================================" );
		NSLog ( @"%@", [self hostModelAndArch] );
		
		NSString *scriptName = @"/usr/bin/sw_vers";
		NSMutableArray *paramArray = [NSMutableArray array];
		[paramArray addObject:@"-productVersion"];
		NSString* response2 = runShellScript2 ( scriptName, paramArray );
		
		if ( response2==nil )
		{
			NSLog ( @"runShellScript2 failed to get Mac OS version???" );
		}
		else
		{
			// NSLog ( @"Got from runShellScript2: [%@]", response2);
			NSLog ( @"%@", [NSString stringWithFormat:@"Mac OS: v%@", response2] );
		}			
		
		NSLog ( @"%@ => %@", _gApplicationName, _gCopyrightVersion );
		
		NSLog ( @"===========================================================" );
		
//		[self debug:@"THIS is s atest message ffkasdfklasfkasjfkasfjds"];
//		fputs("This is some test string....", _gLogFileHandle);
//		fprintf (_gLogFileHandle, "this is a newly redirected text??" );
		 
	}
	
	[pool release];
	
	return YES;
}

+(void) debug:(NSString*)msg
{
	//NSLog ( @"Inside Debug...." );


	// #define  NSLog(format, ...)    [TPLogFileManager debug:[NSString stringWithFormat: format, ## __VA_ARGS__ ]]

	
	if ( _gLogFileHandle )
	{
		// NSLog ( @"2010-10-15steve WRITING>>>>>>>>>>????" );
		// fprintf ( stderr, "2010-10-15steve WRITING>>>>>>>>>>????" );

		NSString *logFileString = [NSString stringWithFormat:@"%s %@ %@\n", "D", [self logDateString], msg];
	
		//NSLog ( @"logFileString= %@", logFileString );
		//NSLog ( @"logFileString= %s", [logFileString UTF8String] );
		
		fputs([logFileString UTF8String], _gLogFileHandle);

		
	}
	else
	{
		// NSLog ( @"2010-10-15steve _gLogFileHandle is NIL >>>>>>>>>>????" );
		//fprintf ( stderr, "2010-10-15steve WAHTTTTTTTTT????" );
	}
	
}


@end
