//
//  TepsPhotoQueryController.m
//  testFypController
//
//  Created by steve on 2/29/12.
//  Copyright 2012 TriPrism, Inc. All rights reserved.
//

#import "TepsPhotoQueryController.h"
// #import "CommonHeader.h"


NSString* keySearchKey = @"searchKey"; // 2013-10-04steve
NSString* keySearchPath = @"searchPath"; // 2013-10-04steve
NSString* keySearchDeep = @"searchDeep"; // 2013-10-04steve


@implementation TepsPhotoQueryController

@synthesize q;
@synthesize t;
@synthesize response;
@synthesize param;
@synthesize timeoutTimer; // 2012-02-29steve

#pragma mark -

- (id)init
{
    if (self = [super init])
    {
        //release in dealloc
        self.q = [[[NSMetadataQuery alloc] init] autorelease]; // 2012-06-16steve

		//remember to unregister for notifications
		[[NSNotificationCenter defaultCenter] addObserver:self
												 selector:@selector(stopSearching)
													 name:NSMetadataQueryDidFinishGatheringNotification 
												   object:nil];
		
		self.t = nil;
		self.response = nil;
		self.param = nil; // 2012-02-29steve
		self.timeoutTimer = nil; // 2012-02-29steve
    }
    return self;
}

- (void)dealloc
{    
	self.q = nil;
	self.response = nil;
	self.t = nil;
	self.param = nil;
	self.timeoutTimer = nil; // 2012-02-29steve
	
    [[NSNotificationCenter defaultCenter] removeObserver:self
													name:NSMetadataQueryDidFinishGatheringNotification
												  object:nil];
	
    [super dealloc];
}


- (void)searchTimedOut:(NSTimer*)timer
{
	if ( [timer isValid] )
		[timer invalidate];
	
	
	self.response = nil;
	
	NSLog ( @"search Took TOO LONG..." );
	
	NSLog ( @"result is %@", self.response );
	
	if ( [delegate respondsToSelector:@selector(doneSearchOperation:)] )
		[delegate doneSearchOperation:param];

	
}

- (void)updateResults:(NSTimer*)timer
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

    //    NSString *tempString = 
//    [NSString stringWithFormat:@"%d", [[timer userInfo] resultCount], nil];
    
	// NSLog ( @"timer userinfo is %@", [timer userInfo] );
	// NSLog ( @"timer userinfo is %@", [[timer userInfo] results]);
	// NSLog ( @"timer userinfo is %@", [[[timer userInfo] results] attributes]);
	
	if ( self.timeoutTimer && [self.timeoutTimer isValid] ) // 2012-02-29steve
		[self.timeoutTimer invalidate];

	
	self.response = [NSMutableArray arrayWithCapacity:1];
	
	id userInfo = nil;
	if ( timer==nil )
		userInfo = q;
	else
		userInfo = [timer userInfo];
	
    //NSLog ( @"userInfo is of class[%@]", [userInfo class] );
	
	id results = [userInfo results];
	//NSLog ( @"results is of class[%@]", [results class] );
	
	//NSLog ( @"There ARE %i ITEMS Found....", [userInfo resultCount] );
	if ( [results isKindOfClass:[NSArray class]] )
	{
		for ( short i=0; i<[results count]; i++ )
		{
			id obj = [results objectAtIndex:i]; // NSMetadataItem
			//NSLog ( @"obj[%i] attributes = %@", i,[obj attributes] );
			//NSLog ( @"obj        kMDItemPath = %@", [obj valueForAttribute:@"kMDItemPath"] );
			[self.response addObject:[obj valueForAttribute:@"kMDItemPath"]];
		}
	}
	
	
	if ( self.response==nil )
        NSLog (@ "Inside %@ => %@...self.response is NIL?????????", self, NSStringFromSelector(_cmd) );
      
	
	//NSLog ( @"result is %@", self.response );

	if ( [delegate respondsToSelector:@selector(doneSearchOperation:)] )
		[delegate doneSearchOperation:self.param];

	
	self.param = nil; // 2012-06-16steve - release the param
	
}


//called via the NSMetadataQueryDidFinishGatheringNotification 
//and/or the stopSearchAction: method
- (void)stopSearching 
{
    //don't invalidate a timer more than once
    if (!([q isStopped]))
    {
        //NSLog(@"Finito. Num results = %d", [q resultCount]);
        [self updateResults:t];
        [q stopQuery];
        [t invalidate];
    }
}

- (IBAction)stopSearchAction:(id)sender
{
    [self stopSearching];
    
}



// "kMDItemContentTypeTree == \"public.image\" AND kMDItemFSName LIKE[cd] \"111111\"",
// "kMDItemContentTypeTree == \"public.image\" AND kMDItemFSName LIKE[cd] \"222222\""
- (void)startSearchActionWithParam:(id)param1
{
    [self startSearchActionWithParamOldway:param1]; // 2013-08-08steve
    return;
    
    
	
	NSLog ( @"Inside %@->[%@] with param1=[%@] ", self, NSStringFromSelector(_cmd), param1 );

	self.param = param1;
	self.response = nil; // 2012-03-01steve

	id onlyInPath = [param1 objectForKey:keySearchPath];
	id arrOfIds = [param1 objectForKey:keySearchKey];
	//NSArray* arrOfIds = [NSArray arrayWithObjects:@"111111",@"123457",nil];

	delegate = [param1 objectForKey:@"delegate"];
	//selector = [param1 objectForKey:@"selector"];
	
	
	[q setDelegate: self];
	
	
	NSString *predicateFormat = @"(kMDItemContentTypeTree==%@) && (kMDItemFSName like[cd] %@)";
	
	NSMutableArray *subPredicates = [NSMutableArray arrayWithCapacity:1];
	for (NSString *term in arrOfIds) {
	    // 2012-06-12steve 
		NSPredicate *p = [NSPredicate predicateWithFormat:predicateFormat, kUTTypeQuickTimeMovie, [NSString stringWithFormat:@"%@*", term]];
		// 2013-10-04steve NSPredicate *p = [NSPredicate predicateWithFormat:predicateFormat, @"public.image", [NSString stringWithFormat:@"%@*", term]];
	    //NSPredicate *p = [NSPredicate predicateWithFormat:predicateFormat, @"public.image", [NSString stringWithFormat:@"*"]]; // 2012-06-12steve
		[subPredicates addObject:p];
	}
	NSLog (@"2012-02-28steve subpredicates = %@", subPredicates );
	
	NSPredicate* predicate = nil;
	if ( [subPredicates count]==1 )
	{
		predicate = [subPredicates objectAtIndex:0];
	}
	else {
		predicate = [NSCompoundPredicate orPredicateWithSubpredicates:subPredicates];
	}

	NSLog (@"2012-02-28steve QUERY predicate = %@", predicate );

	
    // we want our list to be sorted
	[q setSortDescriptors:[NSArray arrayWithObject:[[[NSSortDescriptor alloc] initWithKey:(id)kMDItemFSName ascending:YES] autorelease]]];
	
	
	[q setPredicate:predicate];
    
    //optionally set search scopes - constrain search to this scope
	if ( onlyInPath ) {
		if ( [onlyInPath isKindOfClass:[NSArray class]] )
			[q setSearchScopes:[NSArray arrayWithArray:onlyInPath]];
		else if ( [onlyInPath isKindOfClass:[NSString class]] )
			[q setSearchScopes:[NSArray arrayWithObject:onlyInPath]];

	} 
    
    //start the query and use the run loop 
    //to process the search progress.
    if ([q startQuery])
    {
		NSLog ( @"2012-02-28steve started Query..." );
		
		
		// we are not updating views live		
		self.timeoutTimer = [NSTimer scheduledTimerWithTimeInterval:5.0		// 2012-02-29steve setup 5 sec timeout incase query dies...
												  target:self 
												selector:@selector(searchTimedOut:) 
												userInfo:nil
												 repeats:NO];
		
		
		//NSRunLoop retains the timer
		[[NSRunLoop currentRunLoop] addTimer:self.timeoutTimer forMode:NSDefaultRunLoopMode];

    }
    else
    {
        NSLog(@"Error. Could not start query. Weird.");
    }
}


// 2013-08-08steve - do it old way thru enumeration
- (void)startSearchActionWithParamOldway:(id)param1
{
	
	NSLog ( @"Inside %@->[%@] with param1=[%@] ", self, NSStringFromSelector(_cmd), param1 );
    
	self.param = param1;
	self.response = nil; // 2012-03-01steve
    
	id onlyInPath = [param1 objectForKey:keySearchPath];
	id arrOfIds = [param1 objectForKey:keySearchKey];
	delegate = [param1 objectForKey:@"delegate"];
	
    self.response = [NSMutableArray arrayWithCapacity:1];

    if (onlyInPath) {
        
        BOOL isdirectory = NO;
        BOOL exists = [[NSFileManager defaultManager] fileExistsAtPath:onlyInPath isDirectory:&isdirectory];
        if (exists && isdirectory) {
            
            // 2013-10-18steve NSURL* folderURL = [NSURL URLWithString:onlyInPath ];
            NSURL* folderURL = [NSURL URLWithString:[onlyInPath stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding] ]; // 2013-10-18steve
            
            if ( folderURL ) {
                
                NSArray *keys = [NSArray arrayWithObjects: NSURLIsRegularFileKey, NSURLIsPackageKey, NSURLLocalizedNameKey, NSURLContentModificationDateKey, NSURLCreationDateKey, nil]; // 2012-10-03steve look for NSURLContentModificationDateKey and NSURLCreationDateKey info too
                NSDirectoryEnumerator *enumerator = [[NSFileManager defaultManager] enumeratorAtURL:folderURL
                                                                         includingPropertiesForKeys:keys
                                                                                            options:(NSDirectoryEnumerationSkipsSubdirectoryDescendants |
                                                                                                     NSDirectoryEnumerationSkipsPackageDescendants |
                                                                                                     NSDirectoryEnumerationSkipsHiddenFiles)
                                                                                       errorHandler:^(NSURL *url, NSError *error) {
                                                                                           // Handle the error.
                                                                                           // Return YES if the enumeration should continue after the error.
                                                                                           NSLog (@"%@ bumped into an error with enumeratorAtURL = %@",NSStringFromSelector(_cmd), error ); // 2013-10-20steve
                                                                                           return NO;
                                                                                           
                                                                                       }];
                
                
                for (NSURL *url in enumerator) {
                    
                    BOOL foundItem = NO;
                    
                    
                    NSLog(@"item found url: %@ ", url );
                    NSString* filepath = [url path];
                    NSLog(@"item found path: %@ ", filepath );
                    
                    isdirectory = NO;
                    [[NSFileManager defaultManager] fileExistsAtPath:filepath isDirectory:&isdirectory];
                    
                    if (isdirectory) {
                        NSLog ( @"Inside %@->[%@] skipping Folder: %@", self, NSStringFromSelector(_cmd), filepath ); // 2013-10-18steve
                    }
                    else if (filepath) { // 2013-10-18steve - make sure we can get a filepath
                        
                        // for this search mechanism - nnnnn_myRecordedMovie_YYYYMMDD-HHmmss.jpg
                        // 2013-10-18steve - remove path extension
                        NSArray* fileParts = [[[filepath lastPathComponent] stringByDeletingPathExtension] componentsSeparatedByCharactersInSet:[NSCharacterSet characterSetWithCharactersInString:@"_"]];
                        NSString* basepart = [fileParts objectAtIndex:0];
                        
                        NSLog(@"fileparts = %@", fileParts); // 2013-10-18steve
                        
                        if (arrOfIds) {
                            for ( id eachSearchKey in arrOfIds) {
                                if ( [basepart caseInsensitiveCompare:eachSearchKey] ==NSOrderedSame  ) {
                                    foundItem = YES;
                                    break;
                                }
                            }
                        } else {
                            foundItem = YES; // if nothing to compare against - then let it thru???
                        }
                        
                        if ( foundItem ) {
                            NSString* ext = [filepath pathExtension];
                            if (ext && [ext caseInsensitiveCompare:@"xml"]!=NSOrderedSame) {
                                [self.response addObject:filepath];
                            }
                        }
                        
                    }
                    else {
                        NSLog ( @"Inside %@->[%@] unable to get path from url = [%@] ", self, NSStringFromSelector(_cmd), url ); // 2013-10-18steve
                    }
                    
                }
            
            } else {
                
                NSAlert* alert = [[NSAlert alloc] init];
				[alert setMessageText:[NSString stringWithFormat:@"Unable to Form NSURL from path..." ]];
				[alert setInformativeText:[NSString stringWithFormat:@"path is: %@ \n\nMaybe path needs to Escape Sequenced....", onlyInPath]];
				[alert addButtonWithTitle:@"OK"];
				
				[[NSApplication sharedApplication] activateIgnoringOtherApps: YES];
				[alert runModal];
				
				[alert release];
				alert = nil;

                
            }

        }

    }
    
    
    
    NSLog(@"self.response: %@ ", self.response );


    if ( [delegate respondsToSelector:@selector(doneSearchOperation:)] )
		[delegate doneSearchOperation:self.param];
    
	
	self.param = nil; // 2012-06-16steve - release the param


}


@end
