//
//  TepsNSXmlParser.m
//  HttpUploader
//
//  Created by steve on 9/6/11.
//  Copyright 2011 TriPrism, Inc. All rights reserved.
//

#import "TepsNSXmlParser.h"

//static BOOL self.doVerbose = YES;



id testParser (NSString *fileToParsePath)
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	NSMutableDictionary* result = nil;
	
    BOOL success = NO;
	
	
	NSData* theData = [NSData dataWithContentsOfFile:fileToParsePath];
	if ( theData )
	{
		TepsNSXmlParser* parser = [[TepsNSXmlParser alloc] initWithData:theData];
	    
		if ( parser )
		{
			success = [parser parse]; // return value not used
			
			if ( parser.parserError )
			{
				NSLog(@"ParserError = %@", parser.parserError);
				
			}
			
			NSLog ( @"2011-09-06steve Finished parser.mDictionary contains: %@", parser.mDictionary );
			NSLog ( @"2011-09-06steve Finished parser.curNode contains: %@", parser.curNode );
			
			// result = [[NSMutableDictionary dictionaryWithDictionary:parser.mDictionary] retain];
			result = [[NSMutableDictionary alloc] initWithDictionary:parser.mDictionary copyItems:YES];
			
		}

		[parser release];
	}
	
	[pool release];
	
	return result;
}


id testParser2 (NSString *fileToParsePath, id callbacker)
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];


	
	NSMutableDictionary* result = nil;
	
    BOOL success = NO;
	
	
	NSData* theData = [NSData dataWithContentsOfFile:fileToParsePath];
	if ( theData )
	{
		TepsNSXmlParser* parser = [[TepsNSXmlParser alloc] initWithData:theData];
	    
		if ( parser )
		{
			success = [parser parse]; // return value not used
			
			if ( parser.parserError )
			{
				NSLog(@"ParserError = %@", parser.parserError);
				
			}
			
			
			
			NSLog ( @"2011-09-06steve Finished parser.mDictionary contains: %@", parser.mDictionary );
			
			// result = [[NSMutableDictionary dictionaryWithDictionary:parser.mDictionary] retain];
			result = [[NSMutableDictionary alloc] initWithDictionary:parser.mDictionary copyItems:YES]; // 2013-05-01steve make mutable
			
		}
		
		// [parser release];
		if ( [callbacker respondsToSelector:@selector(parserDidFinish:withResult:)] )
		{
			[callbacker parserDidFinish:parser withResult:result];
			
		}
		else
		{
			[parser release];
		}
	}
	
	[pool release];
	
	
	return result;
}



#pragma mark -

@implementation TepsNSXmlParser

@synthesize mDictionary;
@synthesize mCurrentStringValue;
@synthesize mStack;
@synthesize curNode;
@synthesize itemNeedsArray;
@synthesize itemNeedsDictionary;
@synthesize doVerbose;
@synthesize rootKey;
@synthesize itemNeedsSpecialCare; // 2011-12-13steve


#pragma mark -


-(void) pushOnStack:(id) obj
{
	if (self.doVerbose) NSLog ( @"%@ => %@...obj = %@",self, NSStringFromSelector(_cmd), obj );
	[self.mStack insertObject:obj atIndex:0];
	if (self.doVerbose) NSLog ( @"%@ => %@...stack is now: %@\n",self, NSStringFromSelector(_cmd), self.mStack );
}

-(id) popFromStack
{
	if (self.doVerbose) NSLog ( @"%@ => %@...",self, NSStringFromSelector(_cmd) );

	id obj = nil;
	if ( [self.mStack count] )
	{
		obj = [self.mStack objectAtIndex:0];
		[self.mStack removeObjectAtIndex:0];
	}
	
	if (self.doVerbose) NSLog ( @"%@ => %@...returning obj = %@",self, NSStringFromSelector(_cmd), obj );

	return obj;
}

-(void) addToCurNodeWithData:(id)data withElementName:(id)elementName
{
	if (self.doVerbose) NSLog ( @"%@ => %@...\ndata = %@\nelementName = %@",self, NSStringFromSelector(_cmd), data, elementName );

	if ( data==nil )
		return;
	
	
	if ( [self.curNode isKindOfClass:[NSArray class]] )
	{
		[self.curNode addObject:data];
	}
	else if ( [self.curNode isKindOfClass:[NSDictionary class]] )
	{
		[self.curNode setObject:data forKey:elementName];
	}
	
	if (self.doVerbose) NSLog ( @"%@...self.curNode [%@]:\n%@",NSStringFromSelector(_cmd),[self.curNode class], self.curNode );

	
	self.mCurrentStringValue = nil;
}

-(void) addToParNode:(id) parNode withData:(id) data withElementName:(id)elementName
{
	if (self.doVerbose) NSLog ( @"%@ => %@...parNode = %@\ndata = %@\nelementName = %@",self, NSStringFromSelector(_cmd), parNode, data, elementName );

	if ( data==nil )
		return;

	if ( [parNode isKindOfClass:[NSArray class]] )
	{
		[parNode addObject:data];
	}
	else if ( [parNode isKindOfClass:[NSDictionary class]] )
	{
		
		
		// 2011-12-13steve - check to see if the parentDictionary Already include our special ArrayType
		
		if ( [self.itemNeedsSpecialCare containsObject:[elementName lowercaseString]] )
		{
			id someObj = [parNode objectForKey:elementName];
			if ( someObj )
			{
				if ( [someObj isKindOfClass:[NSMutableArray class]] )
				{
					// great - just add to it
					[someObj addObject:data];
				}
				else {
					// we need to make the previous one an array???
					NSLog( @"2011-12-13steve *******************  NEED to FIX CODE?????  ***************" );
					NSLog( @"2011-12-13steve *******************  NEED to FIX CODE?????  ***************" );
				}
					
			} else {
				
				NSMutableArray* mArr = [NSMutableArray arrayWithObject:data];
				[parNode setObject:mArr forKey:elementName];
			}
			
			
		}
		else {
			[parNode setObject:data forKey:elementName];
		}
		
	}
	
	if (self.doVerbose) NSLog ( @"%@...parNode [%@]:\n%@",NSStringFromSelector(_cmd),[self.curNode class], parNode );

	
}


#pragma mark -



-(void) dealloc
{
	if (self.doVerbose) NSLog ( @"%@ => %@...",self, NSStringFromSelector(_cmd) );
	
    // 2013-05-01steve
    NSLog(@"2013-05-01steve %@ => %@... DEALLOC     DEALLOC     DEALLOC ........",self, NSStringFromSelector(_cmd));
    
	self.mDictionary = nil;
	self.mCurrentStringValue = nil;
	self.mStack = nil;
	self.curNode = nil;
	
	self.itemNeedsArray = nil;
	self.itemNeedsDictionary = nil;
	
	self.rootKey = nil;
	
	[super dealloc];
}


-(id) initWithData:(NSData *)data
{
	if ((self = [super initWithData:data]))
	{
		[self setShouldProcessNamespaces:NO];
		[self setDelegate:self];
		[self setShouldResolveExternalEntities:NO]; // NO = Drastically speeds up parsing with html files
		
		self.mCurrentStringValue =nil;
		self.curNode = nil;
		self.mDictionary = nil;

		self.mStack = [NSMutableArray arrayWithCapacity:1];
		[self pushOnStack:[NSMutableDictionary dictionaryWithCapacity:1]];

	
		self.itemNeedsSpecialCare = [NSSet setWithObjects:@"image",nil]; // 2011-12-13steve
		self.itemNeedsArray = [NSSet setWithObjects:@"ids",@"groupcodes",nil];
		self.itemNeedsDictionary = [NSMutableSet setWithObjects:@"image",@"response",@"subdictionary",@"subdictionary2",@"key",@"result",nil]; // 2012-10-13steve add @"result" // 2012-08-30steve added @"key"
		self.rootKey = [NSString stringWithString:@"response"];
		
		
		self.doVerbose = NO;
	
	}
	
	return self;
	
}


#pragma mark -
#pragma mark NSXMLParserDelegate

- (void) parser:(NSXMLParser *)parser 
didStartElement:(NSString *)elementName 
   namespaceURI:(NSString *)namespaceURI 
  qualifiedName:(NSString *)qName 
	 attributes:(NSDictionary *)attributeDict 
{
	if (self.doVerbose) 
	{
		NSLog (@"photoAdController parser:didStartElement.....................");
		NSLog ( @"Element = [%@]", elementName );
		NSLog ( @"namespaceURI = [%@]", namespaceURI );
		NSLog ( @"qualifiedName = [%@]", qName );
		NSLog ( @"attributes = [%@]", attributeDict );
		NSLog (@"photoAdController parser:didStartElement.....................");
	}
	

	if ( [elementName caseInsensitiveCompare:@"html"]==NSOrderedSame )
	{
		// we wanna break out!!!!
		
		NSLog( @"2011-09-16 This Parser NOT DESIGNED to parse HTML doc...." );
		[parser abortParsing];
		return;
	}
	
	
	id newNode = nil;

	
	if ( attributeDict ) {
		if (self.doVerbose) NSLog ( @"2011-03-20steve attributeDict isKindOfClass [%@]...",[attributeDict class] );
	
		if ( [attributeDict count] ) {
			// 2013-03-20steve - object is BOTH array and dictionary
			if (self.doVerbose) NSLog ( @"2013-03-20steve WE NEED TO ALLOCATE ARRAY AND Dictionary for [%@]...",elementName );
		}
		

	}
	
	if ( [self.itemNeedsArray containsObject:[elementName lowercaseString]] )
	{
		if (self.doVerbose) NSLog ( @"2011-09-16steve WE NEED TO ALLOCATE ARRAY for [%@]...",elementName );
		newNode = [NSMutableArray arrayWithCapacity:1];
	}
	if ( [self.itemNeedsDictionary containsObject:[elementName lowercaseString]] )
	{
		if (self.doVerbose) NSLog ( @"2011-09-16steve WE NEED TO ALLOCATE DICTIONARY for [%@]...",elementName );
		if ( attributeDict )
		{
			newNode = [NSMutableDictionary dictionaryWithDictionary:attributeDict];
		}
		else {
			newNode = [NSMutableDictionary dictionaryWithCapacity:1];
		}
	}

	

	if (newNode) 
	{
		if ( self.curNode ) [self pushOnStack:self.curNode];
		self.curNode = newNode;
	}

}

- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string
{
	if (self.doVerbose) NSLog ( @"%@ => %@...",self, NSStringFromSelector(_cmd) );

	
	NSString* cleanString = [NSString stringWithString:string];
	cleanString = [cleanString stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];

	if ( cleanString && [cleanString length] )
		self.mCurrentStringValue = [NSString stringWithString:cleanString];
	
}


- (void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName 
{
	
	if (self.doVerbose) NSLog ( @"%@ => %@...elementName = [%@]",self, NSStringFromSelector(_cmd), elementName );
	
	NSString* cleanString = nil;
	if ( self.mCurrentStringValue )
	{
		cleanString = [NSString stringWithString:self.mCurrentStringValue];
		cleanString = [cleanString stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
	}

	if (self.doVerbose) NSLog ( @"%@ => %@...cleanString = [%@]",self, NSStringFromSelector(_cmd), cleanString ); // 2011-12-13steve
	
	NSSet* needToPopIfTheseElements = [NSSet setWithSet:self.itemNeedsArray];
	needToPopIfTheseElements = [needToPopIfTheseElements setByAddingObjectsFromSet:self.itemNeedsDictionary];
		
	BOOL nodeDone = [needToPopIfTheseElements containsObject:[elementName lowercaseString]];

	if ( nodeDone && cleanString )
	{
		NSLog ( @"2011-09-16steve Possible Problem - ending current Node - but dangling data: [%@]", cleanString );

		[self addToCurNodeWithData:cleanString withElementName:@"value"];
	}
	
	
	if ( nodeDone )
	{
		id parNode = [self popFromStack];
		[self addToParNode:parNode withData:self.curNode withElementName:elementName];
		self.curNode = parNode;
	}
	else
	{
		[self addToCurNodeWithData:cleanString withElementName:elementName];
	}
	
}


- ( void ) parser:(NSXMLParser *)parser parseErrorOccurred:(NSError *)parseError 
{
	if (self.doVerbose) NSLog ( @"%@ => %@...",self, NSStringFromSelector(_cmd) );
	
	BOOL doNSAlert = NO;
	if ( doNSAlert )
	{
		NSString* errorString = [NSString stringWithFormat:@"Error %i Description: %@, Line: %i, Column: %i", [parseError code],
								 [[parser parserError] localizedDescription], [parser lineNumber],
								 [parser columnNumber]];
		
		
		NSAlert* alert = [NSAlert alertWithMessageText:@"Parse Error" 
										 defaultButton:@"OK" 
									   alternateButton:nil 
										   otherButton:nil 
							 informativeTextWithFormat:[NSString stringWithFormat:@"%@",errorString]];
		
		[alert beginSheetModalForWindow:nil modalDelegate:self didEndSelector:nil contextInfo:nil];
	}
	
	self.mCurrentStringValue = nil;
	
}

- (void)parserDidEndDocument:(NSXMLParser *)parser
{
	if (self.doVerbose) NSLog ( @"%@ => %@...++++++++++++++++++++++++++++++++++++++++++++++++",self, NSStringFromSelector(_cmd) );

//	if (self.doVerbose) NSLog (@ "STACK now contains: %@", self.mStack );
//	if (self.doVerbose) NSLog (@ "self.curNode now contains: %@", self.curNode );
	
	self.mDictionary = self.curNode;
	
	if (self.rootKey)
	{
		id rootObj = [self.mDictionary objectForKey:self.rootKey];
		if ( rootObj )
			self.mDictionary = [NSDictionary dictionaryWithDictionary:rootObj];
	}
	
}

- (void)parserDidStartDocument:(NSXMLParser *)parser
{
	if (self.doVerbose) NSLog ( @"%@ => %@...++++++++++++++++++++++++++++++++++++++++++++++++",self, NSStringFromSelector(_cmd) );
	
}

- (void)parser:(NSXMLParser *)parser validationErrorOccurred:(NSError *)validError
{
	if (self.doVerbose) NSLog ( @"%@ => %@...",self, NSStringFromSelector(_cmd) );

}


- (void)parser:(NSXMLParser *)parser foundComment:(NSString *)comment
{
	NSLog ( @"==========================================" );

	NSLog ( @"%@", comment );
	NSLog ( @"==========================================" );
	
}






@end
