//
//  TepsUrlHandler.m
//  FTPUpload
//
//  Created by steve on 6/12/09.
//  Copyright 2009 TriPrism,Inc. All rights reserved.
//

#import "TepsUrlHandler.h"
#import "TepsNSXmlParser.h" // 2011-09-18steve
#import "TepsAdditions.h" // 2011-09-28steve
#import "TepsXmlWriter.h" // 2012-09-26steve
#import "NSApplication+Relaunch.h"
#import "TepsNSXmlParser.h" // 2014-08-11steve


NSString* sPrefLastValidKeyData = @"prefLastValidKeyData"; // 2014-08-11steve


// 2011-12-14steve WE NEED THIS????for GIGUNDA CUSTOM static NSString* sPrefUploadMovie = @"prefUploadMovie"; // 2010-11-18steve
//static NSTimeInterval sDefaultRequestTimeOutInSeconds = 60.0; // 2011-12-17steve // 4.0;

@implementation NSDate (Utils)

-(NSDate *) toLocalTime
{
    NSTimeZone *tz = [NSTimeZone localTimeZone];
    NSInteger seconds = [tz secondsFromGMTForDate: self];
    return [NSDate dateWithTimeInterval: seconds sinceDate: self];
}

@end



@implementation TepsUrlHandler

@synthesize fUploadTimeOutTimer; // 2011-11-09steve
@synthesize fStarted; // 2011-12-03steve
@synthesize fProgressDelegate; // 2011-12-03steve
@synthesize fResponseDictionary; // 2011-12-05steve
@synthesize fReceivedData; // 2011-12-05steve
@synthesize fNSURLConn; // 2011-12-06steve
@synthesize fDoAsync; // 2011-12-20steve
@synthesize fDummyPort; // 2013-03-22steve
@synthesize fRunLoop; // 2013-03-22steve
@synthesize fDoVerbose;

#pragma mark -


- (id) init
{
	NSLog (@ "Inside %@ => %@...", [self class], NSStringFromSelector(_cmd) );
	
	if ((self = [super init])) {// superclass may return nil
		
    	NSNotificationCenter* nc = [NSNotificationCenter defaultCenter];
		[nc addObserver:self
			   selector:@selector(handleNotification_UploadStart:)
				   name:cNotification_UploadStart
				 object:nil];
		[nc addObserver:self
			   selector:@selector(handleNotification_UploadDone:)
				   name:cNotification_UploadDone
				 object:nil];
		[nc addObserver:self
			   selector:@selector(handleNotification_UploadSuccess:)
				   name:cNotification_UploadSuccess
				 object:nil];
		[nc addObserver:self
			   selector:@selector(handleNotification_UploadFail:)
				   name:cNotification_UploadFail
				 object:nil];
        
		
		self.fProgressDelegate = nil;
		self.fUploadTimeOutTimer = nil; // 2011-11-09steve
		self.fStarted = NO;
		self.fResponseDictionary = nil; // 2011-12-05steve
		self.fNSURLConn = nil; // 2011-12-06steve
		
		self.fDoAsync = YES; // 2011-12-20steve
		
		self.fDummyPort = nil; // 2013-03-21steve
		self.fRunLoop = nil;
		
		self.fDoVerbose = NO;
	}
	
    return self;
    
	
}

// 2009-11-25steve
- (void)dealloc
{
	NSLog (@ "%@->%@...", self, NSStringFromSelector(_cmd) );
    
	[[NSNotificationCenter defaultCenter] removeObserver:self]; // 2011-12-07steve
	
	self.fStarted = NO; // 2011-12-03steve
	self.fUploadTimeOutTimer = nil; // 2011-12-03
	self.fProgressDelegate = nil; // 2011-12-03
	self.fResponseDictionary = nil; // 2011-12-05steve
	self.fNSURLConn = nil; // 2011-12-06steve
	self.fDummyPort = nil; // 2013-03-21steve
	self.fRunLoop = nil;
    self.fReceivedData = nil; // 2013-05-01steve
	
	[super dealloc];
}


// 2011-12-03steve
// USE property/synthesize
//
//// 2009-11-25steve
//// we assume the delgate the had to have been created and allocated externally
//- (void) setProgressDelegate:(id) theDelegate
//{
//	if ( _progressDelegate!=theDelegate )
//	{
//		if ( _progressDelegate ) [_progressDelegate release];
//		_progressDelegate = theDelegate;
//
//	}
//}
//
//// 2009-11-25steve
//- (id) progressDelegate
//{
//	return _progressDelegate;
//}
//



#pragma mark -

- (NSString *)serialNumber
{
    io_service_t    platformExpert = IOServiceGetMatchingService(kIOMasterPortDefault,
                                                                 
                                                                 IOServiceMatching("IOPlatformExpertDevice"));
    CFStringRef serialNumberAsCFString = NULL;
    
    if (platformExpert) {
        serialNumberAsCFString = IORegistryEntryCreateCFProperty(platformExpert,
                                                                 CFSTR(kIOPlatformSerialNumberKey),
                                                                 kCFAllocatorDefault, 0);
        IOObjectRelease(platformExpert);
    }
    
    NSString *serialNumberAsNSString = nil;
    if (serialNumberAsCFString) {
        serialNumberAsNSString = [NSString stringWithString:(NSString *)serialNumberAsCFString];
        CFRelease(serialNumberAsCFString);
    }
    
    return serialNumberAsNSString;
}

#pragma mark -

+(float)getUploadTimeOut	// 2013-03-20steve
{
	return 60.0;
}

+(float)getURLRequestTimeout	// 2013-03-20steve
{
	return 60.0;
}

+(id)getCurUserLoginName
{
	return [NSString stringWithString: @"shlorg1"];
}

+(id)getCurUserLoginPassword
{
	return [NSString stringWithString: @"iphone"];
}

+(id)getPrefFypURL
{
	return [NSString stringWithString: @"http://api.scipah.com"];
}

+ (NSString*) getFypFuseAction
{
	return [NSString stringWithString:@"NoFuseActionAllowed"];
}




#pragma mark -


-(void) destroyUploadTimeOutTimer	// 2011-11-09steve
{
	if ( self.fUploadTimeOutTimer )
	{
		[self.fUploadTimeOutTimer invalidate];
		self.fUploadTimeOutTimer = nil;
	}
	
}

-(void) setupUploadTimeOutTimer:(id)param	// 2011-11-09steve
{
	
	[self destroyUploadTimeOutTimer];
	
	
	// 2010-11-26steve - setup timer to abort process
	// 2010-11-26steve - setup timer to abort process
	float timeOutInSeconds = [TepsUrlHandler getUploadTimeOut]; // [[NSUserDefaults standardUserDefaults] objectForKey:sPrefUploadTimeOut];
	
	float urlRequestTimeOut = [TepsUrlHandler getURLRequestTimeout]; // 2011-12-20steve
	timeOutInSeconds += urlRequestTimeOut; // 2011-12-20steve
	
	
	NSDate* timeOutDate = [NSDate dateWithTimeIntervalSinceNow:timeOutInSeconds];
	self.fUploadTimeOutTimer = [[[NSTimer alloc] initWithFireDate:timeOutDate
														 interval:0.0
														   target:self
														 selector:@selector(uploadTimerFired:)
														 userInfo:param
														  repeats:NO] autorelease];
	if ( self.fUploadTimeOutTimer==nil )
	{
		NSLog (@"2010-11-26steve self.fUploadTimeOutTimer is NIL?????" );
	}
	else
	{
		NSLog (@"2011-12-02steve self.fUploadTimeOutTimer will trigger at: %@",timeOutDate );
		NSRunLoop *runLoop = [NSRunLoop mainRunLoop];
		[runLoop addTimer:self.fUploadTimeOutTimer forMode:NSRunLoopCommonModes];
	}
	
}


// 2010-11-26steve - uploadTimerFired
- (void)uploadTimerFired:(NSTimer*)theTimer
{
	NSLog (@ "Inside %@ => %@...==================================================", self, NSStringFromSelector(_cmd) );
	NSLog (@ "Inside %@ => %@.....Taking too long to upload - need to relaunch....", self, NSStringFromSelector(_cmd) );
	// NSLog (@ "Inside %@ => %@...progressDelegate = [%@]", [self class], NSStringFromSelector(_cmd), [self progressDelegate] );
	NSLog (@ "Inside %@ => %@...==================================================", self, NSStringFromSelector(_cmd) );
	
	
	
	BOOL doRelaunchApp = NO; // [[NSUserDefaults standardUserDefaults] boolForKey:sPrefDoRelaunchAppOnNoResponseTimeOut]; // 2011-12-13steve YES; // 2011-11-09steve
	
	//2011-12-05steve DEBUG if  (doRelaunchApp==NO ) // 2011-11-09steve - try to kill the url rquest
	{
		id userInfo = [theTimer userInfo];
		// 2011-12-14steve not used id urlRequest = [userInfo objectForKey:@"NSMutableURLRequest"];
		// 2011-12-14steve NSURLConnection* nsurlConn = [userInfo objectForKey:@"NSURLConnection"];
		if ( self.fNSURLConn) // 2011-12-14steve if ( nsurlConn )
		{
			NSLog (@ "Inside %@ => %@.....cancelling nsurl connection for [%@]....", self, NSStringFromSelector(_cmd), self.fNSURLConn );
			[self.fNSURLConn cancel];
			
			id baseUrl = [self.fResponseDictionary objectForKey:@"baseUrl"]; // 2011-12-08steve
			if ( baseUrl==nil )
				baseUrl = [NSString stringWithString:@"no valid baseUrl for some reason"];
			
			NSDictionary* errorDict = [NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"Connection Timed Out at: %@",baseUrl],NSLocalizedDescriptionKey,nil];
			NSError *error = [NSError errorWithDomain:@"TepsDomain" code:1000 userInfo:errorDict];
			[self.fResponseDictionary setObject:error forKey:cDictKeyHttpError];
			
			if ( doRelaunchApp==NO ) // 2011-12-13steve
			{
				[[NSNotificationCenter defaultCenter] postNotificationName:cNotification_UploadDone
																	object:self
																  userInfo:self.fResponseDictionary];
			}
			
			// 2011-12-13steve doRelaunchApp = NO;
		}
		else
		{
			doRelaunchApp = YES;
		}
	}
	
	if ( doRelaunchApp )
	{
		id delegate = self.fProgressDelegate; // 2011-12-05steve [self progressDelegate];
		if ( delegate )
		{
			SEL relaunchMethod = @selector(relaunchApp:);
			
			if ( [delegate respondsToSelector:relaunchMethod] )
			{
				LSLaunchFlags flags = NSApplicationRelaunchInBackground; // we want to relaunch this in the BG
				if ( [NSApp isActive] )
				{
					flags = kLSLaunchDefaults;
				}
				
				[self destroyUploadTimeOutTimer]; // 2011-12-20steve - in case on the main thread
				
				[delegate performSelectorOnMainThread:relaunchMethod
										   withObject:[NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithLong:flags], @"LSLaunchFlags", self,@"sender" , nil]
										waitUntilDone:NO];
			}
			else
			{
				NSLog ( @"2010-11-26steve [%@ respondsToSelector:@selector(relaunchApp:)] is FALSE", [delegate class] );
			}
			
		}
	}
	
	
	[self destroyUploadTimeOutTimer]; // 2011-12-06steve
	
	
}

#pragma mark -

// this assumes that param contains all keys that will be used to build the url parameters
-(NSMutableString*) buildCustomURLString:(id)param
{
	NSAutoreleasePool* pool = [[NSAutoreleasePool alloc]init];
	
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	id baseUrl = [param objectForKey:@"baseUrl"];
	id keys = [param objectForKey:@"keys"];
	
	
	NSMutableString* paramString = [NSMutableString stringWithCapacity:0];
	NSMutableArray* allKeys = [NSMutableArray arrayWithArray:[keys allKeys]];
	
	NSUInteger count = 0;
	for ( id aKey in allKeys )
	{
		id obj = [keys objectForKey:aKey];
		
		if ( [obj isKindOfClass:[NSString class]] )
		{
			// good
		}
		else if ( [obj isKindOfClass:[NSArray class]] )
		{
			// convert array to string
			obj = [obj componentsJoinedByString:@","];
		}
		else {
			// everything else is unsupported
			NSLog (@ "Inside %@ => %@...Skipping Key[%@] = [%@]...", self, NSStringFromSelector(_cmd), aKey, obj );
			obj = nil;
		}
		
		if ( obj && [obj isKindOfClass:[NSString class]] )
		{
			if ( count++ ) [paramString appendFormat:@"&"];
			obj = [obj stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
			[paramString appendFormat:@"%@=%@",aKey,[obj stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding]];
		}
        
		
	}
    
	
	NSString* baseURLString = [NSString stringWithString:baseUrl];
    
	NSString *phpCommandFormat = @"%@?%@";
    
    if ([paramString length]==0) { // 2014-08-11steve
        phpCommandFormat = @"%@%@";
    }
    
	NSMutableString *phpCommand = [NSMutableString stringWithFormat:phpCommandFormat,baseURLString, paramString];
	
	
	NSLog (@ "Inside %@ => %@...url string = [%@]", self, NSStringFromSelector(_cmd), phpCommand ); // 2014-08-11steve
	
	phpCommand = [phpCommand retain];
	[pool release];
	
	return [phpCommand autorelease];
}


// mandatory
//[postBody appendData:@"triprism" forName:@"username"];
//[postBody appendData:@"15950m" forName:@"password"];
//[postBody appendData:@"testnoerr" forName:@"event"];
//[postBody appendData:@"148838" forName:@"client"];
//[postBody appendData:@"upload.upload" forName:@"fuseaction"];
//
// optional
//[postBody appendData:@"2011-09-17 21:35:43" forName:@"capturetime"];
//[postBody appendData:@"from Teps-EmailEntry.app" forName:@"metadata"];
//
// mandatory
//[postBody appendImageData:edFileName];



-(NSMutableData*) buildCustomPostBodyData:(id)param
{
	NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init];
	
	NSLog (@ "Inside %@ => %@...param = %@", self, NSStringFromSelector(_cmd), param );
    
    
	NSMutableData *postBody = [NSMutableData dataWithCapacity:0];
	
	[postBody appendBoundary];
	
	NSMutableArray* allKeys = [NSMutableArray arrayWithArray:[param allKeys]];
	
	for ( id aKey in allKeys )
	{
		id obj = [param objectForKey:aKey];
		
		if ( [obj isKindOfClass:[NSString class]] )
		{
			// good
		}
		else if ( [obj isKindOfClass:[NSArray class]] )
		{
			// convert array to string
			obj = [obj componentsJoinedByString:@","];
		}
		else {
			// everything else is unsupported
			NSLog (@ "Inside %@ => %@...Skipping Key[%@] = [%@]...", self, NSStringFromSelector(_cmd), aKey, obj );
			obj = nil;
		}
		
		if ( obj && [obj isKindOfClass:[NSString class]] )
		{
			obj = [obj stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
			[postBody appendData:obj forName:aKey];
		}
		
		
	}
	
	
	// log nsdata to readable string
	NSString* postBodyAsString = [[[NSString alloc] initWithData:postBody encoding:NSUTF8StringEncoding] autorelease];
	NSLog (@ "Inside %@ => %@...Done - returning postBody Data: %@", self, NSStringFromSelector(_cmd), postBodyAsString );
	
	[postBodyAsString writeToFile:@"/postBodyWithOUTImage.txt" atomically:YES encoding:NSUTF8StringEncoding error:nil]; // 2012-10-12steve
	
    
	
	[postBody retain];
	
	[pool release];
	
	return [postBody autorelease];
	
}

-(NSMutableData*) buildCustomPostBodyDataAsXMLData:(id)param	// 2012-10=12steve
{
	NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init];
	
	NSLog (@ "Inside %@ => %@...param = %@", self, NSStringFromSelector(_cmd), param );
	
	
	NSString* xmlDataInfo = nil;
    
	BOOL doTestXmlWriter = YES;
	if ( doTestXmlWriter ) {
		
		// instead of doing a bunch of Content-Disposition: form-data for each key
		// save out to xml data first
		// then just write out ONE single form-data name
		
		
		TepsXmlWriter* xmlWriter = [[TepsXmlWriter alloc] init];
		
		// [xmlWriter doTest];
		
		xmlWriter.mLookupArrayName = [NSMutableDictionary dictionaryWithObjectsAndKeys:@"user",@"userdata",nil];
		
		NSMutableDictionary* param2 = [NSMutableDictionary dictionaryWithCapacity:1]; // 2013-03-20steve
		[param2 setObject:param forKey:@"dictionary"];
		[param2 setObject:@"printstation" forKey:@"mainXmlKeyName"];
		
		// [xmlWriter doStartConversion:[NSMutableDictionary dictionaryWithDictionary:param]];
		
		[xmlWriter doStartConversion2:[NSMutableDictionary dictionaryWithDictionary:param2]];
		
		
		NSLog (@"Final Converted XML is: \n%@", xmlWriter.mString );
		
		if ( xmlWriter.mString==nil ) {
			NSLog (@ "Inside %@ => %@...XML data is NIL ???", self, NSStringFromSelector(_cmd) );
		} else {
			xmlDataInfo = [[NSString alloc] initWithString:xmlWriter.mString];
			
		}
		
		[xmlWriter release];
		xmlWriter = nil;
	}
	
	
	
	NSMutableData *postBody = [NSMutableData dataWithCapacity:0];
	if (postBody && xmlDataInfo ) {
		[postBody appendBoundary];
		[postBody appendData:[xmlDataInfo dataUsingEncoding:NSUTF8StringEncoding] // 2012-10-13steve must encode
					 forName:@"data"	// 2013-03-20steve @"datafile"
					dataType:@"text/xml"];
		
	} else {
		NSLog (@ "Inside %@ => %@...UNABLE to allocate for NSMutableData *postBody ???", self, NSStringFromSelector(_cmd) );
	}
    
	
	
	// log nsdata to readable string
	NSString* postBodyAsString = [[[NSString alloc] initWithData:postBody encoding:NSUTF8StringEncoding] autorelease];
	NSLog (@ "Inside %@ => %@...Done - returning postBody Data: %@", self, NSStringFromSelector(_cmd), postBodyAsString );
	
	[postBodyAsString writeToFile:@"/postBodyWithXMLData.txt" atomically:YES encoding:NSUTF8StringEncoding error:nil];
	
	
	[postBody retain];
	
	[xmlDataInfo release]; // 2012-10-12steve
    
	[pool release];
	
	return [postBody autorelease];
	
}

-(NSMutableData*) buildCustomPostBodyDataAsXMLData3:(id)param	// 2013-03-26steve
{
	NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init];
	
	NSLog (@ "Inside %@ => %@...param = %@", self, NSStringFromSelector(_cmd), param );
	
	id keys = [param objectForKey:@"keys"];
	id mainXmlKeyName = [param objectForKey:@"mainXmlKeyName"];
	if ( mainXmlKeyName==nil ) mainXmlKeyName = @"printstation";
	id attributes = [param objectForKey:@"attributes"];
	
	NSString* xmlDataInfo = nil;
	
	BOOL doTestXmlWriter = YES;
	if ( doTestXmlWriter ) {
		
		// instead of doing a bunch of Content-Disposition: form-data for each key
		// save out to xml data first
		// then just write out ONE single form-data name
		
		TepsXmlWriter* xmlWriter = [[TepsXmlWriter alloc] init];
		
		// [xmlWriter doTest];
		
		xmlWriter.mLookupArrayName = [NSMutableDictionary dictionaryWithObjectsAndKeys:@"user",@"userdata",nil];
		
		NSMutableDictionary* param2 = [NSMutableDictionary dictionaryWithCapacity:1]; // 2013-03-20steve
		[param2 setObject:keys forKey:@"dictionary"];
		[param2 setObject:mainXmlKeyName forKey:@"mainXmlKeyName"];
		if (attributes) [param2 setObject:attributes forKey:@"attributes"];
		
		[xmlWriter doStartConversion3:[NSMutableDictionary dictionaryWithDictionary:param2]];
		
		
		NSLog (@"Final Converted XML is: \n%@", xmlWriter.mString );
		
		if ( xmlWriter.mString==nil ) {
			NSLog (@ "Inside %@ => %@...XML data is NIL ???", self, NSStringFromSelector(_cmd) );
		} else {
			xmlDataInfo = [[NSString alloc] initWithString:xmlWriter.mString];
			
		}
		
		[xmlWriter release];
		xmlWriter = nil;
	}
	
	
	
	NSMutableData *postBody = [NSMutableData dataWithCapacity:0];
	if (postBody && xmlDataInfo ) {
		[postBody appendBoundary];
		[postBody appendData:[xmlDataInfo dataUsingEncoding:NSUTF8StringEncoding] // 2012-10-13steve must encode
					 forName:@"data"	// 2013-03-20steve @"datafile"
					dataType:@"text/xml"];
		
	} else {
		NSLog (@ "Inside %@ => %@...UNABLE to allocate for NSMutableData *postBody ???", self, NSStringFromSelector(_cmd) );
	}
	
	
	
	// log nsdata to readable string
	NSString* postBodyAsString = [[[NSString alloc] initWithData:postBody encoding:NSUTF8StringEncoding] autorelease];
	NSLog (@ "Inside %@ => %@...Done - returning postBody Data: %@", self, NSStringFromSelector(_cmd), postBodyAsString );
	
	[postBodyAsString writeToFile:@"/postBodyWithXMLData.txt" atomically:YES encoding:NSUTF8StringEncoding error:nil];
	
	
	[postBody retain];
	
	[xmlDataInfo release]; // 2012-10-12steve
	
	[pool release];
	
	return [postBody autorelease];
	
}



-(NSMutableData*) buildCustomPostBodyData:(id)info withImagePath:(NSString*)imagePath forKey:(NSString*)imageStringKey
{
	NSLog (@ "Inside %@ => %@...info = %@", self, NSStringFromSelector(_cmd), info );
    
	// build the basic stuff
	NSMutableData *postBody = [self buildCustomPostBodyData:info];
	// postBody = [postBody retain];
	
	// NOT mandatory
	BOOL didAddImage = NO;
	if (postBody && imagePath && imageStringKey)
	{
		didAddImage = [postBody appendImageData2:imagePath forKey:imageStringKey];
		if ( didAddImage==NO )
		{
			NSLog (@ "Inside %@ => %@...Problem with Adding Image Data...", self, NSStringFromSelector(_cmd) );
		}
	}
	else {
		NSLog (@ "Inside %@ => %@...NOT Adding Image...", self, NSStringFromSelector(_cmd) );
	}
	
	
	[postBody writeToFile:@"/postBodyWithImage2.txt" atomically:YES];
	
	
	return postBody;
	
}

// 2011-10-13steve
-(NSMutableData*) buildCustomPostBodyDataAsXMLData:(id)info withImagePath:(NSString*)imagePath forKey:(NSString*)imageStringKey
{
	NSLog (@ "Inside %@ => %@...info = %@", self, NSStringFromSelector(_cmd), info );
	
	// build the basic stuff
	NSMutableData *postBody = [self buildCustomPostBodyDataAsXMLData:info];
	// postBody = [postBody retain];
	
	// NOT mandatory
	BOOL didAddImage = NO;
	if (postBody && imagePath && imageStringKey)
	{
		didAddImage = [postBody appendImageData2:imagePath forKey:imageStringKey];
		if ( didAddImage==NO )
		{
			NSLog (@ "Inside %@ => %@...Problem with Adding Image Data...", self, NSStringFromSelector(_cmd) );
		}
	}
	else {
		NSLog (@ "Inside %@ => %@...NOT Adding Image...", self, NSStringFromSelector(_cmd) );
	}
	
	
	[postBody writeToFile:@"/postBodyWithImageAndXml.txt" atomically:YES];
	
	
	return postBody;
	
}

//-(NSMutableData*) buildAttachmentData:(id)info withImagePath:(NSString*)imagePath forKey:(NSString*)imageStringKey
//{
//	NSLog (@ "Inside %@ => %@...info = %@", self, NSStringFromSelector(_cmd), info );
//
//	// build the basic stuff
//	NSMutableData *postBody = [NSMutableData dataWithLength:0]; //[self buildCustomPostBodyData:info];
//
//	// mandatory
//	BOOL didAddImage = NO;
//	if (postBody && imagePath && imageStringKey)
//	{
//		postBody = [postBody retain];
//		didAddImage = [postBody appendImageData2:imagePath forKey:imageStringKey];
//		if ( didAddImage==NO )
//		{
//			NSLog (@ "Inside %@ => %@...Problem with Adding Image Data...", self, NSStringFromSelector(_cmd) );
//		}
//	}
//	else {
//		NSLog (@ "Inside %@ => %@...NOT Adding Image...", self, NSStringFromSelector(_cmd) );
//	}
//
//
//	[postBody writeToFile:@"/postBodyWithImage2.txt" atomically:YES];
//
//	if ( didAddImage == NO )
//	{
//		[postBody release];
//		postBody = nil;
//	}
//
//	return [postBody autorelease];
//
//}



#pragma mark -

// http://keyservices.phototouchinc.com/index.php?fuseaction=keys.ikey&account=kelloggskrave&code=5EFV-82MG&keypw=merlinw1zard
-(id) addKeysForCheckingPT5Info:(id)info	// 2012-08-30steve
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	NSMutableDictionary* keys = [NSMutableDictionary dictionaryWithCapacity:1];
	[keys setObject:@"keys.ikey" forKey:@"fuseaction"];
	[keys setObject:@"merlinw1zard" forKey:@"keypw"];
	
	// need account and code
	NSString* account = [TepsUrlHandler getCurUserLoginName:(id)nil];
	if ( account==nil ) account = [NSString stringWithString:@"noAccountSpecified"];
	NSString* code = [TepsUrlHandler getCurUserLoginPassword:(id)nil];
	if ( code==nil ) code = [NSString stringWithString:@"noCodeSpecified"];
    
	[keys setObject:account forKey:@"account"];
	[keys setObject:code forKey:@"code"];
    
	
	
	NSMutableDictionary* param = [NSMutableDictionary dictionaryWithDictionary:info];
	[param setObject:keys forKey:@"keys"];
	[param setObject:@"http://keyservices.phototouchinc.com/index.php" forKey:@"baseUrl"];
	return param;
}


-(id) addKeysForCheckingKeysTest:(id)info // 2011-12-20steve THIS IS FORCED TEST VALUES
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
    
	NSMutableDictionary* keys = [NSMutableDictionary dictionaryWithCapacity:1];
	[keys setObject:@"keys.getkey" forKey:@"fuseaction"];
	[keys setObject:@"merlinw1zard" forKey:@"keypw"];
	[keys setObject:@"W8933189644" forKey:@"serno"];
    
    
    //CFStringRef mySerialNumber = CFSTR ("UndeterminedSerialNumber");
    NSString* mySerialNumber = [self serialNumber]; // @"UndeterminedSerialNumber";
    
    NSLog(@"mySerialNumber = %@", mySerialNumber);
    
    if (mySerialNumber) [keys setObject:mySerialNumber forKey:@"serno"];
    
    
	NSMutableDictionary* param = [NSMutableDictionary dictionaryWithDictionary:info];
	[param setObject:keys forKey:@"keys"];
	[param setObject:@"http://keyservices.triprism.com/index.php" forKey:@"baseUrl"];
	[param setObject:@"http://ka.triprism.com/index.php" forKey:@"baseUrl"];
	return param;
    
}

// http://ka.triprism.com new preferred method
-(id) addKeysForCheckingKeysTestKaSite:(id)info // 2014-01-30steve THIS IS FORCED TEST VALUES
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
    
	NSMutableDictionary* keys = [NSMutableDictionary dictionaryWithCapacity:1];
	[keys setObject:@"dff4a59c" forKey:@"keypw"];
	[keys setObject:@"NoSerialNumberFound" forKey:@"serno"];
    
    
    //CFStringRef mySerialNumber = CFSTR ("UndeterminedSerialNumber");
    NSString* mySerialNumber = [self serialNumber]; // @"UndeterminedSerialNumber";
    
    NSLog(@"mySerialNumber = %@", mySerialNumber);
    
    if (mySerialNumber) [keys setObject:mySerialNumber forKey:@"serno"];
    
    
	NSMutableDictionary* param = [NSMutableDictionary dictionaryWithDictionary:info];
	[param setObject:keys forKey:@"keys"];
	[param setObject:@"http://ka.triprism.com/keys/getkey" forKey:@"baseUrl"];
	return param;
    
}

// 2014-08-11steve - back to old method to check for valid key like bamboo does
// http://keyservices.triprism.com/?fuseaction=keys.getkey&keypw=merlinw1zard&apptype=bamboo&serno=C02LLAKXFD59
-(id) addKeysForCheckingKeySiteWithAppType:(id)info // 2014-01-30steve THIS IS FORCED TEST VALUES
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
    
    NSString* apptype = @"tepsvideo";
    
	NSMutableDictionary* keys = [NSMutableDictionary dictionaryWithCapacity:1];
	[keys setObject:@"merlinw1zard" forKey:@"keypw"];
	[keys setObject:@"NoSerialNumberFound" forKey:@"serno"];
    
    
    //CFStringRef mySerialNumber = CFSTR ("UndeterminedSerialNumber");
    NSString* mySerialNumber = [self serialNumber]; // @"UndeterminedSerialNumber";
    NSLog(@"mySerialNumber = %@", mySerialNumber);
    
    if (mySerialNumber) [keys setObject:mySerialNumber forKey:@"serno"];
    
    [keys setObject:apptype forKey:@"apptype"]; // 2014-08-11steve
    
	NSMutableDictionary* param = [NSMutableDictionary dictionaryWithDictionary:info];
    
    BOOL oldway = NO; // 2014-08-11steve
    if (oldway) {
        [param setObject:keys forKey:@"keys"];
        [param setObject:@"http://ka.triprism.com/keys/getkey" forKey:@"baseUrl"];
    } else {
        
        NSString* urlstring = [NSString stringWithFormat:@"http://keyservices.triprism.com/?fuseaction=keys.getkey&keypw=merlinw1zard&apptype=%@&serno=%@",apptype, mySerialNumber];
        [param setObject:urlstring forKey:@"baseUrl"];
        
    }
    
	return param;
    
}




#pragma mark -


-(id) addKeysForFyp4SiteTest:(id)info // THIS IS FORCED TEST VALUES
{
	// build the keys
	NSMutableDictionary* keys = [NSMutableDictionary dictionaryWithCapacity:1];
	[keys setObject:@"upload.upload" forKey:@"fuseaction"];
	[keys setObject:@"testing" forKey:@"username"];
	[keys setObject:@"wizards" forKey:@"password"];
	[keys setObject:@"steveOffice" forKey:@"event"];
	[keys setObject:@"steveClient" forKey:@"client"];
	
	// setup return param
	NSMutableDictionary* param = [NSMutableDictionary dictionaryWithDictionary:info];
	[param setObject:keys forKey:@"keys"];
	[param setObject:@"http://keyservices.triprism.com/index.php" forKey:@"baseUrl"];
	
	return param;
}

// 2011-10-12steve - WE NEED TO UPLOAD HI RES IMAGES!!!!! for MACYS
-(id) addKeysForTransitUploadTest:(id)info // 2011-10-24steve THIS WAS FORCED TESTING
{
	// build the keys - FORCED for now
	NSMutableDictionary* keys = [NSMutableDictionary dictionaryWithCapacity:1];
	
	// 2012-05-22steve [keys setObject:@"upload.transit" forKey:@"f"];
	[keys setObject:@"transit.upload" forKey:@"fuseaction"]; // 2012-05-22steve
    
	[keys setObject:@"freezeframe" forKey:@"username"];
	[keys setObject:@"4205l9fl" forKey:@"password"];
	[keys setObject:@"abc123" forKey:@"groupcode"];
	[keys setObject:@"111111" forKey:@"ticketnumber"];
	
	// setup return param
	NSMutableDictionary* param = [NSMutableDictionary dictionaryWithDictionary:info];
	[param setObject:keys forKey:@"keys"];
	
	// 2012-05-22steve [param setObject:@"http://macys.transit.triprism.com/index.php" forKey:@"baseUrl"];
	[param setObject:@"http://upload.triprism.com/index.php" forKey:@"baseUrl"]; // 2012-05-22steve
	
	return param;
}

#pragma mark -


-(id) addKeysForNoerrEmailUpload:(id)info
{
	NSLog (@ "Inside %@ => %@...info=%@", self, NSStringFromSelector(_cmd),info );
    
	id telstraInfo = [info objectForKey:@"edTelstraInfo"];
	NSLog (@ "Inside %@ => %@...telstraInfo=%@", self, NSStringFromSelector(_cmd),telstraInfo );
	
	id customFuseAction = [telstraInfo objectForKey:@"prefCustomFuseAction"];
	id emails = [telstraInfo objectForKey:@"emails"];
	id customerId = [telstraInfo objectForKey:@"prefCustomerIdKey"];
	id email = [telstraInfo objectForKey:@"email"]; // 2012-09-27steve
	
    //	if (emails==nil || customerId==nil )
	if ( (emails==nil & email==nil)   || customerId==nil )
	{
		NSLog (@ "Inside %@ => %@...Emails and CustomerID REQUIRED... customerId=[%@] and emails=[%@]", self, NSStringFromSelector(_cmd),customerId, emails ); // 2011-10-14steve
		return nil;
        
	}
	
	if ( emails==nil && email ) // 2012-09-27steve
		emails = [NSString stringWithString:email];
	
	
	customFuseAction = [NSString stringWithString:@"customapps.noerr"]; // 2012-09-27steve
	
	
	NSString* fuseActionString = [NSString stringWithString:customFuseAction]; //  [NSString stringWithString:@"customapps.noerr"];
	NSString* photographer = [NSString stringWithString:[info objectForKey:@"edUser"]]; // [NSString stringWithString:@"noerrprograms"];
	NSString* password = [NSString stringWithString:[info objectForKey:@"edPasswd"]];	// [NSString stringWithString:@"5unFl0w3r"];
	NSString* locationString = [NSString stringWithString:[info objectForKey:@"edEventName"]]; // [NSString stringWithString:@"steveoffice"]; // each mall location = event
    
	
	// build the keys
	NSMutableDictionary* keys = [NSMutableDictionary dictionaryWithCapacity:1];
	[keys setObject:fuseActionString forKey:@"fuseaction"];
	[keys setObject:photographer forKey:@"photographer"];
	[keys setObject:password forKey:@"password"];
	[keys setObject:locationString forKey:@"event"];
	[keys setObject:customerId forKey:@"client"];
	[keys setObject:emails forKey:@"emails"];
	
	// setup return param
	NSMutableDictionary* param = [NSMutableDictionary dictionaryWithDictionary:info];
	[param setObject:keys forKey:@"keys"];
	[param setObject:[NSNumber numberWithBool:YES] forKey:@"doNotUploadImage"];
    
	[param setObject:@"http://keyservices.triprism.com/index.php" forKey:@"baseUrl"];
    
	// 2012-02-21steve
	id factoryBaseUrl = [TepsUrlHandler getPrefFypURL]; // 2012-02-21steve
	if ( factoryBaseUrl ) [param setObject:factoryBaseUrl forKey:@"baseUrl"]; // 2012-02-21steve
    
	NSLog ( @"2012-09-27steve final param = %@", param ); // 2012-09-27steve
	
	return param;
}


-(id) addKeysForPT5Site:(id)info // 2011-10-11steve
{
	id pt5Info = [info objectForKey:@"edTelstraInfo"];
	
	NSLog ( @"2012-03-21steve pt5Info = %@", pt5Info ); // 2012-03-21steve
    
	id customFuseAction = [pt5Info objectForKey:@"prefCustomFuseAction"];
	id emails = [pt5Info objectForKey:@"emails"];
	id customerId = [pt5Info objectForKey:@"prefCustomerIdKey"];
	id email = [pt5Info objectForKey:@"email"];
	
	id code = [pt5Info objectForKey:@"code"]; // 2012-04-20steve
	id account = [pt5Info objectForKey:@"account"]; // 2012-04-20steve
	
	
	NSMutableArray* emailArray = [NSMutableArray arrayWithCapacity:1]; // 2012-03-21steve
	if ( emails ) [emailArray addObjectsFromArray:emails];
	if ( email ) [emailArray addObject:email];
	NSLog ( @"2012-03-21steve emailArray = %@", emailArray ); // 2012-03-21steve
    
	
	if (customerId==nil )
	{
		NSLog (@ "Inside %@ => %@...customerId is REQUIRED but is NIL??????", self, NSStringFromSelector(_cmd) ); // 2011-10-14steve
		return nil;
		
	}
	
	NSString* fuseActionString = [NSString stringWithString:customFuseAction]; //  [NSString stringWithString:@"customapps.noerr"];
	NSString* photographer = [NSString stringWithString:[info objectForKey:@"edUser"]]; // [NSString stringWithString:@"noerrprograms"];
	NSString* password = [NSString stringWithString:[info objectForKey:@"edPasswd"]];	// [NSString stringWithString:@"5unFl0w3r"];
	NSString* locationString = [NSString stringWithString:[info objectForKey:@"edEventName"]]; // [NSString stringWithString:@"steveoffice"]; // each mall location = event
	
	
	
	if (code) { // 2012-04-20steve
		NSLog (@"2012-04-20steve OVER-RIDE the password with locationCode = [%@]", code );
		password = [NSString stringWithString:code]; // 2012-04-20steve
	}
	if (account) { // 2012-04-20steve
		NSLog (@"2012-04-20steve OVER-RIDE the username with account = [%@]", account );
		photographer = [NSString stringWithString:account];
	}
	
	
	
	// build the keys
	NSMutableDictionary* keys = [NSMutableDictionary dictionaryWithCapacity:1];
	[keys setObject:fuseActionString forKey:@"fuseaction"];
	[keys setObject:photographer forKey:@"account"];	// 2011-10-12steve photographer in the UI
	[keys setObject:password forKey:@"code"];	// 2011-10-12steve password in the UI
	if (locationString) [keys setObject:locationString forKey:@"event"]; // PT5 doesnt care about this
	[keys setObject:customerId forKey:@"ids"];	// 2011-10-12steve photographer in the UI
    
	// 2012-03-21steve if (emails) [keys setObject:emails forKey:@"emails"];
	if (emailArray) [keys setObject:emailArray forKey:@"emails"]; // 2012-03-21steve
	
	
	// setup return param
	NSMutableDictionary* param = [NSMutableDictionary dictionaryWithDictionary:info];
	[param setObject:keys forKey:@"keys"];
	[param setObject:@"http://keyservices.phototouchinc.com/index.php" forKey:@"baseUrl"];
	
	
	NSLog ( @"2012-03-21steve final param = %@", param ); // 2012-03-21steve
    
	return param;
}


-(id) addKeysForTransitSite:(id)info // 2011-10-24steve
{
	id uploadInfo = [info objectForKey:@"uploadInfo"];
	
    // 2011-12-14steve	id customFuseAction = [uploadInfo objectForKey:@"f"];	// upload.transit???? maybe we want it to be "macys.transit"
	id groupCode = [uploadInfo objectForKey:@"groupCode"];
	id ticketNumber = [uploadInfo objectForKey:@"ticketNumber"];
	
	
	if (groupCode==nil )
	{
		NSLog (@ "Inside %@ => %@...groupcode is REQUIRED but is NIL??????", self, NSStringFromSelector(_cmd) ); // 2011-10-14steve
		return nil;
	}
	if (ticketNumber==nil )
	{
		NSLog (@ "Inside %@ => %@...ticketnumber is REQUIRED but is NIL??????", self, NSStringFromSelector(_cmd) ); // 2011-10-14steve
		return nil;
	}
	
    // 2011-12-14steve	NSString* fuseActionString = [NSString stringWithString:customFuseAction]; //  [NSString stringWithString:@"customapps.noerr"];
	NSString* username = [NSString stringWithString:[info objectForKey:@"edUser"]]; // [NSString stringWithString:@"noerrprograms"];
	NSString* password = [NSString stringWithString:[info objectForKey:@"edPasswd"]];	// [NSString stringWithString:@"5unFl0w3r"];
	
    //	[keys setObject:@"upload.transit" forKey:@"f"];
    //	[keys setObject:@"freezeframe" forKey:@"username"];
    //	[keys setObject:@"4205l9fl" forKey:@"password"];
    //	[keys setObject:@"abc123" forKey:@"groupcode"];
    //	[keys setObject:@"111111" forKey:@"ticketnumber"];
	
	// build the keys
	NSMutableDictionary* keys = [NSMutableDictionary dictionaryWithCapacity:1];
	
	// 2012-05-22steve [keys setObject:@"upload.transit" forKey:@"f"];
	[keys setObject:@"transit.upload" forKey:@"fuseaction"]; // 2012-05-22steve
    
	[keys setObject:username forKey:@"username"];
	[keys setObject:password forKey:@"password"];
	[keys setObject:[NSString stringWithString:groupCode] forKey:@"groupcode"];
	[keys setObject:[NSString stringWithString:ticketNumber] forKey:@"ticketnumber"]; // 2011-10-25steve remove hardcoded 666600
    
	
	// setup return param
	NSMutableDictionary* param = [NSMutableDictionary dictionaryWithDictionary:info];
	[param setObject:keys forKey:@"keys"];
    
	// 2012-05-22steve [param setObject:@"http://macys.transit.triprism.com/index.php" forKey:@"baseUrl"];
	[param setObject:@"http://upload.triprism.com/index.php" forKey:@"baseUrl"]; // 2012-05-22steve
	
	//[param setObject:@"http://transit.triprism.com/index.php" forKey:@"baseUrl"]; // 2011-11-09steve DEBUG
	
	return param;
}


-(id) addKeysForNormalFYP4Site:(id)info // 2011-12-06steve
{
	/* return NIL???
     
     id uploadInfo = [info objectForKey:@"uploadInfo"];
     if ( uploadInfo ) {
     // this is where teps wrote the @"uploadInfo" dictionary to denote NEW implementation
     // where we MUST know in advance which site to upload
     NSLog ( @"2012-09-26steve uploadInfo contains: %@", uploadInfo );
     NSLog ( @"2012-09-26steve ==========================================" );
     
     
     // sample of new subdictionary @"uploadInfo"
     //
     //		OriginalPath = "/Users/Edwin/Desktop/Havisupai%20%C4/IMG_7545.jpg";
     //		Version = "1.0.2";
     //		email = "edwin@triprism.com";
     //		f = fyp;
     
     //		// we need to create UI or pref so the single uploader app will know the
     //		// credentials for both sites
     //		[info setObject:@"upload.upload" forKey:@"edFypFuseAction"];
     //		[info setObject:@"benihana" forKey:@"edUser"];
     //		[info setObject:@"sm00th13" forKey:@"edPasswd"]; // for steve
     //		[info setObject:@"steveTest" forKey:@"edEventName"];
     
     
     [info setObject:@"upload.upload" forKey:@"edFypFuseAction"]; // 2012-09-27steve
     
     // MUST HAVE THESE THREE ITEMS !!!!
     [info setObject:@"noAccountSpecified" forKey:@"edUser"];
     [info setObject:@"noCodeSpecified" forKey:@"edPasswd"]; // for steve
     [info setObject:@"" forKey:@"edEventName"];
     
     
     id user = [[NSUserDefaults standardUserDefaults] objectForKey:sPrefUserLoginNameFYP];
     id code = [[NSUserDefaults standardUserDefaults] objectForKey:sPrefUserLoginPasswordFYP];
     id event = [[NSUserDefaults standardUserDefaults] objectForKey:sPrefUserEnteredEventNameFYP];
     if ( user ) user = [user stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
     if ( code ) code = [code stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
     if ( event ) event = [event stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
     
     if ( user && [user length]==0 ) user = nil;
     if ( code && [code length]==0 ) code = nil;
     if ( event && [event length]==0 ) event = nil;
     
     if ( user==nil || code==nil || event ) {
     
     NSLog ( @"2012-09-26steve - either account and/or code and/or event is missing???" );
     }
     
     if (user) [info setObject:user forKey:@"edUser"];
     if (code) [info setObject:code forKey:@"edPasswd"];
     if (event) [info setObject:event forKey:@"edEventName"];
     
     
     
     id tempObj = [uploadInfo objectForKey:@"OriginalPath"];
     if ( tempObj ) [info setObject:tempObj forKey:@"edOriginalPath"];
     
     tempObj = [uploadInfo objectForKey:@"email"];
     // if ( tempObj ) [info setObject:@"schua.home@gmail.com" forKey:@"edEmails"]; // 2012-09-26steve  <<=== DO NOT HARD CODE
     if ( tempObj ) [info setObject:tempObj forKey:@"edEmails"]; // 2012-09-29steve
     
     NSLog ( @"2012-09-26steve translated info for FYP: %@",info );
     
     //return nil;
     }
     
     
     
     
     // REQUIRED
     NSString* edFypFuseAction = [NSString stringWithString:[info objectForKey:@"edFypFuseAction"]];
     NSString* edUser = [NSString stringWithString:[info objectForKey:@"edUser"]];
     NSString* edPasswd = [NSString stringWithString:[info objectForKey:@"edPasswd"]];
     NSString* edClientName = [NSString stringWithString:[info objectForKey:@"edClientName"]];
     NSString* edEventName = [NSString stringWithString:[info objectForKey:@"edEventName"]];
     // 2011-12-14steve	NSString* edFileName = [NSString stringWithString:[info objectForKey:@"edFileName"]];
     
     
     // build the keys
     NSMutableDictionary* keys = [NSMutableDictionary dictionaryWithCapacity:1];
     
     // Required
     if (edFypFuseAction) [keys setObject:edFypFuseAction forKey:@"fuseaction"];
     if (edUser) [keys setObject:edUser forKey:@"username"];
     if (edPasswd) [keys setObject:edPasswd forKey:@"password"];
     if (edEventName) [keys setObject:edEventName forKey:@"event"];
     if (edClientName) [keys setObject:edClientName forKey:@"client"];
     
     // 2012-06-22steve
     if ( [edFypFuseAction caseInsensitiveCompare:@"upload.pt5"]==NSOrderedSame ) {
     if (edUser) [keys setObject:edUser forKey:@"account"]; // if upload.pt5
     if (edPasswd) [keys setObject:edPasswd forKey:@"code"]; // if upload.pt5
     if (edClientName) [keys setObject:edClientName forKey:@"ids"]; // if upload.pt5
     
     }
     
     
     // OPTIONALS
     id optionalObj = nil;
     
     optionalObj = [info objectForKey:@"edOriginalPath"];
     if ( optionalObj ) [keys setObject:optionalObj forKey:@"localfilelocation"];
     
     optionalObj = [info objectForKey:@"edMetaData"];
     if ( optionalObj ) [keys setObject:optionalObj forKey:@"metadata"];
     
     optionalObj = [info objectForKey:@"edCaptureTime"];
     if ( optionalObj ) [keys setObject:optionalObj forKey:@"capturetime"];
     
     optionalObj = [info objectForKey:@"edEmails"];
     if ( optionalObj ) [keys setObject:optionalObj forKey:@"emails"];
     
     
     // Obsolete Optionals - that were used for custom sites like ncaa, old stb, meadowlands
     optionalObj = [info objectForKey:@"edTelstraInfo"]; // old stb - before having the separate app for emailer
     if ( optionalObj ) {
     NSLog (@"2011-12-06steve!!!!!!!!!!! SHOULD NOT BE HANDLING edTelstraInfo here: %@",optionalObj );
     }
     optionalObj = [info objectForKey:@"edSittingInfoDictionary"];	// meadowlands
     if ( optionalObj ) {
     NSLog (@"2011-12-06steve!!!!!!!!!!! SHOULD NOT BE HANDLING edSittingInfoDictionary here: %@",optionalObj );
     }
     optionalObj = [info objectForKey:@"edKioskStation"]; // ncaa/meadowlands onlocation for registration/sign-in/camera
     if ( optionalObj ) {
     NSLog (@"2011-12-06steve!!!!!!!!!!! SHOULD NOT BE HANDLING edKioskStation here: %@",optionalObj );
     }
     optionalObj = [info objectForKey:@"edMuxedMovieName"]; // ncaa movie
     if ( optionalObj ) {
     NSLog (@"2011-12-06steve!!!!!!!!!!! SHOULD NOT BE HANDLING edMuxedMovieName here: %@",optionalObj );
     }
     
     
     // setup return param
     NSMutableDictionary* param = [NSMutableDictionary dictionaryWithDictionary:info];
     [param setObject:keys forKey:@"keys"];
     [param setObject:@"http://keyservices.triprism.com/index.php" forKey:@"baseUrl"];
     id factoryBaseUrl = [Preferences getPrefFypURL]; // 2011-12-12steve [[NSUserDefaults standardUserDefaults] stringForKey:sPrefFypURL]; // 2011-12-08steve
     if ( factoryBaseUrl ) [param setObject:factoryBaseUrl forKey:@"baseUrl"]; // 2011-12-08steve
     
     
     
     #ifdef USE_DEBUG_URL
     // 2011-12-07steve
     //
     // @"prefFypURL"
     // @"prefFypURLDebugInternal"
     // @"prefFypURLDebugExternal"
     //
     id tpiUrl = nil; // [[NSUserDefaults standardUserDefaults] objectForKey:sPrefFypURL];
     if ( tpiUrl ) {
     NSLog ( @"2011-12-07steve - DEBUGGGGGGGGGGG SETTING baseURL to [%@]...", tpiUrl );
     [param setObject:tpiUrl forKey:@"baseUrl"];
     }
     
     id debugAction = nil; // [[NSUserDefaults standardUserDefaults] objectForKey:sPrefFypFuseAction];
     if ( debugAction )
     {
     [keys setObject:debugAction forKey:@"fuseaction"];
     }
     
     #endif
     
     
     return param;
     
     */
	
}


// 2012-10-12steve
// this is similar to how we upload the new method in the iPhone PhotoTouch+ app
//
//	account = apothic;
//	locationid = "8APQ-U5JY";
//	keypw = ec2a0fa9;
//	code = "schua.home@gmail.com";
//	email = "schua.home@gmail.com";
//	name = noname;
//	userdata =     (
//					{
//						dob = 00000000;
//						email = "schua.home@gmail.com";
//						name = noname;
//					}
//					);

// on entry - we get the oldKeys =
//		account = phototouch;
//		capturetime = "2012-10-11 17:42:48";
//		client = 5555steve;
//		code = "FK1D-XRIE";
//		event = "";
//		fuseaction = "upload.pt5";
//		ids = 5555steve;
//		localfilelocation = "/Macys%20Test/MAIN%20IMAGES%20FOLDER%20%C4/10-11-2012/5555_1.jpg";
//		metadata = "From Teps-HttpUploader";
//		password = "FK1D-XRIE";
//		username = phototouch;

-(id) translateKeysForXML:(id)info // 2012-10-12steve
{
	NSLog (@ "Inside %@ => %@...with info = %@", [self class], NSStringFromSelector(_cmd), info );
    
	[info setObject:[NSNumber numberWithBool:YES] forKey:@"doXmlMethod"]; // 2012-10-13steve
	[info setObject:@"http://upload.phototouchinc.com/upload/" forKey:@"baseUrl"];
	
	
	NSMutableDictionary* newKeys = nil;
	NSMutableDictionary* oldKeys = [info objectForKey:@"keys"];
	if ( oldKeys ) {
		newKeys = [NSMutableDictionary dictionaryWithDictionary:oldKeys];
	}
	
	[newKeys setObject:@"ec2a0fa9" forKey:@"keypw"];
	[newKeys setObject:@"Teps-HttpUploader xml" forKey:@"metadata"];
    
	
	
	id groupcode = nil;
	id ticketnumber = nil;
	id uploadInfo = [info objectForKey:@"uploadInfo"];
	if ( uploadInfo ) {
		groupcode = [uploadInfo objectForKey:@"groupCode"];
		ticketnumber = [uploadInfo objectForKey:@"ticketNumber"];
	}
	
	if (groupcode) {
		[newKeys setObject:groupcode forKey:@"groupcode"];
		[newKeys setObject:groupcode forKey:@"code"];
	} else {
		// use the basename of the file as the code
		// translate client => code
		id client = [oldKeys objectForKey:@"client"];
		if (client) [newKeys setObject:client forKey:@"code"];
	}
	if (ticketnumber) [newKeys setObject:ticketnumber forKey:@"ticketnumber"];
    
	// translate code FIRST!!!!!! before destroying later
	// translate code => locationid
	id password = [oldKeys objectForKey:@"password"];
	if (password) [newKeys setObject:password forKey:@"locationid"];
    
	
	// 2012-10-13steve - force some keys - to see why not uploading
    // 2012-12-18steve remove debug	[newKeys setObject:@"forcedEmail@triprism.com" forKey:@"email"]; // 2012-10-13steve
    // 2012-12-18steve remove debug	[newKeys setObject:@"forcedName" forKey:@"name"]; // 2012-10-13steve
	// NSDictionary* user = [NSDictionary dictionaryWithObjectsAndKeys:@"00000000",@"dob",@"noname",@"name",@"forcedEmail@triprism.com",@"email",nil];
    
	// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	// 2012-12-18steve -
	// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	// for some reason - todd only checks for SINGULAR key = @"email" SINGULAR not @"emails"
	// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	id emails = [newKeys objectForKey:@"emails"]; // 2012-12-18steve
	if ( emails )
		[newKeys setObject:emails forKey:@"email"];
	
	
	NSDictionary* userdata = nil;
	if ( groupcode || ticketnumber ) {
		NSMutableDictionary* user = [NSMutableDictionary dictionaryWithCapacity:1];
		if (groupcode) [user setObject:groupcode forKey:@"groupcode"];
		if (ticketnumber) [user setObject:ticketnumber forKey:@"ticketnumber"];
		
		if ( [user count] )
			userdata = [NSDictionary dictionaryWithObjectsAndKeys:user,@"user",nil];
	}
    
	if ( userdata) // 2012-12-06steve
		[newKeys setObject:userdata forKey:@"userdata"];
	
	// remove unwanted stuff
	[newKeys removeObjectForKey:@"event"];
	[newKeys removeObjectForKey:@"fuseaction"];
	[newKeys removeObjectForKey:@"ids"];
	[newKeys removeObjectForKey:@"password"];
	[newKeys removeObjectForKey:@"username"];
	[newKeys removeObjectForKey:@"event"];
	[newKeys removeObjectForKey:@"client"];
	
	// replace keys with our newly translated keys for xml
	[info setObject:newKeys forKey:@"keys"];
	
	NSLog (@ "Inside %@ => %@... newKey = %@", [self class], NSStringFromSelector(_cmd), newKeys );
	NSLog (@ "Inside %@ => %@...returning translated info = %@", [self class], NSStringFromSelector(_cmd), info );
    
	return info;
	
}

-(id) addKeysForNormalPT5Site:(id)info // 2012-09-26steve - just uploading normal photo to PT5 site
{
	/* return NIL
	 
     id uploadInfo = [info objectForKey:@"uploadInfo"]; // 2012-09-26steve
     if ( uploadInfo ) {
     // this is where teps wrote the @"uploadInfo" dictionary to denote NEW implementation
     // where we MUST know in advance which site to upload
     NSLog ( @"2012-09-26steve uploadInfo contains: %@", uploadInfo );
     NSLog ( @"2012-09-26steve ==========================================" );
     
     
     // sample of new subdictionary @"uploadInfo"
     //
     //		OriginalPath = "/Users/Edwin/Desktop/Havisupai%20%C4/IMG_7545.jpg";
     //		Version = "1.0.2";
     //		email = "edwin@triprism.com";
     //		f = pt5;
     
     //2012-10-12steve -
     //
     // if the uploadInfo contains
     // @"groupCode" or @"ticketNumber"
     // then we need to use the new XML method
     
     
     
     // we need to create UI or pref so the single uploader app will know the
     // credentials for both sites
     [info setObject:@"upload.pt5" forKey:@"edFypFuseAction"];
     [info setObject:@"noAccountSpecified" forKey:@"edUser"];
     [info setObject:@"noCodeSpecified" forKey:@"edPasswd"]; // for steve
     [info setObject:@"" forKey:@"edEventName"];
     
     
     id user = [[NSUserDefaults standardUserDefaults] objectForKey:sPrefUserLoginNamePT5];
     id code = [[NSUserDefaults standardUserDefaults] objectForKey:sPrefUserLoginPasswordPT5];
     id event = [[NSUserDefaults standardUserDefaults] objectForKey:sPrefUserEnteredEventNamePT5];
     if ( user ) user = [user stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
     if ( code ) code = [code stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
     if ( event ) event = [event stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
     
     if ( user && [user length]==0 ) user = nil;
     if ( code && [code length]==0 ) code = nil;
     if ( event && [event length]==0 ) event = nil;
     
     if ( user==nil || code==nil ) {
     
     NSLog ( @"2012-09-26steve - either account or code is missing???" );
     }
     
     if (user) [info setObject:user forKey:@"edUser"];
     if (code) [info setObject:code forKey:@"edPasswd"];
     if (event) [info setObject:event forKey:@"edEventName"];
     
     
     id tempObj = [uploadInfo objectForKey:@"OriginalPath"];
     if ( tempObj ) [info setObject:tempObj forKey:@"edOriginalPath"];
     
     tempObj = [uploadInfo objectForKey:@"email"];
     // 2012-09-29steve if ( tempObj ) [info setObject:@"schua.home@gmail.com" forKey:@"edEmails"]; // 2012-09-26steve  <<=== DO NOT HARD CODE
     if ( tempObj ) [info setObject:tempObj forKey:@"edEmails"]; // 2012-09-29steve
     
     NSLog ( @"2012-09-26steve translated info for PT5: %@",info );
     
     //return nil;
     }
     
     
     
     
     // REQUIRED
     NSString* edFypFuseAction = [NSString stringWithString:[info objectForKey:@"edFypFuseAction"]];
     NSString* edUser = [NSString stringWithString:[info objectForKey:@"edUser"]];
     NSString* edPasswd = [NSString stringWithString:[info objectForKey:@"edPasswd"]];
     NSString* edClientName = [NSString stringWithString:[info objectForKey:@"edClientName"]];
     NSString* edEventName = [NSString stringWithString:[info objectForKey:@"edEventName"]];
     // 2011-12-14steve	NSString* edFileName = [NSString stringWithString:[info objectForKey:@"edFileName"]];
     
     
     // build the keys
     NSMutableDictionary* keys = [NSMutableDictionary dictionaryWithCapacity:1];
     
     // Required
     if (edFypFuseAction) [keys setObject:edFypFuseAction forKey:@"fuseaction"];
     if (edUser) [keys setObject:edUser forKey:@"username"];
     if (edPasswd) [keys setObject:edPasswd forKey:@"password"];
     if (edEventName) [keys setObject:edEventName forKey:@"event"];
     if (edClientName) [keys setObject:edClientName forKey:@"client"];
     
     // 2012-06-22steve
     if ( [edFypFuseAction caseInsensitiveCompare:@"upload.pt5"]==NSOrderedSame ) {
     if (edUser) [keys setObject:edUser forKey:@"account"]; // if upload.pt5
     if (edPasswd) [keys setObject:edPasswd forKey:@"code"]; // if upload.pt5
     if (edClientName) [keys setObject:edClientName forKey:@"ids"]; // if upload.pt5
     
     }
     
     
     // OPTIONALS
     id optionalObj = nil;
     
     optionalObj = [info objectForKey:@"edOriginalPath"];
     if ( optionalObj ) [keys setObject:optionalObj forKey:@"localfilelocation"];
     
     optionalObj = [info objectForKey:@"edMetaData"];
     if ( optionalObj ) [keys setObject:optionalObj forKey:@"metadata"];
     
     optionalObj = [info objectForKey:@"edCaptureTime"];
     if ( optionalObj ) [keys setObject:optionalObj forKey:@"capturetime"];
     
     optionalObj = [info objectForKey:@"edEmails"];
     if ( optionalObj ) [keys setObject:optionalObj forKey:@"emails"];
     
     
     // Obsolete Optionals - that were used for custom sites like ncaa, old stb, meadowlands
     optionalObj = [info objectForKey:@"edTelstraInfo"]; // old stb - before having the separate app for emailer
     if ( optionalObj ) {
     NSLog (@"2011-12-06steve!!!!!!!!!!! SHOULD NOT BE HANDLING edTelstraInfo here: %@",optionalObj );
     }
     optionalObj = [info objectForKey:@"edSittingInfoDictionary"];	// meadowlands
     if ( optionalObj ) {
     NSLog (@"2011-12-06steve!!!!!!!!!!! SHOULD NOT BE HANDLING edSittingInfoDictionary here: %@",optionalObj );
     }
     optionalObj = [info objectForKey:@"edKioskStation"]; // ncaa/meadowlands onlocation for registration/sign-in/camera
     if ( optionalObj ) {
     NSLog (@"2011-12-06steve!!!!!!!!!!! SHOULD NOT BE HANDLING edKioskStation here: %@",optionalObj );
     }
     optionalObj = [info objectForKey:@"edMuxedMovieName"]; // ncaa movie
     if ( optionalObj ) {
     NSLog (@"2011-12-06steve!!!!!!!!!!! SHOULD NOT BE HANDLING edMuxedMovieName here: %@",optionalObj );
     }
     
     
     // setup return param
     NSMutableDictionary* param = [NSMutableDictionary dictionaryWithDictionary:info];
     [param setObject:keys forKey:@"keys"];
     [param setObject:@"http://keyservices.phototouchinc.com/index.php" forKey:@"baseUrl"];
     // 2012-09-26 - here is where we need to add code to get info FROM preferences
     
     
     
     // 2012-10-12steve - translate keys for new XML method if needed
     if ( uploadInfo ) { // 2012-10-12steve
     id groupCode = [uploadInfo objectForKey:@"groupCode"];
     id ticketNumber = [uploadInfo objectForKey:@"ticketNumber"];
     if ( groupCode || ticketNumber ) {
     return [self translateKeysForXML:param];
     }
     else {
     // 2012-12-06steve - we always want to use the new xml method
     NSLog (@"2012-12-06 Always Upload to upload.phototouchinc.com method...");
     return [self translateKeysForXML:param];
     }
     }
     
     
     
     NSLog (@"2012-09-26steve...returning param: %@", param );
     
     return param;
     */
	
	return nil;
}



#pragma mark -

//id telstraInfo = [info objectForKey:@"edTelstraInfo"];
//id customFuseAction = [telstraInfo objectForKey:@"prefCustomFuseAction"];
//id emails = [telstraInfo objectForKey:@"emails"];
//id customerId = [telstraInfo objectForKey:@"prefCustomerIdKey"];
//NSString *phpCommandFormat = @"%@?fuseaction=%@&photographer=%@&password=%@&event=%@&client=%@&emails=%@";

// @"baseUrl"
// @"keys"
-(id) buildURLRequestString:(id)info
{
    
	// build the string
	NSString* customUrlString = [self buildCustomURLString:info];
	
	if ( customUrlString==nil)
	{
		return nil;
	}
	
	// build url
	NSURL *url = [NSURL URLWithString:customUrlString];
	if ( url == nil )
	{
		return nil;
	}
	
	NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:url
														   cachePolicy:NSURLRequestReloadIgnoringCacheData
													   timeoutInterval:[TepsUrlHandler getURLRequestTimeout]]; // 2011-12-17steve
    
	return request;
	
}



-(id) buildURLRequestPostForm:(id)param
{
	NSLog (@ "Inside %@ => %@...param=%@", self, NSStringFromSelector(_cmd),param );
	
	BOOL doNotUploadImage = [[param objectForKey:@"doNotUploadImage"] boolValue];
	id baseUrl = [param objectForKey:@"baseUrl"];
	id imagePath = [param objectForKey:@"edFileName"];
	id keys = [param objectForKey:@"keys"];
    
	BOOL doXmlMethod = NO; // 2012-10-13steve
	id obj = [param objectForKey:@"doXmlMethod"];
	if ( obj && [obj isKindOfClass:[NSNumber class]] )
		doXmlMethod = [obj boolValue];
	
    
	if ( baseUrl==nil )
	{
		return nil;
	}
	if ( imagePath==nil && !doNotUploadImage )
	{
		return nil;
	}
	if ( keys==nil )
	{
		return nil;
	}
	
	// override baseUrl
	//baseUrl = [NSString stringWithFormat:@"http://transit.triprism.com/index.php?password=4205l9fl&username=freezeframe&groupcode=abc123&ticketnumber=111111&f=upload.transit"];
	//baseUrl = [NSString stringWithFormat:@"http://keyservices.triprism.com/index.php"];
	
	NSURL *cgiUrl = [NSURL URLWithString:baseUrl];
	
    //	NSMutableURLRequest *postRequest = [NSMutableURLRequest requestWithURL:cgiUrl
    //															   cachePolicy:NSURLRequestReloadIgnoringCacheData
    //														   timeoutInterval:sDefaultRequestTimeOutInSeconds];
	NSMutableURLRequest *postRequest = [NSMutableURLRequest requestWithURL:cgiUrl
															   cachePolicy:NSURLRequestReloadIgnoringCacheData
														   timeoutInterval:[TepsUrlHandler getURLRequestTimeout]]; // 2011-12-17steve
	
	//adding header information:
	[postRequest setHTTPMethod:@"POST"];
	
	// add Content-Type
	NSString *contentType = [NSString stringWithFormat:@"multipart/form-data; boundary=%@",cTepsBoundaryString];
	[postRequest addValue:contentType forHTTPHeaderField: @"Content-Type"];
	
	// build the body with image
	NSString* imageKey = @"imgfile";
	if ( doNotUploadImage )
	{
		imagePath = nil;
		imageKey = nil;
	}
	
	// 2012-10-13steve NSMutableData* 	postBody = [self buildCustomPostBodyData:keys withImagePath:imagePath forKey:imageKey];
	NSMutableData* postBody = nil; // 2012-10-13steve
	if ( doXmlMethod ) {
        
		// postBody = [self buildCustomPostBodyDataAsXMLData:keys withImagePath:imagePath forKey:imageKey];
		postBody = [self buildCustomPostBodyDataAsXMLData3:param]; // 2013-03-26steve
        
	} else {
		postBody = [self buildCustomPostBodyData:keys withImagePath:imagePath forKey:imageKey];
        
	}
	
	if ( postBody )
	{
		// NSLog (@ "Inside %@ => %@...postBody is: %@", self, NSStringFromSelector(_cmd), postBody );
		
		// add image data
		[postRequest setHTTPBody:postBody];
	}
	else {
		NSLog (@ "Inside %@ => %@...postBody returned NIL?????", self, NSStringFromSelector(_cmd) );
		postRequest = nil;
		
	}
	
	
	NSLog (@ "Inside %@ => %@...Done - returning NSMutableURLRequest: %@", self, NSStringFromSelector(_cmd), postRequest );
	
	
	return postRequest;
}


-(id) buildURLRequestPostFormNew:(id)param	// 2012-09-26steve - follow the iphone method
{
	NSLog (@ "Inside %@ => %@...param=%@", self, NSStringFromSelector(_cmd),param );
	
	BOOL doNotUploadImage = [[param objectForKey:@"doNotUploadImage"] boolValue];
	id baseUrl = [param objectForKey:@"baseUrl"];
	id imagePath = [param objectForKey:@"edFileName"];
	id keys = [param objectForKey:@"keys"];
	
	if ( baseUrl==nil )
	{
		return nil;
	}
	if ( imagePath==nil )
	{
		return nil;
	}
	if ( keys==nil )
	{
		return nil;
	}
	
	// override baseUrl
	//baseUrl = [NSString stringWithFormat:@"http://transit.triprism.com/index.php?password=4205l9fl&username=freezeframe&groupcode=abc123&ticketnumber=111111&f=upload.transit"];
	//baseUrl = [NSString stringWithFormat:@"http://keyservices.triprism.com/index.php"];
	
	NSURL *cgiUrl = [NSURL URLWithString:baseUrl];
	
	//	NSMutableURLRequest *postRequest = [NSMutableURLRequest requestWithURL:cgiUrl
	//															   cachePolicy:NSURLRequestReloadIgnoringCacheData
	//														   timeoutInterval:sDefaultRequestTimeOutInSeconds];
	NSMutableURLRequest *postRequest = [NSMutableURLRequest requestWithURL:cgiUrl
															   cachePolicy:NSURLRequestReloadIgnoringCacheData
														   timeoutInterval:[TepsUrlHandler getURLRequestTimeout]]; // 2011-12-17steve
	
	//adding header information:
	[postRequest setHTTPMethod:@"POST"];
	
	// add Content-Type
	NSString *contentType = [NSString stringWithFormat:@"multipart/form-data; boundary=%@",cTepsBoundaryString];
	[postRequest addValue:contentType forHTTPHeaderField: @"Content-Type"];
	
	// build the body with image
	NSString* imageKey = @"imgfile";
	if ( doNotUploadImage )
	{
		imagePath = nil;
		imageKey = nil;
	}
	NSMutableData* postBody = [self buildCustomPostBodyData:keys withImagePath:imagePath forKey:imageKey];
	
	
	
	if ( postBody )
	{
		// NSLog (@ "Inside %@ => %@...postBody is: %@", self, NSStringFromSelector(_cmd), postBody );
		
		// add image data
		[postRequest setHTTPBody:postBody];
	}
	else {
		NSLog (@ "Inside %@ => %@...postBody returned NIL?????", self, NSStringFromSelector(_cmd) );
		postRequest = nil;
		
	}
	
	
	NSLog (@ "Inside %@ => %@...Done - returning NSMutableURLRequest: %@", self, NSStringFromSelector(_cmd), postRequest );
	
	
	return postRequest;
}



#pragma mark -

// 2011-12-05steve
// It seems like the ASynchronous calls must be made from the MAIN Thread!!!!
// which means these delegates will get called on the main thread
// so - if a process will take long - need to spin off Thread to offload them...
//
// using this ASYNC method,
// we need to setup
// self.fResponseDictionary = [NSMutableDictionary dictionaryWithDictionary:info];

//- (NSCachedURLResponse *)connection:(NSURLConnection *)connection willCacheResponse:(NSCachedURLResponse *)cachedResponse
//{
//	return nil; // 2011-12-15steve
//}

- (void)connection:(NSURLConnection *)connection didCancelAuthenticationChallenge:(NSURLAuthenticationChallenge *)challenge
{
	NSLog (@ "%@ => %@...challenge = %@", self, NSStringFromSelector(_cmd), challenge );
	
}
- (void)connection:(NSURLConnection *)connection didReceiveAuthenticationChallenge:(NSURLAuthenticationChallenge *)challenge
{
	NSLog (@ "%@ => %@...challenge = %@", self, NSStringFromSelector(_cmd), challenge );
	
}
- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data
{
    /* this method only gets called from the ASynchronous transfer */
    
    /* appends the new data to the received data */
    
    
	NSLog (@ "%@ => %@...data = %@", self, NSStringFromSelector(_cmd), data );
	
    
	{
		NSAutoreleasePool *p = [[NSAutoreleasePool alloc]init];
		NSString* string = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding ];
		NSLog (@ "%@ => %@...data as string = %@", self, NSStringFromSelector(_cmd), string );
		[string release];
		[p release];
	}
	
	[self.fReceivedData appendData:data];
    
	
}
- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response
{
	/* Called when the server has determined that it has enough
     information to create the NSURLResponse. It can be called
     multiple times (for example in the case of a redirect), so
     each time we reset the data. */
    
	NSLog (@ "%@ => %@...reponse = %@", self, NSStringFromSelector(_cmd), response );
	if ( [response isKindOfClass:[NSHTTPURLResponse class]] )
	{
		NSInteger statusCode = [(NSHTTPURLResponse*)response statusCode];
		NSLog ( @"====> ReturningResponse.statusCode:\n%i\n", [(NSHTTPURLResponse*)response statusCode] );
        
		NSLog ( @"====> ReturningResponse.allHeaderFields:\n%@\n", [(NSHTTPURLResponse*)response allHeaderFields] ); // 2011-12-12steve
		
		id allHeadersFields = [(NSHTTPURLResponse*)response allHeaderFields];
		if ( allHeadersFields ) [self.fResponseDictionary setObject:allHeadersFields forKey:cDictKeyHttpAllHeadersFields]; // 2011-12-12steve
		[self.fResponseDictionary setObject:[NSNumber numberWithLong:statusCode] forKey:cDictKeyHttpStatusCode];
        
	}
	
    if ( connection ) // 2011-12-20steve
	{
		// 2011-12-20steve - onluy do this if connection, if nil, we are doing Synchronous Method
		// and dont want to lose our fReceivedData
		[self.fReceivedData setLength:0];
	}
	
}


- (void)connectionDidFinishLoading:(NSURLConnection *)connection
{
	NSLog (@ "%@ => %@...", self, NSStringFromSelector(_cmd) );
	
	BOOL doParseHere = NO; // 2013-03-14steve
	
    
	[self destroyUploadTimeOutTimer]; // 2011-11-09steve
    
	// we may need to spawn a thread to process the finished data
	
	if ( self.fReceivedData ) {
		
		NSString *responseString = [[NSString alloc] initWithData:self.fReceivedData encoding:NSMacOSRomanStringEncoding];
		NSLog ( @"2011-09-28steve - returnData = %@", responseString );
		[responseString writeToFile:@"/response.xml" atomically:YES encoding:NSUTF8StringEncoding error:nil]; // 2011-09-29steve
		[responseString release];
        
        // 2013-03-21steve - we want to save it to our dictionary
		[self.fResponseDictionary setObject:self.fReceivedData forKey:cDictKeyHttpReturnData]; // 2013-03-21steve
	}
	
	if ( self.fReceivedData ) {
		
		NSAutoreleasePool * pool2 = [[NSAutoreleasePool alloc] init]; // 2011-12-08steve
		
		BOOL doParse = YES;
		id allHeaders = [self.fResponseDictionary objectForKey:cDictKeyHttpAllHeadersFields]; // 2011-12-12steve
		if ( allHeaders )
		{
			id contentType = [allHeaders objectForKey:@"Content-Type"];
			NSLog ( @"2011-12-12steve contentType class = [%@]", [contentType class] );
			if ( contentType && [contentType isKindOfClass:[NSString class]] )
			{
				NSArray *contentTypeArray = [contentType componentsSeparatedByCharactersInSet:[NSCharacterSet characterSetWithCharactersInString:@";, "]];
				NSLog ( @"2011-12-12steve contentTypeArray = [%@]", contentTypeArray );
				if ( [contentType hasPrefix:@"text/xml"] )
				{
					// excellent - we want that
				}
				else {
					if ( self.fReceivedData ) {
						NSString* asString = [[NSString alloc] initWithData:self.fReceivedData encoding:NSUTF8StringEncoding];
						
						NSRange foundRange = [asString rangeOfString:@"<response" options:NSCaseInsensitiveSearch];
                        
						// if ( [asString hasPrefix:@"<response>"] )
						if ( foundRange.location==NSNotFound ) {
							doParse = NO;
							[self.fResponseDictionary setObject:[NSString stringWithString:asString] forKey:cDictKeyHttpCustomMessage];
						}
						else {
							// great - let's parse it
						}
						
						[asString release];
					}
					else {
						doParse = NO;
						[self.fResponseDictionary setObject:[NSString stringWithString:@"NO RESPONSE???"] forKey:cDictKeyHttpCustomMessage];
					}
					
					if ( doParse==NO )
					{
						[self.fResponseDictionary setObject:@"FAIL" forKey:cDictKeyHttpCustomStatus];	// 2010-10-18steve
					}
                    
				}
			}
			
			
		}
		
		if ( doParseHere ) {
			if ( doParse )
			{ // 2011-12-12steve
				TepsNSXmlParser* parser = [[TepsNSXmlParser alloc] initWithData:self.fReceivedData];
				parser.rootKey = @"key"; // 2011-12-20steveDEBUG
				[parser.itemNeedsDictionary addObject:@"key"]; // 2011-12-20steve
				parser.doVerbose = YES; // 2011-12-20steveDEBUG
				BOOL success = [parser parse];
				
				NSMutableDictionary* newDictionary = self.fResponseDictionary;
				
				if ( parser.parserError ) {
					NSLog ( @"customapps FAILED to Parse Response: [%@]\n\n", parser.parserError );
					// 2010-10-18steve - if there is an error here - then we cannot figure out what is the
					[newDictionary setObject:@"FAIL" forKey:cDictKeyHttpCustomStatus];	// 2010-10-18steve
					[newDictionary setObject:[parser.parserError localizedDescription] forKey:cDictKeyHttpCustomMessage];	// 2010-10-18steve
					
					// 2011-12-13steve BAD BUG - dont use this
					//				id textMesg = [[fResponseDictionary objectForKey:cDictKeyHttpAllHeadersFields] objectForKey:cDictKeyHttpAllHeadersFields]; // 2011-12-12steve
					//				if ( textMesg )
					//					[newDictionary setObject:[NSString stringWithString:textMesg] forKey:cDictKeyHttpCustomMessage];
					
				}
				else {
					// process success or failed
					NSLog(@"2011-09-18steve %@ => customapps parser SUCCEEDED with parser.mDictionary = %@",NSStringFromSelector(_cmd), parser.mDictionary);
					
					// 2012-02-21steve
					id responseDictonary = [parser.mDictionary objectForKey:@"response"]; // 2012-02-21steve
					
					if ( responseDictonary==nil )
						responseDictonary = [parser.mDictionary objectForKey:@"result"]; // 2012-10-13steve for new pt5 with upload.phototouchinc.com
					
					if ( responseDictonary==nil )
						responseDictonary = parser.mDictionary;
					
					id status = [responseDictonary objectForKey:@"status"];
					id message = [responseDictonary objectForKey:@"message"];
					if ( message==nil )
						message = [responseDictonary objectForKey:@"msg"];// 2012-10-13steve
					
					
					// 2012-02-21steve id status = [parser.mDictionary objectForKey:@"status"];
					// 2012-02-21steve id message = [parser.mDictionary objectForKey:@"message"];
					
					if (status) [newDictionary setObject:status forKey:cDictKeyHttpCustomStatus];
					if (message) [newDictionary setObject:message forKey:cDictKeyHttpCustomMessage];
					
					if ( status==nil || message==nil )
					{
						NSLog ( @"NOT GETTING Enough data back from Response from customapps??????_2" ); // 2012-02-21steve
						NSLog ( @"Possibly missing message/status response pair??????_2" ); // 2012-02-21steve
						// 2010-10-18steve - if there is an error here - then we cannot figure out what is the
						[newDictionary setObject:@"FAIL" forKey:cDictKeyHttpCustomStatus];	// 2010-10-18steve
						[newDictionary setObject:@"Not enough data returned for message/status response pair...B" forKey:cDictKeyHttpCustomMessage]; // 2012-02-22steve // 2010-10-18steve
					}
					
				}
				
				[parser release];
				
			}
		}
		
		
		[pool2 release]; // 2011-11-08steve
		
	}
	else
	{
		NSLog (@ "%@ => %@...There is NO self.fReceivedData to process?????", self, NSStringFromSelector(_cmd) );
	}
	
	if ( doParseHere ) {
		NSNotificationCenter *nc = [NSNotificationCenter defaultCenter];
		[nc postNotificationName:cNotification_UploadDone object:self userInfo:self.fResponseDictionary];
	}
	
	
	[self finishNSUrlConnection:connection]; // 2013-03-21steve
	//[NSThread detachNewThreadSelector:@selector(finishNSUrlConnection:) toTarget:self withObject:connection];
    
	
    
}

// gets called from the system - if
// "request timed out" = no internet connection,
// "could not connect to the server" = no internet, url does not exist - like using my mac as the server ip
// "this computer's Internet connection appears to be offline"
//
//  [error userInfo] contains:
//		NSErrorFailingURLKey = http://keyservices.triprism.com/index.php;
//		NSErrorFailingURLStringKey = "http://keyservices.triprism.com/index.php";
//		NSLocalizedDescription = "This computer\U2019s Internet connection appears to be offline.";
//		NSUnderlyingError = Error Domain=kCFErrorDomainCFNetwork Code=-1009 UserInfo=0x5b50c70 "This computer’s Internet connection appears to be offline.";
- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error
{
	NSLog (@ "%@ => %@...error = %@", self, NSStringFromSelector(_cmd), error);
	
	
	NSLog(@"Connection failed! Error - localizedDescription = %@\n NSURLErrorFailingURLStringError = %@",
          [error localizedDescription],
          [[error userInfo] objectForKey:NSURLErrorFailingURLStringErrorKey]);
    
	
	[self destroyUploadTimeOutTimer]; // 2011-11-09steve
    
    if ( self.fReceivedData) [self.fResponseDictionary setObject:self.fReceivedData forKey:cDictKeyHttpReturnData]; // 2013-03-21steve
	
	
	self.fNSURLConn = nil; // 2011-12-15steve
	self.fReceivedData = nil; // 2011-12-15steve
	
	if ( error && self.fResponseDictionary )
	{
		[self.fResponseDictionary setObject:error forKey:cDictKeyHttpError];
        
	}
	else {
		NSLog (@ "%@ => %@...self.fResponseDictionary is nil????", self, NSStringFromSelector(_cmd));
	}
	
	id temp = [self.fResponseDictionary objectForKey:cDictKeyHttpStatusCode]; // 2011-12-08steve - set the code
	if (temp==nil)
	{
		[self.fResponseDictionary setObject:[NSNumber numberWithLong:[error code]] forKey:cDictKeyHttpStatusCode];
        
	}
    
	
	
	
	// let the next guy check for errors, if any
	[[NSNotificationCenter defaultCenter] postNotificationName:cNotification_UploadDone
														object:self
													  userInfo:self.fResponseDictionary];
    
	[self finishNSUrlConnection:connection]; // 2013-03-21steve
	//[NSThread detachNewThreadSelector:@selector(finishNSUrlConnection:) toTarget:self withObject:connection];
    
}


-(BOOL) finishNSUrlConnection:(NSURLConnection *)connection
{
	NSAutoreleasePool* p = [[NSAutoreleasePool alloc] init];
	
    //	if ( self.fDummyPort && self.fRunLoop) {
    //
    //		[self.fRunLoop removePort:self.fDummyPort forMode:NSDefaultRunLoopMode];
    //		// self.fRunLoop = nil;
    //		//self.fDummyPort = nil;
    //	}
	if ( self.fNSURLConn ) {
		[self.fNSURLConn unscheduleFromRunLoop:self.fRunLoop forMode:NSDefaultRunLoopMode];
		self.fRunLoop = nil;
	}
	
	id sender = [self.fResponseDictionary objectForKey:@"sender"];
    
	if ( sender && [sender respondsToSelector:@selector(didEndNSURLConnection:context:)] )
		[sender didEndNSURLConnection:self context:self.fResponseDictionary];
    else {
        NSLog (@ "%@ => %@...UNABLE to find method for %@:%@", self, NSStringFromSelector(_cmd),[sender class],@"didEndNSURLConnection:context:" );
    }
    
    
	[p release];
}


#pragma mark -

// 2011-12-05steve this needs to be called from MAIN THREAD
-(bool) sendAndProcessUrlRequestAsync:(NSMutableURLRequest*)request withInfo:(id)info
{
	if (self.fDoVerbose) NSLog (@ "%@ => %@...request = %@", self, NSStringFromSelector(_cmd),request );
	
	
	// 2011-12-05steve - this needs to get called from the MAIN THREAD
	// 2011-12-05steve - this needs to get called from the MAIN THREAD
	// 2011-12-05steve - this needs to get called from the MAIN THREAD
    
	
	self.fReceivedData = [NSMutableData data];
	self.fResponseDictionary = [NSMutableDictionary dictionaryWithDictionary:info]; // 2011-12-05steve
    
    
    if (self.fDoVerbose) NSLog ( @"2013-03-21steve %@-%@ -> will send request = %@", self, NSStringFromSelector(_cmd),request );
    if (self.fDoVerbose) NSLog ( @"2013-03-21steve %@-%@ -> will send request = %@", self, NSStringFromSelector(_cmd),[request allHTTPHeaderFields] );
    
	self.fNSURLConn = [[[NSURLConnection alloc] initWithRequest:request
                                                       delegate:self
                                               startImmediately:NO] autorelease];
    
    // 2011-12-20steve - DO NOT setup timeOut timer to receive data here... do it after receiving connection???
	if ( self.fNSURLConn )
	{
		[self setupUploadTimeOutTimer:info]; // 2011-12-05steve
	}
    
    
	self.fDummyPort = [NSPort port];
	self.fRunLoop = [NSRunLoop currentRunLoop]; // Get the runloop
    //	if ( self.fRunLoop!=[NSRunLoop mainRunLoop] )
    //		[self.fRunLoop addPort:self.fDummyPort forMode:NSDefaultRunLoopMode];
	
	[self.fNSURLConn scheduleInRunLoop:self.fRunLoop forMode:NSDefaultRunLoopMode];
	[self.fNSURLConn start];
	
    //	if ( self.fRunLoop!=[NSRunLoop mainRunLoop] )
    //		[self.fRunLoop run];
    
	
	if (self.fDoVerbose) NSLog (@ "EXITING  %@ => %@...", [self class], NSStringFromSelector(_cmd) );
	
	return (self.fNSURLConn?true:false);
    
}


-(bool) sendUrlRequestOnly:(NSMutableURLRequest*)request withInfo:(id)info
{
	NSLog (@ "%@ => %@...", self, NSStringFromSelector(_cmd) );
	
	if ( request )
	{
		NSError *error=nil;
		NSURLResponse *response = nil;
		NSData *returnData = [NSURLConnection sendSynchronousRequest:request
												   returningResponse:&response
															   error:&error];
		
		
		NSMutableDictionary *newDictionary = [NSMutableDictionary dictionaryWithDictionary:info];
		
		if (response) [newDictionary setObject:response forKey:cDictKeyHttpResponse];
		if (response) [newDictionary setObject:[NSNumber numberWithLong: [(NSHTTPURLResponse*) response statusCode]] forKey:cDictKeyHttpStatusCode];
		if (error) [newDictionary setObject:error forKey:cDictKeyHttpError];
		if (returnData) [newDictionary setObject:returnData forKey:cDictKeyHttpReturnData];
		
		
		NSLog ( @"====> customapps ReturningResponse:%@", response );
		NSLog ( @"====> ReturningResponse.statusCode:\n%i\n", [(NSHTTPURLResponse*) response statusCode] );
		// NSLog ( @"====> localizedStringForStatusCode is: [%@]\n\n", [response localizedStringForStatusCode:[response statusCode] ] );
		
		if (error)
		{
			NSLog ( @"******* customapps: An Error Occurred while trying to send URL request: *****\n [%@]\n", [error localizedDescription] );
			NSLog (@"2011-09-18steve customapps NSERROR = %@", error );
			// self.fResultDictionary = [NSDictionary dictionaryWithObject:error forKey:@"NSError"];
			
			[info setObject:error forKey:@"NSError"]; // 2012-08-31steve
			
			
		}
		else
		{
			NSLog ( @"2011-09-28steve - returnData = %@", returnData );
			
			NSString *responseString = [[NSString alloc] initWithData:returnData encoding:NSMacOSRomanStringEncoding];
			NSLog ( @"2011-09-28steve - returnData as NSString =\n%@", responseString );
			[responseString writeToFile:@"/response.xml" atomically:YES encoding:NSUTF8StringEncoding error:nil]; // 2011-09-29steve
			[responseString release];
			
			
			
			TepsNSXmlParser* parser = [[TepsNSXmlParser alloc] initWithData:returnData];
			
			parser.doVerbose = YES; // 2013-03-20steve
			
			BOOL success = [parser parse];
			
			[parser.mDictionary setObject:returnData forKey:@"returnData"]; // 2013-03-20steve
			
			
			if ( parser.parserError )
			{
				// self.fResultDictionary = [NSDictionary dictionaryWithObject:parser.parserError forKey:@"NSError"];
				
				NSLog ( @"customapps FAILED to Parse Response: [%@]\n\n", parser.parserError );
				// 2010-10-18steve - if there is an error here - then we cannot figure out what is the
				[newDictionary setObject:@"FAIL" forKey:cDictKeyHttpCustomStatus];	// 2010-10-18steve
				[newDictionary setObject:[parser.parserError localizedDescription] forKey:cDictKeyHttpCustomMessage];	// 2010-10-18steve
				
				// 2012-08-31steve - we need to return this to sender
				[info setObject:@"FAIL" forKey:cDictKeyHttpCustomStatus]; // 2012-08-31steve
				[info setObject:[parser.parserError localizedDescription] forKey:cDictKeyHttpCustomMessage]; // 2012-08-31steve
				
			}
			else {
				// process success or failed
				NSLog(@"2012-08-30steve customapps parser SUCCEEDED with parser.mDictionary = %@",parser.mDictionary);
				
				if ( parser.mDictionary) [newDictionary setObject:parser.mDictionary forKey:@"responseDictionary"];
				if ( parser.mDictionary) [info setObject:parser.mDictionary forKey:@"responseDictionary"];
				
			}
			
			[parser release];
			
		}
		
		
		//		// let the next guy check for errors, if any
		//		NSNotificationCenter *nc = [NSNotificationCenter defaultCenter];
		//		[nc postNotificationName:cNotification_UploadDone object:self userInfo:newDictionary];
		//
		//		if ( info && ([info isKindOfClass:[NSMutableDictionary class]]) )  // 2010-06-25steve check if Mutable
		//			[info removeAllObjects]; // 2009-08-04steve
		
	}
	else
	{
		NSLog (@ "Inside %@ => %@...UNABLE to create NSURLRequest...", self, NSStringFromSelector(_cmd) );
	}
	
	NSLog (@ "EXITING  %@ => %@...", [self class], NSStringFromSelector(_cmd) );
	
	return true;
	
}

-(bool) sendAndProcessUrlRequest:(NSMutableURLRequest*)request withInfo:(id)info
{
	NSLog (@ "%@ => %@...", self, NSStringFromSelector(_cmd) );
	
	if ( request )
	{
		NSError *error=nil;
		NSURLResponse *response = nil;
		NSData *returnData = [NSURLConnection sendSynchronousRequest:request
												   returningResponse:&response
															   error:&error];
		
		
		// NSLog (@"2011-09-30steve bodyData AFTERWARDS = %@",[request HTTPBody] );
		
		//		NSString *bodyData2 = [[NSString alloc] initWithData:[request HTTPBody] encoding:NSMacOSRomanStringEncoding];
		//		NSLog ( @"2011-09-28steve - bodyData AFTERWARDS as string = %@", bodyData2 );
		//		[bodyData2 writeToFile:@"/afterwards.xml" atomically:YES encoding:NSUTF8StringEncoding error:nil]; // 2011-09-29steve
		//		[bodyData2 release];
		
		
		NSMutableDictionary *newDictionary = [NSMutableDictionary dictionaryWithDictionary:info];
		
		if (response) [newDictionary setObject:response forKey:cDictKeyHttpResponse];
		if (response) [newDictionary setObject:[NSNumber numberWithLong: [(NSHTTPURLResponse*) response statusCode]] forKey:cDictKeyHttpStatusCode];
		if (error) [newDictionary setObject:error forKey:cDictKeyHttpError];
		if (returnData) [newDictionary setObject:returnData forKey:cDictKeyHttpReturnData];
		
		
		NSLog ( @"====> customapps ReturningResponse:%@", response );
		NSLog ( @"====> ReturningResponse.statusCode:\n%i\n", [(NSHTTPURLResponse*) response statusCode] );
		// NSLog ( @"====> localizedStringForStatusCode is: [%@]\n\n", [response localizedStringForStatusCode:[response statusCode] ] );
		
		if (error)
		{
			NSLog ( @"******* customapps: An Error Occurred while trying to send URL request: *****\n [%@]\n", [error localizedDescription] );
			NSLog (@"2011-09-18steve customapps NSERROR = %@", error );
			// self.fResultDictionary = [NSDictionary dictionaryWithObject:error forKey:@"NSError"];
			
		}
		else
		{
			NSLog ( @"2011-09-28steve - returnData = %@", returnData );
			
			NSString *responseString = [[NSString alloc] initWithData:returnData encoding:NSMacOSRomanStringEncoding];
			NSLog ( @"2011-09-28steve - returnData = %@", responseString );
			[responseString writeToFile:@"/response.xml" atomically:YES encoding:NSUTF8StringEncoding error:nil]; // 2011-09-29steve
			[responseString release];
			
			
			
			TepsNSXmlParser* parser = [[TepsNSXmlParser alloc] initWithData:returnData];
			BOOL success = [parser parse];
			
			if ( parser.parserError )
			{
				// self.fResultDictionary = [NSDictionary dictionaryWithObject:parser.parserError forKey:@"NSError"];
				
				NSLog ( @"customapps FAILED to Parse Response: [%@]\n\n", parser.parserError );
				// 2010-10-18steve - if there is an error here - then we cannot figure out what is the
				[newDictionary setObject:@"FAIL" forKey:cDictKeyHttpCustomStatus];	// 2010-10-18steve
				[newDictionary setObject:[parser.parserError localizedDescription] forKey:cDictKeyHttpCustomMessage];	// 2010-10-18steve
				
			}
			else {
				// process success or failed
				NSLog(@"2011-09-18steve customapps parser SUCCEEDED with parser.mDictionary = %@",parser.mDictionary);
				// self.fResultDictionary = [[[NSDictionary alloc] initWithDictionary:parser.mDictionary copyItems:YES] autorelease];
				
				// 2012-02-21steve
				id responseDictonary = [parser.mDictionary objectForKey:@"response"]; // 2012-02-21steve
				if ( responseDictonary==nil )
					responseDictonary = parser.mDictionary;
				
				id status = [responseDictonary objectForKey:@"status"];
				id message = [responseDictonary objectForKey:@"message"];
				
				// 2012-02-21steve id status = [parser.mDictionary objectForKey:@"status"];
				// 2012-02-21steve id message = [parser.mDictionary objectForKey:@"message"];
				
				if (status) [newDictionary setObject:status forKey:cDictKeyHttpCustomStatus];
				if (message) [newDictionary setObject:message forKey:cDictKeyHttpCustomMessage];
				
				if ( status==nil || message==nil )
				{
					NSLog ( @"NOT GETTING Enough data back from Response from customapps??????_1" ); // 2012-02-21steve
					NSLog ( @"Possibly missing message/status response pair??????_1" ); // 2012-02-21steve
					// 2010-10-18steve - if there is an error here - then we cannot figure out what is the
					[newDictionary setObject:@"FAIL" forKey:cDictKeyHttpCustomStatus];	// 2010-10-18steve
					[newDictionary setObject:@"Not enough data returned for message/status response pair...A" forKey:cDictKeyHttpCustomMessage]; // 2012-02-22steve // 2010-10-18steve
				}
				
			}
			
			[parser release];
			
		}
		
		
		// let the next guy check for errors, if any
		NSNotificationCenter *nc = [NSNotificationCenter defaultCenter];
		[nc postNotificationName:cNotification_UploadDone object:self userInfo:newDictionary];
		
		if ( info && ([info isKindOfClass:[NSMutableDictionary class]]) )  // 2010-06-25steve check if Mutable
			[info removeAllObjects]; // 2009-08-04steve
		
	}
	else
	{
		NSLog (@ "Inside %@ => %@...UNABLE to create NSURLRequest...", self, NSStringFromSelector(_cmd) );
	}
	
	NSLog (@ "EXITING  %@ => %@...", [self class], NSStringFromSelector(_cmd) );
	
	return true;
	
}

// 2011-12-20steve - RE-Do this Synchronous method to try to match the Async Method
-(bool) sendAndProcessUrlRequestSync:(NSMutableURLRequest*)request withInfo:(id)info // 2011-12-20steve
{
	if (self.fDoVerbose) NSLog (@ "%@ => %@...", self, NSStringFromSelector(_cmd) );
	
	if ( request )
	{
		
		// setup the timeout
		// 2013-03-21steve setup outside of here [self setupUploadTimeOutTimer:info]; // 2011-12-20steve
		
		
		NSError *error=nil;
		NSURLResponse *response = nil;
		
		self.fResponseDictionary = [NSMutableDictionary dictionaryWithDictionary:info]; // 2011-12-05steve
		
		self.fReceivedData = [NSURLConnection sendSynchronousRequest:request
                                                   returningResponse:&response
                                                               error:&error];
		
        //		if (info && [info isKindOfClass:[NSMutableDictionary class]]) {
        //            if (response) [info setObject:response forKey:cDictKeyHttpResponse];
        //            if (response) [info setObject:[NSNumber numberWithLong: [(NSHTTPURLResponse*) response statusCode]] forKey:cDictKeyHttpStatusCode];
        //            if (error) [info setObject:error forKey:cDictKeyHttpError];
        //            if (self.fReceivedData) [info setObject:self.fReceivedData forKey:cDictKeyHttpReturnData];
        //
        //        }
        
		if ( error )
		{
			[self connection:nil didFailWithError:error];
		}
		else
		{
			[self connection:nil didReceiveResponse:response];
			
			[self connectionDidFinishLoading:nil];
		}
		
	}
	else
	{
		NSLog (@ "Inside %@ => %@...UNABLE to create NSURLRequest...", self, NSStringFromSelector(_cmd) );
	}
	
	if (self.fDoVerbose) NSLog (@ "EXITING  %@ => %@...", [self class], NSStringFromSelector(_cmd) );
	
	return true;
	
}



- (bool) testPhotoAdUrlCommandAsync: (NSString*) serialNumber
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	NSLog (@ "Inside %@ => %@...DOES Absolutely NOTHING...", self, NSStringFromSelector(_cmd) ); // 2011-12-12steve
	return false; // 2011-12-12steve
	
}



#pragma mark -

-(bool) doRunFuseActionOnly:(NSMutableDictionary*) param // 2012-08-30steve will not do automatic checking of response
{
	if (self.fDoVerbose) NSLog (@ "%@ => %@...param = %@", self, NSStringFromSelector(_cmd), param ); // 2011-11-09steve fill in param
	
	NSMutableURLRequest* request = nil;
	
	BOOL doPostFormMethod = [[param objectForKey:@"doPostFormMethod"] boolValue];
	if ( doPostFormMethod ) {
		// use multi-part form method
		request = [self buildURLRequestPostForm:param];
	}
	else {
		// use single line url with params
		request = [self buildURLRequestString:param];
	}
	
	BOOL doAsync = self.fDoAsync; // 2011-12-20steve YES; // 2011-11-09steve
	if ( doAsync )
	{
		// PROBLEM - we need to keep the THREAD ALIVE so that it can finish it's thing
		[self sendAndProcessUrlRequestAsync:request withInfo:param]; // 2011-11-09steve
	}
	else
	{
		// 2011-11-09steve - setup timer in case upload dies or takes too long
		NSDictionary* info = nil; // [NSDictionary dictionaryWithObjectsAndKeys:request,@"NSMutableURLRequest",nil];
		[self setupUploadTimeOutTimer:info]; // 2011-11-09steve
		
		// send and process the result
		[self sendUrlRequestOnly:request withInfo:param];
		
		if (self.fDoVerbose) NSLog ( @"2013-03-20steve param at this point is: %@", param );
		
		
		// 2011-11-09steve - Invalidate and remove timer
		[self destroyUploadTimeOutTimer]; // 2011-11-09steve
	}
	
	
	// NSLog (@ "EXITING  %@ => %@...", [self class], NSStringFromSelector(_cmd) );
	if (self.fDoVerbose) NSLog (@ "EXITING  %@ => %@...param = %@", [self class], NSStringFromSelector(_cmd), param );
	
	
	return true;
	
}



- (bool) doRunCustomAppsWithInfoNew:(NSDictionary*) param
{
	if (self.fDoVerbose) NSLog (@ "%@ => %@...param = %@", self, NSStringFromSelector(_cmd), param ); // 2011-11-09steve fill in param
    
	NSMutableURLRequest* request = nil;
	
	BOOL doPostFormMethod = [[param objectForKey:@"doPostFormMethod"] boolValue];
	if ( doPostFormMethod ) {
		// use multi-part form method
		request = [self buildURLRequestPostForm:param];
	}
	else {
		// use single line url with params
		request = [self buildURLRequestString:param];
	}
    
	
	// NSLog ( @"2011-12-14steve Currently- [request allHTTPHeaderFields] = %@", [request allHTTPHeaderFields] );
	[request setValue:@"Teps-HttpUploader/version1.0.0/STEVEsteveSTEVE" forHTTPHeaderField:@"User-Agent"];
	if (self.fDoVerbose) NSLog ( @"2011-12-14steve Currently- [request allHTTPHeaderFields] = %@", [request allHTTPHeaderFields] );
	//NSLog ( @"2011-12-15steve Currently- [request HTTPBody] = %@", [request HTTPBody] );
	if (self.fDoVerbose) NSLog ( @"2011-12-15steve Currently- [request HTTPMethod] = %@", [request HTTPMethod] );
	
	
    // should have just one common place for creation of this self.fResponseDictionary = [NSMutableDictionary dictionaryWithDictionary:param]; // 2013-03-21steve
    
	BOOL doAsync = self.fDoAsync; // 2011-12-20steve YES; // 2011-11-09steve
	if ( doAsync )
	{
		// PROBLEM - we need to keep the THREAD ALIVE so that it can finish it's thing
		[self sendAndProcessUrlRequestAsync:request withInfo:param]; // 2011-11-09steve
	}
	else
	{
		// 2011-11-09steve - setup timer in case upload dies or takes too long
		// NSDictionary* info = nil; // [NSDictionary dictionaryWithObjectsAndKeys:request,@"NSMutableURLRequest",nil];
		// 2013-03-21steve [self setupUploadTimeOutTimer:info]; // 2011-11-09steve
		[self setupUploadTimeOutTimer:param]; // 2013-03-21steve
        
#ifdef 	USE_DEBUG_URL // 2011-12-20steve
		// send and process the result
		[self sendAndProcessUrlRequestSync:request withInfo:param];
#else
		// send and process the result
		[self sendAndProcessUrlRequest:request withInfo:param];
#endif
		
		// 2011-11-09steve - Invalidate and remove timer
		[self destroyUploadTimeOutTimer]; // 2011-11-09steve
	}
	
	
	if (self.fDoVerbose) NSLog (@ "EXITING  %@ => %@...param = %@", [self class], NSStringFromSelector(_cmd), param );
    
	
	return true;
	
}



- (bool) doRunCustomAppsWithInfo:(NSDictionary*) info
{
	NSLog (@ "%@ => %@...", self, NSStringFromSelector(_cmd) );
    
	NSMutableDictionary* param = nil;
	
	// this is the email method for noerr
	param = [self addKeysForNoerrEmailUpload:info];
	[param setObject:[NSNumber numberWithBool:YES] forKey:@"doNotUploadImage"];
    
	
	//id keys = [param objectForKey:@"keys"];
	//[keys setObject:[NSArray arrayWithObjects: @"steve@triprism.com",nil] forKey:@"emails"];
	//[param setObject:[NSNumber numberWithBool:YES] forKey:@"doPostFormMethod"];
	
    //	param = [self addKeysForTransitUploadTest:info];
    //	[param setObject:[NSNumber numberWithBool:YES] forKey:@"doPostFormMethod"];
    //
    //
    //	param = [self addKeysForFyp4SiteTest:info];
    //	[param setObject:[NSNumber numberWithBool:YES] forKey:@"doPostFormMethod"];
    
	
	if (param)
		return [self doRunCustomAppsWithInfoNew:param];
	
	return NO;
    
}


#pragma mark -
- (bool) doRunHttpUploaderWithInfo: (NSDictionary*) info
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
    
	NSLog (@ "Inside %@ => %@... with Info: %@", [self class], NSStringFromSelector(_cmd), info );
    
    
	// 2012-03-21stev PREPARING for NCAA gigunda 2012
	// 2012-03-21steve - if no customFuseAction, then force it???
	// addKeysForPT5Site requires the following keys:
	//		prefCustomFuseAction
	//		prefCustomerIdKey
	//		emails
	NSMutableDictionary* mInfo = [NSMutableDictionary dictionaryWithDictionary:info]; // 2012-03-21steve - we want mutable
	if ( mInfo ) {
		id origCustomAppInfo = [mInfo objectForKey:@"edTelstraInfo"];
		if ( origCustomAppInfo ) {
			NSMutableDictionary* mCustomAppInfo = [NSMutableDictionary dictionaryWithDictionary:origCustomAppInfo];
			
			id customFuseAction = [mCustomAppInfo objectForKey:@"prefCustomFuseAction"];
			if ( customFuseAction==nil ) { // 2012-03-21steve
				id defaultFuseAction = [TepsUrlHandler getFypFuseAction];
				if (defaultFuseAction)
				{
					customFuseAction = [NSString stringWithString:defaultFuseAction];
					[mCustomAppInfo setObject:defaultFuseAction forKey:@"prefCustomFuseAction"];
				}
			}
			
			id customerId = [mCustomAppInfo objectForKey:@"prefCustomerIdKey"];
			if ( customerId==nil ) {
				id edClientName = [mInfo objectForKey:@"edClientName"];
				if ( edClientName ) {
					customerId = [NSString stringWithString:edClientName];
					[mCustomAppInfo setObject:customerId forKey:@"prefCustomerIdKey"];
				}
			}
			
			[mInfo setObject:mCustomAppInfo forKey:@"edTelstraInfo"]; // replace it with new info
			
			NSLog (@ "2012-03-21steve updated mInfo = %@", mInfo );
			
		}
	}
	
	
	// 2011-09-18steve ============================= for NEW edTelstra case =============================
	id customappsInfo = [mInfo objectForKey:@"edTelstraInfo"]; // 2012-03-21steve use mInfo instead of info
	if ( customappsInfo )
	{
		id customFuseAction = [customappsInfo objectForKey:@"prefCustomFuseAction"];
		
		
		BOOL status = NO; // 2011-10-12steve
		if ( customFuseAction ) // 2011-10-14steve - in case teps emailer or teps sends poorly constructed info
		{
			if ( [customFuseAction caseInsensitiveCompare:@"upload.pt5"]==NSOrderedSame ) // 2011-10-12steve
			{
				// great for STB
				NSMutableDictionary* param = [self addKeysForPT5Site:mInfo]; // 2012-03-21steve use mInfo
				
				[param setObject:[NSNumber numberWithBool:NO] forKey:@"doNotUploadImage"];
				[param setObject:[NSNumber numberWithBool:YES] forKey:@"doPostFormMethod"];
				
				if (param) {
					status = [self doRunCustomAppsWithInfoNew:param];
				}
				else { // 2012-03-21steve
					NSLog (@"2012-03-21steve NEED RECOVERY here as we did NOT start the upload.  addKeysForPT5Site failed????" );
					NSMutableDictionary *newDictionary = [NSMutableDictionary dictionaryWithDictionary:mInfo]; // 2012-03-21steve
					
					NSDictionary* errorDict = [NSDictionary dictionaryWithObjectsAndKeys:@"Image Contains edTelstraInfo, addKeysForPT5Site failed...",NSLocalizedDescriptionKey,nil];
					NSError *error = [NSError errorWithDomain:@"TepsDomain" code:1000 userInfo:errorDict];
					if (error) [newDictionary setObject:error forKey:cDictKeyHttpError];
					
					// let the next guy check for errors, if any
					[[NSNotificationCenter defaultCenter] postNotificationName:cNotification_UploadDone
																		object:self
																	  userInfo:newDictionary];
					
                    //					if ( info && ([info isKindOfClass:[NSMutableDictionary class]]) )  // 2010-06-25steve check if Mutable
                    //						[(NSMutableDictionary*)info removeAllObjects]; // 2009-08-04steve
					
					if ( mInfo && ([mInfo isKindOfClass:[NSMutableDictionary class]]) )  // 2012-03-21steve use mInfo // 2010-06-25steve check if Mutable
						[mInfo removeAllObjects]; // 2009-08-04steve
					
					[pool drain];
					
					return false;
					
				}
				
			}
			else if ( customFuseAction ) // for noerr
			{
				NSLog ( @"2011-09-18steve NEED TO set do custom upload method for NEW Teps-EmailCollector..." );
				
				// status = [self doRunCustomAppsWithInfo:info]; // 2012-09-27steve // 2011-10-12steve assign to status
				status = [self doRunCustomAppsWithInfo:mInfo]; // 2012-09-27steve
				
				// [NSApp terminate:self]; // 2011-09-18steve
			}
            
			[pool drain];
			
			// 2011-10-12steve return true;
			return status; // 2011-10-12steve
            
		}
		else { // 2011-10-14steve error handler for missing required info
            
			NSMutableDictionary *newDictionary = [NSMutableDictionary dictionaryWithDictionary:info];
            
			NSDictionary* errorDict = [NSDictionary dictionaryWithObjectsAndKeys:@"Image Contains edTelstraInfo, but NO Custom fuseAction...",NSLocalizedDescriptionKey,nil];
			NSError *error = [NSError errorWithDomain:@"TepsDomain" code:1000 userInfo:errorDict];
			if (error) [newDictionary setObject:error forKey:cDictKeyHttpError];
            
			// let the next guy check for errors, if any
			[[NSNotificationCenter defaultCenter] postNotificationName:cNotification_UploadDone
																object:self
															  userInfo:newDictionary];
			
			if ( info && ([info isKindOfClass:[NSMutableDictionary class]]) )  // 2010-06-25steve check if Mutable
				[(NSMutableDictionary*)info removeAllObjects]; // 2009-08-04steve
			
			[pool drain];
			
			return false;
		}
		
		
	}
	
	id hiresUploadInfo = [info objectForKey:@"uploadInfo"]; // 2011-10-24steve - for transit upload MACYS
	if ( hiresUploadInfo )
	{
		id fuseAction = [hiresUploadInfo objectForKey:@"f"];
		BOOL status = NO;
		if (fuseAction )
		{
			if ( [fuseAction caseInsensitiveCompare:@"macys"]==NSOrderedSame )
			{
				NSMutableDictionary* param = [self addKeysForTransitSite:info];
				
				[param setObject:[NSNumber numberWithBool:NO] forKey:@"doNotUploadImage"];
				[param setObject:[NSNumber numberWithBool:YES] forKey:@"doPostFormMethod"];
				
				if (param) status = [self doRunCustomAppsWithInfoNew:param];
				
			}
			else if ( [fuseAction caseInsensitiveCompare:@"pt5"]==NSOrderedSame ) // 2012-09-26steve
			{
				NSLog (@"2012-09-26steve - FOUND PT5 File...." );
				NSMutableDictionary* param = [self addKeysForNormalPT5Site:info];
				[param setObject:[NSNumber numberWithBool:NO] forKey:@"doNotUploadImage"];
				[param setObject:[NSNumber numberWithBool:YES] forKey:@"doPostFormMethod"];
				
				if (param) status = [self doRunCustomAppsWithInfoNew:param];
			}
			else if ( [fuseAction caseInsensitiveCompare:@"fyp"]==NSOrderedSame ) // 2012-09-26steve
			{
				NSLog (@"2012-09-26steve - FOUND FYP File...." );
				NSMutableDictionary* param = [self addKeysForNormalFYP4Site:info];
				
				[param setObject:[NSNumber numberWithBool:NO] forKey:@"doNotUploadImage"];
				[param setObject:[NSNumber numberWithBool:YES] forKey:@"doPostFormMethod"];
				
				if (param) status = [self doRunCustomAppsWithInfoNew:param];
			}
			
			else {
				NSLog (@"2011-10-24steve SHOULD NOT BE HERE - UNKNOWN fuseAction to Implement for uploadInfo: %@", hiresUploadInfo );
			}
			
		}
		else { // 2011-10-14steve error handler for missing required info
			
			NSMutableDictionary *newDictionary = [NSMutableDictionary dictionaryWithDictionary:info];
			
			NSDictionary* errorDict = [NSDictionary dictionaryWithObjectsAndKeys:@"Image Contains Upload.Transit Info, but NO fuseAction defined...",NSLocalizedDescriptionKey,nil];
			NSError *error = [NSError errorWithDomain:@"TepsDomain" code:1000 userInfo:errorDict];
			if (error) [newDictionary setObject:error forKey:cDictKeyHttpError];
			
			// let the next guy check for errors, if any
			[[NSNotificationCenter defaultCenter] postNotificationName:cNotification_UploadDone
																object:self
															  userInfo:newDictionary];
			
			if ( info && ([info isKindOfClass:[NSMutableDictionary class]]) )  // 2010-06-25steve check if Mutable
				[(NSMutableDictionary*) info removeAllObjects]; // 2009-08-04steve
			
            
			status = false;
		}
		
		
		[pool drain];
		
		return status;
		
	}
	
	
	// =========================================================================
	// 2011-12-06steve - THIS WILL BE THE NEW METHOD FOR STANDARD FYP Uploads
	// =========================================================================
	//
	BOOL doNormalFyp4Upload = YES; // 2011-12-06steve
	if ( doNormalFyp4Upload )
	{
		BOOL status = NO;
        
		NSMutableDictionary* param = [self addKeysForNormalFYP4Site:info];
		
		[param setObject:[NSNumber numberWithBool:NO] forKey:@"doNotUploadImage"];
		[param setObject:[NSNumber numberWithBool:YES] forKey:@"doPostFormMethod"];
        
		if (param)
			status = [self doRunCustomAppsWithInfoNew:param];
        
		
		NSLog (@ "EXITING doNormalFyp4Upload of %@ => %@...", self, NSStringFromSelector(_cmd) );
		
		[pool drain];
		return status;
		
	}
	
    
    
	NSLog (@ "EXITING  %@ => %@...", [self class], NSStringFromSelector(_cmd) );
    
	if ( pool )	[pool release];
    
	return true;
}


// 2009-06-09steve - test http uploader in thread
// info is Normally NSNotification
//   OR NSDictionary
- (void) doRunHttpUploaderInThread:(id) info
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	NSLog (@ "Inside %@ => %@...", [self class], NSStringFromSelector(_cmd) );
	
	
	bool doSimulate = false;
	
	if ( doSimulate )
	{
		NSNotificationCenter *nc2 = [NSNotificationCenter defaultCenter];
		[nc2 postNotificationName:cNotification_UploadDone object:self userInfo:[info userInfo]];
		
	}
	else
	{
		if ( info )
		{
			// NSLog ( @"%@-%@Info is of Base Class = [%@]", [self class], NSStringFromSelector(_cmd), [info class] );
			if ( [info isKindOfClass:[NSNotification class]] )
			{
				// NSLog ( @"Is NSConcreteNotification...");
				// NSLog (@ "Inside %@ => %@...with Dictionary from userInfo =\n%@\n", [self class], NSStringFromSelector(_cmd), [info userInfo] );
				[self doRunHttpUploaderWithInfo:[info userInfo]];
				
			}
			else if ( [info isKindOfClass:[NSDictionary class]] )
			{
				// NSLog ( @"Is NSDictionary...");
				// NSLog (@ "Inside %@ => %@...with Dictionary direct =\n%@\n", [self class], NSStringFromSelector(_cmd), info );
				[self doRunHttpUploaderWithInfo:info];
			}
			else
			{
				NSLog ( @"Unknown Class Type Found: [%@] with the info:\n", [info class], info );
			}
		}
		else
		{
			NSLog (@ "Passed NO Info to %@ => %@...", [self class], NSStringFromSelector(_cmd) );
		}
	}
	
	
	// NSLog (@ "\n\n###########      DONE WITH %@ => %@...     ###########\n\n", [self class], NSStringFromSelector(_cmd) );
	
	
	// 2011-12-03steve
	// if this is really running in the NON-main thread - we CANNOT exit right away -
	// we need to wait for timer to timeout
	// we need SUCCESS or FAIL
	// we need to setup some flag for this
	
	
	
	if ( pool )	[pool release];
}

// 2009-06-09steve - test http uploader in thread
// info is Normally NSNotification
//   OR NSDictionary
- (void) doRunHttpUploaderInThreadForReal:(id) info
{
	NSAutoreleasePool *pool = nil; //  [[NSAutoreleasePool alloc] init];
	
	NSLog (@ "Inside %@ => %@...info = %@", [self class], NSStringFromSelector(_cmd), info );
	
	[[info userInfo] writeToFile:@"/testFileInfo.plist" atomically:YES]; // 2011-12-05steve
	
	bool doSimulate = false;
	
	if ( doSimulate )
	{
		NSNotificationCenter *nc2 = [NSNotificationCenter defaultCenter];
		[nc2 postNotificationName:cNotification_UploadDone object:self userInfo:[info userInfo]];
		
	}
	else
	{
		if ( info )
		{
			// NSLog ( @"%@-%@Info is of Base Class = [%@]", [self class], NSStringFromSelector(_cmd), [info class] );
			if ( [info isKindOfClass:[NSNotification class]] )
			{
				// NSLog ( @"Is NSConcreteNotification...");
				// NSLog (@ "Inside %@ => %@...with Dictionary from userInfo =\n%@\n", [self class], NSStringFromSelector(_cmd), [info userInfo] );
				[self doRunHttpUploaderWithInfo:[info userInfo]];
				
			}
			else if ( [info isKindOfClass:[NSDictionary class]] )
			{
				// NSLog ( @"Is NSDictionary...");
				// NSLog (@ "Inside %@ => %@...with Dictionary direct =\n%@\n", [self class], NSStringFromSelector(_cmd), info );
				[self doRunHttpUploaderWithInfo:info];
			}
			else
			{
				NSLog ( @"Unknown Class Type Found: [%@] with the info:\n", [info class], info );
			}
		}
		else
		{
			NSLog (@ "Passed NO Info to %@ => %@...", [self class], NSStringFromSelector(_cmd) );
		}
	}
	
	
	// NSLog (@ "\n\n###########      DONE WITH %@ => %@...     ###########\n\n", [self class], NSStringFromSelector(_cmd) );
	
	
	// 2011-12-03steve
	// if this is really run in a thread - we CANNOT exit right away -
	// we need to wait for timer to timeout
	// we need SUCCESS or FAIL
	// we need to setup some flag for this
	
	NSLog (@ "Inside %@ => %@... DONE...", [self class], NSStringFromSelector(_cmd) );
    
	
	if ( pool )	[pool release];
}





#pragma mark -

- (void) handleNotification_ScanFolder:(NSNotification*) note
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	NSLog (@ "Inside %@ => %@...", [self class], NSStringFromSelector(_cmd) );
	
	if ( pool )	[pool release];
}

//note = notification is being passed to the thread
- (void) handleNotification_UploadStart:(NSNotification*) note
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
    
	NSLog (@ "Inside %@ => %@...", [self class], NSStringFromSelector(_cmd) );
	
	bool doTest = false;	// 2009-07-31steve
	if ( doTest )
	{
		NSNotificationCenter *nc2 = [NSNotificationCenter defaultCenter];
		[nc2 postNotificationName:cNotification_UploadDone object:self userInfo:[note userInfo]];
	}
	else
	{
		if ( note )
		{
			// NSLog (@ "Inside %@ => %@...with Dictionary =\n%@\n", [self class], NSStringFromSelector(_cmd), [note userInfo] );
            
			// spin off a thread to upload the file
			// 2009-08-03steve [NSThread detachNewThreadSelector:@selector(doRunHttpUploaderInThread:) toTarget:self withObject:note];
			
            //			[self doRunHttpUploaderInThread:note];	// 2009-08-03steve
			
            
			[self performSelectorOnMainThread:@selector(doRunHttpUploaderInThread:)
								   withObject:note
								waitUntilDone:NO ];
            
		}
		else
		{
			NSLog ( @"\n\nUnknown Notification Info inside %@::%@:\n%@\n\n", [self class], NSStringFromSelector(_cmd), note );
		}
	}
	
	
	// NSLog (@ "EXITING %@ => %@...", [self class], NSStringFromSelector(_cmd) );
	
	if ( pool )	[pool release];
    
}

- (void) handleNotification_UploadDone:(NSNotification*) note
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
    
	NSLog (@ "Inside %@ => %@...", [self class], NSStringFromSelector(_cmd) );
	
	if ( [note object] && [note object]!=self ) { // 2011-12-20steve
		NSLog (@ "Inside %@ => %@...NOT for US...", [self class], NSStringFromSelector(_cmd) );
		[pool release];
		return;
	}
	
	
	NSDictionary* info = nil;
	if ( [note isKindOfClass:[NSNotification class]] )
	{
		// NSLog ( @"Is NSConcreteNotification...");
		info = [note userInfo];
		NSLog (@ "Inside %@ => %@...userInfo = %@", [self class], NSStringFromSelector(_cmd), info );
	}
	else
	{
		NSLog ( @"Unknown Class Type Found: [%@] with the info:\n", [info class], info );
	}
    
	
	// 2011-12-06steve - clean up memory
    // 2011-12-14steve	id conn = [info objectForKey:@"NSURLConnection"];
	self.fNSURLConn = nil;
	
    
	bool hasError = false;
	
	// if (cDictKeyHttpError)
	//		error came from connection:didFaileWithError:
	//
	NSError *error = [info objectForKey:cDictKeyHttpError];
	if ( error )
	{
		hasError = true;
		NSLog ( @"cDictKeyHttpError = [%@]", [error userInfo] );	// 2009-08-13steve
	}
	
	// 2009-08-13steve - check for todd's custom errors
	// if (cDictKeyHttpCustomError)
	//		error came from connection:didFinishLoading:
	//
	NSString* customErrorString = [info objectForKey:cDictKeyHttpCustomError];
	if ( customErrorString )
	{
		hasError = true;
		NSLog ( @"cDictKeyHttpCustomError = [%@]", customErrorString );
	}
	
	// 2009-08-19steve
	NSString* statusString = [info objectForKey:cDictKeyHttpCustomStatus];
	if ( statusString )
	{
		if (NSOrderedSame==[statusString caseInsensitiveCompare:@"FAIL"] ) // 2010-10-18steve - from steve
		{
			hasError = true;
		}
		if (NSOrderedSame==[statusString caseInsensitiveCompare:@"ERROR"] ) // from Todd XML
		{
			hasError = true;
		}
		if (NSOrderedSame==[statusString caseInsensitiveCompare:@"Warning"] ) // from Todd XML
		{
			// 2010-12-19steve - if makeamessterpiece, noErr if "No Email Addresses Sent"
			NSString* mesgString = [info objectForKey:cDictKeyHttpCustomMessage];
			if ( [mesgString caseInsensitiveCompare:@"No Email Addresses Sent"]!=NSOrderedSame )
				hasError = true;
			
		}
		if (NSOrderedSame==[statusString caseInsensitiveCompare:@"OK"] )
		{
		}
	}
	
	// 2009-08-19steve - handle status codes other than 200
	NSNumber* httpStatusCode = [info objectForKey:cDictKeyHttpStatusCode]; // 2009-08-19steve
	if ( httpStatusCode )
	{
		NSLog ( @"2009-11-19steve HTTP Status Code is [%li]", [httpStatusCode longValue] ); // 2010-12-19steve // 2009-11-17steves
        
		long statusCode = [httpStatusCode longValue];
		if ( statusCode!=200 )
		{
			NSLog ( @"HTTP Status Code is [%li]", statusCode );
			hasError = true;
		}
	}
	
	
	
	NSNotificationCenter *nc = [NSNotificationCenter defaultCenter];
	if ( hasError ) {
		[nc postNotificationName:cNotification_UploadFail object:self userInfo:info];
	}
	else {
		[nc postNotificationName:cNotification_UploadSuccess object:self userInfo:info];
	}
    
	if ( pool )	[pool release];
    
}

- (void) handleNotification_UploadSuccess:(NSNotification*) note
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	NSLog (@ "Inside %@ => %@...", [self class], NSStringFromSelector(_cmd) );
	
	if ( pool )	[pool release];
}

- (void) handleNotification_UploadFail:(NSNotification*) note
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	NSLog (@ "Inside %@ => %@...", [self class], NSStringFromSelector(_cmd) );
	
	if ( pool )	[pool release];
}



#pragma mark -
- (void) applicationWillTerminate: (NSNotification *) aNotification
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	NSLog (@ "\n2009-11-25steve ================================================================================\n\n" );
	NSLog (@ "Inside %@ => %@...", [self class], NSStringFromSelector(_cmd) );
	NSLog (@ "\n2009-11-25steve ================================================================================\n\n" );
	
	if ( pool )	[pool release];
}



-(BOOL) doTestStuff // 2011-12-05steve
{
	NSLog (@ "Inside %@ => %@...", [self class], NSStringFromSelector(_cmd) );
    
	//id param = [self addKeysForCheckingKeysTest:nil];
	//id param = [self addKeysForCheckingKeysTestKaSite:nil]; // 2014-01-30steve
	id param = [self addKeysForCheckingKeySiteWithAppType:nil]; // 2014-08-11steve
    
    
	[param setObject:[NSNumber numberWithBool:NO] forKey:@"doPostFormMethod"];
	
	self.fDoAsync = NO;
	
    BOOL needToTerminate = YES; // 2014-08-11steve
    BOOL foundSavedData = NO; // 2104-08-11steve
    NSString* errormesg = nil;
    
	if (param) {
        
		[self doRunFuseActionOnly:param];
		
		NSLog ( @"2011-12-20steve got result as: %@", param ); //

		id responseDictionary = [param objectForKey:@"responseDictionary"];
                
        if ( responseDictionary==nil) {
            // 2014-08-11steve - we want to get it from our prefernces
            NSData* lastReturnData = [[NSUserDefaults standardUserDefaults] objectForKey:sPrefLastValidKeyData];
            
            if (lastReturnData) {
                TepsNSXmlParser* parser = [[TepsNSXmlParser alloc] initWithData:lastReturnData];
                parser.doVerbose = YES; // 2013-03-20steve
                
                BOOL success = [parser parse];
                
                if ( parser.parserError )
                {
                    NSLog ( @"INTERNAL prefLastValidKeyData is INValid???:\n [%@]\n\n", parser.parserError );
                    [param setObject:[NSError errorWithDomain:@"TepsVideoDomain"
                                                         code:1000
                                                     userInfo:[NSDictionary dictionaryWithObjectsAndKeys:@"Unable to Parse Internal Saved Key???...",@"localizedDescription", nil]]
                              forKey:@"NSError"];
                    needToTerminate = YES;
                    
                    // if unable to parse this data - we should just delete it
                    [[NSUserDefaults standardUserDefaults] removeObjectForKey:sPrefLastValidKeyData];
                    [[NSUserDefaults standardUserDefaults] synchronize];
                    NSLog(@"Deleted BAD Internal prefLastValidKeyData...");
                    
                    errormesg = [NSString stringWithFormat:@"Error With Fetching Internal Data..."];
                }
                else {
                    // process success or failed
                    NSLog(@"2012-08-30steve customapps parser SUCCEEDED with parser.mDictionary = %@",parser.mDictionary);
                    
                    [parser.mDictionary setObject:lastReturnData forKey:@"returnData"];// 2014-08-23steve - simulate as if from urlHandler

                    responseDictionary = [NSDictionary dictionaryWithDictionary:parser.mDictionary];
                    
                    
                    foundSavedData = YES;
                    
                }
                
                [parser release];
            }
            
        }
        
        
        
		if( responseDictionary ) {
            NSLog(@"responseDictionary is: %@", responseDictionary);
            
            NSData* returndata = [responseDictionary objectForKey:@"returnData"]; // 2014-08-11steve
            
			id key = [responseDictionary objectForKey:@"key"];
			if ( key ) {
                
				// try to see if the key has expired
                id obj = [key objectForKey:@"termination"];
                if ( obj) {
                }
                
                NSString* val = [key objectForKey:@"termination"];
                if ( val && [val isKindOfClass:[NSString class]] &&  [val caseInsensitiveCompare:@"true"]==NSOrderedSame) {
                    // TERMINATE NOW...
                    // Key Expired
                    NSLog(@"server key returned termination = true!!! - NEED to Terminate APP...");
                    needToTerminate = YES;
                    
                    errormesg = [NSString stringWithFormat:@"Server says to terminate key immediately!\n"];
                    NSString* servermsg = [key objectForKey:@"msg"];
                    if (servermsg) {
                        errormesg = [errormesg stringByAppendingFormat:@"%@",servermsg];
                    }

                }
                
                // 2013-05-22steve
                {
                    NSString* zoneString = nil;
                    
                    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
                    [dateFormatter setDateFormat:@"Z"];
                    NSString *tz = [dateFormatter stringFromDate:[NSDate date]];
                    if ( tz) zoneString = [NSString stringWithFormat:@"%@",tz];
                    [dateFormatter release];
                    
                    NSString* exptime = [key objectForKey:@"exptime"];
                    if ( exptime) {
                        NSString* expDateWithZone = [NSString stringWithFormat:@"%@ %@",exptime,zoneString];
                        NSLog(@"exptime = %@", exptime);
                        
                        NSNumberFormatter * f = [[NSNumberFormatter alloc] init];
                        [f setNumberStyle:NSNumberFormatterDecimalStyle];
                        NSNumber * myNumber = [f numberFromString:exptime];
                        [f release];
                        
                        NSDate* expDate = [NSDate dateWithTimeIntervalSince1970:[myNumber doubleValue]];
                        NSLog(@"expDate = %@", [expDate toLocalTime]);
                        
                        
                        //NSDate* expDate = [NSDate dateWithString:expDateWithZone];
                        NSDate* curDate = [NSDate date];
                        NSLog(@"curDate = %@", [curDate toLocalTime]);
                        
                        
                        NSDate* earlierDate = [curDate earlierDate:expDate]; // if earlier or same returns curDate
                        if ( earlierDate == curDate) {
                            NSLog (@"CurDate is BEFORE expirationDate");
                            needToTerminate = NO;
                        }
                        NSDate* laterDate = [curDate laterDate:expDate];
                        if ( laterDate == curDate) {
                            NSLog (@"CurDate is AFTER expirationDate");
                            NSLog (@"CurDate is AFTER expirationDate = true!!! - NEED to Terminate APP...");
                            needToTerminate = YES;
                            if (errormesg) {
                                errormesg = [errormesg stringByAppendingFormat:@"Key has expired on: %@",expDate];
                            }
                            else {
                                errormesg = [NSString stringWithFormat:@"Key has expired on: %@",expDate];
                            }
                        }
                        
                    }
                    
                }
                
                
                
                
			}
            
            
            if ( returndata && key && needToTerminate==NO) {
                if ( !foundSavedData) {
                    NSLog(@"2014-08-11 need to save something here...");
                    // [[NSUserDefaults standardUserDefaults] setObject:key forKey:sPrefLastValidKeyData];
                    [[NSUserDefaults standardUserDefaults] setObject:returndata forKey:sPrefLastValidKeyData];
                    [[NSUserDefaults standardUserDefaults] synchronize]; // 2014-08-11steve
                }
            }
            
		}
		else {
            needToTerminate = YES;

            NSLog(@"2014-08-11 - NO responseDictionary - checking for NSError...");
            NSError* err = [param objectForKey:@"NSError"];
            if ( err) {
                NSLog(@"2014-08-11 - Got Error = %@",err);
                NSLog(@"2014-08-11 - Got Error = %@",[err localizedDescription]);
                errormesg = [NSString stringWithFormat:@"%@",[err localizedDescription]];
                
                if (!foundSavedData) {
                    errormesg = [errormesg stringByAppendingFormat:@"\nAlso It appears No Valid Key was ever found before..."];
                }
            
            } else {
                errormesg = [NSString stringWithFormat:@"Unable To Read Valid Key Dictionary from Server..."];
            }
            
            
		}
		
	}
    else
    {
        
    }
	
    
    // if no internal data found and unable to read
    if ( needToTerminate) {
        
        NSAlert * alert = [NSAlert alertWithMessageText:@"PLEASE REGISTER This APP"
                                          defaultButton:@"OK"
                                        alternateButton:nil
                                            otherButton:nil
                              informativeTextWithFormat:@"Unable to find a valid license for this application.\n\nReason:\n%@\n\n",errormesg];
        
        [alert runModal];
        
        [NSApp terminate:self];
        
    }

    
	
    return needToTerminate;
}

// 2011-12-14steve
//- (id) progressDelegate // 2011-12-05steve
//{
//	return nil;
//}





@end
