//
//  ATMPPR_Security.h
//  testFypController
//
//  Created by tyler on 3/19/10.
//  Copyright 2010 Atomic Pepper LLC. All rights reserved.
//
//  Triprism Inc., is hereby granted a worldwide, perpetual, fully
//  paid license to use, modify, copy, compile and sublicense the
//  contents of this file.

#import <Cocoa/Cocoa.h>
#import "ATMPPR_Base.h"

extern 	NSString* kWebKeyFileName;	// 2011-04-27

@interface ATMPPR_SecureSettings : ATMPPR_Base {
	
@private
    NSMutableDictionary * dataStore_;
    BOOL didRestoreFromPrevious_;
    BOOL needsSaving_;
    NSString * filePath_;
    NSError * lastError_;
	
@public
    
}

@property (readonly)                BOOL didRestoreFromPrevious;


// the shared instance ... it always returns the same object
+(id)persistentSettings;

// call this method to check if the data store was successfully restored from a previous session
+(BOOL)validatedFromPreviousSession;
-(BOOL)validatedFromPreviousSession;

-(id)objectForKey:(NSString *)defaultName error:(NSError **)error;



// new methods for per-file storage

// now create a per-file object using initWithPath:
// initWithPath: will return nil if the dataStore could not be created, in
// which case check the class method +[lastError] for the reason.
-(id)initWithPath:(NSString *)filePath;
+(NSError *)lastError;

-(id)objectForKey:(NSString *)defaultName;
-(void)setObject:(id)value forKey:(NSString *)defaultName;
-(void)removeObjectForKey:(NSString *)defaultName;

-(BOOL)save; // if save returns no, check the object property lastError for the reason

@property (nonatomic, readonly)     NSString * filePath; // the path of the on-disk encrypted file
@property (nonatomic, readonly)     NSError * lastError; // the last error


@end
