//
//  ATMPPR_XMLinEXIF.m
//  CameraControl
//
//  Created by tyler on 11/17/09.
//  Copyright 2009 Atomic Pepper LLC. All rights reserved.
//

#import "ATMPPR_XMLinEXIF.h"
#import "ATMPPR_Log.h"


@implementation ATMPPR_XMLinEXIF
+(id)jpegDataWithPropertyListObject:(id)plistObj embeddedInExifDataForJpegData:(NSData *)data
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) ); // 2011-09-21steve
	db("Inside jpegDataWithPropertyListObject....");
	NSLog ( @"see if this shows up in log file..." );

    NSData * newImageData = nil;
    if (plistObj && data)
    {
        NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];

        // Convert the plist into XML data.
        NSString * s;
        
		// 2011-09-21steve NSData * xmlData = (NSData *)CFPropertyListCreateXMLData( kCFAllocatorDefault, plistObj );
		CFErrorRef *err = nil;
		NSData * xmlData =  (NSData*) CFPropertyListCreateData (
											kCFAllocatorDefault,
											plistObj,
											kCFPropertyListXMLFormat_v1_0,
											0,
											err
											);
		
		if ( xmlData ) [xmlData writeToFile:[@"~/Documents/xmlData2.dat" stringByExpandingTildeInPath] atomically:YES]; // 2011-09-21steve
		if ( err )
		{
			NSLog ( @"error = %@",err );
		}
		
        if(nil == xmlData)
        {
            db("unable to create XML data for object:%@", plistObj);
        }
        else
        {
            if(nil == (s = [NSString stringWithCString:[xmlData bytes] maxLength:[xmlData length] encoding:NSUTF8StringEncoding]))
            {
                db("unable to create string from XML data using [NSString stringWithCString: encoding:NSUTF8StringEncoding]");
                db("raw XML data:]");                
                LOG_DATA(xmlData);
            }
            else if(nil == (s = [NSString stringWithFormat:@"%s",[xmlData bytes]]))
            {
                db("unable to create string from XML data using [NSString stringWithFormat:]");
            }
            else
            {
				s = [s retain]; // 2011-09-21steve
				

				[s writeToFile:[@"~/Documents/xmlDataAsString.txt" stringByExpandingTildeInPath] atomically:YES]; // 2011-09-21steve
				[s writeToFile:[@"~/Documents/xmlDataAsString2.txt" stringByExpandingTildeInPath] atomically:YES encoding:NSUTF8StringEncoding error:nil];

                //NSLog(@"XML property list values:\n%@",s);
                NSBitmapImageRep *iRep = [NSBitmapImageRep imageRepWithData:data];
                NSMutableDictionary * mDict = [[[iRep valueForProperty:NSImageEXIFData] mutableCopy] autorelease];
                [mDict setObject:s forKey:(id)kCGImagePropertyExifUserComment];
                
				NSLog ( @"2011-09-21steve about to embedDictionary: %@", mDict );
				
                newImageData = [iRep representationUsingType:NSJPEGFileType properties:[NSDictionary dictionaryWithObjectsAndKeys:mDict,NSImageEXIFData,[NSNumber numberWithFloat:0.90],NSImageCompressionFactor,nil]];
                
                newImageData = [newImageData retain];
				
				[s release]; // 2011-09-21steve
            }
            [xmlData autorelease];
        }

        [pool drain];        
    }
    return [newImageData autorelease];
}
+(id)jpegDataWithPropertyListObject:(id)plistObj embeddedInExifDataForJpegAtPath:(NSString *)path
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) ); // 2011-09-21steve

    NSData * data = nil;
    if(path)
    {
        data = [self jpegDataWithPropertyListObject:plistObj embeddedInExifDataForJpegData:[NSData dataWithContentsOfFile:path]];
    }
   return data;
}

+(id)propertyListObjectForJpegData:(NSData *)data
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) ); // 2011-09-21steve

    id plistObj = nil;
    if(data)
    {
        NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
        NSBitmapImageRep *iRep = [NSBitmapImageRep imageRepWithData:data];
        plistObj = [[iRep valueForProperty:NSImageEXIFData] objectForKey:(id)kCGImagePropertyExifUserComment];
        if([plistObj isKindOfClass:[NSString class]])
        {
            plistObj = [plistObj dataUsingEncoding:NSUTF8StringEncoding];
        }
        if([plistObj isKindOfClass:[NSData class]])
        {
            plistObj = [(id)CFPropertyListCreateFromXMLData(NULL, (CFDataRef)plistObj, kCFPropertyListImmutable, NULL) autorelease];
        }
        plistObj = [plistObj retain];
        [pool drain];        
    }
    return [plistObj autorelease];
}
+(id)propertyListObjectForJpegAtPath:(NSString *)path
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) ); // 2011-09-21steve

    id plistObj = nil;
    if(path)
    {
        plistObj = [self propertyListObjectForJpegData:[NSData dataWithContentsOfFile:path]];
    }
    return plistObj;
}
@end
