//
//  ATMPPR_Log.h
//  
//
//  Created by tyler on 11/8/09.
//  Copyright 2009 Atomic Pepper LLC. All rights reserved.
//

//#import <Cocoa/Cocoa.h>
//#import <QuartzCore/CoreImage.h>
//#import <QuartzCore/CIFilter.h>
//#import <QuartzCore/CIContext.h>
#import "ATMPPR_Base.h"

enum cups_log_level_s {
    kLogLevelInfo      = 0,
    kLogLevelDebug     = 1,
    kLogLevelDebug2    = 2,
    kLogLevelError     = 3,
    kLogLevelWarn      = 4,
};

APPKIT_EXTERN NSString * ATMPPR_LogFileDidUpdate;
APPKIT_EXTERN NSString * ATMPPR_LogFileAddedString;


@interface ATMPPR_Log : ATMPPR_Base {

}
+(BOOL)validateEmailAddress:(NSString *)emailAddress;

+(NSString *)logDateString;

+(BOOL)setLogFile:(NSString *)path;
+(void)setApplicationName:(NSString *)appName;
+(void)setShouldLogAppName:(BOOL)flag;
+(void)setShouldLogToStdErr:(BOOL)flag;
+(void)setShouldNotifyForLogUpdates:(BOOL)flag;

+(void)fatal:(NSString *)msg;
+(void)debug:(NSString *)msg;
+(void)logData:(NSData *)data;

-(void)logFileDidUpdate:(NSNotification *)notification;
@end

#ifdef db
 #undef db
#endif
#define  db(format, ...)    [ATMPPR_Log debug:[NSString stringWithFormat:@ format, ## __VA_ARGS__ ]]
#ifdef NSLog
 #undef NSLog
#endif
#define  NSLog(format, ...)    [ATMPPR_Log debug:[NSString stringWithFormat: format, ## __VA_ARGS__ ]]
#define  LOG_DATA(data)     [ATMPPR_Log logData:(data)]
#define  LOG_BYTES_LENGTH(__B,__L)   [ATMPPR_Log logData:[NSData dataWithBytesNoCopy:(__B) length:(__L) freeWhenDone:NO]]
