//
//  myCustomNSView.m
//  MyRecorder
//
//  Created by steve on 11/7/10.
//  Copyright 2010 TriPrism, Inc. All rights reserved.
//

#import "myCustomNSView.h"
#import "TepsExtras.h"


@implementation myCustomNSView

- (id)initWithFrame:(NSRect)frame {
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	self = [super initWithFrame:frame];
	if (self) {
		// Initialization code here.
		[self registerForDraggedTypes:[NSArray arrayWithObjects:NSTIFFPboardType, 
									   NSFilenamesPboardType, nil]];
	}
	return self;
}

- (BOOL)acceptsFirstResponder
{
    return YES;
}
- (void)dealloc
{
    [self unregisterDraggedTypes];
    [super dealloc];
}

- (void)setCursor:(NSCursor *)newCursor
{
	[super resetCursorRects];
	[self addCursorRect:[self bounds] cursor:newCursor];
	[newCursor set];
}

- (void)drawRect:(NSRect)rect 
{
	// NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	// Drawing code here.
	
	// [self setCursor:[NSCursor pointingHandCursor]];
	
//	[self resetCursorRects];
//    NSCursor *aCursor = [NSCursor pointingHandCursor];
//    [self addCursorRect:rect cursor:aCursor];
//    [aCursor setOnMouseEntered:YES];
}

- (void)mouseExited:(NSEvent*)event
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

    [self setCursor:[NSCursor arrowCursor]];
	
	[self setNeedsDisplay:YES];
}

- (NSDragOperation)draggingEntered:(id <NSDraggingInfo>)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	if ((NSDragOperationGeneric & [sender draggingSourceOperationMask]) 
		== NSDragOperationGeneric)
	{
		//this means that the sender is offering the type of operation we want
		//return that we want the NSDragOperationGeneric operation that they 
		//are offering
		return NSDragOperationGeneric;
	}
	else
	{
		//since they aren't offering the type of operation we want, we have 
		//to tell them we aren't interested
		// return NSDragOperationGeneric;	// NSDragOperationNone;
		return NSDragOperationNone;
	}
}


- (void)draggingExited:(id <NSDraggingInfo>)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	//we aren't particularily interested in this so we will do nothing
	//this is one of the methods that we do not have to implement
}

- (void)draggingEnded:(id <NSDraggingInfo>)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	//we don't do anything in our implementation
	//this could be ommitted since NSDraggingDestination is an infomal
	//protocol and returns nothing
}

- (NSDragOperation)draggingUpdated:(id <NSDraggingInfo>)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

	[self setCursor:[NSCursor pointingHandCursor]];

	if ((NSDragOperationGeneric & [sender draggingSourceOperationMask]) 
		== NSDragOperationGeneric)
	{
		//this means that the sender is offering the type of operation we want
		//return that we want the NSDragOperationGeneric operation that they 
		//are offering
		return NSDragOperationGeneric;
	}
	else
	{
		//since they aren't offering the type of operation we want, we have 
		//to tell them we aren't interested
		return NSDragOperationNone;
	}
}

- (BOOL)prepareForDragOperation:(id <NSDraggingInfo>)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );

	return YES;
}

- (BOOL)performDragOperation:(id <NSDraggingInfo>)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	NSPasteboard *paste = [sender draggingPasteboard];
	//gets the dragging-specific pasteboard from the sender
	NSArray *types = [NSArray arrayWithObjects:NSTIFFPboardType, 
					  NSFilenamesPboardType, nil];
	//a list of types that we can accept
	NSString *desiredType = [paste availableTypeFromArray:types];
	NSData *carriedData = [paste dataForType:desiredType];
	
	NSLog ( @"2010-11-07steve [paste name] = %@", [paste name] );
	
	id propertyList = [paste propertyListForType:desiredType];
	NSLog ( @"2010-11-07steve [paste propertyList] = %@", propertyList );
	

	NSLog ( @"2010-11-07steve desireType = %@", desiredType );
	NSLog ( @"2010-11-07steve carriedData = %@", carriedData );
	
	
	
	return YES;
}


- (void)concludeDragOperation:(id <NSDraggingInfo>)sender
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
    //re-draw the view with our new data

	NSPasteboard *paste = [sender draggingPasteboard];
	//gets the dragging-specific pasteboard from the sender
	NSArray *types = [NSArray arrayWithObjects:NSTIFFPboardType, 
					  NSFilenamesPboardType, nil];
	//a list of types that we can accept
	NSString *desiredType = [paste availableTypeFromArray:types];
	NSData *carriedData = [paste dataForType:desiredType];
	
	NSLog ( @"2010-11-07steve [paste name] = %@", [paste name] );
	
	id propertyList = [paste propertyListForType:desiredType];
	NSLog ( @"2010-11-07steve [paste propertyList] = %@", propertyList );
	
	
	NSLog ( @"2010-11-07steve desireType = %@", desiredType );
	NSLog ( @"2010-11-07steve carriedData = %@", carriedData );
	
	NSNotificationCenter *nc = [NSNotificationCenter defaultCenter];
	[nc postNotificationName:cNotification_ChangeMovie object:sender userInfo:propertyList];

	
	// [self setNeedsDisplay:YES];
}


@end
