//
//  webKeyInfoObject.m
//  Teps-VideoWall
//
//  Created by Support on 1/17/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "webKeyInfoObject.h"
//#import "Filters.h"

// file is in /var/tmp/.com.tpi.key.tpi

// NSString* kWebKeyFileName = @".com.tpi.key.tpi";	// 2011-04-27
NSString* kWebKeyFileName = @".com.tpi.key.pt";	// 2012-06-25steve
NSString* kWebKeyFileName2 = @".com.tpi.key.tpi"; // 2012-09-17steve
NSString* kBaseSavedPath = @"/var/tmp/"; // 2012-09-21steve


#define kWebKeyInfoKey						@"webkeyInfo"		// 2011-02-11

#define kPrintCountKey						@"printCount"			// 2011-02-11
#define kCreationDateKey					@"dateCreated"			// 2011-02-11
#define kExpirationDateKey					@"expirationDate"		// 2011-02-11
#define kSerialNumberKey					@"serialNumber"			// 2011-02-11
#define kVendorEmailKey						@"vendorVersionEmail"	// 2011-04-25
#define	kVersionKey							@"version"				// 2012-10-04steve

#define kTRPrintCount						@"TRprintCount"			// 2011-03-31
#define kTRPrintCKCount						@"TRprintCKCount"		// 2011-03-31
#define kTRRealPrintCount					@"TRrealPrintCount"		// 2011-03-31
#define kTRPrintToFileCount					@"TRprintToFileCount"	// 2011-03-31
#define kTRPrintToWebCount					@"TRprintToWebCount"	// 2011-03-31

#define kTRLicenseCode						@"TRLicenseCode"		// 2011-04-28steve


static BOOL gDoVerbose = YES; // 2012-09-21steve NO; // 2011-04-15edwin	2011-12-10steve



CFStringRef CopySerialNumberNew (void) // 2011-05-04steve
{
	{
		
		io_service_t    platformExpert = IOServiceGetMatchingService(kIOMasterPortDefault,
																	 IOServiceMatching("IOPlatformExpertDevice"));
		
		if (platformExpert) {
			CFTypeRef serialNumberAsCFString =
			IORegistryEntryCreateCFProperty(platformExpert,
											CFSTR(kIOPlatformSerialNumberKey),
											kCFAllocatorDefault, 0);
			if (serialNumberAsCFString) {
				return serialNumberAsCFString;
			}
			
			IOObjectRelease(platformExpert);
		}
	}
	return nil;
}

NSString* getThisMachinesSerialNumberNew(void)
{
	BOOL oldVerbose = gDoVerbose;
	
	gDoVerbose = YES;
	
	NSString* tempString = (NSString*) CopySerialNumberNew();
	tempString = [tempString stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet] ];
	if ( tempString && [tempString length] ) {
		// great
	} else {
		tempString = [NSString stringWithString:@"UnknownSerialNumber"];
	}
	
	gDoVerbose = oldVerbose;

	return [NSString stringWithString:tempString];
	
}



@implementation webKeyInfoObject

-(void)setVerbose:(BOOL)state // 2011-12-10steve
{
	NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	gDoVerbose = state;
	
}

- (void) dealloc		// 2012-02-09
{
	[settings	save]; // 2013-11-20steve move up - prevent crash
	[super dealloc];
}


-(BOOL) isValidLicense	// 2012-09-21steve
{
	bool isValidDate = [self validateExpirationDate];
	bool isValidMac = [self validateSerialNumber];
	bool isValidVersionCode = [self validateVersion:nil]; // 2012-10-04steve
	bool isValidCount = [self validateCount]; // 2012-11-01steve
	

// 2012-10-05steve - do not let it go thru	
//#ifdef _forFF	// 2012-10-04steve
//	isValidVersionCode = YES; // 2012-10-04steve
//#endif
	
	// 2012-11-01steve BOOL isValid = isValidDate && isValidMac && isValidVersionCode; // 2012-10-04steve
	BOOL isValid = isValidDate && isValidMac && isValidVersionCode && isValidCount; // 2012-11-01steve
	if (isValid) { // 2012-10-04steve must check for isValidVersionCode
		NSLog(@"The licence seems to be valid");		
	}else {
		NSLog(@"The licence is INVALID...");		
	}

	return (isValid);
}


// 2012-10-05steve -(id) initForTPI	// 2012-09-21steve
-(id) initForPT	// 2012-10-05steve
{
	if ((self = [super init]))
	{
		if (gDoVerbose) NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
		NSString* savedPath = [kBaseSavedPath stringByAppendingPathComponent:kWebKeyFileName];
		BOOL exists = [[NSFileManager defaultManager] fileExistsAtPath:savedPath];
		if ( exists ) {
			// NSLog( @"Found TepsPOS security file..." );
			settings = [[ATMPPR_SecureSettings alloc] initWithPath:savedPath];
			if (gDoVerbose) NSLog (@ "Inside %@ => %@...settings=%@", self, NSStringFromSelector(_cmd),settings );
			
			webInfo = [settings objectForKey:kWebKeyInfoKey];
			if (gDoVerbose) NSLog (@ "Inside %@ => %@...checking webInfo...", self, NSStringFromSelector(_cmd) );

			if (webInfo==nil)
				NSLog ( @"Your TPI Security Info File does NOT exist..." );
			else {
				if (gDoVerbose) NSLog(@"webInfo Dictionary = %@", webInfo);
			}
			
		}
		else {
			if (gDoVerbose) NSLog (@ "Inside %@ => %@...Teps Security Info File NOT Found...", self, NSStringFromSelector(_cmd) );
			
		}
	}
	return self;
}

// 2012-10-05steve -(id) initForPT	// 2012-09-21steve
-(id) initForTPI	// 2012-10-05steve
{
	if ((self = [super init]))
	{
		if (gDoVerbose) NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
		NSString* savedPath = [kBaseSavedPath stringByAppendingPathComponent:kWebKeyFileName2];
		BOOL exists = [[NSFileManager defaultManager] fileExistsAtPath:savedPath];
		if ( exists ) {
			// NSLog( @"Found TepsPOS security file..." );
			settings = [[ATMPPR_SecureSettings alloc] initWithPath:savedPath];
			if (gDoVerbose) NSLog (@ "Inside %@ => %@...settings=%@", self, NSStringFromSelector(_cmd),settings );
			
			webInfo = [settings objectForKey:kWebKeyInfoKey];
			if (gDoVerbose) NSLog (@ "Inside %@ => %@...checking webInfo...", self, NSStringFromSelector(_cmd) );
			
			if (webInfo==nil)
				NSLog ( @"Your PT5 Security Info File does NOT exist..." );
			else {
				if (gDoVerbose) NSLog(@"webInfo Dictionary = %@", webInfo);
			}
			
		}
		else {
			if (gDoVerbose) NSLog (@ "Inside %@ => %@...TPI Security Info File NOT Found...", self, NSStringFromSelector(_cmd) );

		}
	}
	return self;
}


-(id) init
{
	if (gDoVerbose) NSLog (@ "Inside %@ => %@...", self, NSStringFromSelector(_cmd) );
	
	if ((self = [super init]))
	{	// superclass may return nil
		
		// 2012-02-09
		// 2012-09-17steve NSString * savedPath = @"/var/tmp/";		
		// 2012-09-17steve savedPath = [savedPath stringByAppendingPathComponent:kWebKeyFileName];
		
		// 2012-09-17steve - new method so we can check both ways
		NSString* baseSavedPath = @"/var/tmp/"; // 2012-09-17steve
		NSString* savedPath = [baseSavedPath stringByAppendingPathComponent:kWebKeyFileName];

		// 2012-09-17steve allow for both cases FOR FreezeFrame
		BOOL exists = [[NSFileManager defaultManager] fileExistsAtPath:savedPath];
		if ( exists ) {
			NSLog( @"Found TepsPOS security file..." );
		}
#ifdef _forFF	// 2012-09-17steve build forFF
		else {
			// try with standard teps share
			NSLog (@"2012-09-17steve Need to try alternate search path for security file..." );
			savedPath = [baseSavedPath stringByAppendingPathComponent:kWebKeyFileName2];
			exists = [[NSFileManager defaultManager] fileExistsAtPath:savedPath];
			if( !exists) {
				NSLog( @"2012-09-17steve - UNABLE to find either valid Teps related security files..." );
			}
		}
#endif
		
		
		settings = [[ATMPPR_SecureSettings alloc] initWithPath:savedPath];
		
		//settings = [ATMPPR_SecureSettings persistentSettings];		
		
		// 2011-04-15edwin
		if (gDoVerbose) NSLog (@ "Inside %@ => %@...settings=%@", self, NSStringFromSelector(_cmd),settings ); // 2011-12-10steve
		
		//webInfo = [settings objectForKey:kWebKeyInfoKey error:NULL];
		webInfo = [settings objectForKey:kWebKeyInfoKey];
		
		// 2011-04-15edwin
		if (gDoVerbose) NSLog ( @"2011-12-10steve checking webInfo..." );	
		
		
		if (webInfo==nil)
			NSLog ( @"Your Security Info File does NOT exist..." ); // 2012-06-26steve
		else {
			if (gDoVerbose) NSLog(@"Dictionary = %@", webInfo);
		}
		
	}
	
	return self;
}

-(ATMPPR_SecureSettings*) settings		// 2012-02-13
{
	return settings;
}


-(void) createNewDictionary
{
}

#pragma mark-


-(void) setLicenseCode:(NSString*) licenseCode	// 2011-04-28steve
{
	if (gDoVerbose) NSLog(@"printcount = %@", licenseCode);
	if (licenseCode) [webInfo setValue:licenseCode forKey:kTRLicenseCode];	
	[settings setObject:webInfo forKey:kWebKeyInfoKey];
}

-(NSString*) getLicenseCode	// 2011-04-28steve
{
	return [webInfo objectForKey:kTRLicenseCode];
}


-(void) setPrintCount:(int) printCount
{
	if (gDoVerbose) NSLog(@"printcount = %d", printCount);
	[webInfo setValue:[NSNumber numberWithInt:printCount] forKey:kPrintCountKey];	
	[settings setObject:webInfo forKey:kWebKeyInfoKey];
}

-(void) setExpirationDate:(NSString*) expDate
{
	if (gDoVerbose) NSLog(@"expiration date = %@", expDate);
	if ( expDate) [webInfo setObject:expDate forKey:kExpirationDateKey]; //2011-05-04steve make sure object is not NIL	
	[settings setObject:webInfo forKey:kWebKeyInfoKey];
	
}

-(void) registerEmail:(NSString*) email
{
	if (gDoVerbose) NSLog(@"email = %@", email);
	if ( email) [webInfo setObject:email forKey:kVendorEmailKey]; // 2011-05-04steve make sure object is not NIL	
	[settings setObject:webInfo forKey:kWebKeyInfoKey];
}

-(NSString*) getRegisteredEmail // 2011-04-27steve
{
	return [webInfo objectForKey:kVendorEmailKey];
}

-(BOOL) isVendorVersionRegistered
{
	BOOL isRegistered =  ([webInfo objectForKey:kVendorEmailKey] != nil);
	
	if (isRegistered==false)
		NSLog(@"not Registered");
	
	return isRegistered;
}


-(long) getPrintCount
{
	if ([self	validateSerialNumber]==false) return 0;
	if ([self	validateExpirationDate]==false) return 0;
	
	
	return [[webInfo	valueForKey:kPrintCountKey]	longValue];
}


-(bool) validateVersion:(NSString*)desiredVersion // 2012-10-04steve
{
	bool isValidVersion = NO;

	NSString	*savedValue = [webInfo objectForKey:kVersionKey];
	if (gDoVerbose) NSLog ( @"savedValue[%@] = [%@]", kVersionKey, savedValue );
	if ( savedValue==nil )
		return NO;
	
	// 2012-10-05steve - try implementing more succinctly - table expandable
	// 2012-10-05steve - we want triprism key to always work
	NSDictionary* validVersions = [NSDictionary dictionaryWithObjectsAndKeys:
								  @"tepsSharePlus",@"tsplus",
								  @"phototouchPlus",@"tsptplus",
								  @"phototouch",@"ac079f", // 2010-10-25steve
								  @"pos",@"pos", // 2010-10-25steve
								  @"triprism",@"triprism",nil];
	
	id obj = [validVersions objectForKey:[[savedValue lowercaseString] stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]] ];
	if ( obj ) {
		if (gDoVerbose) NSLog ( @"%@[%@] is a %@ key...", kVersionKey, savedValue, obj );
		isValidVersion = YES;
	}
	
	/*
	if ( [savedValue caseInsensitiveCompare:@"tsplus"]==NSOrderedSame ) { // check for tepsSharePlus
		if (gDoVerbose) NSLog ( @"savedValue[%@] is a tepsSharePlus key...", kVersionKey, savedValue );
		isValidVersion = YES;
	}
	else if ( [savedValue caseInsensitiveCompare:@"tsptplus"]==NSOrderedSame ) { // check for tepsSharePlus
		if (gDoVerbose) NSLog ( @"savedValue[%@] is a phototouchPlus key...", kVersionKey, savedValue );
		isValidVersion = YES;
	}
	*/
	
	
	return isValidVersion;
}

-(bool) validateSerialNumber
{
	bool		isValidKey = true;
	
	// check for serial number
	NSString	*savedSerialNumber = [webInfo objectForKey:kSerialNumberKey];
	if (gDoVerbose) NSLog ( @"savedSerialNumber = [%@]", savedSerialNumber );
	if ( savedSerialNumber==nil )
		return YES;
		
	NSString* myMacSerialNumber = getThisMachinesSerialNumberNew();
	if (gDoVerbose) NSLog ( @"myMacSerialNumber = [%@]", myMacSerialNumber );
	if ([savedSerialNumber caseInsensitiveCompare:myMacSerialNumber]!=NSOrderedSame)
	{
		isValidKey = false;
		
		NSLog(@"The serial number appears to be invalid, this machine is %@, saved serial number is %@", myMacSerialNumber, savedSerialNumber);
		
		[settings removeObjectForKey:kWebKeyInfoKey];
	}
	
	return isValidKey;
}


-(bool) validateCount // 2012-11-01steve
{
	long count =  [[webInfo	valueForKey:kPrintCountKey]	longValue];
	if ( gDoVerbose) NSLog ( @"Count is %i", count );
	
	if ( count>0 ) {
		// great
	} else {
		NSLog( @"Count is ZERO" );
	}

	return (count>0 );
	
}

-(bool) validateExpirationDate		// 2011-11-17
{

	NSString	*expirationDateStr = [webInfo	objectForKey:kExpirationDateKey];
		
	if (expirationDateStr==nil)
	{
		NSLog(@"The Dictionary Key does not exist");
		return false;
	}
	
	// 2011-04-28steve???? NSTimeZone		*timeZone =  [[NSTimeZone alloc] init];
	NSDateFormatter *dateFormatter = [[[NSDateFormatter alloc] init] autorelease];
	
	[dateFormatter setDateStyle:NSDateFormatterMediumStyle];
	[dateFormatter setTimeStyle:NSDateFormatterNoStyle];	
	// 2011-04-28steve BAD [dateFormatter setTimeZone:[timeZone defaultTimeZone]];
	[dateFormatter setTimeZone:[NSTimeZone defaultTimeZone]]; // 2011-04-28steve - class method 
	
	NSDate *expDate = [dateFormatter dateFromString:expirationDateStr];	
	if (gDoVerbose) NSLog(@"expDate = %@", expDate);
	
	if ( expDate==nil ) { // 2012-11-01steve
		NSLog (@"The expDate is NIL for some reason");
		NSLog (@"This license is considered expired");
		return false;
	}
	
	if ([(NSDate*)[NSDate date] compare:expDate]==NSOrderedDescending) // current Date is Later than intime
	{
		NSLog(@"The licence seems to have expired");
		
		return false;
	}
	return true;
}


#pragma mark-


-(void) setGlobalPrintCounts:(long) printCount	isCK: (bool) ckJob		// 2011-04-29steve // 2011-03-31
{
	if (gDoVerbose) NSLog(@"printcount = %d", printCount);
	
	long currentPrintCount = [[webInfo	valueForKey:kTRPrintCount]	longValue];
	long currentCKrintCount = [[webInfo	valueForKey:kTRPrintCKCount]	longValue];
	
	if (ckJob)
		currentCKrintCount += printCount;
	else
		currentPrintCount += printCount;
	
	
	[webInfo setValue:[NSNumber numberWithLong:currentPrintCount] forKey:kTRPrintCount];	
	[webInfo setValue:[NSNumber numberWithLong:currentCKrintCount] forKey:kTRPrintCKCount];	
	[settings setObject:webInfo forKey:kWebKeyInfoKey];
}



-(void) setPrintCounts:(long) printCount	printToFile: (long) p2fCount	printToWeb: (long) webCount	 // 2011-04-29steve long	// 2011-03-31
{
	if (gDoVerbose) NSLog(@"printcount = %d", printCount);
	
	int currentPrintCount = [[webInfo	valueForKey:kTRRealPrintCount]	longValue];
	currentPrintCount += printCount;
	int currentPrintToFileCount = [[webInfo	valueForKey:kTRPrintToFileCount]	longValue];
	currentPrintToFileCount += p2fCount;
	int currentWebCount = [[webInfo	valueForKey:kTRPrintToWebCount]	longValue];
	currentWebCount += webCount;
	
	
	[webInfo setValue:[NSNumber numberWithLong:currentPrintCount] forKey:kTRRealPrintCount];	
	[webInfo setValue:[NSNumber numberWithLong:currentPrintToFileCount] forKey:kTRPrintToFileCount];	
	[webInfo setValue:[NSNumber numberWithLong:currentWebCount] forKey:kTRPrintToWebCount];	
	[settings setObject:webInfo forKey:kWebKeyInfoKey];
}

-(void) resetAllPrintCounts			// 2011-03-31
{
	[webInfo setValue:[NSNumber numberWithInt:0] forKey:kTRPrintCount];	
	[webInfo setValue:[NSNumber numberWithInt:0] forKey:kTRPrintCKCount];	
	[webInfo setValue:[NSNumber numberWithInt:0] forKey:kTRRealPrintCount];	
	[webInfo setValue:[NSNumber numberWithInt:0] forKey:kTRPrintToFileCount];	
	[webInfo setValue:[NSNumber numberWithInt:0] forKey:kTRPrintToWebCount];	
	[settings setObject:webInfo forKey:kWebKeyInfoKey];
}



-(long) getTRPrintCount		// 2011-03-31
{
	return [[webInfo	valueForKey:kTRPrintCount]	longValue];
}
-(long) getTRPrintCKCount		// 2011-03-31
{
	return [[webInfo	valueForKey:kTRPrintCKCount]	longValue];
}
-(long) getTRRealPrintCount		// 2011-03-31
{
	return [[webInfo	valueForKey:kTRRealPrintCount]	longValue];
}
-(long) getTRPrintToFileCount	// 2011-03-31
{
	return [[webInfo	valueForKey:kTRPrintToFileCount]	longValue];
}
-(long) getTRPrintToWebCount		// 2011-03-31
{
	return [[webInfo	valueForKey:kTRPrintToWebCount]	longValue];
}


@end
